webpackJsonp([112],{

/***/ 103:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
class CachingService {
    constructor() {
        this.cache = {};
        this.pages = {};
    }
    clear() {
        this.cache = {};
        this.pages = {};
    }
    clearCache() {
        this.cache = {};
    }
    addPage(url, elements) {
        this.pages[url] = elements;
    }
    getPage(url) {
        return this.pages[url];
    }
    add(groupName, sectionName, element) {
        let groupObject = this.cache[groupName];
        if (!groupObject) {
            groupObject = {};
            this.cache[groupName] = groupObject;
        }
        let sectionList = groupObject[sectionName];
        if (!sectionList) {
            sectionList = [];
            groupObject[sectionName] = sectionList;
        }
        //Evita duplicados
        let pos = sectionList.findIndex(x => x.productCode === element.productCode);
        if (pos < 0) {
            sectionList.push(element);
        }
    }
    insertTop(groupName, sectionName, element) {
        let groupObject = this.cache[groupName];
        if (!groupObject) {
            groupObject = {};
            this.cache[groupName] = groupObject;
        }
        let sectionList = groupObject[sectionName];
        if (!sectionList) {
            sectionList = [];
            groupObject[sectionName] = sectionList;
        }
        //Evita duplicados
        let pos = sectionList.findIndex(x => x.productCode === element.productCode);
        if (pos < 0) {
            sectionList.unshift(element);
        }
    }
    cleanSection(groupName, sectionName) {
        let groupObject = this.cache[groupName];
        if (!groupObject) {
            groupObject = {};
            this.cache[groupName] = groupObject;
        }
        groupObject[sectionName] = [];
    }
    shrinkSection(groupName, sectionName) {
        let groupObject = this.cache[groupName];
        if (!groupObject) {
            groupObject = {};
            this.cache[groupName] = groupObject;
        }
        let sectionList = groupObject[sectionName];
        if (sectionList) {
            if (sectionList.length > 20) {
                sectionList.splice(0, sectionList.length - 20);
            }
        }
    }
    shrink(groupName, sectionName, onShrink) {
        let groupObject = this.cache[groupName];
        if (!groupObject) {
            groupObject = {};
            this.cache[groupName] = groupObject;
        }
        let sectionList = groupObject[sectionName];
        if (sectionList && sectionList.length > 200) {
            //let from = sectionList.length;
            if (onShrink) {
                onShrink();
            }
            sectionList.splice(0, sectionList.length - 100);
        }
    }
    getGroup(groupName) {
        let list = [];
        let groupObject = this.cache[groupName];
        for (let sectionName in groupObject) {
            let sectionList = groupObject[sectionName];
            if (sectionList && sectionList.length > 0) {
                list = list.concat(sectionList);
            }
        }
        return list;
    }
    getSection(groupName, sectionName) {
        let list = [];
        let groupObject = this.cache[groupName];
        if (groupObject) {
            list = [...groupObject[sectionName]];
        }
        return list;
    }
    asTabEntrySet(tabs, groupName) {
        let tabEntrySet = [];
        let groupObject = this.cache[groupName];
        if (groupObject) {
            tabs.forEach((entry) => {
                let section = entry.code;
                let sectionList = groupObject[section];
                let list = [];
                if (sectionList && sectionList.length > 0) {
                    list = [...sectionList];
                }
                tabEntrySet.push({ group: groupName, code: section, name: entry.name, list: list, index: entry.index, order: entry.order, reference: entry.reference });
            });
        }
        tabEntrySet.sort(function (a, b) {
            return a.index - b.index;
        });
        return tabEntrySet;
    }
    get(groupName, sectionName) {
        let list = [];
        if (groupName && sectionName) {
            list = this.getSection(groupName, sectionName);
        }
        else if (groupName) {
            list = this.getGroup(groupName);
        }
        return list;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = CachingService;

//# sourceMappingURL=caching-service.js.map

/***/ }),

/***/ 104:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NativeRESTClient; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_throw__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_operator_catch__ = __webpack_require__(126);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_operator_catch___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_operator_catch__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_retry__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_retry___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_retry__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_timeout__ = __webpack_require__(177);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_timeout___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_timeout__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_map__ = __webpack_require__(128);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_map___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_map__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_native_http__ = __webpack_require__(142);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_core_provider_error_service__ = __webpack_require__(74);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










let NativeRESTClient = class NativeRESTClient {
    constructor(http, logService) {
        this.http = http;
        this.logService = logService;
    }
    get(resourceURL, params) {
        this.http.setRequestTimeout(10);
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var url = __WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].ENDPOINT + "/" + resourceURL;
            if (params) {
                url += ("?" + params);
            }
            this.http.setDataSerializer("json");
            this.http.setHeader("*", "Accept", "application/json");
            this.http.setHeader("*", "Content-Type", "application/json");
            this.http.get(url, {}, { 'Content-Type': 'application/json' }).then(data => {
                this.logService.log("LLAMANDO WEBSERVICE: " + url + "   [   Resultado OK   ] " + "[   STATUS: " + data.status + "   ]  [   " + "BODY: " + JSON.stringify(data.data) + "   ]");
                observer.next(data.data);
                observer.complete();
            })
                .catch(error => {
                this.logService.log("LLAMANDO WEBSERVICE: " + url + "   [   Resultado ERROR   ] " + "[   STATUS: " + error.status + "   ]  [   " + "ERROR: " + JSON.stringify(error.error) + "   ]");
                observer.error(error.error);
            });
        });
    }
    getFirst(resourceURL, params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.get(resourceURL, params).subscribe(response => {
                var itemToReturn = response;
                if (response) {
                    if (Object.prototype.toString.call(response) === '[object Array]' && response.length > 0) {
                        itemToReturn = response[0];
                    }
                }
                observer.next(itemToReturn);
                observer.complete();
            }, err => {
                observer.error(err);
            });
        });
    }
    post(resourceURL, postData) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var url = __WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].ENDPOINT + "/" + resourceURL;
            let header = {};
            this.http.setDataSerializer("json");
            this.http.setHeader("*", "Accept", "application/json");
            this.http.setHeader("*", "Content-Type", "application/json");
            this.http.post(url, postData, header).then(data => {
                //this.logService.log("LLAMANDO WEBSERVICE: " + url + "   [   Resultado OK   ] " + "[   STATUS: " + data.status + "   ]  [   " + "BODY: " + JSON.stringify(data.data) + "   ]");
                observer.next(data.data);
                observer.complete();
            })
                .catch(error => {
                this.logService.log("LLAMANDO WEBSERVICE: " + url + "   [   Resultado ERROR   ] " + "[   STATUS: " + error.status + "   ]  [   " + "ERROR: " + JSON.stringify(error.error) + "   ]");
                observer.error(error.error);
            });
        });
    }
    postResource(endpoint, postData) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var url = endpoint;
            let header = {};
            this.http.setDataSerializer("json");
            this.http.setHeader("*", "Accept", "application/json");
            this.http.setHeader("*", "Content-Type", "application/json");
            this.http.post(url, postData, header).then(data => {
                //this.logService.log("LLAMANDO WEBSERVICE: " + url + "   [   Resultado OK   ] " + "[   STATUS: " + data.status + "   ]  [   " + "BODY: " + JSON.stringify(data.data) + "   ]");
                observer.next(data.data);
                observer.complete();
            })
                .catch(error => {
                this.logService.log("LLAMANDO WEBSERVICE: " + url + "   [   Resultado ERROR   ] " + "[   STATUS: " + error.status + "   ]  [   " + "ERROR: " + JSON.stringify(error.error) + "   ]");
                observer.error(error.error);
            });
        });
    }
};
NativeRESTClient = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__ionic_native_http__["a" /* HTTP */],
        __WEBPACK_IMPORTED_MODULE_9__modules_core_provider_error_service__["a" /* ErrorService */]])
], NativeRESTClient);

//# sourceMappingURL=rest-native-client.js.map

/***/ }),

/***/ 1046:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_array_utils__ = __webpack_require__(280);


class WishListMapper {
    //Convertir un Model de la app SecurityUserQuestion al mensaje de entrada que espera el WS
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            nombre: model.name,
            descripcion: model.description,
            id_listadeseos: model.wishListId,
            pagina: model.pageId,
            registros: model.pageRows
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            wishListId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_listadeseos),
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(WishListMapper.convertResponseToModel(item));
            });
        }
        return result.sort(__WEBPACK_IMPORTED_MODULE_1__util_array_utils__["a" /* ArrayUtils */].compareValues('name'));
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = WishListMapper;

//# sourceMappingURL=wishlist.model.js.map

/***/ }),

/***/ 1047:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_product_utils__ = __webpack_require__(89);


class WishListDetailMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            articulo: model.productCode,
            id_listadeseos: model.wishListId,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var product = {
            wishListId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_listadeseos),
            article: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            price: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio),
            discountPercentage: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuento),
            isPromo: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.espromo),
            promoExpiration: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.finalizapromo),
            availableUnits: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.udsdisponibles),
            availableInDays: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.diasdisponible),
        };
        //Realiza calculos del producto, como descuentos, impuestos, etc.
        __WEBPACK_IMPORTED_MODULE_1__util_product_utils__["a" /* ProductUtils */].handleDefaults(product);
        return product;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(WishListDetailMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = WishListDetailMapper;

//# sourceMappingURL=wishlist-detail.model.js.map

/***/ }),

/***/ 1048:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductAttributeMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            attributeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_atributo),
            attribute: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.atributo)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductAttributeMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductAttributeMapper;

//# sourceMappingURL=product-attributes.model.js.map

/***/ }),

/***/ 1049:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductAttributeDetailMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token,
            articulo: model.productCode
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            productCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            attributeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_atributo),
            attributeDescription: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.atributo),
            characteristicId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_caracteristica),
            characteristicDescription: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.caracteristica)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductAttributeDetailMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = ProductAttributeDetailMapper;

class ProductAttributeDetailInfoMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token,
            articulo: model.productCode
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            productCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            attributeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_atributo),
            attributeDescription: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.atributo),
            characteristicId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_caracteristica),
            characteristicDescription: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.caracteristica)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductAttributeDetailInfoMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductAttributeDetailInfoMapper;

//# sourceMappingURL=product-attributes-detail.model.js.map

/***/ }),

/***/ 1050:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductMediaMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token,
            articulo: model.productCode
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            productCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageQty: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagenes),
            video: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.video),
            videoQty: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.videos),
            gif: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.gif),
            gifQty: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.gifs),
            thumbnailLoaded: false
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductMediaMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductMediaMapper;

//# sourceMappingURL=product-media.model.js.map

/***/ }),

/***/ 1051:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class CarruselImageMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model ? model.token : null,
            id_usuario: model ? model.userId : null
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertBannerModelToRequest(model, banner) {
        var request = {
            token: model ? model.token : null,
            id_usuario: model ? model.userId : null,
            pagina: model ? model.pageId : null,
            registros: model ? model.pageRows : null,
            id_lista: banner ? banner.showList : null,
            marca: banner ? banner.showBrand : null,
            id_proveedor: banner ? banner.showProvider : null
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        let model = {
            imageId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_imagen),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            showProductCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            showCategoryId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_categoria),
            showFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_familia),
            showSubFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_subfamilia),
            showList: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.lista_articulos),
            showBrand: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.marca),
            showProvider: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.proveedor),
            verified: true
        };
        if (!model.imageId) {
            model.imageId = __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion);
        }
        //model.showCategoryId = "0020";
        //model.showFamilyId = "2064";
        //model.showSubFamilyId = "5503";
        //model.showProductCode = "1183204";
        //model.showList = 15;
        //model.showBrand = "mercedes";
        //model.showProvider = "provider";
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(CarruselImageMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = CarruselImageMapper;

//# sourceMappingURL=carrusel-model.js.map

/***/ }),

/***/ 1052:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class SeasonMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            seasonId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_temporada),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio)
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(SeasonMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = SeasonMapper;

//# sourceMappingURL=season.model.js.map

/***/ }),

/***/ 1053:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class SeasonProductMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            temporada: model.seasonId,
            pagina: model.pageId,
            registros: model.pageRows,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = SeasonProductMapper;

//# sourceMappingURL=season-detail.model.js.map

/***/ }),

/***/ 1054:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductSearchMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            criterio: model.criterion,
            id_atributo: model.attributeId,
            valor: model.value,
            pagina: model.pageId,
            registros: model.pageRows,
            ordenar: model.sortBy,
            id_busqueda: model.searchPaginationId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertModelToFilterRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_busqueda: model.searchPaginationId,
            id_atributo: model.filterAttr,
            pagina: model.pageId,
            resultado: model.criterion,
            ordenar: model.sortBy
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductSearchMapper;

//# sourceMappingURL=product-search.model.js.map

/***/ }),

/***/ 1055:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductFamilyCategorySearchMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            categoria: model.categoryCode,
            familia: model.familyCode,
            subfamilia: model.subfamilyCode,
            pagina: model.page,
            registros: model.records
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductFamilyCategorySearchMapper;

//# sourceMappingURL=product-search-family.model.js.map

/***/ }),

/***/ 1056:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

/*export interface RelatedProductsResponse {
    articulo?: string
    descripcion?: string;
    imagen?: string;
    multimedio?: string;
    precio?: number;
    descuento?: number;
    espromo?: string;
    deseo?: string;
    finalizapromo?: number;
    cantidad?: number;
}*/
class RelatedProductsMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            articulo: model.article,
            pagina: model.pageId,
            registros: model.pageRows
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = RelatedProductsMapper;

//# sourceMappingURL=product-related.model.js.map

/***/ }),

/***/ 1057:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductWithNotAvailableMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            articulo: model.article,
            cantidad_solicitada: model.requestedQuantity,
            cantidad_disponibles: model.availableQuantity,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductWithNotAvailableMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductWithNotAvailableMapper;

//# sourceMappingURL=product-not-available.model.js.map

/***/ }),

/***/ 1058:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class RecommendationMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token,
            id_usuario: model.userId,
            articulo: model.article,
            fecha: model.date,
            estrellas: model.stars,
            detalle: model.detail
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            state: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            article: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            date: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fecha),
            stars: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estrellas),
            detail: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.detalle),
            avatar: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(RecommendationMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = RecommendationMapper;

//# sourceMappingURL=product-recommendation.model.js.map

/***/ }),

/***/ 1059:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductGroupMapper {
    static convertModelToRequest(model) {
        var request = {
            articulo: model.productCode,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            attributeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.criteriogrupo),
            productList: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.itemsagrupados),
            groupLabel: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.valoragrupa)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductGroupMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductGroupMapper;

//# sourceMappingURL=product-group.model.js.map

/***/ }),

/***/ 1060:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class DetArtBannerMapper {
    static convertResponseModel(response) {
        let model = {
            Orden: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.Orden),
            Imagen: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.Imagen)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(DetArtBannerMapper.convertResponseModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = DetArtBannerMapper;

//# sourceMappingURL=detartbanner-model.js.map

/***/ }),

/***/ 1061:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__config_config__ = __webpack_require__(3);


class PurchaseOrderMapper {
    //Convertir un Model de la app PurchaseOrder al mensaje de entrada que espera el WS
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            estado: model.orderStatus,
            fecinicio: model.startDate,
            fecfin: model.finishDate,
            fechacreacion: model.creationDate,
            fechaconfirmacion: model.confirmationDate,
            descuentocompratemprana: model.earlyPurchaseDiscount,
            moneda: model.currency,
            subtotal: model.subtotal,
            impuesto: model.tax,
            porcimpuesto: model.taxPercentage,
            descuento: model.discount,
            porcdescuento: model.discountPercentage,
            costoentrega: model.deliveryCost,
            total: model.total,
            id_direccion: model.addressId,
            metodopago: model.paymentMethod,
            id_tarjeta: model.cardId,
            cupon: model.coupon,
            cantarticulos: model.productQuantity,
            fechaentrega: model.deliveryDate,
            id_ordencompra: model.orderId,
            envia: model.deliveryCompany,
            pagada: model.paymentDone,
            numero_pago: model.paymentAuthorization,
            id_flete: model.freightId,
            //montoflete: model.freightAmount,
            detalle_direccion: model.addressDescription,
            alias_tc: model.creditCardAlias,
            marca_tc: model.creditCardBrand,
            rastreoCCR: model.ccrTrackingCode,
            NumeroEnvio: model.ccrTrackingCode,
            ProvinciaCCR: model.ccrProvince,
            CantonCCR: model.ccrCanton,
            SucursalCCR: model.ccrSubsidiaryName,
            CodigoCCR: model.ccrSubsidiaryCode,
            TiempoVencido: model.expired,
            KountSession: model.KountSession
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            orderId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_ordencompra),
            creationDate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechacreacion),
            confirmationDate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechaconfirmacion),
            earlyPurchaseDiscount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentocompratemprana),
            currency: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.moneda),
            subtotal: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.subtotal),
            tax: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto),
            taxPercentage: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.porcimpuesto),
            discount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuento),
            discountPercentage: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.porcdescuento),
            deliveryCost: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.costoentrega),
            total: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.total),
            orderStatus: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            addressId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_direccion),
            paymentMethod: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.metodopago),
            cardId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_tarjeta),
            coupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cupon),
            productQuantity: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantarticulos),
            deliveryDate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechaentrega),
            freightId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_flete),
            //freightAmount: StringUtils.validateNullOrUndefined(response.montoflete),
            onTime: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.entiempo),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            amountToCharge: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.montocobro),
            deliveryCompany: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.envia),
            paymentDone: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pagada),
            paymentAuthorization: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.numero_pago),
            addressDescription: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.detalle_direccion),
            creditCardAlias: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.alias_tc),
            creditCardBrand: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.marca_tc),
            ccrTrackingCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.rastreoCCR),
            subtotalCoupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.subtotal_cupon),
            taxCoupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto_cupon),
            deliveryCostCoupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.costoentrega_cupon),
            totalCoupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.total_cupon),
            ccrProvince: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.provinciaCCR),
            ccrCanton: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantonCCR),
            ccrSubsidiaryCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codigoCCR),
            ccrSubsidiaryName: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.sucursalCCR),
            orderStatusDescripcion: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.etiqueta_estado),
            expired: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.TiempoVencido),
            KountSession: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.KountSession)
        };
        //Manejo del estado
        /*if(model.orderStatus === AppConfig.order.RECEIVED_STATUS){
            model.orderStatusDescripcion = AppConfig.order.RECEIVED_STATUS_DESCRIPTION;

        }else if(model.orderStatus === AppConfig.order.PROCESSING_STATUS){
            model.orderStatusDescripcion = AppConfig.order.PROCESSING_STATUS_DESCRIPTION;

        }else if(model.orderStatus === AppConfig.order.READY_STATUS){
          model.orderStatusDescripcion = AppConfig.order.READY_STATUS_DESCRIPTION;

        }else if(model.orderStatus === AppConfig.order.PACKAGE_STATUS){
          model.orderStatusDescripcion = AppConfig.order.PACKAGE_STATUS_DESCRIPTION;

        }else if(model.orderStatus === AppConfig.order.ONRUTE_STATUS){
            model.orderStatusDescripcion = AppConfig.order.ONRUTE_STATUS_DESCRIPTION;

        }else if(model.orderStatus === AppConfig.order.DELIVERED){
            model.orderStatusDescripcion = AppConfig.order.DELIVERED_DESCRIPTION;
        }else{
            model.orderStatusDescripcion = model.orderStatus;
        }*/
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list) {
            list.forEach(function (item) {
                result.push(PurchaseOrderMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
    static handleTrackingStatus(model) {
        //Manejo del estado
        if (!model.trackingStatusDescription || model.trackingStatusDescription === "") {
            if (model.trackingStatus === __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.RECEIVED_STATUS) {
                model.trackingStatusDescription = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.RECEIVED_STATUS_DESCRIPTION;
            }
            else if (model.trackingStatus === __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.PROCESSING_STATUS) {
                model.trackingStatusDescription = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.PROCESSING_STATUS_DESCRIPTION;
            }
            else if (model.trackingStatus === __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.READY_STATUS) {
                model.trackingStatusDescription = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.READY_STATUS_DESCRIPTION;
            }
            else if (model.trackingStatus === __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.PACKAGE_STATUS) {
                model.trackingStatusDescription = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.PACKAGE_STATUS_DESCRIPTION;
            }
            else if (model.trackingStatus === __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.ONRUTE_STATUS) {
                model.trackingStatusDescription = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.ONRUTE_STATUS_DESCRIPTION;
            }
            else if (model.trackingStatus === __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.DELIVERED) {
                model.trackingStatusDescription = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].order.DELIVERED_DESCRIPTION;
            }
            else {
                model.trackingStatusDescription = model.trackingStatus;
            }
        }
    }
    static convertTrackingResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            var model = {};
            model.comment = item.comentario;
            model.trackingDate = item.fecha;
            model.trackingStatus = item.estado;
            model.trackingStatusDescription = item.etiqueta;
            model.deliveryDate = item.fechaentrega;
            PurchaseOrderMapper.handleTrackingStatus(model);
            result.push(model);
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = PurchaseOrderMapper;

;
class PurchaseOrderDetailMapper {
    //Convertir un Model de la app PurchaseOrder al mensaje de entrada que espera el WS
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_ordencompra: model.orderId,
            articulo: model.productCode,
            secuencia: model.sequence,
            cantidad: model.quantity,
            precio: model.price,
            subtotal: model.subtotal,
            impuesto: model.tax,
            descuento: model.discount,
            totallinea: model.totalLine
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            productCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            quantity: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantidad),
            price: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio),
            tax: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto),
            discount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuento),
            totalLine: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.totallinea),
            isPromo: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.espromo),
            promoExpiration: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.finalizapromo),
            sequence: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.secuencia),
            availableInDays: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.diasdisponible),
            availableUnits: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.udsdisponibles),
            status: response.estado,
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            totalLineCoupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.totallinea_cupon),
            taxCoupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto_cupon),
            priceCoupon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio_cupon),
            returnedQty: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cant_devuelta),
            canRefund: true
        };
        //Uso para el proceso de devolucion solamente
        if (model.returnedQty && (model.quantity - model.returnedQty) === 0) {
            model.canRefund = false;
            model.refundQuantity = 0; //no hay para devolver
        }
        else {
            model.refundQuantity = 1; //se puede devolver
        }
        model.refundPrice = model.totalLine / model.quantity;
        model.refundPriceCalculated = model.refundPrice;
        model.refundPictures = [];
        model.showRefundOptions = false;
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list) {
            list.forEach(function (item) {
                result.push(PurchaseOrderDetailMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
    static convertResponseListToModelListForRefund(list) {
        let result = [];
        if (list) {
            list.forEach(function (item) {
                let model = PurchaseOrderDetailMapper.convertResponseToModel(item);
                if (model.canRefund) {
                    result.push(model);
                }
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = PurchaseOrderDetailMapper;

;
//# sourceMappingURL=purchase-order.model.js.map

/***/ }),

/***/ 1064:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ 1068:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ 1070:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ 1101:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ 1102:
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),

/***/ 111:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__model_user_model__ = __webpack_require__(1156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_user_navigation_model__ = __webpack_require__(1157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__model_close_session_model__ = __webpack_require__(1158);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__util_rest_native_client__ = __webpack_require__(104);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








let UserService = class UserService {
    constructor(rest, nativeRest) {
        this.rest = rest;
        this.nativeRest = nativeRest;
    }
    /**
     * Registro de un usuario por email
     */
    registerUser(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["c" /* RegistrationMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_REGISTRATION, paramsString).subscribe((response) => {
                if (response) {
                    var result = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["c" /* RegistrationMapper */].convertResponseToModel(response);
                    observer.next(result);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
   * Autenticacion de un usuario por email
   */
    verifyIfExistsAccount(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["g" /* ValidateAccountMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_EXIST_ACCOUNT, paramsString).subscribe((response) => {
                let user = {};
                var result = false;
                if (response) {
                    result = response.correo && params.email.trim() === response.correo.trim();
                }
                user.accessMethod = response.login_RS && response.login_RS === "S" ? "facebook" : "email";
                user.userId = response.id_usuario;
                user.token = response.token;
                user.existent = result;
                user.mustChangePassword = response.cambiapassword;
                observer.next(user);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Autenticacion de un usuario por email
     */
    authUser(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["a" /* AuthMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_AUTH, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_user_model__["a" /* AuthMapper */].convertResponseToModel(response));
                    observer.complete();
                }
                else {
                    observer.next(null);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Obtiene la informacion de un usuario cuando se autentica por Redes Sociales
     */
    authUserForSocialNetwork(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["a" /* AuthMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_AUTH_SOCIAL_NETWORK, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_user_model__["a" /* AuthMapper */].convertResponseToModel(response));
                    observer.complete();
                }
                else {
                    observer.next(null);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
   * Obtiene la informacion de un usuario cuando se autentica por Redes Sociales
   */
    authUserForAppleNetwork(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["a" /* AuthMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_AUTH_APPLE_NETWORK, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_user_model__["a" /* AuthMapper */].convertResponseToModel(response));
                    observer.complete();
                }
                else {
                    observer.next(null);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Cambio de password
     */
    changeUserPassword(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["b" /* PassChangeMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_CHANGE_USER_PASSWORD, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_user_model__["b" /* PassChangeMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    sendPasswordEmail(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["b" /* PassChangeMapper */].convertSendEmailModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_CHANGE_USER_PASSWORD_EMAIL, paramsString).subscribe((response) => {
                observer.next();
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta Maestra de Usuario
     */
    getUser(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["d" /* UserMapper */].convertModelToRequest(session);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_GET_USER, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_user_model__["d" /* UserMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
   * Consulta Maestra de Usuario
   */
    searchPersonNameById(userId, token, identification) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["d" /* UserMapper */].convertSearchIdModelToRequest(userId, token, identification);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SEARCH_ID, paramsString).subscribe((response) => {
                observer.next(response && response.Nombre ? response.Nombre : null);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Modifica un Usuario
     */
    modifyUser(user) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["e" /* UserModifyMapper */].convertModelToRequest(user);
            this.nativeRest.post(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_MODIFY_USER, request).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_user_model__["e" /* UserModifyMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    modifyUserImage(user) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (user) {
                var request = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["e" /* UserModifyMapper */].convertImageModelToRequest(user);
                this.nativeRest.post(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_MODIFY_USER_IMAGE, request).subscribe((response) => {
                    if (response) {
                        observer.next(true);
                        observer.complete();
                    }
                }, error => {
                    observer.error(error);
                });
            }
            else {
                observer.next(true);
                observer.complete();
            }
        });
    }
    /**
   * Consulta Maestra de Usuario
   */
    inactiveUser(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_user_model__["f" /* UserinactivationMapper */].convertModelToRequest(session);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_USER_INACTIVATION, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_user_model__["f" /* UserinactivationMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    trackUserNavigation(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_user_navigation_model__["a" /* UserNavigationMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_USER_NAVIGATION, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_user_navigation_model__["a" /* UserNavigationMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    closeUserSession(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_6__model_close_session_model__["a" /* CloseSessionMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_CLOSE_SESSION_USER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_6__model_close_session_model__["a" /* CloseSessionMapper */].convertResponseToModel(item));
                    observer.complete();
                }
                else {
                    observer.error(new Error("Error de webservice"));
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consultar estado de una sesion
    checkTokenStatus(userId, token) {
        let params = {
            userId: userId,
            token: token
        };
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_close_session_model__["b" /* SessionStatusMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_SESSION_STATUS, paramsString).subscribe((response) => {
                let result = false;
                if (response && response === "A") {
                    result = true;
                }
                observer.next(result);
                observer.complete();
            }, error => {
                observer.next(false);
                observer.complete();
            });
        });
    }
};
UserService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__util_rest_client__["a" /* RESTClient */],
        __WEBPACK_IMPORTED_MODULE_7__util_rest_native_client__["a" /* NativeRESTClient */]])
], UserService);

//# sourceMappingURL=user-service.js.map

/***/ }),

/***/ 114:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LoginService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_device__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__user_service__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__social_google_service__ = __webpack_require__(619);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__social_facebook_service__ = __webpack_require__(621);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__core_provider_error_service__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__datasets_home_favs_dataset__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_facebook__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__social_apple_service__ = __webpack_require__(622);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};














let LoginService = class LoginService {
    constructor(device, googleService, facebookService, appleService, errHandler, loadingCtrl, userService, sessionManager, homeFavsSet, cartManager, events, facebook) {
        this.device = device;
        this.googleService = googleService;
        this.facebookService = facebookService;
        this.appleService = appleService;
        this.errHandler = errHandler;
        this.loadingCtrl = loadingCtrl;
        this.userService = userService;
        this.sessionManager = sessionManager;
        this.homeFavsSet = homeFavsSet;
        this.cartManager = cartManager;
        this.events = events;
        this.facebook = facebook;
    }
    isAccountValid(user) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.userService.verifyIfExistsAccount(user).subscribe((response) => {
                observer.next(response);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    signup(user) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.userService.registerUser(user).subscribe((response) => {
                if (response && response.userId) {
                    observer.next(true);
                    observer.complete();
                }
                else {
                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.USER_CANNOT_BE_CREATED_ERROR));
                }
            }, error => {
                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.CONNECTIVITY_ERROR, error));
            });
        });
    }
    loginWithEmail(email, password) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            var user = {
                email: email,
                password: password,
                accessMethod: 'email',
                country: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCountry,
                currency: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCurrency,
                model: this.device.model,
                platform: this.device.platform
            };
            this.userService.authUser(user).subscribe((authenticatedUser) => {
                if (authenticatedUser && authenticatedUser.userId) {
                    authenticatedUser.email = email;
                    authenticatedUser.existent = true;
                    authenticatedUser.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                    this.sessionManager.getSession().setPrincipal(authenticatedUser);
                    this.sessionManager.getSession().save().subscribe((response) => {
                        this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodEmail).subscribe((flag) => {
                            this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                            observer.next(authenticatedUser);
                            observer.complete();
                        });
                    });
                }
                else {
                    observer.next(null);
                    observer.complete();
                }
            }, error => {
                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.CONNECTIVITY_ERROR, error));
            });
        });
    }
    loginWithGoogle() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            const loading = this.loadingCtrl.create();
            loading.present();
            console.log("GOOGLE LOGIN...");
            this.googleService.login().subscribe((authData) => {
                //Si google respondio correctamente
                if (authData && authData.successful) {
                    //Existe el correo en efast?
                    let user = {};
                    user.email = authData.email;
                    this.isAccountValid(user).subscribe((response) => {
                        //El usuario no existe EN EFAST
                        if (!response.existent) {
                            console.log("GOOGLE LOGIN > Es un correo registrado? " + response);
                            //Datos para registro
                            var newUser = {
                                email: authData.email.toLowerCase(),
                                name: authData.name,
                                firstSurname: authData.lastName,
                                gender: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultGender,
                                birthDate: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultDate,
                                accessMethod: 'google',
                                socialNetworkUserId: authData.accessToken,
                                pictureType: 'url',
                                picture: authData.imageUrl,
                                country: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCountry,
                                currency: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCurrency,
                                fingerPrintValidation: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultNO,
                                pushNotifications: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultNO
                            };
                            console.log("GOOGLE LOGIN > Registrando usuario en Efast...");
                            //Registra el usuario en eFast
                            newUser.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                            this.signup(newUser).subscribe((response) => {
                                if (response) {
                                    console.log("GOOGLE LOGIN > Consultando datos guardados y creando sesion...");
                                    //Obtiene los datos del usuario en Efast
                                    this.userService.authUserForSocialNetwork(newUser).subscribe((authUserData) => {
                                        //El usuario esta bien autenticado
                                        if (authUserData && authUserData.userId) {
                                            console.log("GOOGLE LOGIN > User Autenticado con eFAST! " + JSON.stringify(authUserData));
                                            this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodGoogle).subscribe((flag) => {
                                                authUserData.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                                                this.sessionManager.getSession().setPrincipal(authUserData);
                                                this.sessionManager.getSession().save().subscribe((responseSave) => {
                                                    this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                                    loading.dismiss();
                                                    authUserData.existent = true;
                                                    setTimeout(() => {
                                                        let params = {
                                                            fb_registration_method: "Google"
                                                        };
                                                        this.facebook.logEvent("fb_mobile_complete_registration", params).then(() => { }).catch(e => console.log(e));
                                                    }, 1000);
                                                    observer.next(authUserData);
                                                    observer.complete();
                                                });
                                            });
                                        }
                                        else {
                                            loading.dismiss();
                                            newUser.existent = false;
                                            observer.next(newUser);
                                            observer.complete();
                                        }
                                    }, error => {
                                        loading.dismiss();
                                        observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                                    });
                                }
                                else {
                                    loading.dismiss();
                                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN));
                                }
                            }, error => {
                                loading.dismiss();
                                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                            });
                        }
                        else {
                            //El usuario ya existe en efast
                            console.log("GOOGLE LOGIN > Usuario YA EXISTE en eFast. Consultando datos guardados y creando sesion ");
                            //Obtiene los datos del usuario en Efast
                            this.userService.authUserForSocialNetwork(user).subscribe((authUserData) => {
                                //El usuario esta bien autenticado
                                if (authUserData && authUserData.userId) {
                                    console.log("GOOGLE LOGIN > User Autenticado con eFAST!  " + JSON.stringify(authUserData));
                                    //Guardar el avatar obtenido en el momento de la red social
                                    authUserData.picture = authData.imageUrl;
                                    let image = {
                                        userId: authUserData.userId,
                                        token: authUserData.token,
                                        picture: authData.imageUrl
                                    };
                                    authUserData.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                                    this.userService.modifyUserImage(image).subscribe((response) => {
                                        this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodGoogle).subscribe((flag) => {
                                            this.sessionManager.getSession().setPrincipal(authUserData);
                                            this.sessionManager.getSession().save().subscribe((responseSave) => {
                                                this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                                loading.dismiss();
                                                authUserData.existent = true;
                                                observer.next(authUserData);
                                                observer.complete();
                                            });
                                        });
                                    }, error => {
                                        //Error con el avatar no debe impedir la autenticacion
                                        this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodGoogle).subscribe((flag) => {
                                            this.sessionManager.getSession().setPrincipal(authUserData);
                                            this.sessionManager.getSession().save().subscribe((responseSave) => {
                                                this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                                loading.dismiss();
                                                authUserData.existent = true;
                                                observer.next(authUserData);
                                                observer.complete();
                                            });
                                        });
                                    });
                                }
                                else {
                                    loading.dismiss();
                                    user.existent = false;
                                    observer.next(user);
                                    observer.complete();
                                }
                            }, error => {
                                loading.dismiss();
                                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                            });
                        }
                    });
                }
                else {
                    loading.dismiss();
                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN));
                }
            }, error => {
                loading.dismiss();
                if (error) {
                    let messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN;
                    if (error == "17") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_API_NOT_CONNECTED;
                    }
                    else if (error == "16") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_CANCELED;
                    }
                    if (error == "10") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_DEVELOPER_ERROR;
                    }
                    else if (error == "13") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_ERROR;
                    }
                    else if (error == "8") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_INTERNAL_ERROR;
                    }
                    else if (error == "14") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_INTERRUPTED;
                    }
                    else if (error == "5") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_INVALID_ACCOUNT;
                    }
                    else if (error == "7") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_NETWORK_ERROR;
                    }
                    else if (error == "6") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_RESOLUTION_REQUIRED;
                    }
                    else if (error == "3") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_SERVICE_DISABLED;
                    }
                    else if (error == "2") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_SERVICE_VERSION_UPDATE_REQUIRED;
                    }
                    else if (error == "4") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_SIGN_IN_REQUIRED;
                    }
                    else if (error == "15") {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_TIMEOUT;
                    }
                    else {
                        messageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN;
                    }
                    observer.error(this.errHandler.handleErrWithMessage(this, messageId, error));
                }
                else {
                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                }
            });
        });
    }
    loginWithFacebook() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            const loading = this.loadingCtrl.create();
            loading.present();
            console.log("FB LOGIN...");
            this.facebookService.login().subscribe((authData) => {
                //Si google respondio correctamente
                if (authData && authData.successful) {
                    //Existe el correo en efast?
                    let user = {};
                    user.email = authData.email;
                    this.isAccountValid(user).subscribe((response) => {
                        //El usuario no existe EN EFAST
                        if (!response.existent) {
                            console.log("FB LOGIN > Es un correo registrado? " + response);
                            //Datos para registro
                            var newUser = {
                                email: authData.email.toLowerCase(),
                                name: authData.name,
                                firstSurname: authData.lastName,
                                gender: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultGender,
                                birthDate: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultDate,
                                accessMethod: 'facebook',
                                socialNetworkUserId: authData.accessToken,
                                pictureType: 'url',
                                picture: authData.imageUrl,
                                country: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCountry,
                                currency: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCurrency,
                                fingerPrintValidation: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultNO,
                                pushNotifications: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultNO
                            };
                            console.log("FB LOGIN > Registrando usuario en Efast...");
                            //Registra el usuario en eFast
                            newUser.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                            this.signup(newUser).subscribe((response) => {
                                if (response) {
                                    console.log("FB LOGIN > Consultando datos guardados y creando sesion...");
                                    //Obtiene los datos del usuario en Efast
                                    this.userService.authUserForSocialNetwork(newUser).subscribe((authUserData) => {
                                        //El usuario esta bien autenticado
                                        if (authUserData && authUserData.userId) {
                                            console.log("FB LOGIN > User Autenticado con eFAST! " + JSON.stringify(authUserData));
                                            this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodFacebook).subscribe((flag) => {
                                                authUserData.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                                                this.sessionManager.getSession().setPrincipal(authUserData);
                                                this.sessionManager.getSession().save().subscribe((responseSave) => {
                                                    this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                                    loading.dismiss();
                                                    authUserData.existent = true;
                                                    setTimeout(() => {
                                                        let params = {
                                                            fb_registration_method: "Facebook"
                                                        };
                                                        this.facebook.logEvent("fb_mobile_complete_registration", params).then(() => { }).catch(e => console.log(e));
                                                    }, 1000);
                                                    observer.next(authUserData);
                                                    observer.complete();
                                                });
                                            });
                                        }
                                        else {
                                            loading.dismiss();
                                            newUser.existent = false;
                                            observer.next(newUser);
                                            observer.complete();
                                        }
                                    }, error => {
                                        loading.dismiss();
                                        observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                                    });
                                }
                                else {
                                    loading.dismiss();
                                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN));
                                }
                            }, error => {
                                loading.dismiss();
                                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                            });
                        }
                        else {
                            //El usuario ya existe en efast
                            console.log("FB LOGIN > Usuario YA EXISTE en eFast. Consultando datos guardados y creando sesion ");
                            //Obtiene los datos del usuario en Efast
                            this.userService.authUserForSocialNetwork(user).subscribe((authUserData) => {
                                //El usuario esta bien autenticado
                                if (authUserData && authUserData.userId) {
                                    console.log("FB LOGIN > User Autenticado con eFAST!  " + JSON.stringify(authUserData));
                                    //Guardar el avatar obtenido en el momento de la red social
                                    authUserData.picture = authData.imageUrl;
                                    let image = {
                                        userId: authUserData.userId,
                                        token: authUserData.token,
                                        picture: authData.imageUrl
                                    };
                                    authUserData.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                                    this.userService.modifyUserImage(image).subscribe((response) => {
                                        this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodFacebook).subscribe((flag) => {
                                            this.sessionManager.getSession().setPrincipal(authUserData);
                                            this.sessionManager.getSession().save().subscribe((responseSave) => {
                                                this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                                loading.dismiss();
                                                authUserData.existent = true;
                                                observer.next(authUserData);
                                                observer.complete();
                                            });
                                        });
                                    }, error => {
                                        //Error con el avatar no debe impedir la autenticacion
                                        this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodFacebook).subscribe((flag) => {
                                            this.sessionManager.getSession().setPrincipal(authUserData);
                                            this.sessionManager.getSession().save().subscribe((responseSave) => {
                                                this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                                loading.dismiss();
                                                authUserData.existent = true;
                                                observer.next(authUserData);
                                                observer.complete();
                                            });
                                        });
                                    });
                                }
                                else {
                                    loading.dismiss();
                                    user.existent = false;
                                    observer.next(user);
                                    observer.complete();
                                }
                            }, error => {
                                loading.dismiss();
                                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                            });
                        }
                    });
                }
                else {
                    loading.dismiss();
                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN));
                }
            }, error => {
                loading.dismiss();
                if (error && error.errorCode == "4201") {
                    console.log("FB LOGIN... NULL USER");
                    observer.next(null);
                    observer.complete();
                }
                else {
                    console.log("FB LOGIN... ERR...");
                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.FB_CANNOT_COMPLETE_SIGN, error));
                }
            });
        });
    }
    loginWithApple() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            const loading = this.loadingCtrl.create();
            loading.present();
            console.log("APPLE LOGIN...");
            this.appleService.login().subscribe((authData) => {
                //Si Apple respondio correctamente
                if (authData && authData.successful) {
                    //Existe el correo en efast?
                    let user = {};
                    user.email = authData.email;
                    let appleToken = authData.accessToken;
                    let firebaseToken = this.sessionManager.getPushNotificationDeviceId();
                    this.isAccountValid(user).subscribe((response) => {
                        //El usuario no existe EN EFAST
                        if (!response.existent) {
                            console.log("APPLE LOGIN > Es un correo registrado? " + JSON.stringify(response));
                            //Datos para registro
                            var newUser = {
                                email: authData.email.toLowerCase(),
                                name: authData.name,
                                firstSurname: authData.lastName,
                                gender: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultGender,
                                birthDate: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultDate,
                                accessMethod: 'apple',
                                socialNetworkUserId: null,
                                pictureType: 'url',
                                picture: authData.imageUrl,
                                country: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCountry,
                                currency: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultCurrency,
                                fingerPrintValidation: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultNO,
                                pushNotifications: __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultNO //,
                                /*appleToken: authData.accessToken*/
                            };
                            console.log("APPLE LOGIN > Registrando usuario en Efast...");
                            //Registra el usuario en eFast
                            newUser.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                            this.signup(newUser).subscribe((response) => {
                                if (response) {
                                    console.log("APPLE LOGIN > Consultando datos guardados y creando sesion...");
                                    //Obtiene los datos del usuario en Efast
                                    this.userService.authUserForAppleNetwork(newUser).subscribe((authUserData) => {
                                        //El usuario esta bien autenticado
                                        if (authUserData && authUserData.userId) {
                                            console.log("APPLE LOGIN > User Autenticado con eFAST! " + JSON.stringify(authUserData));
                                            authUserData.appleToken = appleToken;
                                            authUserData.deviceToken = firebaseToken;
                                            this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodApple).subscribe((flag) => {
                                                this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodAppleToken, appleToken).subscribe();
                                                this.sessionManager.getSession().setPrincipal(authUserData);
                                                this.sessionManager.getSession().save().subscribe((responseSave) => {
                                                    //Guarda el token de Apple y Firebease
                                                    //this.userService.modifyUser(authUserData).subscribe((resultUser: User) => {
                                                    //  console.log("=======================");
                                                    //  console.log("Initializing FCM TOKEN GUARDADO 1...")
                                                    //  console.log("=======================");
                                                    this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                                    loading.dismiss();
                                                    authUserData.existent = true;
                                                    setTimeout(() => {
                                                        let params = {
                                                            fb_registration_method: "Apple"
                                                        };
                                                        this.facebook.logEvent("fb_mobile_complete_registration", params).then(() => { }).catch(e => console.log(e));
                                                    }, 1000);
                                                    observer.next(authUserData);
                                                    observer.complete();
                                                    /*}, error => {
                                                      console.log("=======================");
                                                      console.log("Initializing FCM TOKEN NO GUARDADO 1... Error.")
                                                      console.log("=======================");
                                                      loading.dismiss();
                                                      observer.error(this.errHandler.handle(this, AppConfig.err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                                                    });*/
                                                });
                                            });
                                        }
                                        else {
                                            loading.dismiss();
                                            newUser.existent = false;
                                            observer.next(newUser);
                                            observer.complete();
                                        }
                                    }, error => {
                                        loading.dismiss();
                                        observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                                    });
                                }
                                else {
                                    loading.dismiss();
                                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN));
                                }
                            }, error => {
                                loading.dismiss();
                                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                            });
                        }
                        else {
                            //El usuario ya existe en efast
                            console.log("APPLE LOGIN > Usuario YA EXISTE en eFast. Consultando datos guardados y creando sesion ");
                            //Obtiene los datos del usuario en Efast
                            this.userService.authUserForAppleNetwork(user).subscribe((authUserData) => {
                                authUserData.appleToken = appleToken;
                                authUserData.deviceToken = firebaseToken;
                                //El usuario esta bien autenticado
                                if (authUserData && authUserData.userId) {
                                    console.log("APPLE LOGIN > User Autenticado con eFAST!  " + JSON.stringify(authUserData));
                                    this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodApple).subscribe((flag) => {
                                        this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodAppleToken, appleToken).subscribe();
                                        this.sessionManager.getSession().setPrincipal(authUserData);
                                        this.sessionManager.getSession().save().subscribe((responseSave) => {
                                            this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, this.sessionManager.getPrincipal(), Date.now());
                                            loading.dismiss();
                                            authUserData.existent = true;
                                            observer.next(authUserData);
                                            observer.complete();
                                        });
                                    });
                                }
                                else {
                                    loading.dismiss();
                                    user.existent = false;
                                    observer.next(user);
                                    observer.complete();
                                }
                            }, error => {
                                console.log("APPLE LOGIN... ERR...");
                                console.log(JSON.stringify(error));
                                loading.dismiss();
                                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN, error));
                            });
                        }
                    });
                }
                else {
                    loading.dismiss();
                    observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN));
                }
            }, error => {
                loading.dismiss();
                console.log("APPLE LOGIN... ERR...");
                console.log(JSON.stringify(error));
                observer.error(this.errHandler.handle(this, __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].err.SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN));
            });
        });
    }
    checkIfTokenIsValid() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.sessionManager.getSession().getItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod).subscribe((value) => {
                console.log("checkIfTokenIsValid> METODO DE ACCESO... => " + value);
                if (value === __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodGoogle) {
                    console.log("checkIfTokenIsValid> VALIDANDO TOKEN DE GOOGLE...");
                    this.googleService.checkIfTokenIsValid().subscribe((authData) => {
                        let isSocialNetworkTokenValid = authData && authData.successful;
                        if (isSocialNetworkTokenValid) {
                            //Valida el token de E-Fast
                            if (this.sessionManager.isAuthenticated()) {
                                let userId = this.sessionManager.getPrincipal().userId;
                                let token = this.sessionManager.getToken();
                                this.userService.checkTokenStatus(userId, token).subscribe((result) => {
                                    observer.next(result);
                                    observer.complete();
                                });
                            }
                            else {
                                observer.next(false);
                                observer.complete();
                            }
                        }
                        else {
                            observer.next(false);
                            observer.complete();
                        }
                    });
                }
                else if (value === __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodFacebook) {
                    console.log("checkIfTokenIsValid> VALIDANDO TOKEN DE FACEBOOK...");
                    this.facebookService.checkIfTokenIsValid().subscribe((authData) => {
                        let isSocialNetworkTokenValid = authData && authData.successful;
                        if (isSocialNetworkTokenValid) {
                            //Valida el token de E-Fast
                            if (this.sessionManager.isAuthenticated()) {
                                let userId = this.sessionManager.getPrincipal().userId;
                                let token = this.sessionManager.getToken();
                                this.userService.checkTokenStatus(userId, token).subscribe((result) => {
                                    observer.next(result);
                                    observer.complete();
                                });
                            }
                            else {
                                observer.next(false);
                                observer.complete();
                            }
                        }
                        else {
                            observer.next(false);
                            observer.complete();
                        }
                    });
                }
                else if (value === __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodApple) {
                    console.log("checkIfTokenIsValid> VALIDANDO TOKEN DE APPLE...");
                    this.sessionManager.getSession().getItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodAppleToken).subscribe((storedToken) => {
                        if (storedToken) {
                            console.log("checkIfTokenIsValid> VALIDANDO TOKEN DE APPLE... 1");
                            console.log("");
                            let user = this.sessionManager.getPrincipal();
                            this.userService.getUser(user).subscribe((response) => {
                                console.log("checkIfTokenIsValid> VALIDANDO TOKEN DE APPLE... 2 " + JSON.stringify(response));
                                console.log("");
                                if (response.appleToken) {
                                    this.appleService.checkIfTokenIsValid(response.appleToken).subscribe((authData) => {
                                        console.log("checkIfTokenIsValid> VALIDANDO TOKEN DE APPLE... 3 " + JSON.stringify(authData));
                                        let isSocialNetworkTokenValid = authData && authData.successful;
                                        if (isSocialNetworkTokenValid) {
                                            //Valida el token de E-Fast
                                            if (this.sessionManager.isAuthenticated()) {
                                                let userId = this.sessionManager.getPrincipal().userId;
                                                let token = this.sessionManager.getToken();
                                                this.userService.checkTokenStatus(userId, token).subscribe((result) => {
                                                    observer.next(result);
                                                    observer.complete();
                                                });
                                            }
                                            else {
                                                observer.next(false);
                                                observer.complete();
                                            }
                                        }
                                        else {
                                            observer.next(false);
                                            observer.complete();
                                        }
                                    });
                                }
                                else {
                                    observer.next(false);
                                    observer.complete();
                                }
                            }, error => {
                                this.sessionManager.set("userInfoUpdated", false);
                            });
                        }
                        else {
                            observer.next(false);
                            observer.complete();
                        }
                    });
                }
                else {
                    console.log("checkIfTokenIsValid> VALIDANDO TOKEN E-FAST...");
                    //Valida el token de E-Fast
                    if (this.sessionManager.isAuthenticated()) {
                        let userId = this.sessionManager.getPrincipal().userId;
                        let token = this.sessionManager.getToken();
                        this.userService.checkTokenStatus(userId, token).subscribe((result) => {
                            observer.next(result);
                            observer.complete();
                        });
                    }
                    else {
                        observer.next(false);
                        observer.complete();
                    }
                }
            });
        });
    }
    logout(user) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.sessionManager.getSession().removeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.localSearchTermsLog).subscribe();
            const loading = this.loadingCtrl.create();
            loading.present();
            var params = {
                userId: user.userId,
                token: user.token
            };
            this.userService.closeUserSession(params).subscribe((response) => {
                //Limpia el carrito
                this.cartManager.clear();
                this.homeFavsSet.reset();
                this.sessionManager.getSession().getItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.loginMethod).subscribe((value) => {
                    if (value === __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodGoogle) {
                        console.log("DESLOGEANDO TOKEN DE GOOGLE...");
                        this.googleService.logout().subscribe((result) => {
                            console.log("DESLOGEANDO TOKEN DE GOOGLE...DONE! (" + result + ")");
                        });
                    }
                    else if (value === __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodFacebook) {
                        console.log("DESLOGEANDO TOKEN DE FACEBOOK...");
                        this.facebookService.logout().subscribe((result) => {
                            console.log("DESLOGEANDO TOKEN DE FACEBOOK...DONE! (" + result + ")");
                        });
                    }
                    else if (value === __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.loginMethodApple) {
                        console.log("DESLOGEANDO TOKEN DE APPLE...");
                        this.appleService.logout().subscribe((result) => {
                            console.log("DESLOGEANDO TOKEN DE APPLE...DONE! (" + result + ")");
                        });
                    }
                    this.sessionManager.getSession().reset().subscribe((result) => {
                        loading.dismiss();
                        if (result) {
                            console.log("Sesion cerrada en eFast");
                            this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, this.sessionManager.getPrincipal(), Date.now());
                        }
                        observer.next(true);
                        observer.complete();
                    }, error => {
                        loading.dismiss();
                        observer.next(true);
                        observer.complete();
                    });
                }, error => {
                    loading.dismiss();
                    observer.next(true);
                    observer.complete();
                });
            }, error => {
                loading.dismiss();
                observer.next(false);
                observer.complete();
            });
        });
    }
    silentLogout() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            //Limpia el carrito
            this.cartManager.clear();
            //Reseta todos los datos
            this.sessionManager.getSession().reset().subscribe((result) => {
                if (result) {
                    this.facebookService.logout().subscribe((result) => {
                        this.googleService.logout().subscribe((result) => {
                            console.log("Sesion cerrada en eFast");
                            this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, this.sessionManager.getPrincipal(), Date.now());
                            observer.next(true);
                            observer.complete();
                        });
                    });
                }
                else {
                    observer.next(false);
                    observer.complete();
                }
            });
        });
    }
};
LoginService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_device__["a" /* Device */],
        __WEBPACK_IMPORTED_MODULE_7__social_google_service__["a" /* SocialGoogleService */],
        __WEBPACK_IMPORTED_MODULE_8__social_facebook_service__["a" /* SocialFacebookService */],
        __WEBPACK_IMPORTED_MODULE_13__social_apple_service__["a" /* SocialAppleService */],
        __WEBPACK_IMPORTED_MODULE_9__core_provider_error_service__["a" /* ErrorService */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["LoadingController"],
        __WEBPACK_IMPORTED_MODULE_4__user_service__["a" /* UserService */],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_11__datasets_home_favs_dataset__["a" /* HomeFavsDataSet */],
        __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__["a" /* CartManagerService */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_12__ionic_native_facebook__["a" /* Facebook */]])
], LoginService);

//# sourceMappingURL=login-service.js.map

/***/ }),

/***/ 1142:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductCategoryMapper {
    static convertModelToRequest(session) {
        var request = {
            token: session.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var category = {
            code: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_categoria),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen)
        };
        return category;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductCategoryMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductCategoryMapper;

//# sourceMappingURL=product-category.model.js.map

/***/ }),

/***/ 1143:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductUserCategoryMapper {
    static convertModelToRequest(session, model) {
        var request = {
            id_usuario: session.userId,
            token: session.token,
            id_categoria: model ? model.code : null
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            code: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_categoria),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion)
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductUserCategoryMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductUserCategoryMapper;

//# sourceMappingURL=product-category-user.model.js.map

/***/ }),

/***/ 1144:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductCategoryFamilyMapper {
    static convertModelToRequest(params) {
        var request = {
            token: params.token,
            id_categoria: params.categoryCode
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response, categoryCode) {
        let model = {
            familyCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_familia),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            order: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.orden_pasillo),
            visible: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pasillo_visible),
            subLevel: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tercer_nivel)
        };
        if (!model.order)
            model.order = 1;
        model.reference = categoryCode;
        model.code = model.familyCode;
        model.name = (model.name ? model.name : model.description);
        model.order = (model.order ? model.order : 1);
        return model;
    }
    static convertResponseListToModelList(list, categoryCode) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductCategoryFamilyMapper.convertResponseToModel(item, categoryCode));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductCategoryFamilyMapper;

//# sourceMappingURL=product-category-family.model.js.map

/***/ }),

/***/ 1145:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ProductCategorySubFamilyMapper {
    static convertModelToRequest(params) {
        var request = {
            token: params.token,
            id_categoria: params.categoryCode,
            id_familia: params.familyCode
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            subFamilyCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_subfamilia),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion)
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(ProductCategorySubFamilyMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductCategorySubFamilyMapper;

//# sourceMappingURL=product-category-subfamily.model.js.map

/***/ }),

/***/ 1146:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class MiSuperMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model ? model.token : null,
            id_usuario: model ? model.userId : null
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            code: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pasillo),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            visible: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.visible),
            order: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.orden)
        };
        model.imageShow = false;
        if (!model.order)
            model.order = 1;
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(MiSuperMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["d"] = MiSuperMapper;

class MiSuperImageMapper {
    static convertModelToRequest(group) {
        var request = {
            token: group.token,
            id_usuario: group.userId,
            id_pasillo: group.code
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            id: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_imagen),
            url: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.url)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(MiSuperImageMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["c"] = MiSuperImageMapper;

class MiSuperGroupSectionMapper {
    static convertModelToRequest(group) {
        var request = {
            token: group.token,
            id_usuario: group.userId,
            id_pasillo: group.code
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(groupCode, response) {
        var model = {
            code: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_seccion),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            visible: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.visible),
            order: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.orden),
            reference: groupCode
        };
        if (!model.order)
            model.order = 1;
        return model;
    }
    static convertResponseListToModelList(groupCode, list) {
        let result = [];
        list.forEach(function (item) {
            result.push(MiSuperGroupSectionMapper.convertResponseToModel(groupCode, item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = MiSuperGroupSectionMapper;

class MiSuperGroupSectionProductsMapper {
    static convertModelToRequest(pageModel, groupCode, sectionCode) {
        var request = {
            token: pageModel.token,
            id_usuario: pageModel.userId,
            id_pasillo: groupCode,
            id_seccion: sectionCode,
            seccion: sectionCode,
            pagina: pageModel.pageId,
            registros: pageModel.pageRows
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = MiSuperGroupSectionProductsMapper;

//# sourceMappingURL=home-misuper.model.js.map

/***/ }),

/***/ 1147:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

///////////////////////////
class OfferGroupMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model ? model.token : null,
            id_usuario: model ? model.userId : null
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            code: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pasillopromo),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            visible: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.visible),
            order: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.orden)
        };
        model.imageShow = false;
        if (!model.order)
            model.order = 1;
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            let model = OfferGroupMapper.convertResponseToModel(item);
            if (model.name) {
                result.push(model);
            }
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = OfferGroupMapper;

class OfferGroupImageMapper {
    static convertModelToRequest(group) {
        var request = {
            token: group.token,
            id_usuario: group.userId,
            id_pasillo: group.code
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            id: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_imagen),
            url: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.url)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(OfferGroupImageMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = OfferGroupImageMapper;

///////////////////////////
class OfferGroupProductsMapper {
    static convertModelToRequest(pageModel, groupCode) {
        var request = {
            token: pageModel.token,
            id_usuario: pageModel.userId,
            id_pasillopromo: groupCode,
            pagina: pageModel.pageId,
            registros: pageModel.pageRows
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["c"] = OfferGroupProductsMapper;

//# sourceMappingURL=home-offer.model.js.map

/***/ }),

/***/ 1148:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class HomeSectionMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            sectionId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_seccion),
            sectionName: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.seccion),
            order: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.orden_mostrar),
            color: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.color),
            visible: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.visible),
            type: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo),
            template: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.plantilla),
            templateType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo_plantilla)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(HomeSectionMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = HomeSectionMapper;

//# sourceMappingURL=home-section.model.js.map

/***/ }),

/***/ 1149:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class HomeSectionProductsMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_seccion: model.sectionId,
            pagina: model.page,
            registros: model.records
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = HomeSectionProductsMapper;

//# sourceMappingURL=home-section-products.model.js.map

/***/ }),

/***/ 115:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WishListService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__ = __webpack_require__(1046);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_product_model__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__model_wishlist_detail_model__ = __webpack_require__(1047);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let WishListService = class WishListService {
    constructor(rest) {
        this.rest = rest;
    }
    // Agregar lista de deseos
    addWhishList(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_ADD_LIST_USER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertResponseToModel(item));
                    observer.complete();
                }
                else {
                    observer.next(null);
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    //Modificar lista de deseos
    modifyWhishList(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_MODIFY_LIST_USER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertResponseToModel(item));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    //Eliminar lista  de deseos
    deleteWhishList(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_DELETE_LIST_USER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertResponseToModel(item));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    //Agregar producto  a lista de deseos
    addWhishListProduct(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_6__model_wishlist_detail_model__["a" /* WishListDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_ADD_PRODUCT_LIST_USER, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_wishlist_detail_model__["a" /* WishListDetailMapper */].convertResponseToModel(response));
                observer.complete();
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    //Eliminar producto  de una lista de deseos
    deleteWhishListProduct(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_6__model_wishlist_detail_model__["a" /* WishListDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_DELETE_PRODUCT_LIST_USER, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertResponseToModel(response));
                observer.complete();
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    getWhishListProducts(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_PRODUCT_LIST_USER, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_product_model__["a" /* ProductMapper */].convertResponseListToProductsInWishListModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getWhishList(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_LIST_USER, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_wishlist_model__["a" /* WishListMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    deleteProductFromAllWishlist(wishLists, product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (wishLists && wishLists.length > 0) {
                let observables = [];
                for (var i = 0; i < wishLists.length; i++) {
                    var productToDelete = {};
                    productToDelete.userId = product.userId;
                    productToDelete.token = product.token;
                    productToDelete.productCode = product.productCode;
                    productToDelete.wishListId = wishLists[i].wishListId;
                    observables.push(this.deleteWhishListProduct(productToDelete));
                }
                if (observables.length > 0) {
                    __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].forkJoin(observables).subscribe(data => {
                        if (data && data.length > 0) {
                            for (var i = 0; i < data.length; i++) {
                                if (i + 1 === wishLists.length) {
                                    observer.next();
                                    observer.complete();
                                }
                            }
                        }
                        else {
                            observer.next();
                            observer.complete();
                        }
                    }, error => {
                        observer.next();
                        observer.complete();
                    });
                }
                else {
                    observer.next();
                    observer.complete();
                }
            }
            else {
                observer.next();
                observer.complete();
            }
        });
    }
};
WishListService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], WishListService);

//# sourceMappingURL=wish-list-service.js.map

/***/ }),

/***/ 1150:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class NotificationMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            fecinicio: model.startDate,
            fecfin: model.finishDate,
            tipo: model.type,
            id_notificacion: model.uniqueId,
            id_oferta: model.uniqueId,
            leida: model.read,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static isJson(mensaje) {
        try {
            JSON.parse(mensaje);
        }
        catch (e) {
            return false;
        }
        return true;
    }
    static convertResponseToModel(response) {
        let Mensaje;
        let Titulo;
        if (this.isJson(response.mensaje)) {
            Mensaje = JSON.parse(response.mensaje);
        }
        else {
            Mensaje = response.mensaje;
        }
        if (this.isJson(response.titulo)) {
            Titulo = JSON.parse(response.titulo);
        }
        else {
            Titulo = response.titulo;
        }
        var model = {
            date: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fecha),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(Mensaje),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            multimedia: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            estate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            type: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo),
            uniqueId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_notificacion),
            read: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.leida),
            titulo: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(Titulo)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(NotificationMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = NotificationMapper;

//# sourceMappingURL=notifications.model.js.map

/***/ }),

/***/ 1151:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_product_utils__ = __webpack_require__(89);


class OfferProductsMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token,
            id_oferta: model.offerId,
            id_usuario: model.userId,
            pagina: model.pageId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var product = {
            article: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            price: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio),
            discountPercentage: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuento),
            isPromo: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.espromo),
            isInWishList: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.deseo),
            promoExpiration: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.finalizapromo),
            availableUnits: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantidad),
        };
        //Realiza calculos del producto, como descuentos, impuestos, etc.
        __WEBPACK_IMPORTED_MODULE_1__util_product_utils__["a" /* ProductUtils */].handleDefaults(product);
        return product;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(OfferProductsMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = OfferProductsMapper;

//# sourceMappingURL=offer-detail.model.js.map

/***/ }),

/***/ 1153:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class NotificationSettingsMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            notificacionespn: model.notificacionespn,
            notificacionespd: model.notificacionespd,
            notificacionespp: model.notificacionespp,
            notificacionespyp: model.notificacionespyp,
            configuracion: model.configuration
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            notificacionespn: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.notificacionespn),
            notificacionespd: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.notificacionespd),
            notificacionespp: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.notificacionespp),
            notificacionespyp: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.notificacionespyp),
            configuration: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.configuracion),
            state: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(NotificationSettingsMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = NotificationSettingsMapper;

//# sourceMappingURL=notification-settings.model.js.map

/***/ }),

/***/ 1154:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class NotificationTypeMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            typeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_tiponotificacion),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(NotificationTypeMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = NotificationTypeMapper;

//# sourceMappingURL=notifications-TYPE.model.js.map

/***/ }),

/***/ 1155:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class CardMapper {
    static convertModelToRequest(session, model) {
        var request = {
            id_usuario: session.userId,
            token: session.token,
            id_tarjeta: model ? model.cardId : null,
            numerotarjeta: model ? model.cardNumber : null,
            fechaexpira: model ? model.expirationDate : null,
            nombretarjeta: model ? model.cardName : null,
            codigocvv: model ? model.ccvCode : null,
            emisortarjeta: model ? model.issuer : null,
            tarjetapredeterminada: model ? model.default : null,
            tokenTarjeta: model ? model.cardToken : null,
            BIN: model ? model.bin : null,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            cardId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_tarjeta),
            cardNumber: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.numerotarjeta),
            expirationDate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechaexpira),
            cardName: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombretarjeta),
            ccvCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codigocvv),
            issuer: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.emisortarjeta),
            default: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tarjetapredeterminada),
            cardToken: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tokentarjeta),
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(CardMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = CardMapper;

//# sourceMappingURL=card.model.js.map

/***/ }),

/***/ 1156:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class RegistrationMapper {
    static convertModelToRequest(model) {
        var request = {
            correo: model.email,
            password: model.password,
            nombre: model.name,
            primerapellido: model.firstSurname,
            segundoapellido: model.secondSurname,
            genero: model.gender,
            fechanac: model.birthDate,
            telefono: model.phone,
            metodoacceso: model.accessMethod,
            usuario_rs: model.socialNetworkUserId,
            tipoimagen: model.pictureType,
            imagen: model.picture,
            pais: model.country,
            modelo: model.model,
            plataforma: model.platform,
            moneda: model.currency,
            huella: model.fingerPrintValidation,
            envianotificaciones: model.pushNotifications,
            uuid: model.uuid,
            tipo_identificacion: model.identificationType,
            identificacion: model.identification,
            token_aid: model.appleToken,
            token_dispositivo: model.deviceToken
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            userId: response.id_usuario,
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje)
        };
    }
}
/* harmony export (immutable) */ __webpack_exports__["c"] = RegistrationMapper;

class AuthMapper {
    static convertModelToRequest(model) {
        var request = {
            metodoacceso: model.accessMethod,
            correo: model.email,
            password: model.password,
            usuario_rs: model.socialNetworkUserId,
            pais: model.country,
            modelo: model.model,
            plataforma: model.platform,
            moneda: model.currency,
            uuid: model.uuid
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            userId: response.id_usuario,
            token: response.token,
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            firstSurname: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.primerapellido),
            secondSurname: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.segundoapellido),
            pictureType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipoimagen),
            picture: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            country: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pais),
            currency: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.moneda),
            forcePasswordChange: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cambiapassword),
            forceSessionClose: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cerrarsesion),
            appleToken: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.token_AID)
        };
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = AuthMapper;

class PassChangeMapper {
    static convertModelToRequest(model) {
        var request = {
            correo: model.email,
            password: model.password
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertSendEmailModelToRequest(model) {
        var request = {
            token: model.token,
            id_usuario: model.userId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje)
        };
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = PassChangeMapper;

class UserMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertSearchIdModelToRequest(userId, token, identification) {
        var request = {
            id_usuario: userId,
            token: token,
            identificacion: identification
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            email: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.correo),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            firstSurname: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.primerapellido),
            secondSurname: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.segundoapellido),
            gender: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.genero),
            birthDate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechanac),
            phone: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.telefono),
            accessMethod: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.metodoacceso),
            socialNetworkUserId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.usuario_rs),
            pictureType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipoimagen),
            picture: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            country: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pais),
            currency: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.moneda),
            fingerPrintValidation: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.huella),
            pushNotifications: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.envianotificaciones),
            paymentMethod: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.metodopago),
            paypalCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.idpaypal),
            forceLogout: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.forzar_login),
            identification: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.identificacion),
            identificationType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo_identificacion),
            appleToken: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.token_aid),
            deviceToken: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.token_dispositivo),
            feFullName: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre_factura),
            feIdentification: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cedula_factura),
            feIdentificationType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo_id_factura),
            feEmail: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.correo_factura)
        };
    }
}
/* harmony export (immutable) */ __webpack_exports__["d"] = UserMapper;

class UserModifyMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            correo: model.email,
            nombre: model.name,
            primerapellido: model.firstSurname,
            segundoapellido: model.secondSurname,
            genero: model.gender,
            fechanac: model.birthDate,
            telefono: model.phone,
            tipoimagen: model.pictureType,
            //imagen: model.picture,
            pais: model.country,
            huella: model.fingerPrintValidation,
            envianotificaciones: model.pushNotifications,
            metodopago: model.paymentMethod,
            idpaypal: model.paypalCode,
            identificacion: model.identification,
            tipo_identificacion: model.identificationType,
            token_aid: model.appleToken,
            token_dispositivo: model.deviceToken,
            nombre_factura: model.feFullName,
            tipo_id_factura: model.feIdentificationType,
            cedula_factura: model.feIdentification,
            correo_factura: model.feEmail
        };
        return request;
    }
    static convertImageModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            imagen: model.picture
        };
        return request;
    }
    static convertResponseToModel(response) {
        return {
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            email: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.correo),
            name: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre),
            firstSurname: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.primerapellido),
            secondSurname: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.segundoapellido),
            gender: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.genero),
            birthDate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechanac),
            phone: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.telefono),
            pictureType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipoimagen),
            picture: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            fingerPrintValidation: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.huella),
            pushNotifications: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.envianotificaciones),
            paymentMethod: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.metodopago),
            paypalCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.idpaypal),
            identification: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.identificacion),
            identificationType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo_identificacion),
            appleToken: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.token_aid),
            deviceToken: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.token_dispositivo),
            feFullName: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombre_factura),
            feIdentification: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cedula_factura),
            feIdentificationType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo_id_factura),
            feEmail: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.correo_factura)
        };
    }
}
/* harmony export (immutable) */ __webpack_exports__["e"] = UserModifyMapper;

class UserinactivationMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje)
        };
    }
}
/* harmony export (immutable) */ __webpack_exports__["f"] = UserinactivationMapper;

class ValidateAccountMapper {
    static convertModelToRequest(model) {
        var request = {
            correo: model.email
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return response;
    }
}
/* harmony export (immutable) */ __webpack_exports__["g"] = ValidateAccountMapper;

//# sourceMappingURL=user.model.js.map

/***/ }),

/***/ 1157:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class UserNavigationMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            pagina: model.page,
            articulo: model.article,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            state: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(UserNavigationMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = UserNavigationMapper;

//# sourceMappingURL=user-navigation.model.js.map

/***/ }),

/***/ 1158:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class CloseSessionMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(CloseSessionMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = CloseSessionMapper;

class SessionStatusMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(CloseSessionMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = SessionStatusMapper;

//# sourceMappingURL=close-session.model.js.map

/***/ }),

/***/ 1159:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class SinpeMapper {
    static convertModelToRequest(model) {
        var request = {
            idClienteOrigen: model.idClienteOrigen,
            moneda: model.moneda,
            monto: model.monto,
            idCaja: model.idCaja,
            idCajero: model.idCajero,
            codigoInterno: model.codigoInterno,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            codRespuesta: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codRespuesta),
            descripcionTransaccion: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcionTransaccion),
            pagosLista: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pagosLista),
            numTelefonoDestino: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.numTelefonoDestino),
            numTelefonoOrigen: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.numTelefonoOrigen),
            moneda: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.moneda),
            monto: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.monto),
            idClienteOrigen: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.idClienteOrigen),
            nombreCliente: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.nombreCliente),
            codReferencia: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codReferencia),
            codReferenciaBanco: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codReferenciaBanco),
            descripcionSinpe: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcionSinpe),
            fechaRecibido: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechaRecibido),
            idCaja: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_caja),
            idCajero: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_usuario),
            username: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.usuario),
            password: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.usr_contrasena),
            telefonoSinpe: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.telefono),
            token: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.token),
            refreshToken: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.refreshToken),
            expiresIn: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.expiresIn),
            estado: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            toleranciaMas: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tolerancia_mas),
            toleranciaMenos: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tolerancia_menos),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(SinpeMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = SinpeMapper;

//# sourceMappingURL=sinpe.model.js.map

/***/ }),

/***/ 116:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GreenPayConfigService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




let GreenPayConfigService = class GreenPayConfigService {
    constructor(//private errHandler: ErrorService,
        rest) {
        this.rest = rest;
    }
    getConfig() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_GREENPAY_CONFIG).subscribe((response) => {
                //TODO COMENTAR ESTAS LINEAS QUE SON DE PRUEBAS
                //////////////////////////////////////////////
                /// PRUEBAS
                //////////////////////////////////////////////
                /*response.merchantid = "a4f5b5ce-41bc-440e-847f-e08834d65ce7";
                response.terminalid = "Estilos-BNCR-Colones";
                response.publickey = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDCVALboLaezmJZ2n9hQs2lUSTu"+
                  "cDgnedVffMqcPK1cOwEfFZ9WF/TqCX8Z1Mv2xSZsG7dJYOb2AtK82+Y3lnaH69lq"+
                  "q85L2adJLWhARsD6IV7u0UJfCZelP9x8fPFsC2+3w6RSkTKlnhNqtkYvWcqo2pGB"+
                  "Fzh0HaqdV77sjwOxowIDAQAB";
                  response.secretid = "MTZDMjVBODVBNUREODBGRjE3OTI1NjEzNDZDMEQ5ODgyNzlCN0ZEMDI5RkJDNkFENDMyRjJENEFDOEFFMzAzQzYzNkYyNjRDQUZERTI3OUFGNkQ3NjAzRTA3MENCNEJEMDZGODlGRUQzNzNGQzZGNEU3NjAxRjVDQ0EwRDREQTI=";
                  */
                //SANDBOX FUNCIONAL, EL ANTERIOR NO SE UTILIZA
                /*response.merchantid = "3a90fe99-351e-4ad6-8dfe-40322d38f228";
                response.terminalid = "EFAST-c67c-BNCR-CRC";
                response.publickey = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC4hN7Zt0DebdByuXAddISCwlFm"+
                "tOMf+mLPjeV//fhRCg9p89n7aa77WDLKbLWIdQp/fUZ118vCNKEGr15UE1EohrC/"+
                "VsOy5I5rAEhvN6Zofok6T8gWWalH3ENo1ECF3Tdq4+KRHP2L1GGj42Joxy6n22GR"+
                "KG/AY+9MYX/ZfVh9sQIDAQAB";
                  response.secretid = "QUJBQUZGQzdFOEY5RTM0NTRDNzZCMTQyQjc3MEMzNTU5NDIwRkQxNjBBQzBCOUEzNDhERkJGMzY3N0Y4QjA0NjUzNkUwMkFBNTlGOUE4RkIxOUVBQkREN0NFMkZGMkU4NEUyODQ4N0NEMUUwQ0MyQjdDMTUxRjU2NkE5QjUzMzk=";*/
                //////////////////////////////////////////////
                observer.next(response);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
GreenPayConfigService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], GreenPayConfigService);

//# sourceMappingURL=greenpay-config-service.js.map

/***/ }),

/***/ 1160:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class SubsidiaryMapper {
    static convertModelToRequest(session, province, canton) {
        var request = {
            id_usuario: session.userId,
            token: session.token,
            provincia: province,
            canton: canton
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            province: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.provincia),
            canton: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.canton),
            district: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.distrito),
            code: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codigo),
            subsidiary: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.sucursal),
            address: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.direccion),
            phone: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.telefono),
            schedule: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.horario)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(SubsidiaryMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = SubsidiaryMapper;

//# sourceMappingURL=subsidiary.model.js.map

/***/ }),

/***/ 1161:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_date_utils__ = __webpack_require__(690);



class FreightMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_ordencompra: model.orderId,
            id_direccion: model.addressId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            freightId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_flete),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            paymentMethod: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.metodopago),
            amount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.monto),
            tax: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto),
            currency: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.moneda),
            deliveryCompany: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.envia),
            deliveryDays: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.entrega),
            deliveryNaturalDays: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechaentrega),
            deliverySubsidiary: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.sucursal),
            habilDays: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.diasHabiles),
            labelDays: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.etiquetaDias)
        };
        model.amountWithNoTax = (model.amount - model.tax);
        if (model.currency === "CRC") {
            model.currencySymbol = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].app.currencyCRCSymbol;
        }
        else if (model.currency === "USD") {
            model.currencySymbol = __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].app.currencyUSDSymbol;
        }
        //Calcula fecha de entrega basado en los dias naturales
        var dt = new Date();
        if (model.deliveryNaturalDays > 0) {
            dt.setDate(dt.getDate() + model.deliveryNaturalDays);
            model.deliveryDate = dt.getTime();
            model.deliveryDateLabel = __WEBPACK_IMPORTED_MODULE_2__util_date_utils__["a" /* DateUtils */].getLongDateFormat(dt);
        }
        else {
            //var dt = new Date();
            model.deliveryDate = dt.getTime();
            model.deliveryDateLabel = __WEBPACK_IMPORTED_MODULE_2__util_date_utils__["a" /* DateUtils */].getLongDateFormat(dt);
        }
        model.total = model.tax + model.amount;
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(FreightMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = FreightMapper;

//# sourceMappingURL=freight.model.js.map

/***/ }),

/***/ 1162:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./af": 491,
	"./af.js": 491,
	"./ar": 492,
	"./ar-dz": 493,
	"./ar-dz.js": 493,
	"./ar-kw": 494,
	"./ar-kw.js": 494,
	"./ar-ly": 495,
	"./ar-ly.js": 495,
	"./ar-ma": 496,
	"./ar-ma.js": 496,
	"./ar-sa": 497,
	"./ar-sa.js": 497,
	"./ar-tn": 498,
	"./ar-tn.js": 498,
	"./ar.js": 492,
	"./az": 499,
	"./az.js": 499,
	"./be": 500,
	"./be.js": 500,
	"./bg": 501,
	"./bg.js": 501,
	"./bm": 502,
	"./bm.js": 502,
	"./bn": 503,
	"./bn.js": 503,
	"./bo": 504,
	"./bo.js": 504,
	"./br": 505,
	"./br.js": 505,
	"./bs": 506,
	"./bs.js": 506,
	"./ca": 507,
	"./ca.js": 507,
	"./cs": 508,
	"./cs.js": 508,
	"./cv": 509,
	"./cv.js": 509,
	"./cy": 510,
	"./cy.js": 510,
	"./da": 511,
	"./da.js": 511,
	"./de": 512,
	"./de-at": 513,
	"./de-at.js": 513,
	"./de-ch": 514,
	"./de-ch.js": 514,
	"./de.js": 512,
	"./dv": 515,
	"./dv.js": 515,
	"./el": 516,
	"./el.js": 516,
	"./en-au": 517,
	"./en-au.js": 517,
	"./en-ca": 518,
	"./en-ca.js": 518,
	"./en-gb": 519,
	"./en-gb.js": 519,
	"./en-ie": 520,
	"./en-ie.js": 520,
	"./en-il": 521,
	"./en-il.js": 521,
	"./en-nz": 522,
	"./en-nz.js": 522,
	"./eo": 523,
	"./eo.js": 523,
	"./es": 524,
	"./es-do": 525,
	"./es-do.js": 525,
	"./es-us": 526,
	"./es-us.js": 526,
	"./es.js": 524,
	"./et": 527,
	"./et.js": 527,
	"./eu": 528,
	"./eu.js": 528,
	"./fa": 529,
	"./fa.js": 529,
	"./fi": 530,
	"./fi.js": 530,
	"./fo": 531,
	"./fo.js": 531,
	"./fr": 532,
	"./fr-ca": 533,
	"./fr-ca.js": 533,
	"./fr-ch": 534,
	"./fr-ch.js": 534,
	"./fr.js": 532,
	"./fy": 535,
	"./fy.js": 535,
	"./gd": 536,
	"./gd.js": 536,
	"./gl": 537,
	"./gl.js": 537,
	"./gom-latn": 538,
	"./gom-latn.js": 538,
	"./gu": 539,
	"./gu.js": 539,
	"./he": 540,
	"./he.js": 540,
	"./hi": 541,
	"./hi.js": 541,
	"./hr": 542,
	"./hr.js": 542,
	"./hu": 543,
	"./hu.js": 543,
	"./hy-am": 544,
	"./hy-am.js": 544,
	"./id": 545,
	"./id.js": 545,
	"./is": 546,
	"./is.js": 546,
	"./it": 547,
	"./it.js": 547,
	"./ja": 548,
	"./ja.js": 548,
	"./jv": 549,
	"./jv.js": 549,
	"./ka": 550,
	"./ka.js": 550,
	"./kk": 551,
	"./kk.js": 551,
	"./km": 552,
	"./km.js": 552,
	"./kn": 553,
	"./kn.js": 553,
	"./ko": 554,
	"./ko.js": 554,
	"./ky": 555,
	"./ky.js": 555,
	"./lb": 556,
	"./lb.js": 556,
	"./lo": 557,
	"./lo.js": 557,
	"./lt": 558,
	"./lt.js": 558,
	"./lv": 559,
	"./lv.js": 559,
	"./me": 560,
	"./me.js": 560,
	"./mi": 561,
	"./mi.js": 561,
	"./mk": 562,
	"./mk.js": 562,
	"./ml": 563,
	"./ml.js": 563,
	"./mn": 564,
	"./mn.js": 564,
	"./mr": 565,
	"./mr.js": 565,
	"./ms": 566,
	"./ms-my": 567,
	"./ms-my.js": 567,
	"./ms.js": 566,
	"./mt": 568,
	"./mt.js": 568,
	"./my": 569,
	"./my.js": 569,
	"./nb": 570,
	"./nb.js": 570,
	"./ne": 571,
	"./ne.js": 571,
	"./nl": 572,
	"./nl-be": 573,
	"./nl-be.js": 573,
	"./nl.js": 572,
	"./nn": 574,
	"./nn.js": 574,
	"./pa-in": 575,
	"./pa-in.js": 575,
	"./pl": 576,
	"./pl.js": 576,
	"./pt": 577,
	"./pt-br": 578,
	"./pt-br.js": 578,
	"./pt.js": 577,
	"./ro": 579,
	"./ro.js": 579,
	"./ru": 580,
	"./ru.js": 580,
	"./sd": 581,
	"./sd.js": 581,
	"./se": 582,
	"./se.js": 582,
	"./si": 583,
	"./si.js": 583,
	"./sk": 584,
	"./sk.js": 584,
	"./sl": 585,
	"./sl.js": 585,
	"./sq": 586,
	"./sq.js": 586,
	"./sr": 587,
	"./sr-cyrl": 588,
	"./sr-cyrl.js": 588,
	"./sr.js": 587,
	"./ss": 589,
	"./ss.js": 589,
	"./sv": 590,
	"./sv.js": 590,
	"./sw": 591,
	"./sw.js": 591,
	"./ta": 592,
	"./ta.js": 592,
	"./te": 593,
	"./te.js": 593,
	"./tet": 594,
	"./tet.js": 594,
	"./tg": 595,
	"./tg.js": 595,
	"./th": 596,
	"./th.js": 596,
	"./tl-ph": 597,
	"./tl-ph.js": 597,
	"./tlh": 598,
	"./tlh.js": 598,
	"./tr": 599,
	"./tr.js": 599,
	"./tzl": 600,
	"./tzl.js": 600,
	"./tzm": 601,
	"./tzm-latn": 602,
	"./tzm-latn.js": 602,
	"./tzm.js": 601,
	"./ug-cn": 603,
	"./ug-cn.js": 603,
	"./uk": 604,
	"./uk.js": 604,
	"./ur": 605,
	"./ur.js": 605,
	"./uz": 606,
	"./uz-latn": 607,
	"./uz-latn.js": 607,
	"./uz.js": 606,
	"./vi": 608,
	"./vi.js": 608,
	"./x-pseudo": 609,
	"./x-pseudo.js": 609,
	"./yo": 610,
	"./yo.js": 610,
	"./zh-cn": 611,
	"./zh-cn.js": 611,
	"./zh-hk": 612,
	"./zh-hk.js": 612,
	"./zh-tw": 613,
	"./zh-tw.js": 613
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 1162;

/***/ }),

/***/ 1169:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ShippingAddressMapper {
    //Convertir un Model de la app SecurityUserQuestion al mensaje de entrada que espera el WS
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            id_direccion: model.directionId,
            token: model.token,
            pais: model.country,
            provincia: model.province,
            canton: model.canton,
            distrito: model.district,
            barrio: model.ward,
            direccion: model.direction,
            codigopostal: model.postCode,
            telefono: model.phone,
            predeterminada: model.default,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            directionId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_direccion),
            country: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pais),
            province: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.provincia),
            canton: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.canton),
            district: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.distrito),
            ward: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.barrio),
            direction: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.direccion),
            postCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codigopostal),
            phone: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.telefono),
            default: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.predeterminada),
            state: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(ShippingAddressMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ShippingAddressMapper;

//# sourceMappingURL=address.model.js.map

/***/ }),

/***/ 117:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductCategoryService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_product_category_model__ = __webpack_require__(1142);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_product_category_user_model__ = __webpack_require__(1143);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__model_product_category_family_model__ = __webpack_require__(1144);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__model_product_category_subfamily_model__ = __webpack_require__(1145);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








let ProductCategoryService = class ProductCategoryService {
    constructor(rest) {
        this.rest = rest;
    }
    /**
     * Consulta las categorias de productos
     */
    getCategories(session) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_product_category_model__["a" /* ProductCategoryMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PRODUCT_CATEGORIES, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_product_category_model__["a" /* ProductCategoryMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta las categorias de productos preferidas del cliente
     */
    getUserCategories(session) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_product_category_user_model__["a" /* ProductUserCategoryMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PRODUCT_USER_CATEGORIES, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_product_category_user_model__["a" /* ProductUserCategoryMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Agrega una categoria preferida del cliente
     */
    addUserCategory(session, category) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_product_category_user_model__["a" /* ProductUserCategoryMapper */].convertModelToRequest(session, category);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PRODUCT_USER_ADD_CATEGORY, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_product_category_user_model__["a" /* ProductUserCategoryMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Eliminar una categoria preferida del cliente
     */
    removeUserCategory(session, category) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_product_category_user_model__["a" /* ProductUserCategoryMapper */].convertModelToRequest(session, category);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PRODUCT_USER_REMOVE_CATEGORY, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_product_category_user_model__["a" /* ProductUserCategoryMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta las familias
     */
    getFamilies(session, categoryCode) {
        var params = {};
        params.token = session.token;
        params.categoryCode = categoryCode;
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_category_family_model__["a" /* ProductCategoryFamilyMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SEARCH_FAMILIES, paramsString).subscribe((response) => {
                if (response) {
                    let list = __WEBPACK_IMPORTED_MODULE_6__model_product_category_family_model__["a" /* ProductCategoryFamilyMapper */].convertResponseListToModelList(response, categoryCode);
                    let actualList = [];
                    for (var i = 0; i < list.length; i++) {
                        if (list[i].visible === "S") {
                            actualList.push(list[i]);
                        }
                    }
                    observer.next(actualList);
                    observer.complete();
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
   * Consulta las subfamilias
   */
    getSubFamilies(session, categoryCode, familyCode) {
        var params = {};
        params.token = session.token;
        params.categoryCode = categoryCode;
        params.familyCode = familyCode;
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_7__model_product_category_subfamily_model__["a" /* ProductCategorySubFamilyMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SEARCH_SUBFAMILIES, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_7__model_product_category_subfamily_model__["a" /* ProductCategorySubFamilyMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
ProductCategoryService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__util_rest_client__["a" /* RESTClient */]])
], ProductCategoryService);

//# sourceMappingURL=product-category-service.js.map

/***/ }),

/***/ 1173:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class InviteFriendMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.user_Id,
            token: model.token,
            nombre: model.name,
            correo: model.mail
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        return {
            status: response.estado,
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(InviteFriendMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = InviteFriendMapper;

//# sourceMappingURL=invite-friend.model.js.map

/***/ }),

/***/ 1174:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class TermConditionMapper {
    static convertModelToRequest(session) {
        var request = {
            id_usuario: session.userId,
            token: session.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            information: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.detalle)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(TermConditionMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = TermConditionMapper;

//# sourceMappingURL=term-condition.model.js.map

/***/ }),

/***/ 1175:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

//Convertidor de clases del webservice
class SecurityQuestionMapper {
    static mapResponse(o) {
        return {
            id: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(o.id_pregunta),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(o.descripcion)
        };
    }
    static mapResponseList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(SecurityQuestionMapper.mapResponse(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = SecurityQuestionMapper;

//# sourceMappingURL=security-question.model.js.map

/***/ }),

/***/ 1176:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

//Convertidor de clases del webservice
class SecurityUserQuestionMapper {
    static convertModelToRequest(o) {
        var request = {
            id_usuario: o.userId,
            token: o.token,
            id_pregunta: o.questionId,
            respuesta: o.answer
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(o) {
        return {
            questionId: o.id_pregunta,
            answer: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(o.respuesta)
        };
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(SecurityUserQuestionMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = SecurityUserQuestionMapper;

//# sourceMappingURL=security-question-user.model.js.map

/***/ }),

/***/ 1177:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class FAQMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_pregunta: model.faqId,
            pagina: model.page,
            registros: model.registry,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            faqId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pregunta),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pregunta),
            information: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.informacion),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(FAQMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = FAQMapper;

//# sourceMappingURL=faqs.model.js.map

/***/ }),

/***/ 1178:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class RefundMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_tema: model.subjectId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            subjectId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_tema),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
        };
        if (!model.description) {
            model.description = __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.detalle);
        }
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(RefundMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = RefundMapper;

class RefundReasonMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            reasonId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_motivo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(RefundReasonMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["c"] = RefundReasonMapper;

class RefundOrderMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_ordencompra: model.orderId,
            articulo: model.productCode,
            id_motivo: model.reasonId,
            comentario: model.comments,
            fecha: model.date,
            cantidad: model.quantity,
            fecini: model.startDate,
            fecfin: model.finishDate,
            id_devolucion: model.refundId,
            imagen: model.image
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertModelToPostRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            id_devolucion: model.refundId,
            imagen: model.image
        };
        return request;
    }
    static convertResponseToModel(response) {
        var model = {
            refundId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_devolucion),
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            orderId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_ordencompra),
            productCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            date: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fecha),
            reasonId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_motivo),
            comments: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.comentario),
            quantity: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantidad),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(RefundOrderMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = RefundOrderMapper;

//# sourceMappingURL=refund.model.js.map

/***/ }),

/***/ 1179:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class TopicMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            pagina: model.page,
            registros: model.registry,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            topicId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_topico),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(TopicMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = TopicMapper;

//# sourceMappingURL=topic.model.js.map

/***/ }),

/***/ 118:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeCategoryTemplateService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__ = __webpack_require__(790);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let HomeCategoryTemplateService = class HomeCategoryTemplateService {
    constructor(//private sessionManager: SessionManagerService,
        //private categoryService: ProductCategoryService,
        rest) {
        this.rest = rest;
    }
    getSectionGroups(sectionId, user) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["b" /* HomeSectionGroupsMapper */].convertModelToRequest(sectionId, user ? user.token : null, user ? user.userId : null);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_1__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_SECTION_GROUPS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["b" /* HomeSectionGroupsMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getSectionsByGroup(groupId, user) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["c" /* HomeSectionsByGroupMapper */].convertModelToRequest(groupId, user ? user.token : null, user ? user.userId : null);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_1__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_SECTIONS_BY_GROUP, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["c" /* HomeSectionsByGroupMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getFeaturedProducts(groupId, sectionId, user) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["a" /* HomeProductsByGroupAndSectionMapper */].convertModelToRequest(groupId, sectionId, user ? user.token : null, user ? user.userId : null, 1, 2);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_1__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_FEATURED_PRODUCTS_SECTION, paramsString).subscribe((response) => {
                if (response) {
                    let sectionGroup = {
                        groupId: groupId,
                        featureProducts: __WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["a" /* HomeProductsByGroupAndSectionMapper */].convertResponseListToModelList(response)
                    };
                    observer.next(sectionGroup);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getProductsByPage(groupId, sectionId, user, page, size) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["a" /* HomeProductsByGroupAndSectionMapper */].convertModelToRequest(groupId, sectionId, user ? user.token : null, user ? user.userId : null, page, size);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_1__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_FEATURED_PRODUCTS_BY_GROUP, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_home_section_group_model__["a" /* HomeProductsByGroupAndSectionMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
HomeCategoryTemplateService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__util_rest_client__["a" /* RESTClient */]])
], HomeCategoryTemplateService);

//# sourceMappingURL=home-category-template-service.js.map

/***/ }),

/***/ 1201:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MyApp; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_status_bar__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_splash_screen__ = __webpack_require__(663);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_ionic_image_loader__ = __webpack_require__(269);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__config_startup__ = __webpack_require__(666);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_security_providers_user_service__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__modules_orders_providers_cart_manager_service__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__modules_security_providers_login_service__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_security_pages_offline_offline__ = __webpack_require__(267);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ionic_native_screen_orientation__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__modules_security_pages_startup_startup__ = __webpack_require__(268);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__ionic_native_mobile_accessibility__ = __webpack_require__(674);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__ionic_native_in_app_browser__ = __webpack_require__(277);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__modules_support_providers_version_service__ = __webpack_require__(279);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__ionic_native_facebook__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__ionic_native_google_analytics__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__modules_security_pages_version_check_version_check__ = __webpack_require__(675);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__modules_notifications_providers_notifications_service__ = __webpack_require__(158);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__ionic_native_push__ = __webpack_require__(676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__modules_datasets_product_history_dataset__ = __webpack_require__(288);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__modules_support_providers_apprate_service__ = __webpack_require__(677);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__modules_session_session_service__ = __webpack_require__(184);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__awesome_cordova_plugins_app_rate_ngx__ = __webpack_require__(678);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__modules_support_providers_param_service__ = __webpack_require__(240);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__ionic_native_in_app_review_ngx__ = __webpack_require__(679);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};






























let MyApp = class MyApp {
    constructor(platform, inAppReview, statusBar, paramService, appRateService, appRates, sessionService, splashScreen, events, sessionManager, startup, translate, userService, imageloaderConfig, cartManager, alertCtrl, loginService, screenOrientation, accesibility, theInAppBrowser, 
        //private network: Network,
        toastCtrl, versionService, ga, facebook, notificationService, push, historyDataSet) {
        this.platform = platform;
        this.inAppReview = inAppReview;
        this.statusBar = statusBar;
        this.paramService = paramService;
        this.appRateService = appRateService;
        this.appRates = appRates;
        this.sessionService = sessionService;
        this.splashScreen = splashScreen;
        this.events = events;
        this.sessionManager = sessionManager;
        this.startup = startup;
        this.translate = translate;
        this.userService = userService;
        this.imageloaderConfig = imageloaderConfig;
        this.cartManager = cartManager;
        this.alertCtrl = alertCtrl;
        this.loginService = loginService;
        this.screenOrientation = screenOrientation;
        this.accesibility = accesibility;
        this.theInAppBrowser = theInAppBrowser;
        this.toastCtrl = toastCtrl;
        this.versionService = versionService;
        this.ga = ga;
        this.facebook = facebook;
        this.notificationService = notificationService;
        this.push = push;
        this.historyDataSet = historyDataSet;
        this.user = {};
        this.authenticated = false;
        this.flexHome = false;
        this.scrollPerformed = false;
        // GDataCollector = require("GDataCollector.js");
        //GDataCollectort = require("GDataCollector-js-ts").GDataCollector;
        this.totalNotificationsUnread = 0;
        //Para evitar duplicar mensajes de descarga de aplicacion
        this.versionChecked = false;
        this.isUpdateMessageVisible = false;
        this.initializeApp();
    }
    enviarEvento(Evento) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield ga4CrearEvento(Evento);
        });
    }
    initializeApp() {
        this.initTranslator();
        this.platform.ready().then(() => {
            this.initAnalytics();
            setTimeout(() => {
                this.permiso();
            }, 2000);
            let supportedVersion = true;
            //ANDROID PLATFORM
            if (!this.platform.is("ios")) {
                //Mantiene el zoom de la app
                this.accesibility.getTextZoom().then((value) => {
                    if (value > 100) {
                        this.accesibility.setTextZoom(90);
                    }
                    //this.accesibility.usePreferredTextZoom(false);
                });
                //IOS PLATFORM
            }
            else {
                let platformVersion = this.platform.versions();
                if (platformVersion.ios) {
                    supportedVersion = platformVersion.ios.num >= 12.2;
                }
            }
            //this.accesibility.usePreferredTextZoom(false);
            //La orientacion para los listados debe ser portrait
            this.screenOrientation.lock(this.screenOrientation.ORIENTATIONS.PORTRAIT);
            //this.statusBar.styleBlackTranslucent();//descomentar
            //Configuraciones globales de componentes
            this.startup.onStart();
            //this.listenConnection();
            this.initImageLoader();
            this.initEvents();
            this.pushSetup();
            this.statusBar.backgroundColorByHexString("#2471a3");
            //Si no tiene conexion, salida a pantalla emergente
            if (!navigator.onLine) {
                this.rootPage = __WEBPACK_IMPORTED_MODULE_12__modules_security_pages_offline_offline__["a" /* OfflinePage */];
                setTimeout(() => {
                    this.splashScreen.hide();
                }, 1000);
            }
            else {
                //Muestra el view del spinner
                this.rootPage = supportedVersion ? __WEBPACK_IMPORTED_MODULE_14__modules_security_pages_startup_startup__["a" /* StartupPage */] : __WEBPACK_IMPORTED_MODULE_21__modules_security_pages_version_check_version_check__["a" /* VersionCheckPage */];
                setTimeout(() => {
                    this.splashScreen.hide();
                    //Inicializa todo lo requerido a nivel de data para que la app funcione. Requerido que este online
                    this.initConnectivityServices(false);
                }, 1000);
            }
            //this.getShareUrl();
        });
    }
    prueba(test) {
        console.log("RECIBIDO DE FORNT" + test);
    }
    initImageLoader() {
        //this.imageloaderConfig.enableDebugMode();
        this.imageloaderConfig.enableSpinner(false);
        this.imageloaderConfig.setHeight(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderHeight);
        this.imageloaderConfig.setWidth(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderWidth);
        this.imageloaderConfig.setDisplay(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderDisplay);
        this.imageloaderConfig.useImageTag(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderUseImageTag);
        this.imageloaderConfig.setBackgroundSize(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderBackgroundSize);
        this.imageloaderConfig.setBackgroundRepeat(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderBackgroundRepeat);
        this.imageloaderConfig.setFallbackUrl(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderFallbackUrl);
        this.imageloaderConfig.setConcurrency(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderConcurrency);
        this.imageloaderConfig.setMaximumCacheSize(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderMaximumCacheSize);
        this.imageloaderConfig.setMaximumCacheAge(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderMaximumCacheAge);
        //this.imageloaderConfig.setImageReturnType("base64");
        this.imageloaderConfig.enableFallbackAsPlaceholder(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.imageLoaderEnableFallbackAsPlaceholder);
    }
    initEvents() {
        //Metodo para controlar scroll del sidebar
        this.scroll.addScrollEventListener((e) => {
            this.scrollPerformed = true;
        });
        //Cuando la conexion retorna
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.CONNECTION_ESTABLISHED, (user, time) => {
            //Muestra el view del spinner
            this.rootPage = __WEBPACK_IMPORTED_MODULE_14__modules_security_pages_startup_startup__["a" /* StartupPage */];
            setTimeout(() => {
                this.splashScreen.hide();
                //Inicializa todo lo requerido a nivel de data para que la app funcione. Requerido que este online
                this.initConnectivityServices(false);
            }, 1000);
        });
        //Cuando se autentica un usuario
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, (temporalUser, time) => {
            this.initSession();
            this.initUserData(temporalUser);
        });
        //Cuando se inicia una sesion de invitado
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.GUEST_SESSSION_STARTED, (time) => {
            this.initSession();
        });
        //Cuando cierra la sesion un usuario autenticado
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clearSession();
        });
        //Cuando cierra la sesion un usuario autenticado
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.AVATAR_CHANGED, () => {
            this.user = this.sessionManager.getPrincipal();
        });
        this.platform.pause.subscribe((result) => {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.APP_PLATFORM_PAUSE);
        });
        this.platform.resume.subscribe((result) => {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.APP_PLATFORM_RESUME);
            this.cartManager.checkForCheckoutProcessOnResume();
        });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.NOTIFICATIONS_PROCESSED, (counter) => {
            this.totalNotificationsUnread = counter;
            /*if (counter > 0) {
              ViewUtils.presentToast(this.toastCtrl, "Tienes " + counter + (counter > 1 ? " notificaciones nuevas." :  " notificación nueva."));
            }*/
        });
    }
    //Inicializa todo lo requerido a nivel de data para que la app funcione. Requerido que este online
    initConnectivityServices(pushNotificationTrigger) {
        return __awaiter(this, void 0, void 0, function* () {
            //Validacion de los datos del usuario
            this.sessionManager.getSession().restore().subscribe((response) => {
                //En caso de que el usuario se haya registrado por redes sociales, valida el token
                this.loginService.checkIfTokenIsValid().subscribe((result) => {
                    this.checkVersionUptate();
                    if (result) {
                        //Usuario registrado
                        this.user = this.sessionManager.getPrincipal();
                        this.authenticated = this.sessionManager.isAuthenticated();
                        //Evento de que se ha verificado los datos de la sesion
                        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.BOOTSTRAP_SERVICES_READY, { user: this.user, authenticated: this.authenticated, pushNotificationTrigger: pushNotificationTrigger });
                        this.sessionService.getItem("mustRate").subscribe((response) => {
                            if (response == "S" || response == null) {
                                this.checkAppRate();
                            }
                        });
                    }
                    else {
                        //Usuario registrado
                        this.user = null;
                        this.authenticated = false;
                        //Elimina cualquier dado de usuario
                        this.sessionManager.getSession().reset().subscribe((result) => {
                            //Evento de que se ha verificado los datos de la sesion
                            this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.BOOTSTRAP_SERVICES_READY, { user: this.user, authenticated: this.authenticated, pushNotificationTrigger: pushNotificationTrigger });
                        });
                        var collector = null;
                        var resultt;
                        /*this.GDataCollector.init('sand', null, function (resultt) {
                          console.log("collector_:" + result);
                          console.log(result);
                          collector = result;
                          collector.setupCallback({
                              // fires when collection has finished
                              'collect-end':
                                  function(params) {
                                      console.log('collection has ended');
                                      console.log('SessionId', params.MercSessId);
                                      result = params.MercSessId;
                                  },
                              // fires when collection has started.
                              'collect-begin':
                                  function() {
                                      //console.log('collection has started');
                                  }
                          });
                          collector.collectData();
                        });*/
                    }
                });
            });
        });
    }
    initSession() {
        this.clearSession();
    }
    clearSession() {
        this.user = {};
        this.authenticated = this.sessionManager.isAuthenticated();
    }
    initTranslator() {
        this.translate.setDefaultLang(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.language);
        this.translate.use(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.language);
    }
    initAnalytics() {
        this.facebook.logEvent("fb_mobile_activate_app").then(() => {
            console.log("=======================");
            console.log("Initializing Facebook Analytics...READY");
            console.log("=======================");
        }).catch(e => {
            console.log("=======================");
            console.log("Initializing Facebook Analytics...ERROR: " + e);
            console.log("=======================");
        });
        let gaTracker = 'UA-150016519-1';
        this.ga.startTrackerWithId(gaTracker).then(() => {
            console.log("=======================");
            console.log("Initializing Google Analytics (" + gaTracker + ")...READY");
            console.log("=======================");
            this.ga.trackView('Inicio en ' + (this.platform.is("ios") ? "iOS" : "Android"));
            this.enviarEvento('Inicio en ' + (this.platform.is("ios") ? "iOS" : "Android"));
        }).catch(e => {
            console.log("=======================");
            console.log("Initializing Google Analytics (" + gaTracker + ")...ERROR: " + e);
            console.log("=======================");
        });
    }
    initUserData(temporalUser) {
        console.log("=======================");
        console.log("Initializing UserData and CART...");
        console.log("=======================");
        this.user = this.sessionManager.getPrincipal();
        this.authenticated = this.sessionManager.isAuthenticated();
        this.userService.getUser(this.user).subscribe((response) => {
            response.token = this.user.token;
            response.userId = this.user.userId;
            response.appleToken = temporalUser.appleToken;
            //Guarda el token de firebease, esto no debe ser un blocker o afectar el flujo natural
            if (this.sessionManager.getPushNotificationDeviceId()) {
                response.deviceToken = this.sessionManager.getPushNotificationDeviceId();
                this.userService.modifyUser(response).subscribe((resultUser) => {
                }, error => {
                });
            }
            //Inicializa la orden del carrito
            this.cartManager.initialize();
            this.sessionManager.set("userInfoUpdated", true);
            this.sessionManager.getSession().updatePrincipal(response);
            this.notificationService.downloadNotifications();
        }, error => {
            this.sessionManager.set("userInfoUpdated", false);
        });
    }
    /*private listenConnection(): void {
      this.network.onDisconnect().subscribe(() => {
        //this.showOfflineAlert();
      });
    }*/
    /*private showOfflineAlert(): void {
      ViewUtils.presentToast(this.toastCtrl, this.translate.instant("messages.connectionError"));
    }*/
    menuOpened() {
        this.authenticated = this.sessionManager.isAuthenticated();
    }
    fallback() {
        this.user.picture = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.defaultProfileImage;
    }
    openCustomPage(name, title, flags) {
        //colocar el color azul por defecto al entrar en algun menu
        this.statusBar.backgroundColorByHexString("#2471a3");
        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SIDEBAR_MENU_OPTION_REQUESTED);
        //La bandera indica que al darle back a la pantalla emergente se mantenga en el tab default
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].session.LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED, false);
        this.nav.push(name, { flags: flags });
    }
    openProductoHistoryPage(name) {
        this.statusBar.backgroundColorByHexString("#2471a3");
        this.historyDataSet.clear();
        this.historyDataSet.clearLock();
        this.historyDataSet.setPreLoadMode(false); //Dataset no PRE INICIALIZADO en el startup
        this.nav.push('ProductListingPage', {
            dataSet: this.historyDataSet,
            title: "Productos Vistos Recientemente"
        });
    }
    openActiveHome() {
        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SIDEBAR_MENU_OPTION_REQUESTED);
        this.nav.popToRoot();
        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.FLEX_HOME_INITIALIZE);
        setTimeout(() => {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.FLEX_HOME_SUGGEDTED_TAB_FORCE_REFRESH_FROM_SIDEBAR);
        }, 1000);
    }
    trackProductViewed(title) {
        var param = {};
        param.token = this.user ? this.user.token : null;
        param.userId = this.user ? this.user.userId : null;
        param.page = title;
        this.userService.trackUserNavigation(param).subscribe();
    }
    menuScrollUp() {
        this.scroll._scrollContent.nativeElement.scrollTo({ left: 0, top: 0, behavior: 'smooth' });
        setTimeout(() => {
            this.scrollPerformed = false;
        }, 800);
    }
    menuScrollDown() {
        this.scroll._scrollContent.nativeElement.scrollTo({ left: 0, top: 200, behavior: 'smooth' });
        setTimeout(() => {
            this.scrollPerformed = false;
        }, 800);
    }
    getShareUrl() {
        setTimeout(() => {
            this.paramService.getShareUrl().subscribe((result) => {
                this.sessionManager.set("shareUrl", result);
            });
        }, 6000);
    }
    checkVersionUptate() {
        setTimeout(() => {
            this.versionService.isUpdateAvailable().subscribe((result) => {
                this.versionChecked = true;
                this.sessionManager.set("isUpdateAvailable", result);
                this.handleVersionUpdate(result);
            });
        }, 5000);
    }
    checkAppRate() {
        setTimeout(() => {
            var date = null;
            this.sessionService.getItem("lastRateShown").subscribe((response) => {
                date = response;
            });
            setTimeout(() => {
                let date1 = new Date();
                let date2 = date == null ? new Date() : new Date(date);
                let timeInMilisec = date1.getTime() - date2.getTime();
                let daysBetweenDates = Math.ceil(timeInMilisec / (1000 * 60 * 60 * 24));
                let minutes = Math.abs(date2.getTime() - date1.getTime()) / (1000 * 60);
                this.sessionManager.set("mustRateApp", true);
                if (date == null || daysBetweenDates > 7) {
                    this.appRateService.checkAppRate(this.sessionManager.getPrincipal().userId).subscribe((result) => {
                        this.sessionManager.set("mustRateApp", result);
                        this.handleAppRate(result);
                    });
                }
            }, 2000);
        }, 5000);
    }
    Calificar() {
        this.sessionService.storeItem("lastRateShown", new Date()).subscribe();
        this.sessionService.storeItem("mustRate", "N").subscribe();
        if (this.platform.is("android")) {
            window.open('market://details?id=app.efastonline.com', '_system', 'location=yes');
        }
        else if (this.platform.is("ios")) {
            var iOSVersion = navigator.userAgent.match(/OS\s+([\d\_]+)/i)[0].replace(/_/g, '.').replace('OS ', '').split('.');
            var iOSVer = parseInt(iOSVersion[0]) + (parseInt(iOSVersion[1]) || 0) / 10;
            var iOsUrl = "";
            if (iOSVer < 9) {
                iOsUrl = "http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?pageNumber=0&sortOrdering=1&type=Purple+Software&mt=8&id=1466956395";
            }
            else {
                iOsUrl = "itms-apps://itunes.apple.com/app/viewContentsUserReviews/id1466956395?action=write-review";
            }
            window.open(iOsUrl, '_system', 'location=no');
        }
    }
    noCalificar() {
        this.sessionService.storeItem("lastRateShown", new Date()).subscribe();
    }
    handleAppRate(mustRateApp) {
        setTimeout(() => {
            let onRateDialogShow = () => {
                //Logica para iOs de que mostro la calificación, ya que no hay callback
                if (this.platform.is('ios')) {
                    this.sessionService.storeItem("lastRateShown", new Date()).subscribe();
                    this.sessionService.storeItem("mustRate", "N").subscribe();
                }
                else {
                    let timeoutCanceled = false;
                    let alert = this.alertCtrl.create({
                        message: "Califica nuestra aplicación en la tienda",
                        enableBackdropDismiss: false,
                        buttons: [
                            {
                                text: 'No',
                                role: 'cancel',
                                handler: () => {
                                    timeoutCanceled = true;
                                    alert.dismiss();
                                    setTimeout(() => {
                                        this.noCalificar();
                                    }, 500);
                                }
                            },
                            {
                                text: 'Calificar ahora',
                                handler: () => {
                                    timeoutCanceled = true;
                                    this.Calificar();
                                }
                            }
                        ],
                        title: "¿Te gusta E-Fast?"
                    });
                    alert.present();
                }
            };
            let onButtonClicked = (buttonIndex, currentBtn) => {
                if (buttonIndex == 3) {
                    this.sessionService.storeItem("lastRateShown", new Date()).subscribe();
                    this.sessionService.storeItem("mustRate", "N").subscribe();
                    //Salió a calificar la aplicación.
                }
                else if (currentBtn !== "Si") {
                    this.sessionService.storeItem("lastRateShown", new Date()).subscribe();
                    //posponer
                }
                else {
                    console.log("ERRORD", "otro boton");
                }
            };
            if (mustRateApp) {
                if (this.platform.is("ios")) {
                    this.inAppReview.requestReview()
                        .then((res) => __WEBPACK_IMPORTED_MODULE_17__util_view_utils__["a" /* ViewUtils */].showAlert(this.alertCtrl, res))
                        .catch((error) => __WEBPACK_IMPORTED_MODULE_17__util_view_utils__["a" /* ViewUtils */].showAlert(this.alertCtrl, error));
                    this.sessionService.storeItem("lastRateShown", new Date()).subscribe();
                    this.sessionService.storeItem("mustRate", "N").subscribe();
                }
                else {
                    this.platform.ready().then(() => {
                        this.appRates.setPreferences({
                            displayAppName: 'E-fast',
                            useLanguage: 'es',
                            simpleMode: true,
                            showPromptForInAppReview: (this.platform.is("ios")) ? false : false,
                            reviewType: {
                                ios: __WEBPACK_IMPORTED_MODULE_27__awesome_cordova_plugins_app_rate_ngx__["c" /* AppRateReviewTypeIos */].InAppReview,
                                android: __WEBPACK_IMPORTED_MODULE_27__awesome_cordova_plugins_app_rate_ngx__["b" /* AppRateReviewTypeAndroid */].InAppReview
                            },
                            storeAppURL: {
                                ios: '1466956395',
                                android: 'market://details?id=app.efastonline.com'
                            },
                            callbacks: {
                                onRateDialogShow,
                                onButtonClicked
                            }
                        });
                        this.appRates.promptForRating(true);
                    });
                }
                // }
            }
        }, 1000);
    }
    handleVersionUpdate(isUpdateAvailable) {
        if (isUpdateAvailable) {
            if (!this.isUpdateMessageVisible) {
                this.isUpdateMessageVisible = true;
                let yesCallback = () => {
                    this.isUpdateMessageVisible = false;
                    setTimeout(() => {
                        if (this.platform.is('ios')) {
                            this.theInAppBrowser.create("https://apps.apple.com/cr/app/id1466956395", "_system");
                        }
                        else {
                            this.theInAppBrowser.create("https://play.google.com/store/apps/details?id=app.efastonline.com", "_system");
                        }
                    }, 500);
                };
                let cancelationCallback = () => {
                    this.isUpdateMessageVisible = false;
                };
                setTimeout(() => {
                    __WEBPACK_IMPORTED_MODULE_17__util_view_utils__["a" /* ViewUtils */].showYesNoConfirmWithTOAndEvent(this.events, this.alertCtrl, this.translate.instant('messages.newVersionAlert'), yesCallback, cancelationCallback, cancelationCallback, 2000);
                }, 5000);
            }
        }
    }
    permiso() {
        let activeUser;
        const options = {
            android: {
                senderID: '447307238102',
                forceShow: true,
                clearNotifications: false,
                clearBadge: "true",
                sound: true
            },
            ios: {
                alert: 'true',
                badge: true,
                sound: 'true',
                clearBadge: "true"
            }
        };
        //
        //
        if (this.platform.is('ios')) {
            const pushObject = this.push.init(options);
            pushObject.on('registration').subscribe((registration) => {
                let registrationId = registration.registrationId;
                this.sessionManager.setPushNotificationDeviceId(registrationId);
                console.log('PushOptions:: Dispositivo registrado!', JSON.stringify(registration));
            });
        }
        else {
            //android
            this.push.hasPermission().then((res) => {
                if (!res.isEnabled) {
                    //Pedir permiso de notificaciones
                    this.push.createChannel().then((res) => {
                        if (res.requested) {
                            //Pedir permiso de notificaciones
                            const pushObject = this.push.init(options);
                            pushObject.on('registration').subscribe((registration) => {
                            }, error => {
                                console.log("error");
                            } /*, complete((res: any) => {
                              console.log("Completado");
                              pushObject.on('registration').subscribe((registration: any) => {
                                this.securityService.getPersistedSession().subscribe(
                                  (persistedSession) => {
              
                                    if (persistedSession && !persistedSession.isExpired()) {
                                      pushObject.subscribe('gtemas');
              
                                      activeUser = this.sessionManagerService.getSession().getPrincipal();
                                      this.getToken(activeUser.userCode, registration.registrationId);
                                    }
                                  }
                                );
                              }
                              );
                            })*/);
                            //pushObject.on('error').subscribe(error => console.log('PushOptions:: Error con Push plugin', JSON.stringify(error)));
                        }
                    });
                }
                else {
                    const pushObject = this.push.init(options);
                    pushObject.on('registration').subscribe((registration) => {
                    }, error => {
                    } /*, complete((res: any) => {
                      console.log("Completado");
                      pushObject.on('registration').subscribe((registration: any) => {
                        this.securityService.getPersistedSession().subscribe(
                          (persistedSession) => {
          
                            if (persistedSession && !persistedSession.isExpired()) {
                              pushObject.subscribe('gtemas');
          
                              activeUser = this.sessionManagerService.getSession().getPrincipal();
                              this.getToken(activeUser.userCode, registration.registrationId);
                            }
                          },
                         
                        );
                      }
                      );
                    })*/);
                    // pushObject.on('error').subscribe(error => console.log('PushOptions:: Error con Push plugin', JSON.stringify(error)));
                }
            });
        }
    }
    pushSetup() {
        const options = {
            android: {
                senderID: '162091850270',
                forceShow: true,
                clearNotifications: false,
                clearBadge: "true",
                sound: true
            },
            ios: {
                alert: 'true',
                badge: true,
                sound: 'true',
                clearBadge: "true"
            }
        };
        const pushObject = this.push.init(options);
        /* pushObject.on('notification').subscribe((data: any) => {
           if (data.additionalData.foreground) {
             let confirmAlert = this.alertCtrl.create({
               message: data.message,
               buttons: [{
                 text: 'Ok',
                 role: 'cancel'
               }]
             });
             confirmAlert.present();
           } else {
             this.rootPage = StartupPage;
             setTimeout(() => {
               this.splashScreen.hide();
               this.initConnectivityServices(true);
             }, 1000);
           }
         });*/
        pushObject.on('registration').subscribe((registration) => {
            const pushObject2 = this.push.init(options);
            pushObject2.on('registration').subscribe((registration) => {
                let registrationId = registration.registrationId;
                this.sessionManager.setPushNotificationDeviceId(registrationId);
                console.log('PushOptions:: Dispositivo registrado!', JSON.stringify(registration));
            });
        });
        pushObject.on('error').subscribe(error => {
            this.sessionManager.setPushNotificationDeviceIdError(JSON.stringify(error));
            console.error('PushOptions:: Error con Push plugin' + JSON.stringify(error), JSON.stringify(error));
        });
    }
};
__decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Nav"]),
    __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Nav"])
], MyApp.prototype, "nav", void 0);
__decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('scroll'),
    __metadata("design:type", Object)
], MyApp.prototype, "scroll", void 0);
MyApp = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\app\app.html"*/'<ion-menu [content]="content" type="push" (ionOpen)="menuOpened()">\n\n  <ion-content>\n\n  \n\n    <div *ngIf="authenticated" class="menu-header fadeInDown">\n\n      <ion-item menuClose no-lines tappable (click)="openCustomPage(\'ProfilePage\', \'Perfil de Usuario\')">\n\n        <ion-avatar item-start>\n\n          <img [src]="user.picture" (error)="fallback()">\n\n        </ion-avatar>\n\n        <h2 text-left tappable class="upper-case">{{user.name}}</h2>\n\n        <p text-left tappable>{{\'sidebar.viewProfile\' | translate}}</p>\n\n      </ion-item>\n\n    </div>\n\n\n\n\n\n\n\n    <ion-list class="sc5">\n\n      <ion-scroll #scroll name="scroll" scrollY="true" class=" fadeInUp sc5">\n\n\n\n        <button ion-item class="icon-right" item-icon menuClose tappable (click)="openActiveHome()">\n\n          {{\'sidebar.home\' | translate}}\n\n        </button>\n\n\n\n        <button ion-item class="icon-right" item-icon menuClose tappable\n\n          (click)="openCustomPage(\'SearchPage\', \'Busqueda de productos\', \'sidebar\')">\n\n          <img src="assets/images/icons/search_icon.svg" item-end>\n\n          {{\'sidebar.search\' | translate}}\n\n        </button>\n\n\n\n        <button ion-item class="icon-right" item-icon menuClose tappable\n\n          (click)="openCustomPage(\'SearchCategoriesPage\', \'Departamentos\')">\n\n          {{\'sidebar.departments\' | translate}}\n\n        </button>\n\n\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'WishlistPage\', \'Lista de Deseos\')">\n\n          <img src="assets/images/icons/heart.png" item-end>\n\n          {{\'sidebar.wishList\' | translate}}\n\n        </button>\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'GiftCardPage\', \'Tarjetas de regalo\')">\n\n          {{\'sidebar.giftcard\' | translate}}\n\n        </button>\n\n        <!-- <button *ngIf="authenticated" ion-item class="icon-right" item-icon menuClose tappable (click)="openCustomPage(\'OrderDetailPage\', \'Seguimiento\', \'sidebar\')">\n\n           \n\n            {{\'sidebar.tracking\' | translate}}\n\n          </button>-->\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'NotificationCenterPage\', \'Notificaciones\')">\n\n          {{\'sidebar.notifications\' | translate}} <ion-badge *ngIf="this.totalNotificationsUnread > 0" item-end\n\n            color="danger">{{totalNotificationsUnread}}</ion-badge>\n\n        </button>\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'OrdersPage\', \'Ordenes de Compra\')">\n\n          {{\'sidebar.orderHistory\' | translate}}\n\n        </button>\n\n\n\n\n\n\n\n\n\n        <!--EVALUACION DE PRODUCTOS(agregado)-->\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'ReviewOrderPage\', \'\')">\n\n          {{\'sidebar.revieworder\' | translate}}\n\n        </button>\n\n\n\n        <!--AGREGAR SEGUIMIENTO DE ARTICULOS-->\n\n        <!--ANULACION DE PEDIDOS-->\n\n        <!-- PRODUCTOS VISTO RECIENTEMENTE(agregado)-->\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openProductoHistoryPage(\'ProductListingPage\')">\n\n          {{\'sidebar.productlisting\' | translate}}\n\n        </button>\n\n\n\n\n\n        <!-- MIS INTERESES(agregado) -->\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'ProductCategorySetupPage\',\'\')">\n\n          {{\'sidebar.productcategorysetup\' | translate}}\n\n        </button>\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'RefundPage\', \'Devoluciones\')">\n\n          {{\'sidebar.refunds\' | translate}}\n\n        </button>\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n        <button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable\n\n          (click)="openCustomPage(\'FAQsPage\', \'FAQs\')">\n\n          {{\'sidebar.faqs\' | translate}}\n\n        </button>\n\n\n\n        <button ion-item class="icon-right" item-icon menuClose tappable\n\n          (click)="openCustomPage(\'ContactPage\', \'Contacto\')">\n\n          {{\'sidebar.contact\' | translate}}\n\n        </button>\n\n\n\n\n\n\n\n\n\n\n\n        <!--button *ngIf="authenticated" ion-item class="icon-right" menuClose tappable (click)="openCustomPage(\'TopicsPage\', \'Topicos de Ayuda\')">\n\n              <img src="assets/images/icons/user_icon_light.png" item-end>\n\n            {{\'sidebar.customerService\' | translate}}\n\n          </button-->\n\n\n\n        <!--<button *ngIf="authenticated" ion-item class="icon-right" item-icon menuClose tappable (click)="openCustomPage(\'Chat\', \'Chat\')">\n\n              {{\'sidebar.chat\' | translate}}\n\n          </button>-->\n\n\n\n\n\n\n\n        <button *ngIf="!authenticated" ion-item class="icon-right action-button" item-icon menuClose tappable\n\n          (click)="openCustomPage(\'SignupFrontPage\', \'Registro\', \'hideRegisration\')">\n\n          {{\'sidebar.signup\' | translate}}\n\n        </button>\n\n\n\n        <button *ngIf="!authenticated" ion-item class="icon-right" item-icon menuClose tappable\n\n          (click)="openCustomPage(\'LoginInAppPage\', \'Autenticacion\', \'in-app\')">\n\n          {{\'sidebar.login\' | translate}}\n\n        </button>\n\n\n\n      </ion-scroll>\n\n\n\n      <!--\n\n      <ion-fab right bottom *ngIf="scrollPerformed">\n\n        <button ion-fab mini color="yellow" (click)="menuScrollUp()" class="scroll-option m-b-10">\n\n          <ion-icon name="arrow-up"></ion-icon>\n\n        </button>\n\n        <button ion-fab mini color="yellow" (click)="menuScrollDown()" class="scroll-option">\n\n          <ion-icon name="arrow-down"></ion-icon>\n\n        </button>\n\n      </ion-fab>-->\n\n\n\n    </ion-list>\n\n\n\n\n\n\n\n  </ion-content>\n\n\n\n  <ion-footer class=" fadeInRight">\n\n    <div class="bar bar-footer">\n\n      <div class="button-bar bar-dark">\n\n        <a *ngIf="authenticated" ion-button clear class="button" tappable\n\n          (click)="openCustomPage(\'WishlistPage\', \'Lista de Deseos\')" menuClose><img\n\n            src="assets/images/icons/heart_icon.png"></a>\n\n        <a *ngIf="authenticated" ion-button clear class="button" tappable\n\n          (click)="openCustomPage(\'CartPage\', \'Carrito de Compras\', \'sidebar\')" menuClose><img\n\n            src="assets/images/icons/cart_icon.png"></a>\n\n        <a ion-button clear class="button" tappable (click)="openCustomPage(\'SettingsPage\', \'Settings\')" menuClose><img\n\n            src="assets/images/icons/settings_icon.png"></a>\n\n      </div>\n\n    </div>\n\n\n\n  </ion-footer>\n\n\n\n</ion-menu>\n\n\n\n<ion-nav [root]="rootPage" #content swipeBackEnabled="false">\n\n \n\n</ion-nav>'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\app\app.html"*/
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Platform"],
        __WEBPACK_IMPORTED_MODULE_29__ionic_native_in_app_review_ngx__["a" /* InAppReview */],
        __WEBPACK_IMPORTED_MODULE_2__ionic_native_status_bar__["a" /* StatusBar */],
        __WEBPACK_IMPORTED_MODULE_28__modules_support_providers_param_service__["a" /* ParamService */],
        __WEBPACK_IMPORTED_MODULE_25__modules_support_providers_apprate_service__["a" /* AppRateService */],
        __WEBPACK_IMPORTED_MODULE_27__awesome_cordova_plugins_app_rate_ngx__["a" /* AppRate */],
        __WEBPACK_IMPORTED_MODULE_26__modules_session_session_service__["a" /* SessionService */],
        __WEBPACK_IMPORTED_MODULE_3__ionic_native_splash_screen__["a" /* SplashScreen */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_8__modules_session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_7__config_startup__["a" /* Startup */],
        __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__["c" /* TranslateService */],
        __WEBPACK_IMPORTED_MODULE_9__modules_security_providers_user_service__["a" /* UserService */],
        __WEBPACK_IMPORTED_MODULE_4_ionic_image_loader__["a" /* ImageLoaderConfig */],
        __WEBPACK_IMPORTED_MODULE_10__modules_orders_providers_cart_manager_service__["a" /* CartManagerService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["AlertController"],
        __WEBPACK_IMPORTED_MODULE_11__modules_security_providers_login_service__["a" /* LoginService */],
        __WEBPACK_IMPORTED_MODULE_13__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
        __WEBPACK_IMPORTED_MODULE_15__ionic_native_mobile_accessibility__["a" /* MobileAccessibility */],
        __WEBPACK_IMPORTED_MODULE_16__ionic_native_in_app_browser__["a" /* InAppBrowser */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_18__modules_support_providers_version_service__["a" /* VersionService */],
        __WEBPACK_IMPORTED_MODULE_20__ionic_native_google_analytics__["a" /* GoogleAnalytics */],
        __WEBPACK_IMPORTED_MODULE_19__ionic_native_facebook__["a" /* Facebook */],
        __WEBPACK_IMPORTED_MODULE_22__modules_notifications_providers_notifications_service__["a" /* NotificationService */],
        __WEBPACK_IMPORTED_MODULE_23__ionic_native_push__["a" /* Push */],
        __WEBPACK_IMPORTED_MODULE_24__modules_datasets_product_history_dataset__["a" /* ProductHistoryDataSet */]])
], MyApp);

//# sourceMappingURL=app.component.js.map

/***/ }),

/***/ 1212:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OnboardingPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__home_pages_home_flex__ = __webpack_require__(160);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__util_network_utils__ = __webpack_require__(684);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__ = __webpack_require__(42);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let OnboardingPage = class OnboardingPage {
    constructor(navCtrl, toastCtrl, translate) {
        this.navCtrl = navCtrl;
        this.toastCtrl = toastCtrl;
        this.translate = translate;
        this.showForm = false;
        this.imageLoaded = false;
    }
    ionViewWillEnter() {
    }
    onImageLoad() {
        this.imageLoaded = true;
    }
    goToGuestHome() {
        if (__WEBPACK_IMPORTED_MODULE_3__util_network_utils__["a" /* NetUtils */].isOffline()) {
            __WEBPACK_IMPORTED_MODULE_4__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.connectionError"));
        }
        else {
            this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_2__home_pages_home_flex__["a" /* HomeFlexPage */]);
        }
    }
    goToLogin() {
        this.navCtrl.setRoot('LoginPage');
    }
    showRegistration() {
        this.showForm = true;
    }
};
OnboardingPage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'page-onboarding',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\onboarding\onboarding.html"*/'<ion-content class="onboarding">\n\n\n\n  <div class="image-slider-holder">\n\n    <div class="animate">\n\n        <img src="assets/images/onboarding/onboarding-sprite2.jpg">\n\n    </div>\n\n\n\n    <!--<div class="tech-slideshow">\n\n      <div class="mover-1"></div>\n\n      <div class="mover-2"></div>\n\n    </div>-->\n\n\n\n  </div>\n\n\n\n  <div class="logo-container">\n\n    <img src="assets/images/general/LOGO-EFAST.png">\n\n  </div>\n\n\n\n  <div class="bottom" *ngIf="showForm == false">\n\n    <span class="title" ion-button clear>{{ \'onboarding.title1\' | translate }}</span>\n\n    <ion-slides slider="slider" pager>\n\n      <ion-slide>\n\n        <h5 class="xl-txt">{{ \'onboarding.line1\' | translate }}</h5>\n\n      </ion-slide>\n\n      <ion-slide>\n\n        <h5 class="xl-txt">{{ \'onboarding.line2\' | translate }}</h5>\n\n      </ion-slide>\n\n      <ion-slide>\n\n        <h5 class="xl-txt">{{ \'onboarding.line3\' | translate }}</h5>\n\n      </ion-slide>\n\n      <ion-slide>\n\n        <h5 class="xl-txt">{{ \'onboarding.line4\' | translate }}</h5>\n\n      </ion-slide>\n\n    </ion-slides>\n\n  </div>\n\n\n\n  <div class="bottom" *ngIf="showForm == true">\n\n    <div>\n\n      <h5><label class="lg-txt">{{ \'onboarding.wishUseAccount\' | translate }}</label></h5>\n\n      <button class="action-button lg-txt-btn" ion-button round clear margin-bottom tappable (click)="goToLogin()">{{ \'onboarding.enterEasy\' | translate }}</button>\n\n      <h5 class="lg-txt">{{ \'onboarding.justWantEnter\' | translate }}&nbsp;\n\n        <span class="enterLabel" tappable (click)="goToGuestHome()">{{ \'onboarding.enter\' | translate }}</span>\n\n      </h5>\n\n    </div>\n\n  </div>\n\n\n\n  <button ion-button round clear large icon-only color="light" class="button-icon skip-button animated fadeInRight" tappable (click)="showRegistration()" *ngIf="showForm == false">\n\n    <img src="assets/images/icons/icon_arrow_blue.png" tappable>\n\n  </button>\n\n</ion-content>\n\n'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\onboarding\onboarding.html"*/,
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__["c" /* TranslateService */]])
], OnboardingPage);

//# sourceMappingURL=onboarding.js.map

/***/ }),

/***/ 1213:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSeasonsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_listing_product_seasons_listing_service__ = __webpack_require__(680);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};







/**
 * El objetivo de este servicio es cargar datos defaults al inicio de la app
 * para que queden en cache y llenen las pantallas principales y mejorar la UX
 */
let HomeSeasonsService = class HomeSeasonsService {
    constructor(events, 
        //private errHandler: ErrorService,
        sessionManager, seasonService, seasonsListingService) {
        this.events = events;
        this.sessionManager = sessionManager;
        this.seasonService = seasonService;
        this.seasonsListingService = seasonsListingService;
        this.seasons = [];
        this.isLoded = false;
        //Session ha sido cerrada, limpia datos
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.seasons = [];
        this.seasonsListingService.clear();
    }
    /**
     * Carga en cache un conjunto inicial de productos para la muestra inicial de datos
     */
    fetchData() {
        return __awaiter(this, void 0, void 0, function* () {
            this.clear();
            this.fetchSeasons();
        });
    }
    silentFetchData() {
        this.fetchProductsBySeason();
    }
    fetchSeasons() {
        return __awaiter(this, void 0, void 0, function* () {
            this.seasonService.getSeasons(this.sessionManager.getSession().toModel()).subscribe((list) => {
                this.seasons = list;
                this.isLoded = true;
                this.fetchProductsBySeason();
            });
        });
    }
    fetchProductsBySeason() {
        if (this.seasons && this.seasons.length > 0) {
            let observables = [];
            for (var i = 0; i < this.seasons.length; i++) {
                observables.push(this.seasonsListingService.statelessFetchSeasonProducts(this.seasons[i].seasonId, i));
            }
            __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].forkJoin(observables)
                .subscribe(data => {
                for (var i = 0; i < data.length; i++) {
                    var fetchedCategory = data[i];
                    var index = fetchedCategory.index;
                    var list = fetchedCategory.products;
                    var season = this.seasons[index];
                    season.products = [];
                    season.featureProducts = [];
                    if (list && list.length > 0) {
                        season.products = list;
                        if (season.products.length >= 4) {
                            season.featureProducts = season.products.slice(0, 6);
                        }
                    }
                    if (index + 1 === this.seasons.length) {
                        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.LOBBY_SEASONS_READY, this.seasons);
                    }
                }
            }, error => {
                //Manejado por los servicios llamadores
            });
        }
        else {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.LOBBY_SEASONS_READY, this.seasons);
        }
    }
    getSeasons() {
        return this.seasons;
    }
    isSeasonsLoaded() {
        return this.isLoded;
    }
};
HomeSeasonsService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__["a" /* ProductService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_listing_product_seasons_listing_service__["a" /* ProductSeasonsListingService */]])
], HomeSeasonsService);

//# sourceMappingURL=home-seasons-service.js.map

/***/ }),

/***/ 1214:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeFavoritesService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__products_providers_product_listing_product_favorites_listing_service__ = __webpack_require__(681);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};




/**
 * El objetivo de este servicio es cargar datos defaults al inicio de la app
 * para que queden en cache y llenen las pantallas principales y mejorar la UX
 */
let HomeFavoritesService = class HomeFavoritesService {
    constructor(events, favoritesListingService) {
        this.events = events;
        this.favoritesListingService = favoritesListingService;
        this.list = [];
        this.isLoded = false;
        //Session ha sido cerrada, limpia datos
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.list = [];
        this.isLoded = false;
        this.favoritesListingService.clear();
    }
    /**
     * Carga en cache un conjunto inicial de productos para la muestra inicial de datos
     */
    fetchData() {
        return __awaiter(this, void 0, void 0, function* () {
            this.clear();
            this.fetchFavorites();
        });
    }
    silentFetchData() {
        this.fetchNext(null, true);
    }
    fetchFavorites() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.favoritesListingService.isEmpty()) {
                this.fetchNext();
            }
            else {
                this.list = this.favoritesListingService.getData();
                this.isLoded = true;
                this.events.publish(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].event.LOBBY_FAVORITES_LOADED, this.isLoded, this.list);
            }
        });
    }
    fetchNext(callback, forceFetchSilently) {
        if (forceFetchSilently) {
            this.favoritesListingService.resetPage();
        }
        this.favoritesListingService.fetchData().subscribe((list) => {
            this.list = list;
            this.isLoded = true;
            this.events.publish(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].event.LOBBY_FAVORITES_LOADED, this.isLoded, this.list);
            if (callback) {
                callback();
            }
        });
    }
    getFavorites() {
        return this.list;
    }
    isFavoritesLoaded() {
        return this.isLoded;
    }
};
HomeFavoritesService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_2__products_providers_product_listing_product_favorites_listing_service__["a" /* ProductFavoriteListingService */]])
], HomeFavoritesService);

//# sourceMappingURL=home-favorites-service.js.map

/***/ }),

/***/ 1215:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductByCategoryService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductByCategoryService = class ProductByCategoryService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setCategoryCode(categoryCode) {
        this.categoryCode = categoryCode;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.productService.getCategorizedProducts(session, this.categoryCode, this.pageId, this.pageRows).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    for (let i = 0; i < resultList.length; i++) {
                        this.list.push(resultList[i]);
                    }
                    this.pageId++;
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    /** Stateles call */
    statelessFetchCategoryProducts(categoryCode, index) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var category = {};
            let session = this.sessionManager.getSession().toModel();
            this.productService.getCategorizedProducts(session, categoryCode, this.pageId, this.pageRows).subscribe((list) => {
                category.code = categoryCode;
                category.products = list;
                category.index = index;
                observer.next(category);
                observer.complete();
            }, error => {
                observer.next(category);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductByCategoryService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__product_product_service__["a" /* ProductService */]])
], ProductByCategoryService);

//# sourceMappingURL=product-category-listing-service.js.map

/***/ }),

/***/ 1216:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductSuggestedListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductSuggestedListingService = class ProductSuggestedListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = false;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, () => {
            this.clear();
        });
    }
    resetPage() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = true;
    }
    clear() {
        this.resetPage();
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = this.pageId;
            params.pageRows = this.pageRows;
            this.productService.getSuggestedProducts(params).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    //Si esta en TRUE la paginacion es manejada automaticamente, de lo contrario
                    //se ha dicho explicitamente que reinicie y cargue de manera silenciosa la paggina inicial
                    if (this.pageReseted) {
                        this.list = resultList;
                        this.pageId++;
                        this.pageReseted = false;
                    }
                    else {
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        this.pageId++;
                    }
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductSuggestedListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__product_product_service__["a" /* ProductService */]])
], ProductSuggestedListingService);

//# sourceMappingURL=product-suggested-listing-service.js.map

/***/ }),

/***/ 1217:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductDefaultListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let ProductDefaultListingService = class ProductDefaultListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    //private pageId = AppConfig.app.defaultPage;
    //private pageRows = AppConfig.app.defaultPageSize;
    constructor(events) {
        super();
        this.events = events;
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        //this.pageId = AppConfig.app.defaultPage;
        //this.pageRows = AppConfig.app.defaultPageSize;
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        //this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            observer.next(this.list);
            observer.complete();
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductDefaultListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"]])
], ProductDefaultListingService);

//# sourceMappingURL=product-default-listing-service.js.map

/***/ }),

/***/ 1218:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PromosFinalizingListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let PromosFinalizingListingService = class PromosFinalizingListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = false;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    resetPage() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = true;
        this.list = [];
    }
    fetchNext(callback) {
        this.fetchData().subscribe((list) => {
            this.list = list;
            if (callback) {
                callback();
            }
        });
    }
    clear() {
        this.resetPage();
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.productService.getPromoProducts(session, /*AppConfig.app.promoToFinalizeCode*/ __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.promoRegularOffersCode, this.pageId, this.pageRows).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    //Si esta en TRUE la paginacion es manejada automaticamente, de lo contrario
                    //se ha dicho explicitamente que reinicie y cargue de manera silenciosa la paggina inicial
                    if (this.pageReseted) {
                        this.list = resultList;
                        this.pageId++;
                        this.pageReseted = false;
                    }
                    else {
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        this.pageId++;
                    }
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
PromosFinalizingListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__product_product_service__["a" /* ProductService */]])
], PromosFinalizingListingService);

//# sourceMappingURL=promos-finalizing-listing-service.js.map

/***/ }),

/***/ 1219:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PromosRegularService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let PromosRegularService = class PromosRegularService extends __WEBPACK_IMPORTED_MODULE_2__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = false;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    resetPage() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = true;
    }
    clear() {
        this.resetPage();
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchNext(callback) {
        this.fetchData().subscribe((list) => {
            this.list = list;
            if (callback) {
                callback();
            }
        });
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.productService.getPromoProducts(session, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.promoRegularOffersCode, this.pageId, this.pageRows).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    //Si esta en TRUE la paginacion es manejada automaticamente, de lo contrario
                    //se ha dicho explicitamente que reinicie y cargue de manera silenciosa la paggina inicial
                    if (this.pageReseted) {
                        this.list = resultList;
                        this.pageId++;
                        this.pageReseted = false;
                    }
                    else {
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        this.pageId++;
                    }
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
PromosRegularService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__product_product_service__["a" /* ProductService */]])
], PromosRegularService);

//# sourceMappingURL=promos-regular-listing-service.js.map

/***/ }),

/***/ 1220:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ChatMessageService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__model_chat_message_model__ = __webpack_require__(1221);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let ChatMessageService = class ChatMessageService {
    constructor(rest) {
        this.rest = rest;
    }
    //Enviar mensaje
    callChatMessage(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_chat_message_model__["a" /* ChatMessageMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CHAT_MESSAGE, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_chat_message_model__["a" /* ChatMessageMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    //Recibir mensaje
    receiveChatMessage(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_chat_message_model__["a" /* ChatMessageMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_RECEIVE_MESSAGE, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_chat_message_model__["a" /* ChatMessageMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
ChatMessageService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], ChatMessageService);

//# sourceMappingURL=chat-message-service.js.map

/***/ }),

/***/ 1221:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ChatMessageMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.user_Id,
            token: model.token,
            nombre: model.name,
            contenido: model.content,
            id_representante: model.id_Representative,
            fecha: model.date,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            state: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(ChatMessageMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ChatMessageMapper;

//# sourceMappingURL=chat-message.model.js.map

/***/ }),

/***/ 1222:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RewardsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__model_rewards_model__ = __webpack_require__(1223);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_rewards_config_model__ = __webpack_require__(1224);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__home_pages_home_utils__ = __webpack_require__(272);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__core_provider_image_caching_service__ = __webpack_require__(156);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











let RewardsService = class RewardsService {
    constructor(rest, sessionManager, imageCachingService, events) {
        this.rest = rest;
        this.sessionManager = sessionManager;
        this.imageCachingService = imageCachingService;
        this.events = events;
    }
    performRewardsInit(user) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            this.getActivationPromotions(user).subscribe((response) => {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_8__config_config__["a" /* AppConfig */].session.REWARDS_CONFIGURATION, response);
                __WEBPACK_IMPORTED_MODULE_6__home_pages_home_utils__["a" /* HomeUtils */].loadRewardConfiguration(this.sessionManager, this.imageCachingService, "promoCarrusel", true, (cache) => {
                    this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_8__config_config__["a" /* AppConfig */].session.REWARDS_LOADED, true);
                    this.events.publish(__WEBPACK_IMPORTED_MODULE_8__config_config__["a" /* AppConfig */].event.REWARDS_CHANGED);
                });
                observer.next();
                observer.complete();
            }, error => {
                this.sessionManager.clear(__WEBPACK_IMPORTED_MODULE_8__config_config__["a" /* AppConfig */].session.REWARDS_CONFIGURATION);
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_8__config_config__["a" /* AppConfig */].session.REWARDS_LOADED, false);
                observer.next();
                observer.complete();
            });
        });
    }
    //Consulta activación de Promociones
    getActivationPromotions(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_rewards_config_model__["a" /* RewardsConfigurationMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_ACTIVATION_PROMOTIONS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_rewards_config_model__["a" /* RewardsConfigurationMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consultar Puntos Acumulados
    getPointsAccumulated(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_rewards_model__["a" /* ConsultRewardsMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_POINTS_ACCUMULATED, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_rewards_model__["a" /* ConsultRewardsMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consulta los cupones de descuento
    getDiscountCoupons(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_rewards_model__["a" /* ConsultRewardsMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_DISCOUNT_COUPONS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_rewards_model__["a" /* ConsultRewardsMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
RewardsService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */],
        __WEBPACK_IMPORTED_MODULE_9__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_10__core_provider_image_caching_service__["a" /* ImageCachingService */],
        __WEBPACK_IMPORTED_MODULE_7_ionic_angular__["Events"]])
], RewardsService);

//# sourceMappingURL=rewards-service.js.map

/***/ }),

/***/ 1223:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class ConsultRewardsMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            //WS para Consultar Puntos Acumulados
            points: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.puntos),
            date_Points: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechapuntos),
            //WS para consultar Activacion de Promociones
            free_Shipping: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.enviogratis),
            free_Shipping_Banner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.enviogratisbanner),
            gift_Card: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tarjetaregalo),
            Gift_Card_Banner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tarjetaregalobanner),
            recommend_A_Friend: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.recomendarunamigo),
            recommend_A_Friend_Banner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.recomendarunamigobanner),
            next_Purchase_Discount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentoproximacompra),
            next_Purchase_Discount_Banner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentoproximacomprabanner),
            discount_With_Timer_Cart: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentocontimercarrito),
            discount_With_Timer_Value: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentocontimercarritovalor),
            //WS para Consultar cupones de Descuento
            expiration_Date: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.fechavencimiento),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            code: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codigo),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            multimedia: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            estate: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(ConsultRewardsMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ConsultRewardsMapper;

//# sourceMappingURL=rewards.model.js.map

/***/ }),

/***/ 1224:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class RewardsConfigurationMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model ? model.userId : null,
            token: model ? model.token : null,
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            freeShipping: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.enviogratis),
            freeShippingBanner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.enviogratisbanner),
            freeShippingShowProductCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articuloEG),
            freeShippingShowCategoryId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_categoriaEG),
            freeShippingShowFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_familiaEG),
            freeShippingShowSubFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_subfamiliaEG),
            giftCard: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tarjetaregalo),
            giftCardBanner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tarjetaregalobanner),
            giftCardShowProductCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articuloTR),
            giftCardShowCategoryId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_categoriaTR),
            giftCardShowFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_familiaTR),
            giftCardShowSubFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_subfamiliaTR),
            friendRecomendation: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.recomendarunamigo),
            friendRecomendationBanner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.recomendarunamigobanner),
            friendRecomendationShowProductCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articuloRA),
            friendRecomendationShowCategoryId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_categoriaRA),
            friendRecomendationShowFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_familiaRA),
            friendRecomendationShowSubFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_subfamiliaRA),
            nextPurchaseDiscount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentoproximacompra),
            nextPurchaseDiscountBanner: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentoproximacomprabanner),
            nextPurchaseDiscountShowProductCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articuloDC),
            nextPurchaseDiscountShowCategoryId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_categoriaDC),
            nextPurchaseDiscountShowFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_familiaDC),
            nextPurchaseDiscountShowSubFamilyId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_subfamiliaDC),
            discountWithTimerCart: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentocontimercarrito),
            discountWithTimerValue: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuentocontimercarritovalor)
        };
        model.promosQty = 0;
        if (model.giftCard === "S")
            model.promosQty++;
        if (model.friendRecomendation === "S")
            model.promosQty++;
        if (model.nextPurchaseDiscount === "S")
            model.promosQty++;
        if (model.freeShipping === "S")
            model.promosQty++;
        model.hasPromos = model.promosQty > 0;
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(RewardsConfigurationMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = RewardsConfigurationMapper;

//# sourceMappingURL=rewards-config.model.js.map

/***/ }),

/***/ 1225:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductFamilyListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductFamilyListingService = class ProductFamilyListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPage;
        this.list = [];
    }
    setFilterData(categoryCode, familyCode, subfamilyCode) {
        this.categoryCode = categoryCode;
        this.familyCode = familyCode;
        this.subfamilyCode = subfamilyCode;
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var params = {};
            params.page = this.pageId;
            params.records = this.pageRows;
            params.categoryCode = this.categoryCode;
            params.familyCode = this.familyCode;
            params.subfamilyCode = this.subfamilyCode;
            if (this.sessionManager.isAuthenticated()) {
                params.userId = this.sessionManager.getPrincipal().userId;
                params.token = this.sessionManager.getToken();
            }
            this.productService.searchByCategoryAndFamily(params).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    for (let i = 0; i < resultList.length; i++) {
                        this.list.push(resultList[i]);
                    }
                    this.pageId++;
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductFamilyListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__product_product_service__["a" /* ProductService */]])
], ProductFamilyListingService);

//# sourceMappingURL=product-family-listing-service.js.map

/***/ }),

/***/ 1226:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductSectionListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__home_providers_home_section_service__ = __webpack_require__(148);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductSectionListingService = class ProductSectionListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, sectionService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = false;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    setSectionId(sectionId) {
        this.sectionId = sectionId;
    }
    resetPage() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = true;
    }
    clear() {
        this.resetPage();
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var params = {};
            let session = this.sessionManager.getSession().toModel();
            params.userId = session && session.userId > 0 ? session.userId : null;
            params.token = session && session.token > 0 ? session.token : null;
            params.page = this.pageId;
            params.records = this.pageRows;
            params.sectionId = this.sectionId;
            this.sectionService.getSectionsProducts(params).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    //Si esta en TRUE la paginacion es manejada automaticamente, de lo contrario
                    //se ha dicho explicitamente que reinicie y cargue de manera silenciosa la paggina inicial
                    if (this.pageReseted) {
                        this.list = resultList;
                        this.pageId++;
                        this.pageReseted = false;
                    }
                    else {
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        this.pageId++;
                    }
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductSectionListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_5__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_6__home_providers_home_section_service__["a" /* HomeSectionService */]])
], ProductSectionListingService);

//# sourceMappingURL=product-section-listing-service.js.map

/***/ }),

/***/ 1227:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TimerManager; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

let TimerManager = class TimerManager {
    constructor() {
        this.pool = [];
        this.pool.push(new Timer("1"));
        this.pool.push(new Timer("2"));
        this.pool.push(new Timer("3"));
    }
    start() {
        this.startAll();
    }
    release() {
        this.stopAll();
    }
    startAll() {
        for (let i = 0; i < this.pool.length; i++) {
            this.pool[i].start();
        }
    }
    stopAll() {
        for (let i = 0; i < this.pool.length; i++) {
            this.pool[i].stop();
        }
    }
};
TimerManager = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], TimerManager);

class Timer {
    constructor(id) {
        this.active = false;
        this.id = id;
    }
    getId() {
        return this.id;
    }
    isActive() {
        return this.active;
    }
    start() {
        this.active = true;
    }
    stop() {
        this.active = false;
    }
}
//# sourceMappingURL=timer-manager.js.map

/***/ }),

/***/ 1228:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductSimilarListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let ProductSimilarListingService = class ProductSimilarListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, productService) {
        super();
        this.events = events;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    setFilterData(user, product) {
        this.user = user;
        this.product = product;
    }
    clear() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPage;
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var param = {};
            param.pageId = this.pageId;
            param.pageRows = this.pageRows;
            param.token = this.user ? this.user.token : null;
            param.article = this.product.productCode;
            this.productService.getSimilarProducts(param).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    for (let i = 0; i < resultList.length; i++) {
                        this.list.push(resultList[i]);
                    }
                    this.pageId++;
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductSimilarListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_4__product_product_service__["a" /* ProductService */]])
], ProductSimilarListingService);

//# sourceMappingURL=product-similar-listing-service.js.map

/***/ }),

/***/ 1229:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductSearchListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductSearchListingService = class ProductSearchListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(sessionManager, productService, events) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.events = events;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.searchResultsQuantity = 0;
        this.searchPaginationId = null;
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.searchPaginationId = null;
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    setCriteria(criteria) {
        this.criteria = criteria;
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        this.sortBy = sortBy;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
    }
    fetchData(clearOnFetch) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            console.log("public fetchData");
            var search = {};
            search.criterion = this.criteria;
            search.pageId = this.pageId;
            search.pageRows = this.pageRows;
            search.sortBy = this.sortBy;
            search.searchPaginationId = this.searchPaginationId;
            if (this.sessionManager.isAuthenticated()) {
                search.userId = this.sessionManager.getPrincipal().userId;
                search.token = this.sessionManager.getToken();
            }
            this.productService.search(search).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    this.searchResultsQuantity = resultList[0].searchQuantity;
                    this.searchPaginationId = resultList[0].searchPaginationId;
                    if (clearOnFetch) {
                        this.list = resultList;
                    }
                    else {
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        this.pageId++;
                    }
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        let message;
        if (this.searchResultsQuantity) {
            message = this.searchResultsQuantity + " resultados con '" + this.criteria + "'";
        }
        else {
            message = "Resultados con '" + this.criteria + "'";
        }
        return message;
    }
};
ProductSearchListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_6__product_product_service__["a" /* ProductService */],
        __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"]])
], ProductSearchListingService);

//# sourceMappingURL=product-search-listing-service.js.map

/***/ }),

/***/ 1230:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TransientCachingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__caching_service__ = __webpack_require__(103);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let TransientCachingService = class TransientCachingService extends __WEBPACK_IMPORTED_MODULE_1__caching_service__["a" /* CachingService */] {
    constructor() {
        super();
    }
    loadFrom(cache) {
        this.cache = Object.assign({}, cache.cache);
        this.pages = Object.assign({}, cache.pages);
    }
};
TransientCachingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], TransientCachingService);

//# sourceMappingURL=transient-caching-service.js.map

/***/ }),

/***/ 13:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
class RESTConfig {
}
/* harmony export (immutable) */ __webpack_exports__["a"] = RESTConfig;

//public static readonly ENDPOINT: string = 'http://186.96.88.106:8095/API'; //DEVICE
RESTConfig.ENDPOINT = "https://app.efastonline.com/API"; //HTTPS
//public static readonly ENDPOINT: string = 'http://172.16.0.36:8082/API'; //HTTPS
//public static readonly ENDPOINT: string = "http://172.16.0.36:8091/API";
//public static readonly ENDPOINT: string = 'http://navegacion.catalogoestilos.com:8095/API'; //INTERNA
//Seguridad
RESTConfig.WS_SECURITY_QUESTIONS = "TraePreguntasSeguridad";
RESTConfig.WS_USER_SECURITY_QUESTIONS = "TraePreguntasSeguridadUsuario";
RESTConfig.WS_SECURITY_REGISTRATION = "Registro";
RESTConfig.WS_SECURITY_AUTH = "AutenticaUsuario";
RESTConfig.WS_SECURITY_AUTH_SOCIAL_NETWORK = "AutenticaUsuarioRS";
RESTConfig.WS_SECURITY_AUTH_APPLE_NETWORK = "AutenticaUsuarioAID";
RESTConfig.WS_SECURITY_CHANGE_USER_PASSWORD = "CambiarPassword";
RESTConfig.WS_SECURITY_CHANGE_USER_PASSWORD_EMAIL = "EnviaCorreoRC";
RESTConfig.WS_SECURITY_GET_USER = "ConsultaMaestra";
RESTConfig.WS_SECURITY_MODIFY_USER = "ModificarUsuario";
RESTConfig.WS_SECURITY_MODIFY_USER_IMAGE = "ModificaImagen";
RESTConfig.WS_SECURITY_USER_INACTIVATION = "InactivarUsuario";
RESTConfig.WS_SECURITY_EXIST_ACCOUNT = "ExisteCorreo";
//Categorias
RESTConfig.WS_PRODUCT_CATEGORIES = "Categorias";
RESTConfig.WS_PRODUCT_USER_CATEGORIES = "CategoriasPreferidas";
RESTConfig.WS_PRODUCT_USER_ADD_CATEGORY = "AgregarCategoria";
RESTConfig.WS_PRODUCT_USER_REMOVE_CATEGORY = "EliminarCategoria";
//Tarjetas
RESTConfig.WS_CARDS = "ConsultaTarjeta";
RESTConfig.WS_ADD_CARDS = "AgregarTarjeta";
RESTConfig.WS_MODIFY_CARDS = "ModificarTarjeta";
RESTConfig.WS_REMOVE_CARDS = "EliminarTarjeta";
RESTConfig.WS_VALIDATE_CARDS = "ValidaTarjeta";
//Productos
RESTConfig.WS_USER_VIEWED_PRODUCTS = "HistoricoBusqueda";
RESTConfig.WS_LOBBY_SUGGESTED_PRODUCTS = "ConsultaDeTodoUnPoco";
RESTConfig.WS_LOBBY_SUGGESTED_MY_INTEREST_PRODUCTS = "ConsultaDeTodoUnPocoMI";
RESTConfig.WS_LOBBY_FAVORITED_PRODUCTS = "ConsultaFavoritos";
RESTConfig.WS_LOBBY_PROMO_PRODUCTS = "ConsultaPromociones";
RESTConfig.WS_LOBBY_PROMO_PRODUCTS_INI = "ConsultaPromocionesIni";
RESTConfig.WS_LOBBY_PRODUCTS_BY_CATEGORY = "ConsultaArtsXCategoria";
RESTConfig.WS_LOBBY_PRODUCTS_BY_CATEGORY_INI = "ConsultaArtsXCategoriaIni";
RESTConfig.WS_LOBBY_SEASONS = "ConsultaTemporadas";
RESTConfig.WS_SEARCH_HISTORY_ADD = "NavDescUsuario";
RESTConfig.WS_SEARCH_HISTORY_QUERY = "HistoricoBusqDesc";
RESTConfig.WS_SEARCH_FAMILIES = "Familias";
RESTConfig.WS_SEARCH_SUBFAMILIES = "SubFamilias";
RESTConfig.WS_BANNER_LIST_PRODUCTS = "ConsultaListaArtsBanner";
RESTConfig.WS_BANNER_BRAND_PRODUCTS = "ConsultaMarcaArtsBanner";
RESTConfig.WS_BANNER_PROVIDER_PRODUCTS = "ConsultaProvArtsBanner";
//Carruseles de Productos
RESTConfig.WS_LOBBY_MAIN_CARRUSEL = "CarruselPrincipalDeTodoUnPoco";
RESTConfig.WS_LOBBY_FEATURED_CARRUSEL = "CarruselDestacadosDeTodoUnPoco";
RESTConfig.WS_LOBBY_NEW_PRODUCTS_CARRUSEL = "CarruselNuevosDeTodoUnPoco";
RESTConfig.WS_GENERAL_CARRUSEL = "CARRUSELPRINCIPAL";
//Definicion de endpoint de servicios
RESTConfig.WS_USER_SECURITY_ADD_QUESTION = "AgregarPregSeguridad";
RESTConfig.WS_USER_SECURITY_MODIFY_QUESTION = "ActualizarPregSeguridad";
RESTConfig.WS_DELETE_SECURITY_USER_QUESTION = "EliminarPregSeguridad";
//Direccion de Usuario
RESTConfig.WS_GET_ADDRESS_USER = "ConsultaDireccionEnvio";
RESTConfig.WS_ADD_ADDRESS_USER = "AgregarDireccion";
RESTConfig.WS_MODIFY_ADDRESS_USER = "ModificarDireccion";
RESTConfig.WS_DELETE_ADDRESS_USER = "EliminarDireccion";
//Lista de deseos
RESTConfig.WS_ADD_LIST_USER = "AgregarListaDeseos";
RESTConfig.WS_MODIFY_LIST_USER = "ActualizaListaDeseos";
RESTConfig.WS_DELETE_LIST_USER = "EliminarListaDeseos";
RESTConfig.WS_ADD_PRODUCT_LIST_USER = "AgregarArtsListaDeseos";
RESTConfig.WS_DELETE_PRODUCT_LIST_USER = "EliminaArtsListaDeseos";
RESTConfig.WS_CONSULT_LIST_USER = "ConsultaListaDeseos";
RESTConfig.WS_CONSULT_PRODUCT_LIST_USER = "ConsultaArtsXListaDeseos";
//Orden de compra
RESTConfig.WS_CONSULT_PURCHASE_ORDER = "ConsultaOC";
RESTConfig.WS_ADD_PURCHASE_ORDER = "AgregaOC";
RESTConfig.WS_MODIFY_PURCHASE_ORDER = "ModificarOC";
RESTConfig.WS_DELETE_PURCHASE_ORDER = "EliminaOC";
RESTConfig.WS_CONSULT_PRODUCT_PURCHASE_ORDER = "ConsultaDetOC";
RESTConfig.WS_ADD_PRODUCT_PURCHASE_ORDER = "AgregaDetOC";
RESTConfig.WS_MODIFY_PRODUCT_PURCHASE_ORDER = "ModificaDetOC";
RESTConfig.WS_DELETE_PRODUCT_PURCHASE_ORDER = "EliminaDetOC";
RESTConfig.WS_VALIDATE_PURCHASE_ORDER = "ValidaOC";
RESTConfig.WS_ACTIVE_PURCHASE_ORDER = "ActivaOC";
RESTConfig.WS_ADD_PURCHASE_LOG = "RegistraErrorBitacora";
RESTConfig.WS_APPLY_ORDER_COUPON = "APLICACUPON";
//Reservas
RESTConfig.WS_LOCK_PRODUCT_DETAIL = "ReservaArticulo";
RESTConfig.WS_RELEASE_PRODUCT_DETAIL = "LiberaArticulo";
//Tracking
RESTConfig.WS_TRACING_PURCHASE_ORDER = "SeguimientoOC";
RESTConfig.WS_TRACING_PURCHASE_ORDER_VIA_CCR = "TrazabilidadPedidos";
//Cerrar sesion de usuario
RESTConfig.WS_CLOSE_SESSION_USER = "CerrarSesion";
//Invitar amigo
RESTConfig.WS_INVITE_FRIEND = "InvitarAmigo";
//Consultar Productos de Temporada
RESTConfig.WS_CONSULT_SEASON_PRODUCTS = "ConsultaArtsXTemporada";
//Consultar todos los atributos
RESTConfig.WS_CONSULT_ATTRIBUTES = "ConsultaAtributos";
//Agregar recomendacion
RESTConfig.WS_ADD_RECOMMENDATION = "AgregaRecomendacion";
//Productos relacionados a un producto dado
RESTConfig.WS_RELATED_PRODUCTS = "ConsultaRelacionados";
//Productos similares a un producto dado
RESTConfig.WS_SIMILAR_PRODUCTS = "ConsultaSimilares";
//Realizar búsqueda de productos
RESTConfig.WS_LOOK_PRODUCTS = "BusquedaArts";
RESTConfig.WS_LOOK_PRODUCTS_NEW = "LupaArts";
RESTConfig.WS_LOOK_SIMILAR_PRODUCTS = "BusquedaArtsSimilares";
RESTConfig.WS_LOOK_PRODUCTS_FILTERS = "ConsultaAtributosXBusqueda";
RESTConfig.WS_LOOK_PRODUCTS_FILTERS_VALUES = "ConsultaValoresXAtributoBusq";
RESTConfig.WS_LOOK_PRODUCTS_BY_FILTER = "ConsultaArtsXAtribBusqueda";
//Consultar informacion general de articulos
RESTConfig.WS_CONSULT_ARTICLES = "ConsultaArticulos";
//Consultar banner de ofertas o informacion
RESTConfig.WS_CONSULT_DET_ART_BANNER = "DetArtBanner";
//Consultar Recomendacion
RESTConfig.WS_CONSULT_RECOMMENDATION = "ConsultaRecomendacion";
//Consultar grupos de Productos
RESTConfig.WS_CONSULT_GROUPS = "CriteriosAgrupa";
//Almacena informacion de navegacion del usuario
RESTConfig.WS_USER_NAVIGATION = "NavegacionUsuario";
// Consultar productos de unba oferta
RESTConfig.WS_OFFER_PRODUCTS = "ArtsXOferta";
// Modificar  configuracion
RESTConfig.WS_MODIFY_NOTIFICATION_SETTINGS = "ModificaConfNotif";
// Compartir a un amigo cupon
RESTConfig.WS_SHARE_CUPON = "CompartirCupon";
// Consultar topicos de servicio al cliente
RESTConfig.WS_QUERY_TOPICS = "ConsultaTopicos";
// Consultar detalle topicos de servicio al cliente
RESTConfig.WS_QUERY_TOPICS_DETAIL = "ConsultaInfTopicos";
// Consultar categorias de preguntas frecuentes
RESTConfig.WS_FAQs = "ConsultaPregFrec";
// Consultar contenido de una FAQ
RESTConfig.WS_FAQs_DETAIL = "ConsultaInfPregFrec";
// Consultar las ofertas
RESTConfig.WS_CONSULT_OFFERS = "Ofertas";
//Consulta notificaciones de ofertas en formato html y titulo
RESTConfig.WS_CONSULT_OFFERS_HTML = "OfertasHTML";
// Agregar productos guardados
RESTConfig.WS_ADD_PRODUCTS_SAVED = "AgregaGuardados";
// Eliminar  productos guardados
RESTConfig.WS_DELETE_PRODUCTS_SAVED = "EliminaGuardados";
// Consultar  productos guardados
RESTConfig.WS_CONSULT_PRODUCTS_SAVED = "ConsultaGuardados";
// Enviar mensajes de chat
RESTConfig.WS_CHAT_MESSAGE = "EnviarMensaje";
// Recibir mensajes de chat
RESTConfig.WS_RECEIVE_MESSAGE = "RecibirMensaje";
// Consultar Notificaciones Generales
RESTConfig.WS_CHECK_NOTIFICATION = "ConsultaNotificaciones";
//Consulta notificaciones generales con formato HTML y titulo
RESTConfig.WS_CHECK_NOTIFICATION_HTML = "ConsultaNotificacionesHTML";
RESTConfig.WS_MARK_NOTIFICATION_AS_READ = "MarcaLeidaNotif";
// Consultar Notificaciones de Ofertas
RESTConfig.WS_CONSULT_NOTIFICATION_OFFERS = "ConsultaNotificacionesOfertas";
RESTConfig.WS_MARK_NOTIFICATION_OFFER = "MarcaLeidaOferta";
// Consultar Notificaciones de Puntos Ganados
RESTConfig.WS_CONSULT_NOTIFICATION_POINTS = "ConsultaNotificacionesPG";
// Consultar Notificaciones de Ordenes
RESTConfig.WS_CONSULT_NOTIFICATION_ORDERS = "ConsultaNotificacionesOC";
//Consulta la configuración de notificaciones
RESTConfig.WS_CONSULT_CONFIGURATION = "ConsultaConfNotif";
RESTConfig.WS_CONSULT_CONFIGURATION_TYPE = "ConsultaTipoNotificaciones";
//Consulta activación de Promociones
RESTConfig.WS_CONSULT_ACTIVATION_PROMOTIONS = "ConsultaActPromociones";
//Consultar Puntos Acumulados
RESTConfig.WS_CONSULT_POINTS_ACCUMULATED = "ConsultaPuntos";
//Consulta los cupones de descuento
RESTConfig.WS_CONSULT_DISCOUNT_COUPONS = "ConsultaCupones";
//Registrar Productos Sin Disponible
RESTConfig.WS_REGISTER_PRODUCT_WITHOUT_AVAILABLE = "AgregaNoDisponibles";
//Servicio de Fletes
RESTConfig.WS_CONSULT_FREIGHT = "ConsultaFletes";
//Consultar estado de una sesion
RESTConfig.WS_SESSION_STATUS = "EstadoSesion";
//Consultar estado de una sesion
RESTConfig.WS_SEARCH_BY_FAMILY = "ConsultaArtsXCF";
RESTConfig.WS_SEARCH_BY_FAMILY_OR_CATEGORY = "ConsultaArtsXCFS";
//Consultar atributos de un producto
RESTConfig.WS_PRODUCT_ATTRIBUTES = "ConsultaDetalleAtributos";
RESTConfig.WS_PRODUCT_ATTRIBUTES_INFO = "ConsultaDetalleAtributosInfo";
//Consultar imagenes de un producto
RESTConfig.WS_PRODUCT_IMAGES = "ConsultaIVG";
//Consultar SECCIONES del Lobby
RESTConfig.WS_LOBBY_SECTIONS = "ConsultaSecciones";
RESTConfig.WS_LOBBY_SECTIONS_DETAIL = "ConsultaArtsXSec";
RESTConfig.WS_LOBBY_SECTION_GROUPS = "GrupoSeccion";
RESTConfig.WS_LOBBY_SECTIONS_BY_GROUP = "ConsultaSecXGrupo";
RESTConfig.WS_LOBBY_FEATURED_PRODUCTS_BY_GROUP = "ConsultaArtsXGrupoSecPag";
RESTConfig.WS_LOBBY_FEATURED_PRODUCTS_SECTION = "ConsultaArtsXGrupoSecIni";
//GreenPay
RESTConfig.WS_GREENPAY_CONFIG = "InfoGP";
//Sanbox
//TODO al liberar cambiar a produccion
/*
public static readonly WS_GREENPAY_TOKENIZE_ORDER:   string    = "https://sandbox-merchant.greenpay.me/tokenize";
public static readonly WS_GREENPAY_TOKENIZE_CARD:    string    = "https://sandbox-checkout.greenpay.me/tokenize";
public static readonly WS_GREENPAY_CHECKOUT_ORDER:   string    = "https://sandbox-merchant.greenpay.me";
public static readonly WS_GREENPAY_CHECKOUT_CARD:    string    = "https://sandbox-checkout.greenpay.me";
public static readonly WS_GREENPAY_CHECKOUT_CARD_KOUNT: string = "https://sandbox-checkout.greenpay.me/kount"*/
//Production
RESTConfig.WS_GREENPAY_TOKENIZE_ORDER = "https://merchant.greenpay.me/tokenize";
RESTConfig.WS_GREENPAY_TOKENIZE_CARD = "https://checkout.greenpay.me/tokenize";
RESTConfig.WS_GREENPAY_CHECKOUT_ORDER = "https://merchant.greenpay.me";
RESTConfig.WS_GREENPAY_CHECKOUT_CARD = "https://checkout.greenpay.me";
RESTConfig.WS_GREENPAY_CHECKOUT_CARD_KOUNT = "https://checkout.greenpay.me/kount";
RESTConfig.WS_ORDER_PAYMENT_INFO = "OCPago";
//Tarjetas de regalo
RESTConfig.WS_USER_GIFT_CARDS = "ConsultaTarjetasRegalo";
RESTConfig.WS_SEND_GIFT_CARD = "EnviarTarjetaRegalo";
RESTConfig.WS_GIFT_CARD_TYPE = "ConsultaMontoTR";
RESTConfig.WS_GIFT_CARD = "ConsultaTipoTR";
RESTConfig.WS_ADD_GIFT_CARD = "AgregaTR";
//Devoluciones
RESTConfig.WS_REFUND_SUBJECT = "ConsultaTemasDev";
RESTConfig.WS_REFUND_SUBJECT_DETAIL = "ConsultaDetTemasDev";
RESTConfig.WS_REFUND_REASONS = "ConsultaMotDev";
RESTConfig.WS_REFUND_ORDER = "AgregarOrdenDev";
RESTConfig.WS_REFUND_ORDER_LIST = "ConsultaDetOrdDev";
RESTConfig.WS_REFUND_ADD_IMAGE = "AgregaImagenOrdenDev";
//Terminos y condiciones
RESTConfig.WS_TERMS_CONDITIONS = "ConsultaTerminosCondiciones";
//Consulta si hay que valorar la aplicación
RESTConfig.WS_APPRATE = "ConsultaValorarApp";
//Manejo de versiones
RESTConfig.WS_VERSION_CONTROL = "ConsultaVersion";
//Lobby 2.0 - Mi Super
RESTConfig.WS_LOBBY_MISUPER_GROUPS = "ConsultaPasillos";
RESTConfig.WS_LOBBY_MISUPER_GROUPS_IMAGES = "ConsultaImagenesXPasillo";
RESTConfig.WS_LOBBY_MISUPER_GROUPS_SECTIONS = "ConsultaSecXPasillo";
RESTConfig.WS_LOBBY_MISUPER_GROUPS_PRODUCTS = "ConsultaArtsXSecXPas";
//Merqueo
RESTConfig.WS_LOBBY_MISUPER_MERQUEO_PRODUCTS = "ConsultaArtsXPasilloPag";
RESTConfig.WS_LOBBY_CATEGORY_MERQUEO_PRODUCTS = "ConsultaArtsXCFPag";
RESTConfig.WS_LOBBY_MISUPER_MERQUEO_SECTION_LIST_PRODUCTS = "ConsultaArtsXSeccionPag";
//Promociones
RESTConfig.WS_LOBBY_OFFERS_GROUPS = "ConsultaPasillosPromo";
RESTConfig.WS_LOBBY_OFFERS_GROUPS_IMAGES = "ConsultaImagXPasilloPromo";
RESTConfig.WS_LOBBY_OFFERS_GROUPS_PRODUCTS = "ConsultaArtsXPasPromo";
//Consultar Sucursales de Correos de Costa Rica
RESTConfig.WS_SUBSIDIARY_PROVINCES = "ConsultaProvinciasCCR";
RESTConfig.WS_SUBSIDIARY_CANTONS = "ConsultaCantonesCCR";
RESTConfig.WS_SUBSIDIARY_LIST = "ConsultaSucursalesCCR";
RESTConfig.WS_PROMO_TITLE_LIST = "ConsultaTipoPromociones";
RESTConfig.WS_PROMO_SECTION_TYPE_LIST = "ConsultaTipoSeccion";
RESTConfig.WS_LOBBY_PROMO_PRODUCTS_SECTION_TYPE = "ConsultaArtsSecTipo";
RESTConfig.WS_LOBBY_PROMO_GROUPS = "ConsultaPasillosSeccion";
RESTConfig.WS_LOBBY_PROMO_IMAGES_BY_GROUP = "ConsultaImagXPasilloSeccion";
RESTConfig.WS_LOBBY_PROMO_SECTIONS_BY_HALLWAY = "ConsultaSeccionPasillo";
RESTConfig.WS_LOBBY_PROMO_PRODUCTS_BY_SECTION = "ConsultaArtsXPasSeccion";
//Imei
RESTConfig.WS_REGISTER_IMEI = "RegistraIMEI";
RESTConfig.WS_QUERY_IMEI = "ConsultaIMEI";
//FE
RESTConfig.WS_SEARCH_ID = "ConsultaNombreXID";
//Partametros para ciertas configuraciones
RESTConfig.WS_PARAM_SHARE_URL = "ConsultaUrlCompartir";
//Sinpe Movil 📲
RESTConfig.WS_SINPE_GET_INFO = "InfoSinpe";
RESTConfig.WS_SINPE_GET_PHONE_NUMBER = "TelSinpe";
RESTConfig.WS_SINPE_GET_STATUS = "EstadoSinpeEfast";
RESTConfig.WS_SINPE_SAVE_TRANSACTION = "AplicaSinpeEfast";
RESTConfig.WS_SINPE_SAVE_TRANSACTION_LOG = "BitSinpe_Efast";
// -------------------SERVICIOS DE PRUEBA---------------------------------//
// public static readonly WS_SINPE_GET_TOKEN: string =
//   "http://taurus-uat-integracion.cruxconsultores.info/api/Integracion/ObtenerToken";
// public static readonly WS_SINPE_REFRESH_TOKEN: string =
//   "http://taurus-uat-integracion.cruxconsultores.info/api/Integracion/RefrescarToken";
// public static readonly WS_SINPE_CONSULTA_PAGO: string =
//   "http://taurus-uat-integracion.cruxconsultores.info/api/Pago/ConsultaPago";
// public static readonly WS_SINPE_VINCULAR_PAGO: string =
//   "http://taurus-uat-integracion.cruxconsultores.info/api/Pago/VincularPago";
// public static readonly WS_SINPE_VINCULAR_PAGO_1PASO: string =
//   "http://taurus-uat-integracion.cruxconsultores.info/api/Pago/VincularPagoEnUnPaso";
// -------------------SERVICIOS DE PRUEBA---------------------------------//
// -------------------SERVICIOS DE PRODUCCION---------------------------------//
RESTConfig.WS_SINPE_GET_TOKEN = "https://crux-taurus-servicio-integracion.azurewebsites.net/api/Integracion/ObtenerToken";
RESTConfig.WS_SINPE_REFRESH_TOKEN = "https://crux-taurus-servicio-integracion.azurewebsites.net/api/Integracion/RefrescarToken";
RESTConfig.WS_SINPE_CONSULTA_PAGO = "https://crux-taurus-servicio-integracion.azurewebsites.net/api/Pago/ConsultaPago";
RESTConfig.WS_SINPE_VINCULAR_PAGO = "https://crux-taurus-servicio-integracion.azurewebsites.net/api/Pago/VincularPago";
RESTConfig.WS_SINPE_VINCULAR_PAGO_1PASO = "https://crux-taurus-servicio-integracion.azurewebsites.net/api/Pago/VincularPagoEnUnPaso";
//# sourceMappingURL=rest-config.js.map

/***/ }),

/***/ 148:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSectionService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_home_section_model__ = __webpack_require__(1148);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_home_section_products_model__ = __webpack_require__(1149);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__products_model_product_model__ = __webpack_require__(71);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let HomeSectionService = class HomeSectionService {
    constructor(rest) {
        this.rest = rest;
    }
    getSections(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_home_section_model__["a" /* HomeSectionMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_SECTIONS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_home_section_model__["a" /* HomeSectionMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getSectionsProducts(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_home_section_products_model__["a" /* HomeSectionProductsMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_SECTIONS_DETAIL, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_6__products_model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
HomeSectionService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], HomeSectionService);

//# sourceMappingURL=home-section-service.js.map

/***/ }),

/***/ 156:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImageCachingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_file__ = __webpack_require__(210);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_transfer__ = __webpack_require__(440);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let ImageCachingService = class ImageCachingService {
    constructor(platform, transfer, file, alertCtrl) {
        this.platform = platform;
        this.transfer = transfer;
        this.file = file;
        this.alertCtrl = alertCtrl;
        this.storageDirectory = '';
        this.platform.ready().then(() => {
            // make sure this is on a device, not an emulation (e.g. chrome tools device mode)
            if (!this.platform.is('cordova')) {
                return false;
            }
            if (this.platform.is('ios')) {
                this.storageDirectory = cordova.file.documentsDirectory;
            }
            else if (this.platform.is('android')) {
                this.storageDirectory = cordova.file.dataDirectory;
            }
            else {
                // exit otherwise, but you could add further types here e.g. Windows
                return false;
            }
        });
    }
    downloadFile(url, fileId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            this.platform.ready().then(() => {
                const fileTransfer = this.transfer.create();
                fileTransfer.download(url, this.storageDirectory + fileId).then((entry) => {
                    observer.next(true);
                    observer.complete();
                }, (error) => {
                    observer.next(false);
                    observer.complete();
                });
            });
        });
    }
    checkIfFileIsDownloaded(fileId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            this.file.checkFile(this.storageDirectory, fileId)
                .then((result) => {
                observer.next(result);
                observer.complete();
            }).catch((err) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    clearFile(fileId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            this.file.removeFile(this.storageDirectory, fileId)
                .then((result) => {
                observer.next(result.success);
                observer.complete();
            }).catch((err) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    getFilePath(fileId) {
        return this.storageDirectory + fileId;
    }
};
ImageCachingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Platform"], __WEBPACK_IMPORTED_MODULE_4__ionic_native_file_transfer__["a" /* FileTransfer */], __WEBPACK_IMPORTED_MODULE_3__ionic_native_file__["a" /* File */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["AlertController"]])
], ImageCachingService);

//# sourceMappingURL=image-caching-service.js.map

/***/ }),

/***/ 157:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PurchaseOrderService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__ionic_native_device__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__ = __webpack_require__(1061);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__util_rest_native_client__ = __webpack_require__(104);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__rewards_model_giftcard_model__ = __webpack_require__(442);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_ionic_angular__ = __webpack_require__(8);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











let PurchaseOrderService = class PurchaseOrderService {
    constructor(rest, nativeRest, session, platform, device) {
        this.rest = rest;
        this.nativeRest = nativeRest;
        this.session = session;
        this.platform = platform;
        this.device = device;
    }
    //Consultar una orden de compra
    getPurchaseOrders(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_PURCHASE_ORDER, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Agregar una orden de compra
    addPurchaseOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_ADD_PURCHASE_ORDER, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseToModel(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Modificar Orden de compra
    modifyPurchaseOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_MODIFY_PURCHASE_ORDER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    let model = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseToModel(item);
                    //Si hubo un error en la respuesta
                    if (model.status == 1) {
                        observer.error(new Error("La orden no se pudo guardar"));
                    }
                    else {
                        observer.next(model);
                        observer.complete();
                    }
                }
                else {
                    observer.error(new Error("Respuesta no es valida"));
                }
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Eliminar Orden de compra
    deletePurchaseOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_DELETE_PURCHASE_ORDER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseToModel(item));
                    observer.complete();
                }
                else {
                    observer.error(new Error("Respuesta no es valida"));
                }
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Consultar producto de Orden de compra
    getPurchaseOrderDetail(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest
                .get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_PRODUCT_PURCHASE_ORDER, request)
                .subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    getPurchaseOrderDetailForRefund(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest
                .get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_PRODUCT_PURCHASE_ORDER, request)
                .subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseListToModelListForRefund(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Agregar producto de Orden de compra
    addPurchaseOrderDetail(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest
                .getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_ADD_PRODUCT_PURCHASE_ORDER, request)
                .subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseToModel(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Modifica producto de Orden de compra
    modifyPurchaseOrderDetail(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest
                .getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_MODIFY_PRODUCT_PURCHASE_ORDER, request)
                .subscribe((response) => {
                try {
                    this.addSimpleLog("CARRITO " + params.orderId + " - ACTUALIZANDO DETALLE", request +
                        "(RESULTADO estado: " +
                        response.estado +
                        " mensaje:" +
                        response.mensaje +
                        ")").subscribe();
                }
                catch (e) {
                    console.log(e);
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseToModel(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Reserva articulos para una orden
    lockPurchaseOrderDetail(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_LOCK_PRODUCT_DETAIL, request).subscribe((response) => {
                let model = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseToModel(response);
                params.status = model.status;
                params.message = model.message;
                observer.next(params);
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.next(null);
                observer.complete();
            });
        });
    }
    //Liberar articulos para una orden
    releasePurchaseOrderDetail(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest
                .getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_RELEASE_PRODUCT_DETAIL, request)
                .subscribe((response) => {
                let model = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseToModel(response);
                params.status = model.status;
                params.message = model.message;
                observer.next(params);
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Liberar articulos para una orden utilizando HTTP nativo
    releasePurchaseOrderDetailViaNative(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            /*this.rest.getFirst(RESTConfig.WS_RELEASE_PRODUCT_DETAIL, request).subscribe(
                    (response: PurchaseOrderDetailResponse) => {
                        observer.next(PurchaseOrderDetailMapper.convertResponseToModel(response));
                        observer.complete();
                    },
                    //Si hubo algun error
                    error => {
                        observer.error(error);
                    }
                );*/
            this.nativeRest
                .getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_RELEASE_PRODUCT_DETAIL, request)
                .subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseToModel(response));
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    //Elimina producto de Orden de compra
    deleteProductPurchaseOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest
                .getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_DELETE_PRODUCT_PURCHASE_ORDER, request)
                .subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["a" /* PurchaseOrderDetailMapper */].convertResponseToModel(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Valida Orden de compra
    validatePurchaseOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_VALIDATE_PURCHASE_ORDER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseToModel(item));
                    observer.complete();
                }
                else {
                    observer.next(null);
                    observer.complete();
                }
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Activa Orden de compra
    activePurchaseOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_ACTIVE_PURCHASE_ORDER, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseToModel(item));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Seguimiento Orden de compra
    trackPurchaseOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_TRACING_PURCHASE_ORDER, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertTrackingResponseListToModelList(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Seguimiento Orden de compra via Correos de Costa Rica
    trackPurchaseOrderViaCCR(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            params.ccrTrackingCode = params.ccrTrackingCode;
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest
                .get(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_TRACING_PURCHASE_ORDER_VIA_CCR, request)
                .subscribe((response) => {
                let trackingInfo;
                if (response) {
                    trackingInfo = response.listadoField;
                }
                observer.next(trackingInfo ? JSON.parse(trackingInfo) : trackingInfo);
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Seguimiento Orden de compra
    getPurchaseOrderPaymentInfo(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_ORDER_PAYMENT_INFO, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseToModel(response));
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Aplica un cupon a la orden
    applyCoupon(params) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_9__rewards_model_giftcard_model__["a" /* GiftCardMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_APPLY_ORDER_COUPON, request).subscribe((response) => {
                let model = __WEBPACK_IMPORTED_MODULE_5__model_purchase_order_model__["b" /* PurchaseOrderMapper */].convertResponseToModel(response);
                model.status = parseInt(response.estado);
                observer.next(model);
                observer.complete();
            }, 
            //Si hubo algun error
            (error) => {
                observer.error(error);
            });
        });
    }
    //Agregar una orden de compra
    addSimpleLog(functionality, message) {
        let params = {
            id_usuario: this.session.getPrincipal().userId,
            token: this.session.getToken(),
            fecha: new Date().getTime(),
            dispositivo: this.platform.is("ios") ? "ios" : "android",
            dispositivoVersion: this.device.version,
            appVersion: __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].app.version,
            funcionalidad: functionality,
            trama: message,
        };
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Compone los parametros del WS
            this.nativeRest.post(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_ADD_PURCHASE_LOG, params).subscribe((response) => {
                observer.next();
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    //Agregar una orden de compra
    addPurchaseLog(functionality, order) {
        let params = {
            id_usuario: this.session.getPrincipal().userId,
            token: this.session.getToken(),
            fecha: new Date().getTime(),
            dispositivo: this.platform.is("ios") ? "ios" : "android",
            dispositivoVersion: this.device.version,
            appVersion: __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].app.version,
            funcionalidad: functionality,
            trama: JSON.stringify(order),
        };
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            this.nativeRest.post(__WEBPACK_IMPORTED_MODULE_7__config_rest_config__["a" /* RESTConfig */].WS_ADD_PURCHASE_LOG, params).subscribe((response) => {
                observer.next();
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
};
PurchaseOrderService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_6__util_rest_client__["a" /* RESTClient */],
        __WEBPACK_IMPORTED_MODULE_8__util_rest_native_client__["a" /* NativeRESTClient */],
        __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_10_ionic_angular__["Platform"],
        __WEBPACK_IMPORTED_MODULE_0__ionic_native_device__["a" /* Device */]])
], PurchaseOrderService);

//# sourceMappingURL=purchase-order-service.js.map

/***/ }),

/***/ 158:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NotificationService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__ = __webpack_require__(1150);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__offers_service__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_ionic_angular__ = __webpack_require__(8);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









let NotificationService = class NotificationService {
    constructor(rest, 
        // private errHandler: ErrorService,
        events, sessionManager, offerService) {
        this.rest = rest;
        this.events = events;
        this.sessionManager = sessionManager;
        this.offerService = offerService;
        this.GENERAL_NOTIFICATIONS = "efast-generalNotifications";
        this.ORDERS_NOTIFICATIONS = "efast-ordersNotifications";
        this.DEALS_NOTIFICATIONS = "efast-dealsNotifications";
        this.downloaded_not = false;
    }
    downloadNotifications() {
        if (!this.downloaded_not) {
            this.downloadGeneralNotifications(() => {
                this.downloadOrdersNotifications(() => {
                    this.downloadDealsNotifications(() => {
                        setTimeout(() => {
                            this.updateUnreadCounter();
                        }, 1000);
                    });
                });
            });
            this.downloaded_not = true;
        }
        else {
            setTimeout(() => {
                this.updateUnreadCounter();
            }, 2000);
        }
    }
    downloadGeneralNotifications(callback) {
        var lastMonth = new Date();
        lastMonth.setMonth(lastMonth.getMonth() - 1);
        var date = new Date();
        var params = {};
        params.userId = this.sessionManager.getPrincipal().userId;
        params.token = this.sessionManager.getToken();
        params.startDate = lastMonth.getTime();
        params.finishDate = date.getTime();
        params.type = null;
        this.getNotifications(this.GENERAL_NOTIFICATIONS, params).subscribe((list) => {
            this.storeNotifications(this.GENERAL_NOTIFICATIONS, list);
            if (callback)
                callback();
        });
    }
    downloadOrdersNotifications(callback) {
        var lastMonth = new Date();
        lastMonth.setMonth(lastMonth.getMonth() - 1);
        var date = new Date();
        var params = {};
        params.userId = this.sessionManager.getPrincipal().userId;
        params.token = this.sessionManager.getToken();
        params.startDate = lastMonth.getTime();
        params.finishDate = date.getTime();
        params.type = null;
        this.getNotificationOrders(params).subscribe((list) => {
            this.storeNotifications(this.ORDERS_NOTIFICATIONS, list);
            if (callback)
                callback();
        });
    }
    downloadDealsNotifications(callback) {
        var lastMonth = new Date();
        lastMonth.setMonth(lastMonth.getMonth() - 1);
        var date = new Date();
        var params = {};
        params.userId = this.sessionManager.getPrincipal().userId;
        params.token = this.sessionManager.getToken();
        params.startDate = lastMonth.getTime();
        params.finishDate = date.getTime();
        params.type = null;
        this.offerService.getOffers(params).subscribe((offers) => {
            let offersNotifications = [];
            if (offers) {
                //let date = new Date().getTime();
                offers.forEach((offer) => {
                    var notification = {
                        date: offer.offerId,
                        message: offer.description,
                        uniqueId: offer.offerId,
                        image: offer.image,
                        read: offer.read,
                        titulo: offer.titulo
                    };
                    offersNotifications.push(notification);
                });
                if (offersNotifications.length > 0) {
                    for (let i = 0; i < offersNotifications.length; i++) {
                        this.performOfferDetailFetch(offersNotifications[i]).subscribe((result) => {
                            offersNotifications[i].details = result.details;
                            if (i + 1 === offersNotifications.length) {
                                this.storeNotifications(this.DEALS_NOTIFICATIONS, offersNotifications);
                                if (callback)
                                    callback();
                            }
                        });
                    }
                }
                else {
                    this.storeNotifications(this.DEALS_NOTIFICATIONS, offersNotifications);
                    if (callback)
                        callback();
                }
            }
            else {
                this.storeNotifications(this.DEALS_NOTIFICATIONS, offersNotifications);
                if (callback)
                    callback();
            }
        });
    }
    performOfferDetailFetch(parent) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            let offerParams = {};
            offerParams.token = this.sessionManager.getToken();
            offerParams.userId = this.sessionManager.getPrincipal().userId;
            offerParams.offerId = parent.uniqueId;
            this.offerService.getOfferDetail(offerParams).subscribe((list) => {
                parent.details = list;
                observer.next(parent);
                observer.complete();
            });
        });
    }
    storeNotifications(keyName, downloadedList) {
        this.sessionManager.set(keyName, downloadedList);
        //console.log("storeNotifications >> " +keyName + " : " + JSON.stringify(downloadedList));
        /*if(downloadedList && downloadedList.length > 0){
          for(let i=0; i<downloadedList.length; i++){
            if(downloadedList[i].read === 'N'){
              this.totalNotificationsUnread++;
            }
          }
        }*/
    }
    markAllAsRead(keyName) {
        const downloadedList = this.sessionManager.get(keyName);
        let someUnread = false;
        if (downloadedList && downloadedList.length > 0) {
            for (let j = 0; j < downloadedList.length; j++) {
                if (downloadedList[j].read === 'N') {
                    if (keyName === this.GENERAL_NOTIFICATIONS) {
                        this.markGeneralNotificationAsRead(downloadedList[j]).subscribe((response) => {
                            //console.log("Mandando a actualizar NOTIF...Listo");
                            downloadedList[j].read = 'S';
                            someUnread = true;
                        });
                    }
                    else if (keyName === this.DEALS_NOTIFICATIONS) {
                        this.markOfferNotificationAsRead(downloadedList[j]).subscribe((response) => {
                            //console.log("Mandando actualizar OFERTA...Listo");
                            downloadedList[j].read = 'S';
                            someUnread = true;
                        });
                    }
                    else if (keyName === this.ORDERS_NOTIFICATIONS) {
                        this.markGeneralNotificationAsRead(downloadedList[j]).subscribe((response) => {
                            //console.log("Mandando actualizar ORDERS...Listo");
                            downloadedList[j].read = 'S';
                            someUnread = true;
                        });
                    }
                }
            }
        }
        if (someUnread) {
            this.updateUnreadCounter();
        }
    }
    updateUnreadCounter() {
        let totalUnread = 0;
        this.getStoredNotifications(this.GENERAL_NOTIFICATIONS).subscribe((storedList) => {
            if (storedList && storedList.length > 0) {
                for (let j = 0; j < storedList.length; j++) {
                    if (storedList[j].read === "N") {
                        totalUnread++;
                    }
                    ;
                }
            }
            this.getStoredNotifications(this.ORDERS_NOTIFICATIONS).subscribe((storedList2) => {
                if (storedList2 && storedList2.length > 0) {
                    for (let j = 0; j < storedList2.length; j++) {
                        if (storedList2[j].read === "N") {
                            totalUnread++;
                        }
                        ;
                    }
                }
                this.getStoredNotifications(this.DEALS_NOTIFICATIONS).subscribe((storedList3) => {
                    if (storedList3 && storedList3.length > 0) {
                        for (let j = 0; j < storedList3.length; j++) {
                            if (storedList3[j].read === "N") {
                                totalUnread++;
                            }
                            ;
                        }
                    }
                    this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.NOTIFICATIONS_PROCESSED, totalUnread);
                });
            });
        });
    }
    removeNotifications() {
        this.sessionManager.getSession().storeItem(this.GENERAL_NOTIFICATIONS, []).subscribe();
        this.sessionManager.getSession().storeItem(this.ORDERS_NOTIFICATIONS, []).subscribe();
        this.sessionManager.getSession().storeItem(this.DEALS_NOTIFICATIONS, []).subscribe();
        this.sessionManager.set(this.GENERAL_NOTIFICATIONS, []);
        this.sessionManager.set(this.ORDERS_NOTIFICATIONS, []);
        this.sessionManager.set(this.DEALS_NOTIFICATIONS, []);
    }
    getStoredNotifications(keyName) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            const downloadedList = this.sessionManager.get(keyName);
            //console.log("getStoredNotifications >> " +keyName + " : " + JSON.stringify(downloadedList));
            observer.next(downloadedList);
            observer.complete();
        });
    }
    // Consultar Notificaciones Generales
    getNotifications(type, params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CHECK_NOTIFICATION, paramsString).subscribe(
            // this.rest.getNotificacionesDesa(RESTConfig.WS_CHECK_NOTIFICATION_HTML, paramsString).subscribe(
            (response) => {
                let result = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertResponseListToModelList(response);
                observer.next(result);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    markGeneralNotificationAsRead(notif) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            notif.userId = this.sessionManager.getPrincipal().userId;
            notif.token = this.sessionManager.getToken();
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertModelToRequest(notif);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_MARK_NOTIFICATION_AS_READ, paramsString).subscribe((response) => {
                let result = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertResponseListToModelList(response);
                observer.next(result);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    markOfferNotificationAsRead(notif) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            notif.userId = this.sessionManager.getPrincipal().userId;
            notif.token = this.sessionManager.getToken();
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertModelToRequest(notif);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_MARK_NOTIFICATION_OFFER, paramsString).subscribe((response) => {
                let result = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertResponseListToModelList(response);
                observer.next(result);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    // Consultar Notificaciones de Ofertas
    getNotificationOffers(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_NOTIFICATION_OFFERS, paramsString).subscribe(
            //this.rest.getFirst(RESTConfig.WS_CONSULT_NOTIFICATION_OFFERS, paramsString).subscribe(
            (response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    // Consultar Notificaciones de Puntos Ganados
    getNotificationPoints(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_NOTIFICATION_POINTS, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    // Consultar Notificaciones de Ordenes
    getNotificationOrders(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_NOTIFICATION_ORDERS, paramsString).subscribe((response) => {
                let result = __WEBPACK_IMPORTED_MODULE_4__model_notifications_model__["a" /* NotificationMapper */].convertResponseListToModelList(response);
                observer.next(result);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
NotificationService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */],
        __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_7__offers_service__["a" /* OffersService */]])
], NotificationService);

//# sourceMappingURL=notifications-service.js.map

/***/ }),

/***/ 160:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeFlexPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic2_super_tabs__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__security_providers_login_service__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ionic_native_screen_orientation__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__datasets_home_favs_dataset__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_status_bar__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__core_provider_caching_misuper_caching_service__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__core_provider_caching_category_caching_service__ = __webpack_require__(163);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__ionic_native_facebook__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__ionic_native_google_analytics__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__ionic_native_unique_device_id__ = __webpack_require__(289);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__security_providers_device_uniqueid_service__ = __webpack_require__(282);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__ionic_native_uid__ = __webpack_require__(623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__ionic_native_android_permissions__ = __webpack_require__(239);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__ionic_native_device__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__providers_home_misuper_service__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__datasets_home_categories_dataset__ = __webpack_require__(287);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__notifications_providers_notifications_service__ = __webpack_require__(158);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__security_providers_user_service__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__orders_providers_purchase_order_service__ = __webpack_require__(157);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};



























let HomeFlexPage = class HomeFlexPage {
    constructor(navCtrl, platform, toastCtrl, alertCtrl, statusBar, sessionManager, screenOrientation, cartManager, navParams, events, miSuperProductCache, categoryProductCache, translate, favsDataSet, authService, ga, facebook, uniqueDeviceID, uniqueIdService, uid, device, androidPermissions, misuperService, homeCategoryDataSet, notificationService, 
        //private productService: ProductService,
        orderService, userService) {
        this.navCtrl = navCtrl;
        this.platform = platform;
        this.toastCtrl = toastCtrl;
        this.alertCtrl = alertCtrl;
        this.statusBar = statusBar;
        this.sessionManager = sessionManager;
        this.screenOrientation = screenOrientation;
        this.cartManager = cartManager;
        this.navParams = navParams;
        this.events = events;
        this.miSuperProductCache = miSuperProductCache;
        this.categoryProductCache = categoryProductCache;
        this.translate = translate;
        this.favsDataSet = favsDataSet;
        this.authService = authService;
        this.ga = ga;
        this.facebook = facebook;
        this.uniqueDeviceID = uniqueDeviceID;
        this.uniqueIdService = uniqueIdService;
        this.uid = uid;
        this.device = device;
        this.androidPermissions = androidPermissions;
        this.misuperService = misuperService;
        this.homeCategoryDataSet = homeCategoryDataSet;
        this.notificationService = notificationService;
        this.orderService = orderService;
        this.userService = userService;
        this.sections = [];
        this.tabsLoaded = false;
        this.activeIndex = 0;
        this.defaultBlue = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultTabColor;
        //Global spinner
        this.showGlobalSpinner = true;
        this.totalNotificationsUnread = 0;
        this.tokenUpdated = false;
        this.pages = {
            page1: 'HomeSuggestedPage',
            page2: 'HomeFavsPage',
            page3: 'HomePromosPage',
            page4: 'HomeCategoriesPage',
            page5: 'HomeSeasonalPage',
            page6: 'HomeSectionPage',
            page7: 'HomeMiSuperPage',
            page8: 'HomePromosTemplatePage',
            page9: 'HomeCategoriesTemplatePage'
        };
        this.resizeCallback = () => {
            setTimeout(() => {
                this.content.resize();
            }, 100);
        };
    }
    enviarEvento(Evento) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield ga4CrearEvento(Evento);
        });
    }
    ionViewDidLoad() {
        //Permite el manejo de rotacion
        //this.screenOrientation.unlock();
        //Actualizacion de los tabs
        this.renderTabs();
        //Configuracion de recepcion de eventos para actualizar UI
        this.defineEvents();
        //Limpia caches
        this.miSuperProductCache.clear();
        this.categoryProductCache.clear();
    }
    ionViewWillEnter() {
        //se comenta ya que el cambio se realiza segun color de categoria
        //this.statusBar.styleBlackTranslucent();
        //Almacena el ID unico del dispositivo
        this.storeUniqueDeviceID();
        //Limpiar timer del carrito
        this.sessionManager.setCheckoutProcessStarted(false);
        this.cartManager.clearTimer();
        let forceDetaultView = this.sessionManager.pull(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.LOBBY_FORCE_AUTOCHANGE_TO_DEFAULT_TAB);
        //Bandera global que especifica si cada vez que la pagina obtiene el focus
        //amerita la cancelacion del cambio al tab default y refrescado
        let cancelTabChangeAndRefresh = this.sessionManager.pull(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED);
        if (forceDetaultView || !cancelTabChangeAndRefresh) {
            //Siempre pone la primer seccion como default
            if (this.sections.length > 0) {
                this.activeSection = this.sections[0];
            }
            if (this.activeIndex != 0) {
                this.slideToIndex(0);
                this.activeIndex = 0;
                this.fireTabSettingsUpdate();
            }
            //Despiera envento para enfocar el tab actual
            this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_CURRENT_TAB_REFRESH_ON_FOCUS, {
                color: this.tabColor,
                activeSectionId: this.activeSection ? this.activeSection.sectionId : 0,
                tabType: this.activeSection ? this.activeSection.type : null,
                template: this.activeSection ? this.activeSection.template : null,
                templateType: this.activeSection ? this.activeSection.templateType : null
            });
        }
        //Despiera envento para enfocar el tab actual
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_CURRENT_TAB_GAIN_FOCUS, {
            color: this.tabColor,
            activeSectionId: this.activeSection ? this.activeSection.sectionId : 0,
            tabType: this.activeSection ? this.activeSection.type : null,
            template: this.activeSection ? this.activeSection.template : null,
            templateType: this.activeSection ? this.activeSection.templateType : null
        });
        //volver a poner el color de fondo al salir y regresar a categorias
        this.statusBar.backgroundColorByHexString(this.tabColor);
    }
    ionViewDidEnter() {
        //Carga en diferido informacion para Cache
        this.fetchLazyLobbyData();
        //Maneja la rotacion y el resize de los banners
        this.screenOrientation.onChange().subscribe(this.resizeCallback);
        //Valida si la sesion actual no ha vencido
        if (this.sessionManager.isSessionHalted()) {
            __WEBPACK_IMPORTED_MODULE_6__util_view_utils__["a" /* ViewUtils */].showAlert(this.alertCtrl, this.translate.instant('messages.sessionExpired'), () => {
                let user = this.sessionManager.getPrincipal();
                this.authService.logout(user).subscribe((result) => {
                    if (result) {
                        this.navCtrl.setRoot('LoginPage');
                    }
                    else {
                        __WEBPACK_IMPORTED_MODULE_6__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.closeSessionProblem"));
                    }
                });
            });
        }
        if (this.sessionManager.isAuthenticated()) {
            setTimeout(() => {
                this.updateUserFirebaseToken();
            }, 8000);
            setTimeout(() => {
                this.notificationService.downloadNotifications();
            }, 4000);
        }
    }
    ionViewWillLeave() {
        //Despiera envento para enfocar el tab actual
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_CURRENT_TAB_LOST_FOCUS, {
            color: this.tabColor,
            activeSectionId: this.activeSection ? this.activeSection.sectionId : 0,
            tabType: this.activeSection ? this.activeSection.type : null,
            template: this.activeSection ? this.activeSection.template : null,
            templateType: this.activeSection ? this.activeSection.templateType : null
        });
    }
    defineEvents() {
        //Cuando el carrito se actualiza
        this.cartStoredItems = this.cartManager.getStoredItemsQuantity();
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.SHOPPING_CART_REFRESHED, (cartStoredItems) => {
            //Setea la cantidad de items
            this.cartStoredItems = cartStoredItems;
        });
        //Cuando se solicita inicializar el estado del home
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_INITIALIZE, () => {
            //selecciona el primer tab
            this.slideToIndex(0);
            this.activeSection = this.sections[0];
            this.activeIndex = 0;
            this.fireTabSettingsUpdate();
            //Despiera envento para enfocar el tab actual
            this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_CURRENT_TAB_REFRESH_ON_FOCUS, {
                color: this.tabColor,
                activeSectionId: this.activeSection ? this.activeSection.sectionId : 0,
                tabType: this.activeSection ? this.activeSection.type : null,
                template: this.activeSection ? this.activeSection.template : null,
                templateType: this.activeSection ? this.activeSection.templateType : null
            });
        });
        //Cuando el VIEW que esta contenido en el tab principal esta listo y cargado
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.HOME_MAIN_TAB_WILL_ENTER, () => {
            if (this.showGlobalSpinner) {
                setTimeout(() => {
                    this.ga.trackView('Lobby de ' + this.activeSection.sectionName).then(() => { }).catch(e => console.log(e));
                    this.enviarEvento('Lobby de ' + this.activeSection.sectionName);
                    let params = {
                        fb_content_id: this.activeSection.sectionName,
                        fb_content_type: "Lobby"
                    };
                    this.facebook.logEvent("fb_mobile_content_view", params).then(() => { }).catch(e => console.log(e));
                }, 1000);
            }
            //Oculta el spinner general
            this.showGlobalSpinner = false;
        });
        //Eventos que se ejecutan cuando hay cambios en la data de favoritos
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_CART_LIST, () => { this.reloadFavs(); });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_SAVED_LIST, () => { this.reloadFavs(); });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_WISHLIST_LIST, () => {
            this.reloadFavs();
        });
        //Cuando la conexion retorna
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.NOTIFICATIONS_PROCESSED, (counter) => {
            this.totalNotificationsUnread = counter;
        });
        //this.statusBar.backgroundColorByHexString(this.tabColor);
    }
    reloadFavs() {
        //if(this.activeSection.type === AppConfig.lobby.FAVS_TYPE){
        //Pone el view en modo de carga de datos y dado que es un Tab compartido se elimina cualquier dado precargado
        this.favsDataSet.clear();
        //Recupera los datos del Dataset
        this.favsDataSet.fetch(() => {
            //Despiera envento para enfocar el tab actual
            this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_RESPONSE_TO_FAVS_CHANGE, {
                color: this.tabColor,
                activeSectionId: this.activeSection ? this.activeSection.sectionId : 0,
                tabType: this.activeSection ? this.activeSection.type : null,
                template: this.activeSection ? this.activeSection.template : null,
                templateType: this.activeSection ? this.activeSection.templateType : null
            });
        });
        //}
    }
    renderTabs() {
        this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.HOME_SECTIONS).subscribe((data) => {
            this.handleSections(data);
        });
    }
    handleSections(data) {
        //Valida los datos de cada seccion
        if (data && data.length > 0) {
            for (let i = 0; i < data.length; i++) {
                let section = data[i];
                if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isNotEmpty(section.color)) {
                    section.color = "#" + section.color;
                }
                else {
                    section.color = this.defaultBlue;
                }
                if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isNotEmpty(section.type)) {
                    let pageName = "";
                    let type = section.template == 'S' ? section.templateType : section.type;
                    switch (type) {
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.SUGGESTED_TYPE:
                            pageName = "page1";
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.FAVS_TYPE:
                            pageName = "page2";
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.PROMOS_TYPE:
                            if (section.template == 'S') {
                                pageName = "page8";
                            }
                            else {
                                pageName = "page3";
                            }
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.CATEGORIES_TYPE:
                            if (section.template == 'S') {
                                pageName = "page9";
                            }
                            else {
                                pageName = "page4";
                            }
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.CATEGORIES_TILDE_TYPE:
                            if (section.template == 'S') {
                                pageName = "page9";
                            }
                            else {
                                pageName = "page4";
                            }
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.SEASONS_TYPE:
                            pageName = "page5";
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.OTHERS_TYPE:
                            pageName = "page6";
                            break;
                        case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.MISUPER_TYPE:
                            pageName = "page7";
                            break;
                    }
                    section.pageName = pageName;
                }
                if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isNotEmpty(section.pageName) &&
                    __WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isNotEmpty(section.visible) &&
                    section.visible === "S") {
                    this.sections.push(section);
                }
            }
        }
        //Ordena las secciones
        this.sections.sort(function (a, b) {
            return a.order - b.order;
        });
        //Seccion activa por default
        if (this.sections.length > 0) {
            this.activeSection = this.sections[0];
            this.fireTabSettingsUpdate();
        }
        this.tabsLoaded = true;
    }
    onTabSelect(ev) {
        //Valida si se le da tab al mismo que esta seleccionado
        if (this.activeIndex === ev.index) {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_CURRENT_TAB_TABBED, {
                color: this.tabColor,
                activeSectionId: this.activeSection ? this.activeSection.sectionId : 0,
                tabType: this.activeSection ? this.activeSection.type : null,
                template: this.activeSection ? this.activeSection.template : null,
                templateType: this.activeSection ? this.activeSection.templateType : null
            });
        }
        else {
            //Es un nuevo tab el que va a quedar vigente
            this.activeIndex = ev.index;
            this.previousSection = this.activeSection;
            this.activeSection = this.sections.find(i => i.sectionId === ev.id);
            this.fireTabSettingsUpdate();
            setTimeout(() => {
                this.ga.trackView('Lobby de ' + this.activeSection.sectionName).then(() => { }).catch(e => console.log(e));
                this.enviarEvento('Lobby de ' + this.activeSection.sectionName);
                let params = {
                    fb_content_id: this.activeSection.sectionName,
                    fb_content_type: "Lobby"
                };
                this.facebook.logEvent("fb_mobile_content_view", params).then(() => { }).catch(e => console.log(e));
                if (this.sessionManager.isAuthenticated()) {
                    setTimeout(() => {
                        this.notificationService.downloadNotifications();
                    }, 3000);
                }
            }, 1000);
            //Colocar el nuevo color en el statusBar
            //this.statusBar.backgroundColorByHexString(this.tabColor);
        }
    }
    fireTabSettingsUpdate() {
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.TAB, this.activeSection ? this.activeSection.type : null);
        this.tabColor = this.activeSection ? this.activeSection.color : this.defaultBlue;
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.FLEX_HOME_TAB_CHANGED, {
            color: this.tabColor,
            activeSectionId: this.activeSection ? this.activeSection.sectionId : 0,
            tabType: this.activeSection ? this.activeSection.type : null,
            template: this.activeSection ? this.activeSection.template : null,
            templateType: this.activeSection ? this.activeSection.templateType : null
        });
        this.statusBar.backgroundColorByHexString(this.tabColor);
    }
    slideToIndex(index) {
        this.superTabs.slideTo(index);
    }
    openSearch() {
        //Marca en sesion el tab que esta activo
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.SIDEBAR_MENU_OPTION_REQUESTED);
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.GLOBAL_MENU_SEARCH_OPTION_REQUESTED);
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.TAB, this.activeSection ? this.activeSection.type : null);
        this.changeStatusBarColor();
        setTimeout(() => {
            this.navCtrl.push('SearchPage');
        }, 200);
    }
    openSearchLive() {
        //Marca en sesion el tab que esta activo
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.SIDEBAR_MENU_OPTION_REQUESTED);
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.GLOBAL_MENU_SEARCH_OPTION_REQUESTED);
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.TAB, this.activeSection ? this.activeSection.type : null);
        this.changeStatusBarColor();
        setTimeout(() => {
            this.navCtrl.push('SearchPage');
        }, 200);
    }
    openCart() {
        //Marca en sesion el tab que esta activo
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.SIDEBAR_MENU_OPTION_REQUESTED);
        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.GLOBAL_MENU_CART_OPTION_REQUESTED);
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].lobby.TAB, this.activeSection ? this.activeSection.type : null);
        this.changeStatusBarColor();
        this.navCtrl.push('CartPage');
    }
    navbarBackground() {
        return { "background-color": this.tabColor, "color": "white" };
    }
    storeUniqueDeviceID() {
        if (this.sessionManager.isAuthenticated()) {
            //Valida si el Device ID ya se registro
            let isDeviceRegistered = this.sessionManager.get(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_REGISTERED);
            if (!isDeviceRegistered) {
                if (this.platform.is("ios")) {
                    this.registerDeviceUUID();
                }
                else {
                    this.registerNativeDeviceUUID();
                }
            }
        }
        else {
            this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_REGISTERED, false);
        }
    }
    registerNativeDeviceUUID() {
        let nuuid = this.device.uuid;
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID, nuuid);
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_TYPE, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_TYPE_UUID);
        this.uniqueIdService.registerUUID(this.sessionManager.getSession().toModel(), nuuid).subscribe((result) => {
            this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_REGISTERED, result);
        });
    }
    registerDeviceUUID() {
        this.uniqueDeviceID.get()
            .then((uuid) => {
            this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID, uuid);
            this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_TYPE, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_TYPE_UUID);
            this.uniqueIdService.registerUUID(this.sessionManager.getSession().toModel(), uuid).subscribe((result) => {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_REGISTERED, result);
            });
        })
            .catch((error) => console.log(error));
    }
    registerImei() {
        return __awaiter(this, void 0, void 0, function* () {
            const { hasPermission } = yield this.androidPermissions.checkPermission(this.androidPermissions.PERMISSION.READ_PHONE_STATE);
            if (!hasPermission) {
                const result = yield this.androidPermissions.requestPermission(this.androidPermissions.PERMISSION.READ_PHONE_STATE);
                if (!result.hasPermission) {
                    //Fallback, dado que siempre se debe guardar un ID para el dispositov
                    this.registerDeviceUUID();
                }
            }
            else {
                let imei = this.uid.IMEI;
                if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isNotEmpty(imei)) {
                    this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID, imei);
                    this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_TYPE, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_TYPE_IMEI);
                    this.uniqueIdService.registerIMEI(this.sessionManager.getSession().toModel(), imei).subscribe((result) => {
                        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DEVICE_UNIQUE_ID_REGISTERED, result);
                    });
                }
                else {
                    //Fallback, dado que siempre se debe guardar un ID para el dispositov
                    this.registerDeviceUUID();
                }
            }
        });
    }
    fetchLazyLobbyData() {
        return __awaiter(this, void 0, void 0, function* () {
            //Lobby de Mi Super
            setTimeout(() => {
                this.misuperService.performGroupsInitLazy(this.sessionManager.getSession().toModel()).subscribe((data) => { });
            }, 2000);
            //Lobby de Categorias
            setTimeout(() => {
                this.homeCategoryDataSet.performInitCategories().subscribe(() => { });
            }, 4000);
        });
    }
    updateUserFirebaseToken() {
        return __awaiter(this, void 0, void 0, function* () {
            const deviceToken = this.sessionManager.getPushNotificationDeviceId();
            let user = this.sessionManager.getPrincipal();
            if (deviceToken) {
                if (!this.tokenUpdated) {
                    user.deviceToken = deviceToken;
                    this.userService.modifyUser(user).subscribe((resultUser) => {
                        //this.tokenUpdated = true;
                        this.sessionManager.getSession().updatePrincipal(user);
                        this.addLog("[PUSH_NOTIFICATION] STORE TOKEN " + user.userId + " ", JSON.stringify(user));
                    }, error => {
                        this.addLog("[PUSH_NOTIFICATION] STORE TOKEN " + user.userId + " - ERROR", JSON.stringify(error));
                    });
                }
            }
            else {
                const deviceTokenErr = this.sessionManager.getPushNotificationDeviceErr();
                if (deviceTokenErr) {
                    this.addLog("[PUSH_NOTIFICATION] STORE TOKEN " + user.userId + " - ERROR", deviceTokenErr);
                }
                else {
                    this.addLog("[PUSH_NOTIFICATION] STORE TOKEN " + user.userId + " - ERROR", "NO HAY TOKEN, NO HAY PERMISOS PARA ENVIAR PUSH NOTIFICATION");
                }
            }
        });
    }
    addLog(functionality, message) {
        try {
            this.orderService.addSimpleLog(functionality, message).subscribe();
        }
        catch (e) {
            console.log(e);
        }
    }
    openNotificationsPage() {
        this.changeStatusBarColor();
        this.navCtrl.push('NotificationCenterPage');
    }
    changeStatusBarColor() {
        this.statusBar.backgroundColorByHexString("#2471a3");
        this.statusBar.styleBlackTranslucent();
    }
};
__decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2_ionic2_super_tabs__["a" /* SuperTabs */]),
    __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2_ionic2_super_tabs__["a" /* SuperTabs */])
], HomeFlexPage.prototype, "superTabs", void 0);
__decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('content'),
    __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Content"])
], HomeFlexPage.prototype, "content", void 0);
HomeFlexPage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'page-home-flex',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\home\pages\home-flex.html"*/'<ion-header no-border no-shadow [ngStyle]="navbarBackground()">\n\n \n\n  <ion-navbar transparent>\n\n    <button ion-button menuToggle color="light">\n\n      <ion-icon name="md-menu"></ion-icon>\n\n    </button>\n\n    <ion-title color="light">\n\n      <div class="title-bar">\n\n        <img showWhen="android,windows" class="title-image" height="40" alt="logo"\n\n          src="assets/images/general/Logo-E-Fast.png">\n\n        <img showWhen="ios" height="40" alt="logo" src="assets/images/general/Logo-E-Fast.png">\n\n      </div>\n\n    </ion-title>\n\n    <ion-buttons end>\n\n      <!--<button ion-button button-clear icon-only class="button button-action button-clear" tappable\n\n        (click)="openSearchLive()">\n\n        <ion-icon name="md-search" style="font-size: 30px; color:white"></ion-icon>\n\n      </button>-->\n\n      <button ion-button button-clear icon-only class="button button-action button-clear" tappable\n\n        (click)="openSearch()">\n\n        <ion-icon name="md-search" style="font-size: 30px; color:white"></ion-icon>\n\n    </button>\n\n      <button ion-button button-clear icon-only class="button button-clear" tappable (click)="openCart()">\n\n        <ion-icon name="md-cart" style="font-size: 30px; color:white"></ion-icon>\n\n        <div class="shopping-cart"><span class="badge badge-assertive header-badge"\n\n            style="color:white">{{cartStoredItems}}</span></div>\n\n      </button>\n\n    </ion-buttons>\n\n  </ion-navbar>\n\n\n\n</ion-header>\n\n\n\n<ion-content #content no-bounce [ngStyle]="navbarBackground()" fullscreen #myContent>\n\n  <ion-spinner name="circles" color="light" *ngIf="showGlobalSpinner"></ion-spinner>\n\n  <super-tabs tappable *ngIf="tabsLoaded" id="mainTabs" scrollTabs toolbarBackground="alpha" toolbarColor="light"\n\n    indicatorColor="light"\n\n    [config]="{ sideMenu: \'left\', transitionDuration: 300, shortSwipeDuration: 300, tabsPlacement: \'top\' }"\n\n    (tabSelect)="onTabSelect($event)" no-border no-shadow>\n\n    <super-tab tappable *ngFor="let section of sections" [root]="pages[section.pageName]" [title]="section.sectionName"\n\n      [id]="section.sectionId"></super-tab>\n\n  </super-tabs>\n\n\n\n  <ion-fab *ngIf="totalNotificationsUnread > 0" right bottom>\n\n    <button ion-fab class="button-notifications" (click)="openNotificationsPage();">\n\n      <!--<button ion-fab class="button-notifications" (click)="this.navCtrl.push(\'NotificationCenterPage\');">-->\n\n      <ion-icon name="mail" style="font-size: 30px; color:white"></ion-icon>\n\n      <div class="shopping-cart"><span class="badge badge-assertive header-badge"\n\n          style="color:white">&nbsp;{{totalNotificationsUnread}}</span></div>\n\n    </button>\n\n  </ion-fab>\n\n\n\n</ion-content>'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\home\pages\home-flex.html"*/
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Platform"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["AlertController"],
        __WEBPACK_IMPORTED_MODULE_12__ionic_native_status_bar__["a" /* StatusBar */],
        __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_9__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
        __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__["a" /* CartManagerService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavParams"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_13__core_provider_caching_misuper_caching_service__["a" /* MiSuperCachingService */],
        __WEBPACK_IMPORTED_MODULE_14__core_provider_caching_category_caching_service__["a" /* CategoryCachingService */],
        __WEBPACK_IMPORTED_MODULE_7__ngx_translate_core__["c" /* TranslateService */],
        __WEBPACK_IMPORTED_MODULE_11__datasets_home_favs_dataset__["a" /* HomeFavsDataSet */],
        __WEBPACK_IMPORTED_MODULE_8__security_providers_login_service__["a" /* LoginService */],
        __WEBPACK_IMPORTED_MODULE_16__ionic_native_google_analytics__["a" /* GoogleAnalytics */],
        __WEBPACK_IMPORTED_MODULE_15__ionic_native_facebook__["a" /* Facebook */],
        __WEBPACK_IMPORTED_MODULE_17__ionic_native_unique_device_id__["a" /* UniqueDeviceID */],
        __WEBPACK_IMPORTED_MODULE_18__security_providers_device_uniqueid_service__["a" /* UniqueIdService */],
        __WEBPACK_IMPORTED_MODULE_19__ionic_native_uid__["a" /* Uid */],
        __WEBPACK_IMPORTED_MODULE_21__ionic_native_device__["a" /* Device */],
        __WEBPACK_IMPORTED_MODULE_20__ionic_native_android_permissions__["a" /* AndroidPermissions */],
        __WEBPACK_IMPORTED_MODULE_22__providers_home_misuper_service__["a" /* HomeMiSuperService */],
        __WEBPACK_IMPORTED_MODULE_23__datasets_home_categories_dataset__["a" /* HomeCategoriesDataSet */],
        __WEBPACK_IMPORTED_MODULE_24__notifications_providers_notifications_service__["a" /* NotificationService */],
        __WEBPACK_IMPORTED_MODULE_26__orders_providers_purchase_order_service__["a" /* PurchaseOrderService */],
        __WEBPACK_IMPORTED_MODULE_25__security_providers_user_service__["a" /* UserService */]])
], HomeFlexPage);

//# sourceMappingURL=home-flex.js.map

/***/ }),

/***/ 161:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomePromosTemplateTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__ = __webpack_require__(79);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomePromosTemplateTabbedDataSet = class HomePromosTemplateTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__["a" /* TabbedDataSet */] {
    constructor(sessionManager, sectionService) {
        super();
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
        //this.setPreviewPageSize(50); //Muestra una cantidad para preview
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setSectionListToQuery(sections) {
        this.sectionListToQuery = "";
        if (sections != null && sections.length > 0) {
            for (let i = 0; i < sections.length; i++) {
                let section = sections[i];
                this.sectionListToQuery += (section.code + ",");
            }
        }
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            //let useList: boolean = false;
            let section;
            if (!this.sectionCode) {
                section = this.sectionListToQuery;
                //useList = true;
            }
            else {
                section = this.sectionCode;
            }
            this.sectionService.getProductsByHallwaySection(session, this.lobbyId, this.groupCode, section, fetchPageId, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomePromosTemplateTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__["a" /* SectionService */]])
], HomePromosTemplateTabbedDataSet);

//# sourceMappingURL=home-promos-template-tabbed-dataset.js.map

/***/ }),

/***/ 162:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSectionGroupTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__home_providers_home_category_template_service__ = __webpack_require__(118);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__ = __webpack_require__(79);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeSectionGroupTabbedDataSet = class HomeSectionGroupTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__["a" /* TabbedDataSet */] {
    constructor(sessionManager, categoryTemplateService) {
        super();
        this.sessionManager = sessionManager;
        this.categoryTemplateService = categoryTemplateService;
        //this.setPreviewPageSize(50); //Muestra una cantidad para preview
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setSectionListToQuery(sections) {
        this.sectionListToQuery = "";
        if (sections != null && sections.length > 0) {
            for (let i = 0; i < sections.length; i++) {
                let section = sections[i];
                this.sectionListToQuery += (section.code + ",");
            }
        }
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            let user = this.sessionManager.getSession().getPrincipal();
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            //let useList: boolean = false;
            let section;
            if (!this.sectionCode) {
                section = this.sectionListToQuery;
                //useList = true;
            }
            else {
                section = this.sectionCode;
            }
            this.categoryTemplateService.getProductsByPage(parseInt(this.groupCode, 10), section, user, fetchPageId, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomeSectionGroupTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_0__home_providers_home_category_template_service__["a" /* HomeCategoryTemplateService */]])
], HomeSectionGroupTabbedDataSet);

//# sourceMappingURL=home-section-group-tabbed-dataset.js.map

/***/ }),

/***/ 163:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CategoryCachingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__caching_service__ = __webpack_require__(103);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let CategoryCachingService = class CategoryCachingService extends __WEBPACK_IMPORTED_MODULE_1__caching_service__["a" /* CachingService */] {
    constructor() {
        super();
    }
};
CategoryCachingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], CategoryCachingService);

//# sourceMappingURL=category-caching-service.js.map

/***/ }),

/***/ 164:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeCategoryTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__tabbed_dataset__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeCategoryTabbedDataSet = class HomeCategoryTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_4__tabbed_dataset__["a" /* TabbedDataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
        //this.setPreviewPageSize(50); //Muestra una cantidad para preview
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setSectionListToQuery(sections) {
        this.sectionListToQuery = "";
        if (sections != null && sections.length > 0) {
            for (let i = 0; i < sections.length; i++) {
                let section = sections[i];
                this.sectionListToQuery += (section.code + ",");
            }
        }
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var params = {};
            params.page = fetchPageId;
            params.records = __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.defaultPageSize;
            params.categoryCode = this.groupCode;
            params.subfamilyCode = null;
            let section;
            if (!this.sectionCode) {
                section = this.sectionListToQuery;
            }
            else {
                section = this.sectionCode;
            }
            params.familyCode = section;
            if (this.sessionManager.isAuthenticated()) {
                params.userId = this.sessionManager.getPrincipal().userId;
                params.token = this.sessionManager.getToken();
            }
            this.productService.searchByFamilyMerqueo(params).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
};
HomeCategoryTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], HomeCategoryTabbedDataSet);

//# sourceMappingURL=home-category-tabbed-dataset.js.map

/***/ }),

/***/ 165:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeFavsDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para el Tab de FAVORITOS
 */
let HomeFavsDataSet = class HomeFavsDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
        //this.setPreviewPageSize(50); //Muestra una cantidad para preview
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            this.productService.getFavoritedProducts(params).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomeFavsDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], HomeFavsDataSet);

//# sourceMappingURL=home-favs-dataset.js.map

/***/ }),

/***/ 166:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MiSuperCachingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__caching_service__ = __webpack_require__(103);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let MiSuperCachingService = class MiSuperCachingService extends __WEBPACK_IMPORTED_MODULE_1__caching_service__["a" /* CachingService */] {
    constructor() {
        super();
    }
};
MiSuperCachingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], MiSuperCachingService);

//# sourceMappingURL=misuper-caching-service.js.map

/***/ }),

/***/ 167:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OffersService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__products_model_product_model__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_model_offer_model__ = __webpack_require__(441);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__products_model_offer_detail_model__ = __webpack_require__(1151);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let OffersService = class OffersService {
    constructor(rest) {
        this.rest = rest;
    }
    getOffers(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__products_model_offer_model__["a" /* OfferMapper */].convertModelToRequest(params);
            //this.rest.getNotificacionesDesa(RESTConfig.WS_CONSULT_OFFERS_HTML, paramsString).subscribe(
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_OFFERS, paramsString).subscribe((response) => {
                let list = __WEBPACK_IMPORTED_MODULE_5__products_model_offer_model__["a" /* OfferMapper */].convertResponseListToModelList(response);
                observer.next(list);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consultar productos de una oferta
    getOfferDetail(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_6__products_model_offer_detail_model__["a" /* OfferProductsMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_OFFER_PRODUCTS, request).subscribe((response) => {
                let list = __WEBPACK_IMPORTED_MODULE_4__products_model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response);
                observer.next(list);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
OffersService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], OffersService);

//# sourceMappingURL=offers-service.js.map

/***/ }),

/***/ 17:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_product_attributes_model__ = __webpack_require__(1048);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__model_product_model__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__model_product_attributes_detail_model__ = __webpack_require__(1049);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__model_product_media_model__ = __webpack_require__(1050);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__ = __webpack_require__(1051);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__model_season_model__ = __webpack_require__(1052);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__model_season_detail_model__ = __webpack_require__(1053);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__model_product_search_model__ = __webpack_require__(1054);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__model_product_search_family_model__ = __webpack_require__(1055);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__model_product_related_model__ = __webpack_require__(1056);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__model_product_not_available_model__ = __webpack_require__(1057);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__model_product_recommendation_model__ = __webpack_require__(1058);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__model_product_group_model__ = __webpack_require__(1059);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__core_provider_image_caching_service__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__model_offer_model__ = __webpack_require__(441);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__core_provider_caching_category_caching_service__ = __webpack_require__(163);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__model_detartbanner_model__ = __webpack_require__(1060);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

























let ProductService = class ProductService {
    constructor(rest, events, sessionManager, imageCachingService, cache) {
        this.rest = rest;
        this.events = events;
        this.sessionManager = sessionManager;
        this.imageCachingService = imageCachingService;
        this.cache = cache;
    }
    getAttributes(sesion) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_product_attributes_model__["a" /* ProductAttributeMapper */].convertModelToRequest(sesion);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_ATTRIBUTES, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_4__model_product_attributes_model__["a" /* ProductAttributeMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getProductAttributes(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_7__model_product_attributes_detail_model__["b" /* ProductAttributeDetailMapper */].convertModelToRequest(product);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PRODUCT_ATTRIBUTES, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_7__model_product_attributes_detail_model__["b" /* ProductAttributeDetailMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getProductAttributesInfo(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_7__model_product_attributes_detail_model__["a" /* ProductAttributeDetailInfoMapper */].convertModelToRequest(product);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PRODUCT_ATTRIBUTES_INFO, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_7__model_product_attributes_detail_model__["a" /* ProductAttributeDetailInfoMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getProductMedia(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_8__model_product_media_model__["a" /* ProductMediaMapper */].convertModelToRequest(product);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PRODUCT_IMAGES, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_8__model_product_media_model__["a" /* ProductMediaMapper */].convertResponseToModel(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta los productos que ha visto un usuario
     */
    getRecentViewedProducts(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_USER_VIEWED_PRODUCTS, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                else {
                    response = [];
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta los productos sugeridos de la Seccion de TODO UN POCO
     */
    getSuggestedProducts(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_SUGGESTED_PRODUCTS, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                else {
                    response = [];
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getMySuggestedProducts(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_SUGGESTED_MY_INTEREST_PRODUCTS, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                else {
                    response = [];
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta Carrusel Global
     */
    performGlobalCarruselInit(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_GENERAL_CARRUSEL, paramsString).subscribe((response) => {
                if (response) {
                    var images = [];
                    for (var i = 0; i < response.length; i++) {
                        if (response[i].imagen && response[i].imagen.trim().length > 0) {
                            images.push(response[i]);
                        }
                    }
                    var filterImages = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertResponseListToModelList(images);
                    this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].session.GLOBAL_CARRUSEL, filterImages);
                    if (filterImages.length > 0) {
                        let promoImageCache = [];
                        __WEBPACK_IMPORTED_MODULE_20__util_view_utils__["a" /* ViewUtils */].performImageClearCaching(this.imageCachingService, "globalCarrusel", filterImages, promoImageCache, () => {
                            this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].session.GLOBAL_CARRUSEL_LOADED, true);
                            this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.GLOBAL_CARRUSEL_CHANGED);
                            observer.next();
                            observer.complete();
                        });
                    }
                    else {
                        observer.next();
                        observer.complete();
                    }
                }
                else {
                    response = [];
                    observer.next();
                    observer.complete();
                }
            }, error => {
                this.sessionManager.clear(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].session.GLOBAL_CARRUSEL);
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta Carrusel Global
     */
    getGlobalCarrusel(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_GENERAL_CARRUSEL, paramsString).subscribe((response) => {
                if (response) {
                    var images = [];
                    for (var i = 0; i < response.length; i++) {
                        if (response[i].imagen && response[i].imagen.trim().length > 0) {
                            images.push(response[i]);
                        }
                    }
                    let list = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertResponseListToModelList(images);
                    ///////////////////////////////////////////////
                    //FIX ionic 3, para mitigar el problema con el Carrusel infinito del Slider (PALEATIVO) el problema se solventa en IONIC 4
                    //https://github.com/ionic-team/ionic-v3/issues/511
                    //https://github.com/ionic-team/ionic/issues/11138
                    //https://github.com/ionic-team/ionic/issues/5050
                    //https://github.com/ionic-team/ionic-app-scripts/issues/1279
                    if (list && list.length > 0) {
                        let newList = [...list];
                        list = list.concat(newList);
                        newList = [...list];
                        if (list && list.length > 0) {
                            list = list.concat(newList);
                        }
                    }
                    ///////////////////////////////////////////////
                    observer.next(list);
                    observer.complete();
                }
                else {
                    response = [];
                    observer.next();
                    observer.complete();
                }
            }, error => {
                this.sessionManager.clear(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].session.GLOBAL_CARRUSEL);
                observer.error(error);
            });
        });
    }
    /**
     * Consulta Carrusel de Imagenes Principal
     */
    getMainImageCarrusel(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MAIN_CARRUSEL, paramsString).subscribe((response) => {
                if (response) {
                    var images = [];
                    for (var i = 0; i < response.length; i++) {
                        if (response[i].imagen && response[i].imagen.trim().length > 0) {
                            images.push(response[i]);
                        }
                    }
                }
                else {
                    response = [];
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertResponseListToModelList(images));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta Carrusel de Imagenes Destadados
     */
    getFeaturedImageCarrusel(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_FEATURED_CARRUSEL, paramsString).subscribe((response) => {
                if (response) {
                    var images = [];
                    for (var i = 0; i < response.length; i++) {
                        if (response[i].imagen && response[i].imagen.trim().length > 0) {
                            images.push(response[i]);
                        }
                    }
                }
                else {
                    images = [];
                }
                let list = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertResponseListToModelList(images);
                ///////////////////////////////////////////////
                //FIX ionic 3, para amortiguar el problema con el Carrusel infinito del Slider
                if (list && list.length > 0) {
                    let newList = [...list];
                    list = list.concat(newList);
                    newList = [...list];
                    if (list && list.length > 0) {
                        list = list.concat(newList);
                    }
                }
                ///////////////////////////////////////////////
                observer.next(list);
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta Carrusel de Imagenes Nuevos Productos
     */
    getNewProductsImageCarrusel(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_NEW_PRODUCTS_CARRUSEL, paramsString).subscribe((response) => {
                if (response) {
                    var images = [];
                    for (var i = 0; i < response.length; i++) {
                        if (response[i].imagen && response[i].imagen.trim().length > 0) {
                            images.push(response[i]);
                        }
                    }
                }
                else {
                    images = [];
                }
                let list = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertResponseListToModelList(images);
                /////////////////////////////////////////////
                //FIX ionic 3, para amortiguar el problema con el Carrusel infinito del Slider
                if (list && list.length > 0) {
                    let newList = [...list];
                    list = list.concat(newList);
                    newList = [...list];
                    if (list && list.length > 0) {
                        list = list.concat(newList);
                    }
                }
                ///////////////////////////////////////////////
                observer.next(list);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta de lista de productos para un banner
     */
    getBannerProductList(session, banner) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertBannerModelToRequest(session, banner);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_BANNER_LIST_PRODUCTS, paramsString).subscribe((response) => {
                if (response && response.length === 1) {
                    if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                        response = [];
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta los productos para un banner por Marca
     */
    getBannerProductBrandList(session, banner) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertBannerModelToRequest(session, banner);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_BANNER_BRAND_PRODUCTS, paramsString).subscribe((response) => {
                if (response && response.length === 1) {
                    if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                        response = [];
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta los productos para un banner por Marca
     */
    getBannerProductProviderList(session, banner) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_9__model_carrusel_model__["a" /* CarruselImageMapper */].convertBannerModelToRequest(session, banner);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_BANNER_PROVIDER_PRODUCTS, paramsString).subscribe((response) => {
                if (response && response.length === 1) {
                    if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                        response = [];
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta los productos de la Seccion de FAVORITOS
     */
    getFavoritedProducts(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_FAVORITED_PRODUCTS, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                else {
                    response = [];
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getPromosSectionTitles(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_22__model_offer_model__["b" /* OfferTitleMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PROMO_TITLE_LIST, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_22__model_offer_model__["b" /* OfferTitleMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta los productos de la Seccion de PROMOS
     */
    getPromoProducts(session, promoType, pageId, pageRows) {
        var filter = {
            userId: session && session.userId > 0 ? session.userId : null,
            token: session && session.token > 0 ? session.token : null,
            promoType: promoType,
            pageId: pageId,
            pageRows: pageRows
        };
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_PRODUCTS, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta los productos de la Seccion de PROMOS
     */
    getPromoProductsResume(session, promoType, pageRows) {
        var filter = {
            userId: session && session.userId > 0 ? session.userId : null,
            token: session && session.token > 0 ? session.token : null,
            promoType: promoType,
            pageId: 1,
            pageRows: pageRows
        };
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_PRODUCTS_INI, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta los productos de la Seccion de CATEGORIAS
     */
    getCategorizedProducts(session, categoryCode, pageId, pageRows) {
        var filter = {
            userId: session && session.userId > 0 ? session.userId : null,
            token: session && session.token > 0 ? session.token : null,
            categoryCode: categoryCode,
            pageId: pageId,
            pageRows: pageRows
        };
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PRODUCTS_BY_CATEGORY, paramsString).subscribe((response) => {
                if (response) {
                    //Valida respuesta vacia
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getCategorizedProductsResume(session, categoryCode, pageId, pageRows) {
        var filter = {
            userId: session && session.userId > 0 ? session.userId : null,
            token: session && session.token > 0 ? session.token : null,
            categoryCode: categoryCode,
            pageId: pageId,
            pageRows: pageRows
        };
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PRODUCTS_BY_CATEGORY_INI, paramsString).subscribe((response) => {
                if (response) {
                    //Valida respuesta vacia
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Consulta los temporadas
     */
    getSeasons(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_10__model_season_model__["a" /* SeasonMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_SEASONS, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_10__model_season_model__["a" /* SeasonMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getSeasonProducts(season) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_11__model_season_detail_model__["a" /* SeasonProductMapper */].convertModelToRequest(season);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_SEASON_PRODUCTS, request).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Consulta los criterios de filtrado
    getFilterAttributes(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_12__model_product_search_model__["a" /* ProductSearchMapper */].convertModelToFilterRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOOK_PRODUCTS_FILTERS, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseSearchAttListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consulta los valores de un criterio de filtrado
    getFilterAttributeValues(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_12__model_product_search_model__["a" /* ProductSearchMapper */].convertModelToFilterRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOOK_PRODUCTS_FILTERS_VALUES, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseSearchAttValueListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    searchFiltered(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_12__model_product_search_model__["a" /* ProductSearchMapper */].convertModelToFilterRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOOK_PRODUCTS_BY_FILTER, request).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Realizar búsqueda de productos
    search(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_12__model_product_search_model__["a" /* ProductSearchMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOOK_PRODUCTS, request).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Realizar búsqueda de productos
    searchNew(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_12__model_product_search_model__["a" /* ProductSearchMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOOK_PRODUCTS_NEW, request).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Realizar búsqueda de productos similares
    searchSimilar(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_12__model_product_search_model__["a" /* ProductSearchMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOOK_SIMILAR_PRODUCTS, request).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Realizar búsqueda de productos
    searchByCategoryAndFamily(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_13__model_product_search_family_model__["a" /* ProductFamilyCategorySearchMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SEARCH_BY_FAMILY_OR_CATEGORY, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Realizar búsqueda de productos solo por familia
    searchByFamily(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_13__model_product_search_family_model__["a" /* ProductFamilyCategorySearchMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SEARCH_BY_FAMILY, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Realizar búsqueda de productos solo por familia
    searchByFamilyMerqueo(filter) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_13__model_product_search_family_model__["a" /* ProductFamilyCategorySearchMapper */].convertModelToRequest(filter);
            //ID para cachear la pagina
            let url = __WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_CATEGORY_MERQUEO_PRODUCTS;
            if (paramsString) {
                url += ("?" + paramsString);
            }
            //Existe la data cacheada para el grupo
            let cacheList = this.cache.getPage(url);
            //console.log("searchByFamilyMerqueo VERIFICANDO si existe CACHE -> " + url);
            if (cacheList && cacheList.length > 0) {
                //console.log("searchByFamilyMerqueo CACHE -> " + url + " ITEMS GUARDADOS: " + cacheList.length);
                observer.next(cacheList);
                observer.complete();
            }
            else {
                this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_CATEGORY_MERQUEO_PRODUCTS, paramsString).subscribe((response) => {
                    if (response) {
                        if (response.length === 1) {
                            if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                                response = [];
                            }
                        }
                    }
                    else {
                        response = [];
                    }
                    //console.log("searchByFamilyMerqueo SERVER -> " + url + " ITEMS DESCARGADOS: " + response.length);
                    let list = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response);
                    this.cache.addPage(url, list);
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
    /**
     * Consulta los criterios de busqueda
     */
    getSearchCriteriaHistory(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SEARCH_HISTORY_QUERY, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    /**
     * Agrega un criterio de busqueda
     */
    addSearchCriteriaHistory(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertSearchTermModelToRequest(product);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SEARCH_HISTORY_ADD, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseToModel(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    // Consultar informacion general de articulos
    getProduct(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(product);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_ARTICLES, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseToModel(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    getDetBanner() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_DET_ART_BANNER).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_24__model_detartbanner_model__["a" /* DetArtBannerMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    //Productos relacionados a un producto dado
    getRelatedProducts(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_14__model_product_related_model__["a" /* RelatedProductsMapper */].convertModelToRequest(product);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_RELATED_PRODUCTS, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Productos similares a un producto dado
    getSimilarProducts(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_14__model_product_related_model__["a" /* RelatedProductsMapper */].convertModelToRequest(product);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SIMILAR_PRODUCTS, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Registrar Productos Sin Disponible
    registerProductWithoutAvailable(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_15__model_product_not_available_model__["a" /* ProductWithNotAvailableMapper */].convertModelToRequest(product);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_REGISTER_PRODUCT_WITHOUT_AVAILABLE, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_15__model_product_not_available_model__["a" /* ProductWithNotAvailableMapper */].convertResponseToModel(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    getProductRecommendations(recomendation) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_16__model_product_recommendation_model__["a" /* RecommendationMapper */].convertModelToRequest(recomendation);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_RECOMMENDATION, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_16__model_product_recommendation_model__["a" /* RecommendationMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    //Consultar una orden de compra
    addProductRecommendation(recomendation) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_16__model_product_recommendation_model__["a" /* RecommendationMapper */].convertModelToRequest(recomendation);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_ADD_RECOMMENDATION, request).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_16__model_product_recommendation_model__["a" /* RecommendationMapper */].convertResponseToModel(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
    addSavedProducts(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_ADD_PRODUCTS_SAVED, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    deleteSavedProducts(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_DELETE_PRODUCTS_SAVED, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getSavedProducts(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_PRODUCTS_SAVED, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_6__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getProductGroups(product) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_17__model_product_group_model__["a" /* ProductGroupMapper */].convertModelToRequest(product);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_GROUPS, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_17__model_product_group_model__["a" /* ProductGroupMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
};
ProductService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */],
        __WEBPACK_IMPORTED_MODULE_21_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_19__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_18__core_provider_image_caching_service__["a" /* ImageCachingService */],
        __WEBPACK_IMPORTED_MODULE_23__core_provider_caching_category_caching_service__["a" /* CategoryCachingService */]])
], ProductService);

//# sourceMappingURL=product-service.js.map

/***/ }),

/***/ 18:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RESTClient; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch__ = __webpack_require__(126);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_retry__ = __webpack_require__(176);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_retry___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_retry__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_timeout__ = __webpack_require__(177);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_timeout___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_timeout__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_map__ = __webpack_require__(128);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_map___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_map__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__logger_utils__ = __webpack_require__(307);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__modules_core_provider_error_service__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};












let RESTClient = class RESTClient {
    constructor(http, errHandler) {
        this.http = http;
        this.errHandler = errHandler;
    }
    get(resourceURL, params) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"]((observer) => {
            var url = __WEBPACK_IMPORTED_MODULE_8__config_rest_config__["a" /* RESTConfig */].ENDPOINT + "/" + resourceURL;
            if (params) {
                url += "?" + params;
            }
            //LoggerUtils.logWithDashSeparator(this, "URL: " + url);
            //let requestDate = new Date();
            //console.log("url:" + url);
            this.http.get(url).subscribe((response) => {
                //let responseDate = new Date();
                //let log = resourceURL + " ("+(Math.abs((responseDate.getTime() - requestDate.getTime()) / 1000))+" s) [PARAMS " + params + "]";
                //this.errHandler.log(log);
                //LoggerUtils.logWS(this, log);
                observer.next(response);
                observer.complete();
            }, (error) => {
                observer.error(this.errHandler.handleWS(this, __WEBPACK_IMPORTED_MODULE_11__config_config__["a" /* AppConfig */].err.HTTP_ERROR, error, url));
            });
        });
    }
    /*getNotificacionesDesa(resourceURL : string, params? : string): Observable<any>{
      return new Observable<any>(observer => {
        var url = RESTConfig.ENDPOINTDESA + "/" + resourceURL;
        if(params){
            url += ("?" + params);
        }
  
        //LoggerUtils.logWithDashSeparator(this, "URL: " + url);
        //let requestDate = new Date();
        //console.log("url:" + url);
        this.http.get(url).subscribe(response => {
  
            //let responseDate = new Date();
            //let log = resourceURL + " ("+(Math.abs((responseDate.getTime() - requestDate.getTime()) / 1000))+" s) [PARAMS " + params + "]";
            //this.errHandler.log(log);
            //LoggerUtils.logWS(this, log);
  
            observer.next(response);
            observer.complete();
        }, error => {
            observer.error(this.errHandler.handleWS(this, AppConfig.err.HTTP_ERROR, error, url));
        });
      });
    }*/
    getFirst(resourceURL, params) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"]((observer) => {
            this.get(resourceURL, params).subscribe((response) => {
                var itemToReturn = response;
                if (response) {
                    if (Object.prototype.toString.call(response) === "[object Array]" &&
                        response.length > 0) {
                        itemToReturn = response[0];
                    }
                }
                observer.next(itemToReturn);
                observer.complete();
            }, (err) => {
                observer.error(err);
            });
        });
    }
    /*getFDesa(resourceURL : string, params? : string): Observable<any>{
      return new Observable<any>(observer => {
          this.getDesa(resourceURL, params).subscribe(response => {
              var itemToReturn = response;
              if(response){
                  if(Object.prototype.toString.call( response ) === '[object Array]' && response.length > 0) {
                      itemToReturn = response[0];
                  }
              }
              observer.next(itemToReturn);
              observer.complete();
          }, err => {
            observer.error(err);
          });
      });
    }*/
    /*getDesa(resourceURL : string, params? : string): Observable<any>{
      return new Observable<any>(observer => {
        var url = RESTConfig.ENDPOINTDESA + "/" + resourceURL;
        if(params){
            url += ("?" + params);
        }
   
        //LoggerUtils.logWithDashSeparator(this, "URL: " + url);
        //let requestDate = new Date();
        //console.log("url:" + url);
        this.http.get(url).subscribe(response => {
   
            //let responseDate = new Date();
            //let log = resourceURL + " ("+(Math.abs((responseDate.getTime() - requestDate.getTime()) / 1000))+" s) [PARAMS " + params + "]";
            //this.errHandler.log(log);
            //LoggerUtils.logWS(this, log);
   
            observer.next(response);
            observer.complete();
        }, error => {
            observer.error(this.errHandler.handleWS(this, AppConfig.err.HTTP_ERROR, error, url));
        });
      });
    }*/
    /*getFirstDesa(resourceURL : string, params? : string): Observable<any>{
      return new Observable<any>(observer => {
          this.getNotificacionesDesa(resourceURL, params).subscribe(response => {
              var itemToReturn = response;
              if(response){
                  if(Object.prototype.toString.call( response ) === '[object Array]' && response.length > 0) {
                      itemToReturn = response[0];
                  }
              }
              observer.next(itemToReturn);
              observer.complete();
          }, err => {
            observer.error(err);
          });
      });
    }*/
    post(resourceURL, postData) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"]((observer) => {
            const headers = new __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["e" /* HttpHeaders */]().set("Content-Type", "application/json");
            var url = __WEBPACK_IMPORTED_MODULE_8__config_rest_config__["a" /* RESTConfig */].ENDPOINT + "/" + resourceURL;
            __WEBPACK_IMPORTED_MODULE_9__logger_utils__["a" /* LoggerUtils */].logWithDashSeparator(this, "POST URL: " + url);
            this.http.post(url, postData, { headers }).subscribe((response) => {
                observer.next(response);
                observer.complete();
            }, (error) => {
                observer.error(this.errHandler.handleWS(this, __WEBPACK_IMPORTED_MODULE_11__config_config__["a" /* AppConfig */].err.HTTP_ERROR, error, resourceURL));
            });
        });
    }
    postExternal(resourceURL, postData, headers) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"]((observer) => {
            var url = resourceURL;
            __WEBPACK_IMPORTED_MODULE_9__logger_utils__["a" /* LoggerUtils */].logWithDashSeparator(this, "POST URL: " + url);
            this.http.post(url, postData, { headers }).subscribe((response) => {
                observer.next(response);
                observer.complete();
            }, (error) => {
                observer.error(this.errHandler.handleWS(this, __WEBPACK_IMPORTED_MODULE_11__config_config__["a" /* AppConfig */].err.HTTP_ERROR, error, resourceURL));
            });
        });
    }
};
RESTClient = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */], __WEBPACK_IMPORTED_MODULE_10__modules_core_provider_error_service__["a" /* ErrorService */]])
], RESTClient);

//# sourceMappingURL=rest-client.js.map

/***/ }),

/***/ 184:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SessionService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_native_storage__ = __webpack_require__(308);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__util_logger_utils__ = __webpack_require__(307);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let SessionService = class SessionService {
    constructor(nativeStorage, events) {
        this.nativeStorage = nativeStorage;
        this.events = events;
    }
    setPrincipal(signedUser) {
        this.user = signedUser;
        if (this.user) {
            this.token = this.user.token;
            if (__WEBPACK_IMPORTED_MODULE_4__util_string_utils__["a" /* StringUtils */].isEmpty(this.user.pictureType)) {
                this.user.pictureType = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultProfileImageType;
            }
            if (__WEBPACK_IMPORTED_MODULE_4__util_string_utils__["a" /* StringUtils */].isEmpty(this.user.picture)) {
                this.user.picture = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultProfileImage;
            }
        }
    }
    updatePrincipal(signedUser) {
        this.setPrincipal(signedUser);
        this.save().subscribe((response) => { });
    }
    getPrincipal() {
        return this.user;
    }
    isAuthenticated() {
        return this.user != null && this.user.token > 0 && this.user.userId > 0;
    }
    getToken() {
        return this.token;
    }
    storeItem(key, value) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.nativeStorage.setItem(key, value).then(() => {
                observer.next(true);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    getItem(key) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.nativeStorage.getItem(key).then((data) => {
                observer.next(data);
                observer.complete();
            }, error => {
                if (error.code == "2") {
                    observer.next(null);
                    observer.complete();
                }
                else {
                    observer.error(error);
                }
            });
        });
    }
    removeItem(key) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.nativeStorage.remove(key).then((data) => {
                observer.next(data);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    save() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.principal, this.user).subscribe((response) => {
                observer.next(true);
                observer.complete();
            }, error => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    saveError(errorMessage) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.getItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.errorLog).subscribe((response) => {
                let log = response;
                if (!log) {
                    log = [];
                }
                log.push(errorMessage);
                this.storeItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.errorLog, log).subscribe((response) => {
                    observer.next();
                    observer.complete();
                }, error => {
                    observer.next();
                    observer.complete();
                });
            }, error => {
                __WEBPACK_IMPORTED_MODULE_6__util_logger_utils__["a" /* LoggerUtils */].logWithDashSeparator(this, "Session ErrorLog Saving Error! " + error);
                observer.next();
                observer.complete();
            });
        });
    }
    reset() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            console.log("Session Reset!... ");
            this.user = null;
            this.token = 0;
            this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.SESSSION_RESET, Date.now());
            this.nativeStorage.keys().then((data) => {
                if (data && Array.isArray(data) && data.length > 0) {
                    let count = data.length;
                    for (let i = 0; i < count; i++) {
                        if (data[i].indexOf("efast") > -1) {
                            console.log("Session Reset! Limpiando... " + data[i]);
                            this.storeItem(data[i], null).subscribe();
                        }
                        if (i + 1 === count) {
                            observer.next(true);
                            observer.complete();
                        }
                    }
                }
                else {
                    console.log("Session Reset! No hay datos guardados de previo. ");
                    observer.next(true);
                    observer.complete();
                }
            }, error => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    restore() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            this.user = null;
            this.events.publish(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.SESSSION_RESTORE, Date.now());
            this.getItem(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].rootParams.principal).subscribe((response) => {
                let flag = false;
                //Valida que los datos del principal sean consistentes
                if (response && response.token > 0 && response.userId > 0) {
                    flag = true;
                    this.setPrincipal(response);
                }
                else {
                    flag = false;
                }
                __WEBPACK_IMPORTED_MODULE_6__util_logger_utils__["a" /* LoggerUtils */].logWithDashSeparator(this, "Session Restored!");
                observer.next(flag);
                observer.complete();
            }, error => {
                __WEBPACK_IMPORTED_MODULE_6__util_logger_utils__["a" /* LoggerUtils */].logWithDashSeparator(this, "Session Restored Error! " + error);
                observer.next(false);
                observer.complete();
            });
        });
    }
    toModel() {
        var session;
        if (this.user) {
            session = {
                userId: this.user.userId,
                token: this.token
            };
        }
        else {
            session = {
                userId: null,
                token: null
            };
        }
        return session;
    }
};
SessionService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_native_storage__["a" /* NativeStorage */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["Events"]])
], SessionService);

//# sourceMappingURL=session-service.js.map

/***/ }),

/***/ 240:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ParamService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




let ParamService = class ParamService {
    constructor(rest) {
        this.rest = rest;
    }
    getShareUrl() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_PARAM_SHARE_URL).subscribe((response) => {
                if (response == "N") {
                    observer.error();
                }
                else {
                    observer.next(response);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
ParamService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], ParamService);

//# sourceMappingURL=param-service.js.map

/***/ }),

/***/ 241:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeMiSuperTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__home_providers_home_misuper_service__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__ = __webpack_require__(79);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeMiSuperTabbedDataSet = class HomeMiSuperTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__["a" /* TabbedDataSet */] {
    constructor(sessionManager, misuperService) {
        super();
        this.sessionManager = sessionManager;
        this.misuperService = misuperService;
        //this.setPreviewPageSize(50); //Muestra una cantidad para preview
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setSectionListToQuery(sections) {
        this.sectionListToQuery = "";
        if (sections != null && sections.length > 0) {
            for (let i = 0; i < sections.length; i++) {
                let section = sections[i];
                this.sectionListToQuery += (section.code + ",");
            }
        }
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            /*var params: ProductFamilyCategorySearch = {};
            params.page = fetchPageId;
            params.records = AppConfig.app.defaultPageSize;
            params.categoryCode = this.groupCode;
            params.subfamilyCode = null;
      
            let section;
            if(!this.sectionCode){
              section = this.sectionListToQuery;
            }else{
              section = this.sectionCode;
            }
      
            params.familyCode = section;
      
            if(this.sessionManager.isAuthenticated()){
              params.userId = this.sessionManager.getPrincipal().userId;
              params.token = this.sessionManager.getToken();
            }
            this.productService.searchByFamilyMerqueo(params).subscribe((resultList: Product[]) => {
                observer.next(resultList);
                observer.complete();
            },
            error => {
                observer.next(this.list);
                observer.complete();
            });*/
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.defaultPageSize;
            if (this.sessionManager.isAuthenticated()) {
                params.userId = this.sessionManager.getPrincipal().userId;
                params.token = this.sessionManager.getToken();
            }
            let useList = false;
            let section;
            if (!this.sectionCode) {
                section = this.sectionListToQuery;
                useList = true;
            }
            else {
                section = this.sectionCode;
            }
            this.misuperService.getMiSuperProductSection(params, this.groupCode, section, useList).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomeMiSuperTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__home_providers_home_misuper_service__["a" /* HomeMiSuperService */]])
], HomeMiSuperTabbedDataSet);

//# sourceMappingURL=home-misuper-tabbed-dataset.js.map

/***/ }),

/***/ 267:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OfflinePage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_network__ = __webpack_require__(665);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__startup_startup__ = __webpack_require__(268);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let OfflinePage = class OfflinePage {
    constructor(events, toast, loadingCtrl, navParams, navCtrl, network) {
        this.events = events;
        this.toast = toast;
        this.loadingCtrl = loadingCtrl;
        this.navParams = navParams;
        this.navCtrl = navCtrl;
        this.network = network;
        this.error = "C03";
    }
    ionViewDidEnter() {
        this.error = this.navParams.get("cause");
        this.connected = this.network.onConnect().subscribe(data => {
            this.displayNetworkUpdate(data.type);
        }, error => console.error(error));
        this.disconnected = this.network.onDisconnect().subscribe(data => {
            this.displayNetworkUpdate(data.type);
        }, error => console.error(error));
    }
    ionViewWillLeave() {
        this.connected.unsubscribe();
        this.disconnected.unsubscribe();
    }
    checkConnection() {
        const loading = this.loadingCtrl.create();
        loading.present();
        setTimeout(() => {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].event.CONNECTION_ESTABLISHED);
            loading.dismiss();
            this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_4__startup_startup__["a" /* StartupPage */]);
        }, 1000);
    }
    displayNetworkUpdate(connectionState) {
        let networkType = this.network.type;
        this.toast.create({
            message: `Actualmente estas '${connectionState}' mediante '${networkType}'`,
            duration: 3000
        }).present();
        if (connectionState === 'online') {
            setTimeout(() => {
                this.events.publish(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].event.CONNECTION_ESTABLISHED);
            }, 2000);
        }
    }
};
OfflinePage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'page-offline',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\offline\offline.html"*/'<ion-content class="onboarding">\n\n\n\n    <img class="image" src="assets/images/general/logo-horizontal.png" alt="">\n\n\n\n      <div class="bottom">\n\n        <span class="title md-txt-lg">No pudimos conectarnos con el servidor.<br>¿Te quedaste sin internet?</span>\n\n      </div>\n\n\n\n      <div class="footer-button">\n\n        <button class="action-button lg-txt-btn" ion-button block clear round tappable (click)="checkConnection()">Reintentar</button>\n\n        <ng-container *ngIf="this.error"><br><small><label class="lg-txt">Cod. {{this.error}}</label></small></ng-container>\n\n      </div>\n\n\n\n</ion-content>\n\n'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\offline\offline.html"*/,
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["LoadingController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavParams"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavController"],
        __WEBPACK_IMPORTED_MODULE_3__ionic_native_network__["a" /* Network */]])
], OfflinePage);

//# sourceMappingURL=offline.js.map

/***/ }),

/***/ 268:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return StartupPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__home_pages_home_flex__ = __webpack_require__(160);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__offline_offline__ = __webpack_require__(267);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_provider_greenpay_config_service__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__datasets_home_suggested_dataset__ = __webpack_require__(274);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__profile_providers_geozone_service__ = __webpack_require__(273);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};














let StartupPage = class StartupPage {
    constructor(sessionManager, events, navCtrl, toastCtrl, translate, greenPayConfigService, productService, cartManager, geoZoneService, homeSuggestedDataSet) {
        this.sessionManager = sessionManager;
        this.events = events;
        this.navCtrl = navCtrl;
        this.toastCtrl = toastCtrl;
        this.translate = translate;
        this.greenPayConfigService = greenPayConfigService;
        this.productService = productService;
        this.cartManager = cartManager;
        this.geoZoneService = geoZoneService;
        this.homeSuggestedDataSet = homeSuggestedDataSet;
        this.warningLatencyMessage = true;
        this.processLoadDidFinish = false;
        this.imageLoadDidFinish = false;
        this.isUserAuthenticated = false;
        //Cuando se ha inicializado los datos del usuario
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].event.BOOTSTRAP_SERVICES_READY, (startupSession) => {
            this.startupSession = startupSession;
            this.isUserAuthenticated = startupSession.authenticated;
            this.preloadGlobalCarrusel(startupSession).subscribe();
            //setTimeout(() => {
            this.initLobbySections(startupSession);
            //}, 2000);
        });
    }
    ionViewDidLoad() {
        this.warningLatencyMessage = true;
        /*setTimeout(() => {
            if(this.warningLatencyMessage){
              ViewUtils.presentToast(this.toastCtrl, this.translate.instant("messages.connectionLag"), 3000);
            }
        }, AppConfig.app.latencyTimeout);*/
    }
    /*****************************************************************
     * Manejo de datos para Caches
     *****************************************************************/
    //Verifica las secciones del lobby que se han de cargar
    initLobbySections(startupSession) {
        //Consulta los distintos tabs que se van a mostrar
        this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.HOME_SECTIONS).subscribe((sections) => {
            if (sections && sections.length > 0) {
                //Hay secciones, procede a precargar
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.FLEX_HOME_ACTIVE, true);
                this.initCacheCatalogs(startupSession, sections);
            }
            else {
                //Envia a pantalla de Offline, si no hay respuesta
                this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_5__offline_offline__["a" /* OfflinePage */], { cause: "C01" });
            }
        }, error => {
            //Envia a pantalla de Offline, si no hay respuesta
            this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_5__offline_offline__["a" /* OfflinePage */], { cause: "C02" });
        });
    }
    //Datos precargados del View del Lobby para el usuario
    initCacheCatalogs(startupSession, sections) {
        return __awaiter(this, void 0, void 0, function* () {
            let authenticated = startupSession.authenticated;
            let observables = [];
            observables.push(this.sessionManager.refreshDataSet(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.PRODUCT_CATEGORY));
            console.log("refresh dataset" + __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.PRODUCT_ATTRIBUTES);
            observables.push(this.sessionManager.refreshDataSet(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.PRODUCT_ATTRIBUTES));
            if (authenticated) {
                observables.push(this.cartManager.performInit());
            }
            if (sections && sections.length > 0) {
                for (let i = 0; i < sections.length; i++) {
                    let section = sections[i];
                    if (__WEBPACK_IMPORTED_MODULE_9__util_string_utils__["a" /* StringUtils */].isNotEmpty(section.type)) {
                        switch (section.type) {
                            case __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].lobby.SUGGESTED_TYPE:
                                observables.push(this.homeSuggestedDataSet.performInit());
                                break;
                        }
                    }
                }
            }
            __WEBPACK_IMPORTED_MODULE_6_rxjs__["Observable"].forkJoin(observables).subscribe((data) => {
                this.warningLatencyMessage = false;
                this.processLoadDidFinish = true;
                if (this.imageLoadDidFinish) {
                    this.forward(startupSession, authenticated);
                }
            });
        });
    }
    //Carga los datos de la pasarela de pagos en la sesion
    performPaymentConfigInit() {
        return new __WEBPACK_IMPORTED_MODULE_6_rxjs__["Observable"](observer => {
            this.greenPayConfigService.getConfig().subscribe((config) => {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.greenPayConfig, config);
                observer.next();
                observer.complete();
            }, error => {
                observer.next();
                observer.complete();
            });
        });
    }
    performGeoZonesInit() {
        return new __WEBPACK_IMPORTED_MODULE_6_rxjs__["Observable"](observer => {
            this.geoZoneService.loadWards().subscribe((list) => {
                this.events.publish(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].event.GEO_ZONES_LOADED);
                observer.next();
                observer.complete();
            }, error => {
                observer.next();
                observer.complete();
            });
        });
    }
    forward(startupSession, authenticated) {
        //Consulta las secciones del lobby
        this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.HOME_SECTIONS).subscribe((data) => {
            if (data && data.length > 0) {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.FLEX_HOME_ACTIVE, true);
                if (authenticated) {
                    this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_4__home_pages_home_flex__["a" /* HomeFlexPage */]);
                }
                else {
                    this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_4__home_pages_home_flex__["a" /* HomeFlexPage */]);
                }
                if (startupSession && startupSession.pushNotificationTrigger) {
                    setTimeout(() => {
                        this.events.publish(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].event.PUSH_NOTIFICATION_READY);
                    }, 1000);
                }
            }
            else {
                this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_5__offline_offline__["a" /* OfflinePage */], { cause: "C01" });
            }
        }, error => {
            this.navCtrl.setRoot(__WEBPACK_IMPORTED_MODULE_5__offline_offline__["a" /* OfflinePage */], { cause: "C02" });
        });
    }
    preloadGlobalCarrusel(session) {
        return new __WEBPACK_IMPORTED_MODULE_6_rxjs__["Observable"](observer => {
            this.productService.getGlobalCarrusel(session).subscribe((images) => {
                this.globalCarruselImages = images;
                observer.next();
                observer.complete();
            });
        });
    }
    onImageLoad() {
    }
    onCarruselImageLoad(item, i) {
        this.globalCarruselImages[i].verified = true;
        this.checkImageProcessing(item, i);
    }
    onCarruselLoadError(item, i) {
        this.globalCarruselImages[i].verified = false;
        this.checkImageProcessing(item, i);
    }
    checkImageProcessing(item, i) {
        if (i + 1 === this.globalCarruselImages.length) {
            //Check all verified images
            for (let idx = this.globalCarruselImages.length - 1; idx >= 0; idx--) {
                if (!this.globalCarruselImages[idx].verified) {
                    this.globalCarruselImages.splice(idx, 1);
                }
            }
            this.imageLoadDidFinish = true;
            this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.GLOBAL_CARRUSEL_LOADED, true);
            if (this.globalCarruselImages.length > 0) {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.GLOBAL_CARRUSEL, [...this.globalCarruselImages]);
            }
            else {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].session.GLOBAL_CARRUSEL, []);
            }
            this.events.publish(__WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].event.GLOBAL_CARRUSEL_CHANGED);
            if (this.processLoadDidFinish) {
                this.forward(this.startupSession, this.isUserAuthenticated);
            }
        }
    }
};
StartupPage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'page-startup',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\startup\startup.html"*/'<ion-content class="startup">\n\n\n\n  <!-- Realiza la precarga de la imagen en memoria -->\n\n  <img src="assets/images/onboarding/onboarding-sprite2.jpg" (load)="onImageLoad()" style="display:none;" >\n\n\n\n  <div class="splash">\n\n    <img showWhen="android,windows" class="image" src="assets/images/general/box-clear.png" alt="" width="120" height="120">\n\n    <img showWhen="ios" class="image-ios" src="assets/images/general/box-clear.png" alt="" width="120" height="120">\n\n  </div>\n\n\n\n  <ng-container *ngIf="globalCarruselImages">\n\n    <img *ngFor="let item of globalCarruselImages; let i = index;" (load)="onCarruselImageLoad(item, i)" (error)="onCarruselLoadError(item, i)" src="{{item.image}}" style="display:none;">\n\n  </ng-container>\n\n\n\n</ion-content>\n\n'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\startup\startup.html"*/,
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_12__ngx_translate_core__["c" /* TranslateService */],
        __WEBPACK_IMPORTED_MODULE_7__core_provider_greenpay_config_service__["a" /* GreenPayConfigService */],
        __WEBPACK_IMPORTED_MODULE_13__products_providers_product_product_service__["a" /* ProductService */],
        __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__["a" /* CartManagerService */],
        __WEBPACK_IMPORTED_MODULE_11__profile_providers_geozone_service__["a" /* GeoZoneService */],
        __WEBPACK_IMPORTED_MODULE_8__datasets_home_suggested_dataset__["a" /* HomeSuggestedDataSet */]])
], StartupPage);

//# sourceMappingURL=startup.js.map

/***/ }),

/***/ 270:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WishListHelperService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__wish_list_service__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_facebook__ = __webpack_require__(65);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








let WishListHelperService = class WishListHelperService {
    constructor(toastCtrl, alertCtrl, translate, modalCtrl, wishListService, sessionManager, facebook, events) {
        this.toastCtrl = toastCtrl;
        this.alertCtrl = alertCtrl;
        this.translate = translate;
        this.modalCtrl = modalCtrl;
        this.wishListService = wishListService;
        this.sessionManager = sessionManager;
        this.facebook = facebook;
        this.events = events;
    }
    setCallback(callback) {
        this.changeCallback = callback;
    }
    performWishListAction(item, skipPropagation) {
        if (item.isInWishList === 'N') {
            this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.WISH_LIST).subscribe((list) => {
                //Ya tiene lista de deseos?
                if (list && list.length > 0) {
                    this.chooseWishListAndSaveInThere(item, list);
                }
                else {
                    this.createWishList(item);
                }
            }, error => { });
        }
        else {
            this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.WISH_LIST).subscribe((list) => {
                if (list && list.length > 0) {
                    var product = {};
                    var user = this.sessionManager.getSession().getPrincipal();
                    product.userId = user.userId;
                    product.token = user.token;
                    product.productCode = item.productCode;
                    if (item.isInWishList === 'S') {
                        this.wishListService.deleteProductFromAllWishlist(list, product).subscribe(() => {
                            item.isInWishList = 'N';
                            if (!skipPropagation) {
                                this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_WISHLIST_LIST, { product: item });
                            }
                            __WEBPACK_IMPORTED_MODULE_5__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.itemRemoved"));
                            if (this.changeCallback) {
                                this.changeCallback(item);
                            }
                        });
                    }
                }
                else {
                    __WEBPACK_IMPORTED_MODULE_5__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.notWishlistCreated"));
                }
            }, error => { });
        }
    }
    createWishList(item) {
        let modal = this.modalCtrl.create('EditWishListPage', {
            selectedWishlist: null,
            modal: true
        });
        modal.onDidDismiss(result => {
            let newWishList = result;
            if (newWishList.wishListId) {
                //Consulta los datos de la lista
                this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.WISH_LIST).subscribe((list) => {
                    //Ya tiene lista de deseos?
                    if (list && list.length > 0) {
                        let selectedWishList;
                        for (let i = 0; i < list.length; i++) {
                            if (list[i].wishListId === newWishList.wishListId) {
                                selectedWishList = list[i];
                                break;
                            }
                        }
                        if (selectedWishList) {
                            this.handleWishList(selectedWishList.wishListId, selectedWishList.name, item);
                        }
                    }
                });
            }
        });
        modal.present();
    }
    chooseWishListAndSaveInThere(item, list) {
        let alert = this.alertCtrl.create();
        alert.setTitle('Lista de deseos');
        for (var i = 0; i < list.length; i++) {
            var wishlist = list[i];
            alert.addInput({
                type: 'radio',
                label: wishlist.name,
                value: JSON.stringify(wishlist),
                checked: (i == 0 ? true : false)
            });
        }
        alert.addInput({
            type: 'radio',
            label: '(Nueva)',
            value: 'new',
            checked: false
        });
        alert.addButton({
            text: 'OK',
            handler: (data) => {
                if (data === "new") {
                    this.createWishList(item);
                }
                else {
                    let selectedWishList = JSON.parse(data);
                    this.handleWishList(selectedWishList.wishListId, selectedWishList.name, item);
                }
            }
        });
        alert.addButton({
            text: 'Cancelar',
            role: "cancel"
        });
        alert.present();
    }
    selectWishList(item, list, callback) {
        let alert = this.alertCtrl.create();
        alert.setTitle('Lista de deseos');
        for (var i = 0; i < list.length; i++) {
            var wishlist = list[i];
            alert.addInput({
                type: 'radio',
                label: wishlist.name,
                value: JSON.stringify(wishlist),
                checked: (i == 0 ? true : false)
            });
        }
        alert.addButton({
            text: 'OK',
            handler: (data) => {
                if (callback) {
                    let selectedWishList = JSON.parse(data);
                    callback(selectedWishList);
                }
            }
        });
        alert.addButton({
            text: 'Cancelar',
            role: "cancel"
        });
        alert.present();
    }
    chooseWishListToDelete(item, list) {
        let alert = this.alertCtrl.create();
        alert.setTitle('De que lista deseas eliminarlo');
        for (var i = 0; i < list.length; i++) {
            var wishlist = list[i];
            alert.addInput({
                type: 'radio',
                label: wishlist.name,
                value: JSON.stringify(wishlist),
                checked: true
            });
        }
        alert.addButton('Cancelar');
        alert.addButton({
            text: 'Guardar',
            handler: (data) => {
                let selectedWishList = JSON.parse(data);
                this.handleWishList(selectedWishList.wishListId, selectedWishList.name, item);
            }
        });
        alert.present();
    }
    moveToWishListAction(item, callback) {
        this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.WISH_LIST).subscribe((list) => {
            if (list && list.length > 0) {
                //Selecciona la lista
                this.selectWishList(item, list, (wishList) => {
                    //Elimina el producto de la lista actual
                    var product = {};
                    var user = this.sessionManager.getSession().getPrincipal();
                    product.userId = user.userId;
                    product.token = user.token;
                    product.productCode = item.productCode;
                    if (item.isInWishList === 'S') {
                        this.wishListService.deleteProductFromAllWishlist(list, product).subscribe(() => {
                            item.isInWishList = 'N';
                            //Agrega el producto a la nueva list
                            this.handleWishList(wishList.wishListId, wishList.name, item, callback);
                        });
                    }
                });
            }
        }, error => { });
        this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.WISH_LIST).subscribe((list) => {
            if (list && list.length > 0) {
            }
            else {
                __WEBPACK_IMPORTED_MODULE_5__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.notWishlistCreated"));
            }
        }, error => { });
    }
    handleWishList(wishListId, wishListName, item, callback) {
        var product = {};
        var user = this.sessionManager.getSession().getPrincipal();
        product.userId = user.userId;
        product.token = user.token;
        product.productCode = item.productCode;
        product.wishListId = wishListId;
        if (item.isInWishList === 'N') {
            setTimeout(() => {
                this.wishListService.addWhishListProduct(product).subscribe((result) => {
                    setTimeout(() => {
                        let params = {
                            fb_content_id: (item.productCode + " " + item.description),
                            fb_content_type: "Producto"
                        };
                        this.facebook.logEvent("fb_mobile_add_to_wishlist", params).then(() => { }).catch(e => console.log(e));
                    }, 1000);
                    item.isInWishList = 'S';
                    this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_WISHLIST_LIST, { product: item });
                    if (callback) {
                        callback(wishListId);
                    }
                    __WEBPACK_IMPORTED_MODULE_5__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.itemAddedToList") + "'" + wishListName + "'");
                    if (this.changeCallback) {
                        this.changeCallback(item);
                    }
                });
            }, 1000);
        }
    }
};
WishListHelperService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["AlertController"],
        __WEBPACK_IMPORTED_MODULE_2__ngx_translate_core__["c" /* TranslateService */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["ModalController"],
        __WEBPACK_IMPORTED_MODULE_1__wish_list_service__["a" /* WishListService */],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_7__ionic_native_facebook__["a" /* Facebook */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["Events"]])
], WishListHelperService);

//# sourceMappingURL=wish-list-helper-service.js.map

/***/ }),

/***/ 271:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductHelperService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_social_sharing__ = __webpack_require__(285);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__orders_providers_cart_manager_service__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__datasets_product_similar_dataset__ = __webpack_require__(484);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_android_permissions__ = __webpack_require__(239);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ionic_native_email_composer__ = __webpack_require__(485);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__support_providers_param_service__ = __webpack_require__(240);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















let ProductHelperService = class ProductHelperService {
    constructor(sessionManager, paramService, productService, socialSharing, alertCtrl, platform, toastCtrl, loadingCtrl, actionSheetCtrl, translate, productSimilarDataSet, cartManagerService, androidPermissions, emailComposer) {
        this.sessionManager = sessionManager;
        this.paramService = paramService;
        this.productService = productService;
        this.socialSharing = socialSharing;
        this.alertCtrl = alertCtrl;
        this.platform = platform;
        this.toastCtrl = toastCtrl;
        this.loadingCtrl = loadingCtrl;
        this.actionSheetCtrl = actionSheetCtrl;
        this.translate = translate;
        this.productSimilarDataSet = productSimilarDataSet;
        this.cartManagerService = cartManagerService;
        this.androidPermissions = androidPermissions;
        this.emailComposer = emailComposer;
        this.user = {};
    }
    showProductMenu(appCtrl, navCtrl, actionSheetCtrl, item, skipSimilars) {
        let buttonList = [];
        if (skipSimilars) {
            buttonList = [
                {
                    text: "Guardar para luego",
                    cssClass: "action-sheet-button",
                    icon: !this.platform.is("ios") ? "bookmark" : null,
                    handler: () => {
                        this.set(item);
                        this.addItemToSavedList(navCtrl);
                    },
                },
                {
                    text: "Compartir",
                    cssClass: "action-sheet-button",
                    icon: !this.platform.is("ios") ? "share" : null,
                    handler: () => {
                        this.set(item);
                        this.share().subscribe();
                    },
                },
            ];
        }
        else {
            buttonList = [
                {
                    text: "Guardar para luego",
                    cssClass: "action-sheet-button",
                    icon: !this.platform.is("ios") ? "bookmark" : null,
                    handler: () => {
                        this.set(item);
                        this.addItemToSavedList(navCtrl);
                    },
                },
                {
                    text: "Compartir",
                    cssClass: "action-sheet-button",
                    icon: !this.platform.is("ios") ? "share" : null,
                    handler: () => {
                        this.set(item);
                        this.share().subscribe();
                    },
                },
                {
                    text: "Productos similares",
                    cssClass: "action-sheet-button",
                    icon: !this.platform.is("ios") ? "albums" : null,
                    handler: () => {
                        this.productSimilarDataSet.clear();
                        this.productSimilarDataSet.setProduct(item);
                        this.productSimilarDataSet.setPreLoadMode(false); //Dataset no PRE INICIALIZADO en el startup
                        this.productSimilarDataSet.setOneTimeFetch(true);
                        var title = "Productos similares";
                        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED, true);
                        appCtrl.getRootNav().push("ProductListingPage", {
                            dataSet: this.productSimilarDataSet,
                            title: title,
                        });
                    },
                },
            ];
        }
        const actionSheet = actionSheetCtrl.create({
            cssClass: "avatar-action-sheet",
            //title: item.description,
            buttons: buttonList,
        });
        actionSheet.present();
    }
    showWishlistProductMenu(appCtrl, navCtrl, actionSheetCtrl, item, moveToListCallback, deleteFromListCallback) {
        let buttonList = [];
        buttonList = [
            {
                text: "Mover a otra lista",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "repeat" : null,
                handler: () => {
                    if (moveToListCallback) {
                        moveToListCallback();
                    }
                },
            },
            {
                text: "Eliminar de la lista",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "close" : null,
                handler: () => {
                    if (deleteFromListCallback) {
                        deleteFromListCallback();
                    }
                },
            },
            {
                text: "Guardar para luego",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "bookmark" : null,
                handler: () => {
                    this.set(item);
                    this.addItemToSavedList(navCtrl);
                },
            },
            {
                text: "Compartir",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "share" : null,
                handler: () => {
                    this.set(item);
                    this.share().subscribe();
                },
            },
            {
                text: "Productos similares",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "albums" : null,
                handler: () => {
                    this.productSimilarDataSet.clear();
                    this.productSimilarDataSet.setProduct(item);
                    this.productSimilarDataSet.setPreLoadMode(false); //Dataset no PRE INICIALIZADO en el startup
                    this.productSimilarDataSet.setOneTimeFetch(true);
                    var title = "Productos similares";
                    this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED, true);
                    appCtrl.getRootNav().push("ProductListingPage", {
                        dataSet: this.productSimilarDataSet,
                        title: title,
                        navbarStyle: "blue",
                    });
                },
            },
        ];
        const actionSheet = actionSheetCtrl.create({
            cssClass: "avatar-action-sheet",
            //title: item.description,
            buttons: buttonList,
        });
        actionSheet.present();
    }
    set(item) {
        this.user = this.sessionManager.getPrincipal();
        this.record = {
            product: item,
            productAttributes: [],
            productReviews: [],
            filteredProductReviews: [],
            relatedProducts: [],
            similarProducts: [],
            media: [],
            videos: [],
            productLoaded: true,
            imagesLoaded: false,
            attributesLoaded: false,
            relatedProductsLoaded: false,
            similarProductsLoaded: false,
            productReviewsLoaded: false,
            galleryMode: "images",
            productTitle: item.description,
        };
    }
    setRecord(item) {
        this.user = this.sessionManager.getPrincipal();
        this.record = item;
    }
    share() {
        const loading = this.loadingCtrl.create();
        loading.present();
        return new __WEBPACK_IMPORTED_MODULE_6_rxjs__["Observable"]((observer) => {
            this.fetchProductAttributes().subscribe(() => {
                this.fetchProductImages().subscribe(() => {
                    loading.dismiss();
                    this.performShare();
                    observer.next();
                    observer.complete();
                });
            });
        });
    }
    performShare(decimalPipe) {
        let buttonList = [
            {
                text: "Compartir por WhatsApp",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "logo-whatsapp" : null,
                handler: () => {
                    if (parseFloat(navigator.userAgent.match(/.*?(?:windows phone|android\D+([0-9\.]*))|()/i)[1]) >= 13) {
                        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].checkSharingPermissions2(this.androidPermissions)
                            .then((resultRequestMedia) => {
                            this.whatsAppShare(decimalPipe);
                        })
                            .catch((err) => {
                            console.log(err);
                        });
                    }
                    else {
                        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].checkSharingPermissions(this.androidPermissions).subscribe((result) => {
                            if (result) {
                                this.whatsAppShare(decimalPipe);
                            }
                        }, (error) => {
                            console.log(error);
                        });
                    }
                    /* ViewUtils.checkSharingPermissions(this.androidPermissions).subscribe(
                      (result: boolean) => {
                        if (result) {
                          this.whatsAppShare(decimalPipe);
                        }
                      }
                    );*/
                },
            },
            {
                text: "Compartir por Facebook",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "logo-facebook" : null,
                handler: () => {
                    if (parseFloat(navigator.userAgent.match(/.*?(?:windows phone|android\D+([0-9\.]*))|()/i)[1]) >= 13) {
                        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].checkSharingPermissions2(this.androidPermissions)
                            .then((resultRequestMedia) => {
                            this.facebookShare(decimalPipe);
                        })
                            .catch((err) => {
                            console.log(err);
                        });
                    }
                    else {
                        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].checkSharingPermissions(this.androidPermissions).subscribe((result) => {
                            if (result) {
                                this.facebookShare(decimalPipe);
                            }
                        }, (error) => {
                            console.log(error);
                        });
                    }
                    //this.facebookShare(decimalPipe);
                },
            },
            {
                text: "Compartir por Email",
                cssClass: "action-sheet-button",
                icon: !this.platform.is("ios") ? "mail" : null,
                handler: () => {
                    if (parseFloat(navigator.userAgent.match(/.*?(?:windows phone|android\D+([0-9\.]*))|()/i)[1]) >= 13) {
                        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].checkSharingPermissions2(this.androidPermissions)
                            .then((resultRequestMedia) => {
                            this.emailShare(decimalPipe);
                        })
                            .catch((err) => {
                            console.log(err);
                        });
                    }
                    else {
                        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].checkSharingPermissions(this.androidPermissions).subscribe((result) => {
                            if (result) {
                                this.emailShare(decimalPipe);
                            }
                        }, (error) => {
                            console.log(error);
                        });
                    }
                    // ViewUtils.checkSharingPermissions(this.androidPermissions).subscribe(
                    //   (result: boolean) => {
                    //     if (result) {
                    //       this.emailShare(decimalPipe);
                    //     }
                    //   }
                    // );
                },
            },
        ];
        const actionSheet = this.actionSheetCtrl.create({
            cssClass: "avatar-action-sheet",
            buttons: buttonList,
        });
        actionSheet.present();
    }
    whatsAppShare(decimalPipe) {
        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.appOpening"));
        this.paramService.getShareUrl().subscribe((result) => {
            //Mensaje FORMATEADO de acuerdo al lineamiento de Whatsapp para Negritas
            let price = decimalPipe
                ? decimalPipe.transform(this.record.product.price, "1.0-0")
                : this.record.product.price;
            let message = 'Este producto te puede interesar *"' +
                this.record.product.description +
                '"* a tan solo *₡' +
                price +
                "* colones. \n\n";
            //message += 'Puedes verlo en: \n\n' + " " + result + this.record.product.productCode;
            //message += this.formatAttributesAsString("*"); // * -> Bold en Whatsapp
            try {
                if (this.platform.is("ios")) {
                    setTimeout(() => {
                        this.socialSharing.shareViaWhatsApp(message, null, result + this.record.product.productCode);
                    }, 500);
                }
                else {
                    setTimeout(() => {
                        this.socialSharing.shareViaWhatsApp(message, null, result + this.record.product.productCode);
                        //this.socialSharing.shareViaWhatsApp(message, null, result + this.record.product.productCode);
                        //this.socialSharing.shareVia("com.whatsapp", message, null, null, result + this.record.product.productCode);//original
                        /*
                      //Metodo no compatible con todas las versiones de android, suele fallar en xiaomi
                      this.socialSharing.shareViaWhatsApp(message, null, result + this.record.product.productCode).then(() => {
                        // Success!
                        console.log("ERRORD: funciona");
                      }).catch((err) => {
                        console.log("ERRORD:" + err);
                        // Error!
                      });*/
                    }, 500);
                }
            }
            catch (error) {
                __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.appNotAvailable"));
                //ViewUtils.presentToast(this.toastCtrl, "ERRORD:" + error.message + error);
            }
        }, (error) => {
            __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.shareErr"));
        });
    }
    facebookShare(decimalPipe) {
        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.appOpening"));
        this.paramService.getShareUrl().subscribe((result) => {
            //Mensaje FORMATEADO de acuerdo al lineamiento de FB para Negritas (Utiliza MARKDOWN)
            let price = decimalPipe
                ? decimalPipe.transform(this.record.product.price, "1.0-0")
                : this.record.product.price;
            let message = 'Este producto te puede interesar "' +
                this.record.product.description +
                '" a tan solo ₡' +
                price +
                " colones. \n\n";
            message +=
                "Puedes verlo en: \n\n" + result + this.record.product.productCode;
            message +=
                "\n\nDescarga la app de E-Fast para que veas todo el detalle del producto y otras increíbles ofertas. \n\n" +
                    " * Google Play: http://play.google.com/store/apps/details?id=app.efastonline.com \n\n" +
                    " * App Store: https://apps.apple.com/cr/app/e-fast/id1466956395?l=en \n\n" +
                    " * AppGallery: https://appgallery.huawei.com/app/C101754587 \n\n";
            //message += this.formatAttributesAsStringWithPrefix("- "); // ** -> Italic en FB
            //this.socialSharing.canShareVia("com.apple.social.facebook").then(() => {
            this.socialSharing.shareViaFacebookWithPasteMessageHint(message, null, null, "Copiamos el mensaje en tu portapapeles para que lo pegues en tu post.");
            //this.socialSharing.shareViaFacebook(message, null,null)
            /*setTimeout(() => {
            if(this.platform.is("ios")){
            this.socialSharing.shareViaFacebookWithPasteMessageHint(message, this.record.media[0].url, null, 'Copiamos el mensaje en tu portapapeles para que lo pegues en tu post.');
            }else{
              this.socialSharing.shareViaFacebook(
                message,null,
                "https://www.efastonline.com/producto-sugerido.php?pid="+this.record.product.productCode
              ).then(() => { })
                .catch(() => { });
            }
          }, 500);*/
            /*}).catch(() => {
            ViewUtils.presentToast(this.toastCtrl, this.translate.instant('messages.appNotAvailable'));
          });*/
        }, (error) => {
            __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.shareErr") + error.message);
        });
    }
    emailShare(decimalPipe) {
        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.appOpening"));
        this.paramService.getShareUrl().subscribe((result) => {
            //Mensaje FORMATEADO de acuerdo al lineamiento del Email para Negritas (Utiliza HTML)
            let price = decimalPipe
                ? decimalPipe.transform(this.record.product.price, "1.0-0")
                : this.record.product.price;
            let message = 'Este producto te puede interesar <b>"' +
                this.record.product.description +
                '"</b> a tan solo <b>' +
                price +
                "</b> colones. <br><br>";
            message +=
                "Puedes verlo en: \n\n" +
                    " <br>" +
                    result +
                    this.record.product.productCode;
            message +=
                "<br><br><b>Descarga la app de E-Fast para que veas todo el detalle del producto y otras increíbles ofertas.</b><br><br>" +
                    " * Google Play: http://play.google.com/store/apps/details?id=app.efastonline.com <br><br>" +
                    " * App Store: https://apps.apple.com/cr/app/e-fast/id1466956395?l=en <br><br>" +
                    " * AppGallery: https://appgallery.huawei.com/app/C101754587 <br><br>";
            var imgLinks = [];
            for (let i = 0; i < this.record.media.length; i++) {
                let mediaData = this.record.media[i];
                imgLinks.push(mediaData.url);
            }
            try {
                setTimeout(() => {
                    if (this.platform.is("ios")) {
                        let email = {
                            to: [],
                            cc: null,
                            bcc: null,
                            subject: "Producto de E-Fast que te puede interesar.",
                            body: message,
                            isHtml: true,
                            attachments: imgLinks,
                        };
                        this.emailComposer.open(email);
                    }
                    else {
                        this.socialSharing.shareViaEmail(message, "Producto de E-Fast que te puede interesar.", [], null, null, imgLinks);
                    }
                    /*let email = {
                      to: [],
                      cc: null,
                      bcc: null,
                      subject: 'Producto de E-Fast que te puede interesar.',
                      body: message,
                      isHtml: true,
                      attachments: imgLinks
                    };
                    this.emailComposer.open(email);*/
                }, 1000);
            }
            catch (_a) {
                __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.appNotAvailable"));
            }
        });
    }
    moreShare(decimalPipe) {
        let message = "*Descarga la app de E-Fast para que veas todo el detalle del producto y otras increíbles ofertas.* \n\n" +
            " Google Play: http://play.google.com/store/apps/details?id=app.efastonline.com \n\n" +
            " App Store: https://apps.apple.com/cr/app/e-fast/id1466956395?l=en \n\n" +
            " AppGallery: https://appgallery.huawei.com/app/C101754587 \n\n";
        let price = decimalPipe
            ? decimalPipe.transform(this.record.product.price, "1.0-0")
            : this.record.product.price;
        message +=
            'Este producto te puede interesar *"' +
                this.record.product.description +
                '"* a tan solo *₡' +
                price +
                "* colones. \n\n";
        message += this.formatAttributesAsString("*"); // * -> Bold en Whatsapp
        var imgLinks = [];
        for (let i = 0; i < this.record.media.length; i++) {
            let mediaData = this.record.media[i];
            imgLinks.push(mediaData.url);
        }
        var options = {
            message: message,
            subject: "Producto de E-Fast que te puede interesar",
            files: imgLinks,
            chooserTitle: "Seleccione",
        };
        this.socialSharing.shareWithOptions(options);
    }
    fetchProductAttributes() {
        return new __WEBPACK_IMPORTED_MODULE_6_rxjs__["Observable"]((observer) => {
            //Maestro de atributos
            this.sessionManager
                .getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.PRODUCT_ATTRIBUTES)
                .subscribe((cacheAttributes) => {
                if (cacheAttributes && cacheAttributes.length > 0) {
                    //Clona la lista de atributos para asociar el set al producto actual
                    //Esto para la funcionalidad de stack de productos
                    let attributes = [...cacheAttributes];
                    //Limpia maestro de attributos
                    for (let j = 0; j < attributes.length; j++) {
                        attributes[j].details = [];
                    }
                    //Atributos asociados al producto
                    this.record.product.token = this.user ? this.user.token : null;
                    this.productService
                        .getProductAttributes(this.record.product)
                        .subscribe((attributesDetails) => {
                        this.record.attributesLoaded = true;
                        if (attributesDetails && attributesDetails.length > 0) {
                            for (let i = 0; i < attributesDetails.length; i++) {
                                var detail = attributesDetails[i];
                                for (let j = 0; j < attributes.length; j++) {
                                    if (attributes[j].attributeId === detail.attributeId) {
                                        attributes[j].details.push(detail);
                                        //EL atributo tiene detalles
                                        this.addProductAttribute(attributes[j]);
                                        break;
                                    }
                                }
                            }
                        }
                        observer.next();
                        observer.complete();
                    });
                }
                else {
                    observer.next();
                    observer.complete();
                }
            });
        });
    }
    addProductAttribute(attribute) {
        let found = false;
        if (this.record.productAttributes &&
            this.record.productAttributes.length > 0) {
            for (let i = 0; i < this.record.productAttributes.length; i++) {
                if (this.record.productAttributes[i].attributeId === attribute.attributeId) {
                    found = true;
                }
            }
        }
        if (!found) {
            this.record.productAttributes.push(attribute);
        }
    }
    fetchProductImages() {
        return new __WEBPACK_IMPORTED_MODULE_6_rxjs__["Observable"]((observer) => {
            var param = {};
            param.token = this.user ? this.user.token : null;
            param.productCode = this.record.product.productCode;
            this.productService
                .getProductMedia(param)
                .subscribe((data) => {
                if (data) {
                    this.record.galleryMode = "images";
                    //Imagenes
                    var rootImage = data.image;
                    var imgQty = data.imageQty;
                    if (imgQty > 0) {
                        this.loadMediaSetByType(imgQty, rootImage, "image");
                        if (this.record.media.length > 0) {
                            this.record.imagesLoaded = true;
                        }
                    }
                }
                observer.next();
                observer.complete();
            });
        });
    }
    /**
     * Consulta el listado de imagenes para el producto
     */
    loadMediaSetByType(numberOfMediaItems, rootURL, mediaType) {
        if (rootURL && rootURL.length > 0) {
            if (numberOfMediaItems) {
                if (numberOfMediaItems > 1 && rootURL && rootURL.length > 0) {
                    let rootPath = undefined;
                    if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isPatternPresent(rootURL, new RegExp(/[http://]|[HTTP://]/, "i"))) {
                        rootPath = "http://";
                        rootURL = rootURL.replace(rootPath, "");
                    }
                    else if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isPatternPresent(rootURL, new RegExp(/[https://]|[HTTPS://]/, "i"))) {
                        rootPath = "https://";
                        rootURL = rootURL.replace(rootPath, "");
                    }
                    if (!rootPath || rootPath.length < 1) {
                        rootPath = "";
                    }
                    var tokens = rootURL.split("/");
                    if (tokens.length > 0) {
                        for (let i = 0; i < tokens.length - 1; i++) {
                            rootPath += tokens[i] + "/";
                        }
                        let pictureCode = tokens[tokens.length - 1];
                        let pictureCodeTokens = pictureCode.split("_");
                        if (pictureCodeTokens.length > 0) {
                            for (let i = 1; i < numberOfMediaItems + 1; i++) {
                                let newPictureCode = pictureCodeTokens[0] +
                                    "_" +
                                    i +
                                    "_" +
                                    pictureCodeTokens[pictureCodeTokens.length - 1];
                                this.record.media.push({
                                    type: mediaType,
                                    url: rootPath + newPictureCode,
                                });
                            }
                        }
                    }
                }
                else if (numberOfMediaItems === 1) {
                    this.record.media.push({ type: mediaType, url: rootURL });
                }
            }
            else {
                //El campo numberOfImages no viene, entonces toma la unica imagen
                this.record.media.push({ type: mediaType, url: rootURL });
            }
        }
    }
    loadVideoSet(vodeosString) {
        if (vodeosString && vodeosString.length > 0) {
            var videos = vodeosString.split(",");
            if (videos && videos.length > 0) {
                for (var i = 0; i < videos.length; i++) {
                    var videoId = videos[i].replace(/\s/g, "");
                    this.record.videos.push({
                        videoId: videoId,
                        type: "video",
                        url: "https://www.youtube.com/watch?v=" + videoId,
                        thumbnail: "https://img.youtube.com/vi/" + videoId + "/hqdefault.jpg",
                    });
                }
            }
        }
    }
    addItemToSavedList(navCtrl) {
        if (this.sessionManager.isAuthenticated()) {
            this.record.product.article = this.record.product.productCode;
            this.record.product.token = this.user ? this.user.token : null;
            this.record.product.userId = this.user ? this.user.userId : null;
            this.productService
                .addSavedProducts(this.record.product)
                .subscribe((result) => {
                if (result) {
                    this.cartManagerService
                        .removeOrderDetail(this.record.product)
                        .subscribe((result) => {
                        __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.itemSaved"));
                    });
                }
            });
        }
        else {
            __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].showConfirm(this.alertCtrl, this.translate.instant("messages.wishCreateAccount"), () => {
                __WEBPACK_IMPORTED_MODULE_7__util_view_utils__["a" /* ViewUtils */].goToRegistration(navCtrl);
            });
        }
    }
    formatAttributesAsString(featuredChard) {
        let message = "";
        if (this.record.productAttributes &&
            this.record.productAttributes.length > 0) {
            for (let i = 0; i < this.record.productAttributes.length; i++) {
                let attribute = this.record.productAttributes[i];
                if (attribute.details) {
                    let hasContent = false;
                    let attMessage = featuredChard + attribute.attribute + ":" + featuredChard + " \n\n";
                    for (let j = 0; j < attribute.details.length; j++) {
                        let detail = attribute.details[j];
                        if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isNotEmpty(detail.characteristicDescription)) {
                            attMessage += "" + detail.characteristicDescription + "\n\n";
                            hasContent = true;
                        }
                    }
                    if (hasContent) {
                        message += attMessage;
                    }
                }
            }
        }
        return message;
    }
    formatAttributesAsStringWithPrefix(featuredChard) {
        let message = "";
        if (this.record.productAttributes &&
            this.record.productAttributes.length > 0) {
            for (let i = 0; i < this.record.productAttributes.length; i++) {
                let attribute = this.record.productAttributes[i];
                if (attribute.details) {
                    let hasContent = false;
                    let attMessage = featuredChard + attribute.attribute + ":\n\n";
                    for (let j = 0; j < attribute.details.length; j++) {
                        let detail = attribute.details[j];
                        if (__WEBPACK_IMPORTED_MODULE_5__util_string_utils__["a" /* StringUtils */].isNotEmpty(detail.characteristicDescription)) {
                            attMessage += "" + detail.characteristicDescription + "\n\n";
                            hasContent = true;
                        }
                    }
                    if (hasContent) {
                        message += attMessage;
                    }
                }
            }
        }
        return message;
    }
};
ProductHelperService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_14__support_providers_param_service__["a" /* ParamService */],
        __WEBPACK_IMPORTED_MODULE_2__product_service__["a" /* ProductService */],
        __WEBPACK_IMPORTED_MODULE_1__ionic_native_social_sharing__["a" /* SocialSharing */],
        __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["AlertController"],
        __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["Platform"],
        __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["LoadingController"],
        __WEBPACK_IMPORTED_MODULE_8_ionic_angular__["ActionSheetController"],
        __WEBPACK_IMPORTED_MODULE_10__ngx_translate_core__["c" /* TranslateService */],
        __WEBPACK_IMPORTED_MODULE_11__datasets_product_similar_dataset__["a" /* ProductSimilarDataSet */],
        __WEBPACK_IMPORTED_MODULE_9__orders_providers_cart_manager_service__["a" /* CartManagerService */],
        __WEBPACK_IMPORTED_MODULE_12__ionic_native_android_permissions__["a" /* AndroidPermissions */],
        __WEBPACK_IMPORTED_MODULE_13__ionic_native_email_composer__["a" /* EmailComposer */]])
], ProductHelperService);

//# sourceMappingURL=product-helper-service.js.map

/***/ }),

/***/ 272:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_string_utils__ = __webpack_require__(7);



/**
 * Revision 1.0.20170321
 * Utility class that provides number utilities.
 *
 * @author Coliand Studio
 * @version 1.0.20170321
 *
 */
class HomeUtils {
    static loadRewardConfiguration(sessionManager, imageCachingService, localStorageCacheId, forceDownload, callback) {
        let promoImageCache = [];
        let promoConfig = sessionManager.get(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].session.REWARDS_CONFIGURATION);
        if (promoConfig) {
            let images = [];
            promoImageCache = [];
            if (promoConfig.giftCard === 'S' && promoConfig.giftCardBanner)
                images.push({
                    imageId: "giftCardBanner",
                    image: promoConfig.giftCardBanner,
                    showProductCode: promoConfig.giftCardShowProductCode,
                    showCategoryId: promoConfig.giftCardShowCategoryId,
                    showFamilyId: promoConfig.giftCardShowFamilyId,
                    showSubFamilyId: promoConfig.giftCardShowSubFamilyId
                });
            if (promoConfig.nextPurchaseDiscount === 'S' && promoConfig.nextPurchaseDiscountBanner)
                images.push({
                    imageId: "nextPurchaseDiscountBanner",
                    image: promoConfig.nextPurchaseDiscountBanner,
                    showProductCode: promoConfig.nextPurchaseDiscountShowProductCode,
                    showCategoryId: promoConfig.nextPurchaseDiscountShowCategoryId,
                    showFamilyId: promoConfig.nextPurchaseDiscountShowFamilyId,
                    showSubFamilyId: promoConfig.nextPurchaseDiscountShowSubFamilyId
                });
            if (promoConfig.friendRecomendation === 'S' && promoConfig.friendRecomendationBanner)
                images.push({
                    imageId: "friendRecomendationBanner",
                    image: promoConfig.friendRecomendationBanner,
                    showProductCode: promoConfig.friendRecomendationShowProductCode,
                    showCategoryId: promoConfig.friendRecomendationShowCategoryId,
                    showFamilyId: promoConfig.friendRecomendationShowFamilyId,
                    showSubFamilyId: promoConfig.friendRecomendationShowSubFamilyId
                });
            if (promoConfig.freeShipping === 'S' && promoConfig.freeShippingBanner)
                images.push({
                    imageId: "freeShippingBanner",
                    image: promoConfig.freeShippingBanner,
                    showProductCode: promoConfig.freeShippingShowProductCode,
                    showCategoryId: promoConfig.freeShippingShowCategoryId,
                    showFamilyId: promoConfig.freeShippingShowFamilyId,
                    showSubFamilyId: promoConfig.freeShippingShowSubFamilyId
                });
            if (forceDownload) {
                __WEBPACK_IMPORTED_MODULE_1__util_view_utils__["a" /* ViewUtils */].performImageClearCaching(imageCachingService, localStorageCacheId, images, promoImageCache, () => {
                    if (callback) {
                        callback(promoImageCache);
                    }
                });
            }
            else {
                __WEBPACK_IMPORTED_MODULE_1__util_view_utils__["a" /* ViewUtils */].performImageCaching(imageCachingService, localStorageCacheId, images, promoImageCache, () => {
                    if (callback) {
                        callback(promoImageCache);
                    }
                });
            }
        }
    }
    static showCarruselImageDetail(appCtrl, sessionManager, image, searchFamilyDataSet, searchBannerDataSet) {
        searchBannerDataSet.setPreLoadMode(false); //Dataset no PRE INICIALIZADO en el startup
        //La bandera indica que al darle back a la pantalal emergente se mantenga en el tab actual
        sessionManager.set(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].session.LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED, true);
        //Tiene producto, abre el mismo
        if (!__WEBPACK_IMPORTED_MODULE_2__util_string_utils__["a" /* StringUtils */].isEmpty(image.showProductCode)) {
            appCtrl.getRootNav().push('ProductDetailPage', { productCode: image.showProductCode });
        }
        else {
            //Tiene marca
            if (image.showBrand) {
                //Indica que el DS no se utilizara en modo de precarga
                searchBannerDataSet.setBannerBrand(image);
                searchBannerDataSet.clear();
                appCtrl.getRootNav().push('ProductListingPage', { dataSet: searchBannerDataSet, title: null });
                //Tiene ID de lista
            }
            else if (image.showList) {
                searchBannerDataSet.setBannerList(image);
                searchBannerDataSet.clear();
                appCtrl.getRootNav().push('ProductListingPage', { dataSet: searchBannerDataSet, title: null });
                //Tiene Proveedor
            }
            else if (image.showProvider) {
                searchBannerDataSet.setBannerProvider(image);
                searchBannerDataSet.clear();
                appCtrl.getRootNav().push('ProductListingPage', { dataSet: searchBannerDataSet, title: null });
            }
            else {
                //Tiene categoria, familia y subfamilia
                let category = image.showCategoryId;
                let family = image.showFamilyId;
                let subfamily = image.showSubFamilyId;
                if (__WEBPACK_IMPORTED_MODULE_2__util_string_utils__["a" /* StringUtils */].isNotEmpty(category) || __WEBPACK_IMPORTED_MODULE_2__util_string_utils__["a" /* StringUtils */].isNotEmpty(family) || __WEBPACK_IMPORTED_MODULE_2__util_string_utils__["a" /* StringUtils */].isNotEmpty(subfamily)) {
                    searchFamilyDataSet.clear();
                    searchFamilyDataSet.setFilterData(category, family, subfamily);
                    appCtrl.getRootNav().push('ProductListingPage', { dataSet: searchFamilyDataSet, title: null });
                }
            }
        }
    }
    static handleWishList(authenticated, wishListHelper, alertCtrl, translate, navCtrl, item) {
        if (authenticated) {
            wishListHelper.performWishListAction(item);
        }
        else {
            __WEBPACK_IMPORTED_MODULE_1__util_view_utils__["a" /* ViewUtils */].showAuthDialog(alertCtrl, translate.instant('messages.registerToWishList'), () => {
                __WEBPACK_IMPORTED_MODULE_1__util_view_utils__["a" /* ViewUtils */].goToRegistration(navCtrl);
            });
        }
    }
    static handleWishListFromLobby(authenticated, wishListHelper, alertCtrl, translate, appCtrl, item, skipPropagation, skipPropagationCallback) {
        if (authenticated) {
            wishListHelper.setCallback(skipPropagationCallback);
            wishListHelper.performWishListAction(item, skipPropagation);
        }
        else {
            __WEBPACK_IMPORTED_MODULE_1__util_view_utils__["a" /* ViewUtils */].showAuthDialog(alertCtrl, translate.instant('messages.registerToWishList'), () => {
                __WEBPACK_IMPORTED_MODULE_1__util_view_utils__["a" /* ViewUtils */].goToRegistrationFromRoot(appCtrl);
            });
        }
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = HomeUtils;

//# sourceMappingURL=home.utils.js.map

/***/ }),

/***/ 273:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GeoZoneService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_common_http__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__ = __webpack_require__(125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_throw__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch__ = __webpack_require__(126);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_catch__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_map__ = __webpack_require__(128);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_map___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_map__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__util_array_utils__ = __webpack_require__(280);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let GeoZoneService = class GeoZoneService {
    constructor(http) {
        this.http = http;
        this.countryUrl = 'assets/geozone/countries.json';
        this.provinceUrl = 'assets/geozone/provinces.json';
        this.cantonUrl = 'assets/geozone/cantons.json';
        this.districtUrl = 'assets/geozone/districts.json';
        this.wardsUrl = 'assets/geozone/wards.json';
        this.countryList = [];
        this.provinceList = [];
        this.cantonList = [];
        this.districtList = [];
        this.wardList = [];
        this.countryLoaded = false;
        this.provinceLoaded = false;
        this.cantonLoaded = false;
        this.districtLoaded = false;
        this.wardLoaded = false;
        this.cantonCache = {};
        this.districtCache = {};
        this.wardCache = {};
    }
    loadCountries() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            if (!this.countryLoaded) {
                this.fetchList(this.countryUrl).subscribe(list => {
                    this.countryList = list;
                    this.countryLoaded = true;
                    observer.next(this.countryList);
                    observer.complete();
                });
            }
            else {
                observer.next(this.countryList);
                observer.complete();
            }
        });
    }
    loadProvinces() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            if (!this.provinceLoaded) {
                this.fetchList(this.provinceUrl).subscribe(list => {
                    this.provinceList = list && list.length > 0 ? list.sort(__WEBPACK_IMPORTED_MODULE_6__util_array_utils__["a" /* ArrayUtils */].compareValues('provinceName')) : list;
                    this.provinceLoaded = true;
                    observer.next(this.provinceList);
                    observer.complete();
                });
            }
            else {
                observer.next(this.provinceList);
                observer.complete();
            }
        });
    }
    loadCantons() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            if (!this.cantonLoaded) {
                this.fetchList(this.cantonUrl).subscribe(list => {
                    this.cantonList = list;
                    this.cantonLoaded = true;
                    observer.next(this.cantonList);
                    observer.complete();
                });
            }
            else {
                observer.next(this.cantonList);
                observer.complete();
            }
        });
    }
    loadDistricts() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            if (!this.districtLoaded) {
                this.fetchList(this.districtUrl).subscribe(list => {
                    this.districtList = list;
                    this.districtLoaded = true;
                    observer.next(this.districtList);
                    observer.complete();
                });
            }
            else {
                observer.next(this.districtList);
                observer.complete();
            }
        });
    }
    loadWards() {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            if (!this.wardLoaded) {
                this.fetchList(this.wardsUrl).subscribe(list => {
                    this.wardList = list;
                    this.wardLoaded = true;
                    observer.next(this.wardList);
                    observer.complete();
                });
            }
            else {
                observer.next(this.wardList);
                observer.complete();
            }
        });
    }
    getCountryList() {
        return this.countryList;
    }
    getProvinceList() {
        return this.provinceList;
    }
    fetchCantonList(provinceCode) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            observer.next(this.getCantonList(provinceCode));
            observer.complete();
        });
    }
    getCantonList(provinceCode) {
        let cantons = [];
        cantons = this.cantonCache[provinceCode];
        if (!cantons) {
            cantons = [];
            for (let i = 0; i < this.cantonList.length; i++) {
                if (this.cantonList[i].provinceCode === provinceCode) {
                    cantons.push(this.cantonList[i]);
                }
            }
        }
        this.cantonCache[provinceCode] = cantons;
        return cantons;
    }
    fetchDistrictList(provinceCode, cantonCode) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            observer.next(this.getDistrictList(provinceCode, cantonCode));
            observer.complete();
        });
    }
    getDistrictList(provinceCode, cantonCode) {
        let key = provinceCode + "." + cantonCode;
        let districts = [];
        districts = this.districtCache[key];
        if (!districts) {
            districts = [];
            for (let i = 0; i < this.districtList.length; i++) {
                if (this.districtList[i].cantonKey === key) {
                    districts.push(this.districtList[i]);
                }
            }
        }
        this.districtCache[key] = districts;
        return districts;
    }
    fetchWardList(provinceCode, cantonCode, districtCode) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            observer.next(this.getWardList(provinceCode, cantonCode, districtCode));
            observer.complete();
        });
    }
    getWardList(provinceCode, cantonCode, districtCode) {
        let key = provinceCode + "." + cantonCode + "." + districtCode;
        let wards = [];
        wards = this.wardCache[key];
        if (!wards) {
            wards = [];
            for (let i = 0; i < this.wardList.length; i++) {
                if (this.wardList[i].districtKey === key) {
                    wards.push(this.wardList[i]);
                }
            }
        }
        this.wardCache[key] = wards;
        return wards;
    }
    getProvinceByCode(provinceCode) {
        let province = null;
        for (let i = 0; i < this.provinceList.length; i++) {
            if (this.provinceList[i].provinceCode === provinceCode) {
                province = this.provinceList[i];
                break;
            }
        }
        return province;
    }
    getCantonByCode(provinceCode, cantonCode) {
        let key = provinceCode + "." + cantonCode;
        let cantons = this.getCantonList(provinceCode);
        let canton = null;
        for (let i = 0; i < cantons.length; i++) {
            if (cantons[i].cantonKey === key) {
                canton = cantons[i];
                break;
            }
        }
        return canton;
    }
    getDistrictByCode(provinceCode, cantonCode, districtCode) {
        let key = provinceCode + "." + cantonCode + "." + districtCode;
        let districts = this.getDistrictList(provinceCode, cantonCode);
        let district = null;
        for (let i = 0; i < districts.length; i++) {
            if (districts[i].districtKey === key) {
                district = districts[i];
                break;
            }
        }
        return district;
    }
    getZone(provinceCode, cantonCode, districtCode, wardCode) {
        let zone = null;
        //Si viene la direccion completa
        let key = null;
        let isRegisteredWard = wardCode && wardCode != "00";
        let ward = null;
        if (isRegisteredWard) {
            key = provinceCode + "." + cantonCode + "." + districtCode + "." + wardCode;
            for (let i = 0; i < this.wardList.length; i++) {
                if (this.wardList[i].wardKey === key) {
                    ward = this.wardList[i];
                    break;
                }
            }
        }
        else {
            key = provinceCode + "." + cantonCode + "." + districtCode;
            for (let i = 0; i < this.wardList.length; i++) {
                if (this.wardList[i].districtKey === key) {
                    ward = this.wardList[i];
                    break;
                }
            }
        }
        if (ward) {
            let province = {
                provinceCode: ward.provinceCode,
                provinceName: ward.provinceName
            };
            let canton = {
                cantonCode: ward.cantonCode,
                cantonName: ward.cantonName,
                cantonKey: ward.cantonKey
            };
            let district = {
                districtCode: ward.districtCode,
                districtName: ward.districtName,
                districtKey: ward.districtKey
            };
            if (isRegisteredWard) {
                zone = {
                    province: province,
                    canton: canton,
                    district: district,
                    ward: ward
                };
            }
            else {
                zone = {
                    province: province,
                    canton: canton,
                    district: district,
                    ward: {
                        wardCode: "00",
                        wardName: "(Otro)"
                    }
                };
            }
        }
        return zone;
    }
    fetchList(url) {
        return this.http.get(url).catch(this.handleError);
    }
    handleError(error) {
        let errMsg;
        if (error instanceof __WEBPACK_IMPORTED_MODULE_1__angular_common_http__["d" /* HttpErrorResponse */]) {
            if (error.status === 404) {
                errMsg = 'Error loading countries.json file. Please configure WebPack and load countries.json assets to your root folder';
            }
            const err = error.error;
            errMsg = `${error.status} - ${error.statusText || ''} ${err}`;
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error(errMsg);
        return __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].throw(errMsg);
    }
};
GeoZoneService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__angular_common_http__["b" /* HttpClient */]])
], GeoZoneService);

//# sourceMappingURL=geozone-service.js.map

/***/ }),

/***/ 274:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSuggestedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_dataset__ = __webpack_require__(29);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};







/**
 * Fuente de datos para el Tab de SECCION DE TODO UN POCO
 */
let HomeSuggestedDataSet = class HomeSuggestedDataSet extends __WEBPACK_IMPORTED_MODULE_6__base_dataset__["a" /* DataSet */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        //Contador de pagina interna, para invocar el segundo catalogo
        this.localFetchPageId = __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultPage;
        this.switchToGeneralSuggestion = false;
        //Listados de imagenes que se muestran en los carruseles
        this.mainCarrusel = [];
        this.featuredCarrusel = [];
        this.newProductsCarrusel = [];
        //this.setPreviewPageSize(18); //Muestra una cantidad para preview
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
        this.events.publish(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].event.LOBBY_SUGGESTED_DATA_PROVIDER_READY);
    }
    onReset() {
        this.localFetchPageId = __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultPage;
        this.switchToGeneralSuggestion = false;
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultPageSize;
            //Verifica si es una sesion activa
            if (params.userId && params.token) {
                if (this.switchToGeneralSuggestion) {
                    //Si ya no hay mas productos relacionados al usuario per se
                    params.pageId = this.localFetchPageId;
                    this.productService.getSuggestedProducts(params).subscribe((resultList) => {
                        //Hay productos relacionados a mis intereses
                        if (resultList && resultList.length > 0) {
                            this.localFetchPageId++;
                            observer.next(resultList);
                            observer.complete();
                        }
                        else {
                            observer.next([]);
                            observer.complete();
                        }
                    }, error => {
                        observer.next([]);
                        observer.complete();
                    });
                }
                else {
                    this.productService.getMySuggestedProducts(params).subscribe((resultList) => {
                        //Hay productos relacionados a mis intereses
                        if (resultList && resultList.length > 0) {
                            observer.next(resultList);
                            observer.complete();
                        }
                        else {
                            this.switchToGeneralSuggestion = true;
                            //Si ya no hay mas productos relacionados al usuario per se
                            params.pageId = this.localFetchPageId;
                            this.productService.getSuggestedProducts(params).subscribe((resultList) => {
                                //Hay productos relacionados a mis intereses
                                if (resultList && resultList.length > 0) {
                                    this.localFetchPageId++;
                                    observer.next(resultList);
                                    observer.complete();
                                }
                                else {
                                    observer.next([]);
                                    observer.complete();
                                }
                            }, error => {
                                observer.next([]);
                                observer.complete();
                            });
                        }
                    }, error => {
                        observer.next([]);
                        observer.complete();
                    });
                }
            }
            else {
                this.productService.getSuggestedProducts(params).subscribe((resultList) => {
                    //Hay productos relacionados a mis intereses
                    if (resultList && resultList.length > 0) {
                        observer.next(resultList);
                        observer.complete();
                    }
                    else {
                        observer.next([]);
                        observer.complete();
                    }
                }, error => {
                    observer.next([]);
                    observer.complete();
                });
            }
        });
    }
    fetchMainCarrusel(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            this.productService.getMainImageCarrusel(this.sessionManager.getSession().toModel()).subscribe((list) => {
                if (list && list.length > 0) {
                    if (callback)
                        callback(list);
                }
            });
        });
    }
    fetchFeaturedCarrusel(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            this.productService.getFeaturedImageCarrusel(this.sessionManager.getSession().toModel()).subscribe((list) => {
                if (list && list.length > 0) {
                    if (callback)
                        callback(list);
                }
            });
        });
    }
    fetchNewProductsCarrusel(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            this.productService.getNewProductsImageCarrusel(this.sessionManager.getSession().toModel()).subscribe((list) => {
                if (list && list.length > 0) {
                    if (callback)
                        callback(list);
                }
            });
        });
    }
};
HomeSuggestedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__["a" /* ProductService */]])
], HomeSuggestedDataSet);

//# sourceMappingURL=home-suggested-dataset.js.map

/***/ }),

/***/ 275:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CardService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__model_card_model__ = __webpack_require__(1155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let CardService = class CardService {
    constructor(rest) {
        this.rest = rest;
    }
    /**
     * Consulta las tarjetas
     */
    getCards(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CARDS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Agrega una tarjeta
     */
    addCard(session, card) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertModelToRequest(session, card);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_ADD_CARDS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Modifica una tarjeta
     */
    modifyCard(session, card) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertModelToRequest(session, card);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_MODIFY_CARDS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Modifica una tarjeta
     */
    removeCard(session, card) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertModelToRequest(session, card);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_REMOVE_CARDS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    //Validar tarjeta
    validateCard(session, card) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertModelToRequest(session, card);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_VALIDATE_CARDS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_card_model__["a" /* CardMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
CardService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], CardService);

//# sourceMappingURL=card-service.js.map

/***/ }),

/***/ 276:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/**
 * Revision 1.0.20170321
 * Utility class that provides number utilities.
 *
 * @author Coliand Studio
 * @version 1.0.20170321
 *
 */
class NumberUtils {
    /**
     * Utility method that allows to round a number with certain precision.
     * @return {number} number rounded with precision.
     * @param {number} numberToRound
     * @param {number} precision
     */
    static roundWithPrecision(numberToRound, precision) {
        if (numberToRound) {
            var multiplier = Math.pow(10, precision || 0);
            return Math.round(numberToRound * multiplier) / multiplier;
        }
        return 0;
    }
    static randomIntFromInterval(min, max) {
        return Math.floor(Math.random() * (max - min + 1) + min);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = NumberUtils;

//# sourceMappingURL=number.utils.js.map

/***/ }),

/***/ 278:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddressService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__model_address_model__ = __webpack_require__(1169);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let AddressService = class AddressService {
    constructor(rest) {
        this.rest = rest;
    }
    getShippingAddress(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_GET_ADDRESS_USER, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    addShippingAddress(session, address) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            address.userId = session.userId;
            address.token = session.token;
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertModelToRequest(address);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_ADD_ADDRESS_USER, paramsString).subscribe(//El WS siempre retorna xxxxResponse
            (list) => {
                if (list) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertResponseToModel(list));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    //Modificar direccion
    modifyShippingAddress(session, address) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            address.userId = session.userId;
            address.token = session.token;
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertModelToRequest(address);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_MODIFY_ADDRESS_USER, paramsString).subscribe(//El WS siempre retorna xxxxResponse
            (list) => {
                if (list) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertResponseToModel(list));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    //Eliminar direccion
    deleteShippingAddress(session, address) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            address.userId = session.userId;
            address.token = session.token;
            var paramsString = __WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertModelToRequest(address);
            //Realiza la consulta del webservice
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_DELETE_ADDRESS_USER, paramsString).subscribe(//El WS siempre retorna xxxxResponse
            (list) => {
                if (list) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_address_model__["a" /* ShippingAddressMapper */].convertResponseToModel(list));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
};
AddressService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__util_rest_client__["a" /* RESTClient */]])
], AddressService);

;
//# sourceMappingURL=address-service.js.map

/***/ }),

/***/ 279:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return VersionService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let VersionService = class VersionService {
    constructor(rest) {
        this.rest = rest;
    }
    isUpdateAvailable() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = "version=" + __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.version;
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_VERSION_CONTROL, paramsString).subscribe((response) => {
                let updateAvailable = false;
                if (response) {
                    updateAvailable = response.cambio === "S";
                }
                observer.next(updateAvailable);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
VersionService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], VersionService);

//# sourceMappingURL=version-service.js.map

/***/ }),

/***/ 280:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/**
 * Revision 1.0.20170321
 * Utility class that provides number utilities.
 *
 * @author Coliand Studio
 * @version 1.0.20170321
 *
 */
class ArrayUtils {
    // function for dynamic sorting
    static compareValues(key, order = 'asc') {
        return function (a, b) {
            if (!a.hasOwnProperty(key) || !b.hasOwnProperty(key)) {
                // property doesn't exist on either object
                return 0;
            }
            const varA = (typeof a[key] === 'string') ? a[key].toUpperCase() : a[key];
            const varB = (typeof b[key] === 'string') ? b[key].toUpperCase() : b[key];
            let comparison = 0;
            if (varA > varB) {
                comparison = 1;
            }
            else if (varA < varB) {
                comparison = -1;
            }
            return ((order == 'desc') ? (comparison * -1) : comparison);
        };
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ArrayUtils;

//# sourceMappingURL=array.utils.js.map

/***/ }),

/***/ 281:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeOffersService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__products_model_product_model__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_home_offer_model__ = __webpack_require__(1147);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let HomeOffersService = class HomeOffersService {
    constructor(rest) {
        this.rest = rest;
    }
    performInit(params) {
        this.groups = [];
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_home_offer_model__["b" /* OfferGroupMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_OFFERS_GROUPS, paramsString).subscribe((response) => {
                if (response) {
                    let list = __WEBPACK_IMPORTED_MODULE_5__model_home_offer_model__["b" /* OfferGroupMapper */].convertResponseListToModelList(response);
                    let observables = [];
                    for (var i = 0; i < list.length; i++) {
                        if (list[i].visible === "S") {
                            observables.push(this.getGroupImages(list[i]));
                        }
                    }
                    //Consulta las imagenes de cada grupo
                    if (observables.length > 0) {
                        __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].forkJoin(observables).subscribe(data => {
                            this.groups = data;
                            observer.next(this.groups);
                            observer.complete();
                        });
                    }
                    else {
                        observer.next([]);
                        observer.complete();
                    }
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getGroups() {
        if (this.groups) {
            //Ordena los grupos
            this.groups.sort(function (a, b) {
                return a.order - b.order;
            });
        }
        return this.groups;
    }
    getGroupImages(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_home_offer_model__["a" /* OfferGroupImageMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_OFFERS_GROUPS_IMAGES, paramsString).subscribe((response) => {
                if (response) {
                    let images = __WEBPACK_IMPORTED_MODULE_5__model_home_offer_model__["a" /* OfferGroupImageMapper */].convertResponseListToModelList(response);
                    params.images = images;
                    observer.next(params);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getProductForGroupSection(pageModel, groupCode) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_home_offer_model__["c" /* OfferGroupProductsMapper */].convertModelToRequest(pageModel, groupCode);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_OFFERS_GROUPS_PRODUCTS, paramsString).subscribe((response) => {
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_4__products_model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
HomeOffersService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], HomeOffersService);

//# sourceMappingURL=home-offers-service.js.map

/***/ }),

/***/ 282:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UniqueIdService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__util_string_utils__ = __webpack_require__(7);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let UniqueIdService = class UniqueIdService {
    constructor(rest) {
        this.rest = rest;
    }
    registerUUID(user, uuid) {
        return this.registerUniqueId(user, null, uuid);
    }
    registerIMEI(user, imei) {
        return this.registerUniqueId(user, imei, null);
    }
    registerUniqueId(user, imei, uuid) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = {
                id_usuario: user.userId,
                token: user.token,
                imei: imei,
                uuid: uuid,
                ip: null
            };
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_REGISTER_IMEI, paramsString).subscribe((response) => {
                observer.next(true);
                observer.complete();
            }, error => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    verifyIfUUIDsLocked(user, uuid) {
        return this.verifyUniqueIdIsLocked(user, null, uuid);
    }
    verifyIfIMEIIsLocked(user, imei) {
        return this.verifyUniqueIdIsLocked(user, imei, null);
    }
    verifyUniqueIdIsLocked(user, imei, uuid) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var request = {
                id_usuario: user.userId,
                token: user.token,
                imei: imei,
                uuid: uuid,
                ip: null
            };
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_2__config_rest_config__["a" /* RESTConfig */].WS_QUERY_IMEI, paramsString).subscribe((response) => {
                observer.next((response && response.estado != "ACTIVO"));
                observer.complete();
            }, error => {
                observer.next(true);
                observer.complete();
            });
        });
    }
};
UniqueIdService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__util_rest_client__["a" /* RESTClient */]])
], UniqueIdService);

//# sourceMappingURL=device-uniqueid-service.js.map

/***/ }),

/***/ 283:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductListingDataSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let ProductListingDataSetNavigator = class ProductListingDataSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
};
ProductListingDataSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], ProductListingDataSetNavigator);

//# sourceMappingURL=product-listing-dataset-navigator.js.map

/***/ }),

/***/ 284:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductListingSimilarSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let ProductListingSimilarSetNavigator = class ProductListingSimilarSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
};
ProductListingSimilarSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], ProductListingSimilarSetNavigator);

//# sourceMappingURL=product-listing-similar-dataset-navigator.js.map

/***/ }),

/***/ 286:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GreenPayCheckoutService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_http__ = __webpack_require__(142);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_aes_js__ = __webpack_require__(443);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_aes_js___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_aes_js__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_node_jsencrypt__ = __webpack_require__(444);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_node_jsencrypt___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_node_jsencrypt__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__error_service__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__greenpay_config_service__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__util_rest_native_client__ = __webpack_require__(104);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_device__ = __webpack_require__(85);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













let GreenPayCheckoutService = class GreenPayCheckoutService {
    constructor(http, sessionManager, greenPayConfigService, platform, device, nativeRest, logService) {
        this.http = http;
        this.sessionManager = sessionManager;
        this.greenPayConfigService = greenPayConfigService;
        this.platform = platform;
        this.device = device;
        this.nativeRest = nativeRest;
        this.logService = logService;
        this.rsa = new __WEBPACK_IMPORTED_MODULE_3_node_jsencrypt__();
        this.orderId = 0;
        this.defaultErrMessage = "Banco autorizador rechazó la transacción";
        this.defaultPrefix = "CARRITO";
    }
    checkout(order, card, user) {
        this.defaultPrefix = "CARRITO";
        this.orderId = order.orderId;
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            //Para evitar cobros dobles lleva un control interno para ver si la orden ya pago
            this.sessionManager
                .getSession()
                .getItem("efast-ord" + order.orderId)
                .subscribe((paymentResult) => {
                if (paymentResult) {
                    this.addLog(this.defaultPrefix +
                        " " +
                        this.orderId +
                        " - GREENPAY (Utilizado order cachada. Guardado en localstorage)", JSON.stringify(paymentResult));
                    observer.next(paymentResult);
                    observer.complete();
                }
                else {
                    this.addLog(this.defaultPrefix +
                        " " +
                        this.orderId +
                        " - GREENPAY (Utilizado order NO cachada.)", "-");
                    this.handleCheckout(order, card, user).subscribe((result) => {
                        observer.next(result);
                        observer.complete();
                    });
                }
            });
        });
    }
    checkoutGiftCard(order, card, user) {
        this.defaultPrefix = "TARJETA REGALO";
        this.orderId = order.orderId;
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            //Para evitar cobros dobles lleva un control interno para ver si la orden ya pago
            this.sessionManager
                .getSession()
                .getItem("efast-ord" + order.orderId)
                .subscribe((paymentResult) => {
                if (paymentResult) {
                    this.addLog(this.defaultPrefix +
                        " " +
                        this.orderId +
                        " - GREENPAY (Utilizado order cachada. Guardado en localstorage)", JSON.stringify(paymentResult));
                    observer.next(paymentResult);
                    observer.complete();
                }
                else {
                    this.addLog(this.defaultPrefix +
                        " " +
                        this.orderId +
                        " - GREENPAY (Utilizado order NO cachada.)", "-");
                    this.handleCheckoutTR(order, card, user).subscribe((result) => {
                        observer.next(result);
                        observer.complete();
                    });
                }
            });
        });
    }
    checkoutGiftCardSinpe(order, card, user) {
        this.defaultPrefix = "TARJETA REGALO";
        this.orderId = order.orderId;
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            this.sessionManager
                .getSession()
                .getItem("efast-ord" + order.orderId)
                .subscribe((paymentResult) => {
                if (paymentResult) {
                    this.addLog(this.defaultPrefix +
                        " " +
                        this.orderId +
                        " - GREENPAY (Utilizado order cachada. Guardado en localstorage)", JSON.stringify(paymentResult));
                    observer.next(paymentResult);
                    observer.complete();
                }
                else {
                    this.addLog(this.defaultPrefix +
                        " " +
                        this.orderId +
                        " - GREENPAY (Utilizado order NO cachada.)", "-");
                    this.handleCheckout(order, card, user).subscribe((result) => {
                        observer.next(result);
                        observer.complete();
                    });
                }
            });
        });
    }
    handleCheckoutTR(order, card, user) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            let paymentResult = {};
            this.greenPayConfigService.getConfig().subscribe((config) => {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_7__config_config__["a" /* AppConfig */].app.greenPayConfig, config);
                this.config = config;
                //Order data
                let orderRequestData = {
                    secret: this.config.secretid,
                    merchantId: this.config.merchantid,
                    terminal: this.config.terminalid,
                    amount: order.amountToCharge,
                    currency: order.currency,
                    description: order.description,
                    orderReference: order.orderId.toString(),
                    //"kountsession": order.KountSession,
                    additional: {
                        customer: {
                            name: user.feFullName.substring(0, 49),
                            email: user.email,
                            identification: user.identification,
                            billingAddress: {
                                country: "CR",
                                street1: "Digital Address" + user.email,
                            },
                            shippingAddress: {
                                country: "CR",
                                street1: "Digital Address" + user.email,
                            },
                        },
                        products: [
                            {
                                description: "TR",
                                skuId: order.orderId.toString(),
                                quantity: 1,
                                price: Number(order.amountToCharge),
                                type: "APP",
                            },
                        ],
                    },
                };
                //Card data
                let cardData = {
                    token: card.cardToken,
                    kountSession: order.KountSession,
                };
                this.createCheckoutOrder(orderRequestData).subscribe(() => {
                    this.prepareCheckout(cardData).subscribe((data) => {
                        if (data) {
                            let checkoutData = JSON.parse(data);
                            paymentResult.orderId = checkoutData.orderId;
                            paymentResult.authorization = checkoutData.authorization;
                            let result = checkoutData.result;
                            if (result) {
                                let code = result.resp_code;
                                let reason = result.reserved_private4;
                                let msg = (reason ? reason : this.defaultErrMessage) +
                                    " (" +
                                    code +
                                    ")";
                                paymentResult.error = msg;
                            }
                        }
                        observer.next(paymentResult);
                        observer.complete();
                    }, (error) => {
                        paymentResult.error = error
                            ? error.message
                            : this.defaultErrMessage;
                        observer.next(paymentResult);
                        observer.complete();
                    });
                }, (error) => {
                    paymentResult.error = error
                        ? error.message
                        : this.defaultErrMessage;
                    observer.next(paymentResult);
                    observer.complete();
                });
            }, (error) => {
                paymentResult.error = error ? error.message : this.defaultErrMessage;
                observer.next(paymentResult);
                observer.complete();
            });
        });
    }
    handleCheckout(order, card, user) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            let paymentResult = {};
            this.greenPayConfigService.getConfig().subscribe((config) => {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_7__config_config__["a" /* AppConfig */].app.greenPayConfig, config);
                this.config = config;
                //Order data
                let orderRequestData = {
                    secret: this.config.secretid,
                    merchantId: this.config.merchantid,
                    terminal: this.config.terminalid,
                    amount: order.amountToCharge,
                    currency: order.currency,
                    description: order.description,
                    orderReference: order.orderId.toString(),
                    //"kountsession": order.KountSession,
                    additional: {
                        customer: {
                            name: user.feFullName,
                            email: user.email,
                            identification: user.identification,
                            billingAddress: {
                                country: "CR",
                                street1: order.addressDescription,
                            },
                            shippingAddress: {
                                country: "CR",
                                street1: order.addressDescription,
                            },
                        },
                        products: [
                            {
                                description: order.details[0].description,
                                skuId: order.details[0].productCode,
                                quantity: order.details[0].quantity,
                                price: order.details[0].price,
                                type: "APP",
                            },
                        ],
                    },
                };
                //Card data
                let cardData = {
                    token: card.cardToken,
                    kountSession: order.KountSession,
                };
                this.createCheckoutOrder(orderRequestData).subscribe(() => {
                    this.prepareCheckout(cardData).subscribe((data) => {
                        if (data) {
                            let checkoutData = JSON.parse(data);
                            paymentResult.orderId = checkoutData.orderId;
                            paymentResult.authorization = checkoutData.authorization;
                            let result = checkoutData.result;
                            if (result) {
                                let code = result.resp_code;
                                let reason = result.reserved_private4;
                                let msg = (reason ? reason : this.defaultErrMessage) +
                                    " (" +
                                    code +
                                    ")";
                                paymentResult.error = msg;
                            }
                        }
                        observer.next(paymentResult);
                        observer.complete();
                    }, (error) => {
                        paymentResult.error = error
                            ? error.message
                            : this.defaultErrMessage;
                        observer.next(paymentResult);
                        observer.complete();
                    });
                }, (error) => {
                    paymentResult.error = error
                        ? error.message
                        : this.defaultErrMessage;
                    observer.next(paymentResult);
                    observer.complete();
                });
            }, (error) => {
                paymentResult.error = error ? error.message : this.defaultErrMessage;
                observer.next(paymentResult);
                observer.complete();
            });
        });
    }
    createCheckoutOrder(data) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            let header = {};
            this.http.setDataSerializer("json");
            this.http.setHeader("*", "Accept", "application/json");
            this.http.setHeader("*", "Content-Type", "application/json");
            this.addLog(this.defaultPrefix +
                " " +
                this.orderId +
                " - GREENPAY (createCheckoutOrder REQ)", JSON.stringify(data));
            this.http
                .post(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_GREENPAY_CHECKOUT_ORDER, data, header)
                .then((response) => {
                this.addLog(this.defaultPrefix +
                    " " +
                    this.orderId +
                    " - GREENPAY (createCheckoutOrder RES)", JSON.stringify(response.data));
                if (response.status === 200) {
                    this.security = JSON.parse(response.data);
                    this.createdOn = new Date();
                    observer.next(response.data);
                    observer.complete();
                }
                else {
                    this.security = null;
                    this.createdOn = null;
                    observer.error();
                }
            })
                .catch((error) => {
                this.addLog(this.defaultPrefix +
                    " " +
                    this.orderId +
                    " - GREENPAY (createCheckoutOrder ERR)", JSON.stringify(error));
                try {
                    this.logService.log("WEBSERVICE: WS_CHECKOUT_ORDER   [   Resultado ERR   ] [ DETAIL: " +
                        JSON.stringify(error) +
                        "   ]");
                }
                catch (e) { }
                this.security = null;
                this.createdOn = null;
                observer.error(error.error);
            });
        });
    }
    performCheckout(data, accessToken) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            let header = {};
            this.http.setDataSerializer("json");
            this.http.setHeader("*", "Accept", "application/json");
            this.http.setHeader("*", "Content-Type", "application/json");
            this.http.setHeader("*", "liszt-token", accessToken);
            this.addLog(this.defaultPrefix +
                " " +
                this.orderId +
                " - GREENPAY (performCheckout REQ)", JSON.stringify(data));
            this.http
                .post(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_GREENPAY_CHECKOUT_CARD_KOUNT, data, header)
                .then((response) => {
                this.addLog(this.defaultPrefix +
                    " " +
                    this.orderId +
                    " - GREENPAY (performCheckout RES)", JSON.stringify(response.data));
                if (response.status === 200) {
                    observer.next(response.data);
                    observer.complete();
                }
                else {
                    let error = new Error(this.defaultErrMessage);
                    observer.error(error);
                }
            })
                .catch((error) => {
                this.addLog(this.defaultPrefix +
                    " " +
                    this.orderId +
                    " - GREENPAY (performCheckout ERR)", JSON.stringify(error));
                try {
                    this.logService.log("WEBSERVICE: WS_CHECKOUT_ORDER   [   Resultado ERR   ] [ DETAIL: " +
                        JSON.stringify(error) +
                        "   ]");
                }
                catch (e) { }
                observer.error(error.error);
            });
        });
    }
    prepareCheckout(cardData) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            try {
                this.rsa.setPublicKey(this.config.publickey);
                const body = this.ciperPack(cardData, this.security.session);
                this.performCheckout(body, this.security.token).subscribe((data) => {
                    observer.next(data);
                    observer.complete();
                }, (error) => {
                    observer.error(error);
                });
            }
            catch (err) {
                observer.error(err);
            }
        });
    }
    cipherGenerateAESPairs() {
        var key = [];
        var iv;
        for (let k = 0; k < 16; k++) {
            key.push(Math.floor(Math.random() * 255));
        }
        for (let k = 0; k < 16; k++) {
            iv = Math.floor(Math.random() * 255);
        }
        return {
            k: key,
            s: iv,
        };
    }
    ciperPack(obj, session, pair_) {
        var pair = pair_ !== undefined ? pair_ : this.cipherGenerateAESPairs();
        var textBytes = __WEBPACK_IMPORTED_MODULE_2_aes_js__["utils"].utf8.toBytes(JSON.stringify(obj));
        var aesCtr = new __WEBPACK_IMPORTED_MODULE_2_aes_js__["ModeOfOperation"].ctr(pair.k, new __WEBPACK_IMPORTED_MODULE_2_aes_js__["Counter"](pair.s));
        var encryptedBytes = aesCtr.encrypt(textBytes);
        var encryptedHex = __WEBPACK_IMPORTED_MODULE_2_aes_js__["utils"].hex.fromBytes(encryptedBytes);
        var returnObj = {
            session: session,
            ld: encryptedHex,
            lk: this.rsa.encrypt(JSON.stringify(pair)),
        };
        return returnObj;
    }
    /*private ciperVerify(signed, toVerify) {
        const sig = new KJUR.crypto.Signature({
            "alg": "SHA256withRSA"
        })
        sig.init('-----BEGIN PUBLIC KEY-----'+this.config.publickey+'-----END PUBLIC KEY-----');
        sig.updateString(toVerify)
        return sig.verify(signed)
    }*/
    addLog(functionality, message) {
        try {
            this.addSimpleLog(functionality, message).subscribe();
        }
        catch (e) {
            console.log(e);
        }
    }
    addSimpleLog(functionality, message) {
        let params = {
            id_usuario: this.sessionManager.getPrincipal().userId,
            token: this.sessionManager.getToken(),
            fecha: new Date().getTime(),
            dispositivo: this.platform.is("ios") ? "ios" : "android",
            dispositivoVersion: this.device.version,
            appVersion: __WEBPACK_IMPORTED_MODULE_7__config_config__["a" /* AppConfig */].app.version,
            funcionalidad: functionality,
            trama: message,
        };
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            //Compone los parametros del WS
            this.nativeRest.post(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_ADD_PURCHASE_LOG, params).subscribe((response) => {
                observer.next();
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
};
GreenPayCheckoutService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_http__["a" /* HTTP */],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_9__greenpay_config_service__["a" /* GreenPayConfigService */],
        __WEBPACK_IMPORTED_MODULE_11_ionic_angular__["Platform"],
        __WEBPACK_IMPORTED_MODULE_12__ionic_native_device__["a" /* Device */],
        __WEBPACK_IMPORTED_MODULE_10__util_rest_native_client__["a" /* NativeRESTClient */],
        __WEBPACK_IMPORTED_MODULE_8__error_service__["a" /* ErrorService */]])
], GreenPayCheckoutService);

//# sourceMappingURL=greenpay-checkout-service.js.map

/***/ }),

/***/ 287:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeCategoriesDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_ionic_angular__ = __webpack_require__(8);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Fuente de datos para el Tab de CATEGORIAS
 */
let HomeCategoriesDataSet = class HomeCategoriesDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, events, productService) {
        super();
        this.sessionManager = sessionManager;
        this.events = events;
        this.productService = productService;
        //Lista de datos
        this.categories = [];
        //Se devuelve al view un preview de datos de 2 categorias
        this.firstCategoryPreviewList = [];
        //Se guarda el restante conjunto de datos
        this.firstCategoryPreviewRemainingList = [];
    }
    //Seccion de productos que se desea cargar
    setCategoryCode(categoryCode) {
        this.categoryCode = categoryCode;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider para la categoria especificada
    //Este metodo se usa para cuando el DataSet esta en modo stateFull y realizando paginacion
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            this.getCategoryProductData(this.categoryCode, fetchPageId, 0).subscribe((categoryFetched) => {
                observer.next(categoryFetched.products);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
    //Esta funcionalidad se utiliza para extender el comportamiento estandar del DataSet, dado
    //que se lleva el control de multiples detalles de productos por cada categoreia
    initializeCategories(callback) {
        this.categories = [];
        this.firstCategoryPreviewList = [];
        this.firstCategoryPreviewRemainingList = [];
        this.prepare();
        this.sessionManager.getDataSet(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.PRODUCT_CATEGORY).subscribe((list) => {
            this.categories = [...list];
            this.loadCategories(callback);
        });
    }
    performInitCategories() {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            this.initializeCategories();
            observer.next();
            observer.complete();
        });
    }
    loadCategories(callback) {
        if (this.categories && this.categories.length > 0) {
            let observables = [];
            for (var i = 0; i < this.categories.length; i++) {
                observables.push(this.getCategoryProductResumeData(this.categories[i].code, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage, i));
            }
            __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"].forkJoin(observables).subscribe(data => {
                for (var i = 0; i < data.length; i++) {
                    var fetchedCategory = data[i];
                    var index = fetchedCategory.index;
                    var list = fetchedCategory.products;
                    var category = this.categories[index];
                    category.products = [];
                    category.featureProducts = [];
                    if (list && list.length > 0) {
                        category.products = list;
                        category.featureProducts = category.products;
                    }
                    //Item final de la ieracion
                    if (index + 1 === this.categories.length) {
                        //Indica al DataSet que el estado de procesamiento/recuperacion de datos ha finalizado
                        this.finishProcessing();
                        //Ordenamiento y merge de categorias
                        this.mergeCategoriesOnRefresh(this.categories);
                        //////////////////////////////
                        //Carga un preview para agilizar el UI
                        this.firstCategoryPreviewList = this.categories; //.slice(0, 5);
                        //this.firstCategoryPreviewRemainingList = this.categories.slice(5, this.categories.length);
                        //////////////////////////////
                        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.LOBBY_CATEGORIES_READY, this.categories);
                        if (callback) {
                            callback(this.getCategoriesState());
                        }
                    }
                }
            });
        }
        else {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.LOBBY_CATEGORIES_READY, this.categories);
        }
    }
    //Realiza la consulta propia del provider para la categoria especificada
    getCategoryProductData(categoryCode, fetchPageId, index) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            var transientCategory = {};
            this.productService.getCategorizedProducts(session, categoryCode, fetchPageId, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize).subscribe((list) => {
                transientCategory.code = categoryCode;
                transientCategory.products = list;
                transientCategory.index = index;
                observer.next(transientCategory);
                observer.complete();
            }, error => {
                observer.next(transientCategory);
                observer.complete();
            });
        });
    }
    getCategoryProductResumeData(categoryCode, fetchPageId, index) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            var transientCategory = {};
            let featuredQuantityForCategory = 2;
            this.productService.getCategorizedProductsResume(session, categoryCode, fetchPageId, featuredQuantityForCategory).subscribe((list) => {
                transientCategory.code = categoryCode;
                transientCategory.products = list;
                transientCategory.index = index;
                observer.next(transientCategory);
                observer.complete();
            }, error => {
                observer.next(transientCategory);
                observer.complete();
            });
        });
    }
    mergeCategoriesOnRefresh(list) {
        if (list && list.length > 0) {
            if (this.categories && this.categories.length > 0) {
                for (let i = 0; i < this.categories.length; i++) {
                    let category = this.categories[i];
                    for (let j = 0; j < list.length; j++) {
                        let tempCategory = list[j];
                        if (tempCategory.code === category.code) {
                            category.featureProducts = tempCategory.featureProducts;
                            break;
                        }
                    }
                }
            }
            else {
                this.categories = list;
            }
        }
    }
    clearAndPreload(callback) {
        this.clear();
        this.categoryCode = "";
        this.categories = [];
        this.firstCategoryPreviewList = [];
        this.firstCategoryPreviewRemainingList = [];
        let state = this.getCategoriesState();
        state["categories"] = [];
        if (callback)
            callback(state);
        this.initializeCategories();
    }
    fetchCategories(callback) {
        //////////////////////////////
        if (!this.isFetchingData) {
            //Maneja un preview para agilizar el UI
            if (this.firstCategoryPreviewList.length > 0) {
                this.categories = [...this.firstCategoryPreviewList];
                this.firstCategoryPreviewList = [];
            }
            else if (this.firstCategoryPreviewRemainingList.length > 0) {
                this.categories = this.categories.concat([...this.firstCategoryPreviewRemainingList]);
                this.firstCategoryPreviewRemainingList = [];
            }
        }
        //////////////////////////////
        if (callback)
            callback(this.getCategoriesState());
    }
    getCategoriesState() {
        let state = this.getState();
        state["categories"] = this.categories;
        return state;
    }
    prepareCategories(callback) {
        this.prepare(callback);
    }
    //Verifica que alguna categoria tenga productos
    isCategorySetEmpty() {
        let hasData = false;
        if (this.categories && this.categories != undefined && this.categories.length > 0) {
            for (var i = 0; i < this.categories.length; i++) {
                hasData = this.categories[i].products.length > 0;
                if (hasData)
                    break;
            }
        }
        return !hasData;
    }
};
HomeCategoriesDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_6_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], HomeCategoriesDataSet);

//# sourceMappingURL=home-categories-dataset.js.map

/***/ }),

/***/ 288:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductHistoryDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para el Tab de FAVORITOS
 */
let ProductHistoryDataSet = class ProductHistoryDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            this.productService.getRecentViewedProducts(params).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
ProductHistoryDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], ProductHistoryDataSet);

//# sourceMappingURL=product-history-dataset.js.map

/***/ }),

/***/ 29:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__config_config__ = __webpack_require__(3);
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};


/**
 * Clase base de un set de datos paginado
 */
class DataSet {
    constructor() {
        //Bandera general que indica que el Provider se inicializo
        this.initialized = false;
        //Control de modelos para el View
        this.pageId = 0; //AppConfig.app.defaultPage;
        this.list = [];
        this.nextPage = [];
        //Control de secciones de datos para mostrar o no las mismas
        this.isTimeout = false;
        this.isFetchingData = true;
        //Para indicar que un request internamente se esta ejjecutando
        this.internalRequestPerforming = false;
        //ID del timer del T.O.
        this.timerId = 0;
        //Para guardar el estado inicial y poder restaurarlo
        this.snapshot = [];
        //Indica que el DataSet se utilzara con inicializacion previa a su utilizacion
        this.preLoadMode = true;
        //Manejo de funcionalidad de Preview de la primera pagina
        this.firstPagePreviewMode = false;
        //Se devuelve al view un preview de datos de 8 items
        this.firstPagePreviewList = [];
        //Se guarda el restante conjunto de datos
        this.firstPagePreviewRemainingList = [];
        //Indiva cuando el Dataset comienza proceso de limpiado de memoria
        this.isShrinking = false;
        //Fuerza que el DS se mantenga vacio, esto para evitar consultas adicionales
        this.keepEmpty = false;
        //Solo se utiliza para forzar que se haga solo el fetch unico
        this.oneTimeFetch = false;
        this.previewPageSize = 50; //8
        //Deshabilita totalmente los caches
        this.previewModeCacheOn = true;
    }
    turnOffPreviewCache() {
        this.previewModeCacheOn = false;
    }
    isPreviewCacheTurnedOn() {
        return this.previewModeCacheOn;
    }
    setPreLoadMode(preLoadMode) {
        this.preLoadMode = preLoadMode;
    }
    setErrHandler(errHandler) {
        //this.errHandler = errHandler;
    }
    setPlatform(platform) {
        this.platform = platform;
    }
    /*****************************************************************
     * Manejo de precarga y funcionalidad de inicialzacion
     *****************************************************************/
    isInitialized() {
        return this.initialized;
    }
    setInitialized(initialized) {
        this.initialized = initialized;
    }
    //Funcionalidad se llama una vez cuando la app inicia
    initialize() {
        if (!this.initialized) {
            this.reset();
            //Que no cargue la siguiente pagina de una vez
            let skipNextPageFetching = true;
            //Mantiene un set de datos inicial
            this.fetch((state) => {
                this.initialized = true;
                this.onInitialize();
                //Se actualizan las referencias del cache para que almacene el fetch inicial, para que cuando se solicite
                //se tome como data ya paginada.
                this.nextPage = [...this.list];
                this.list = [];
            }, skipNextPageFetching);
        }
    }
    performInit() {
        return new __WEBPACK_IMPORTED_MODULE_0_rxjs__["Observable"](observer => {
            //this.initialize();
            observer.next();
            observer.complete();
        });
    }
    //Mantiene un set de datos cargados
    clearAndPreset(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            //let currentSize = this.list.length;
            this.reset((state) => {
                if (callback) {
                    callback({
                        isTimeout: this.isTimeout,
                        isFetchingData: this.isFetchingData,
                        list: [],
                        listHeader: [],
                        listFeatured: []
                    });
                }
            });
            //Mantiene un set de datos inicial
            this.fetch((state) => {
                //Se actualizan las referencias del cache para que almacene el fetch inicial, para que cuando se solicite
                //se tome como data ya paginada.
                this.nextPage = [...this.list];
                this.list = [];
            }, true);
        });
    }
    /*****************************************************************
     * Manejo de informacion, paginacion y control de data para el View
     *****************************************************************/
    reset(callback) {
        this.isShrinking = false;
        this.firstPagePreviewMode = false;
        this.firstPagePreviewList = [];
        this.keepEmpty = false;
        this.firstPagePreviewRemainingList = [];
        this.pageId = 0; //AppConfig.app.defaultPage;
        this.isFetchingData = true;
        this.isTimeout = false;
        this.oneTimeFetch = false;
        this.list = [];
        this.nextPage = [];
        if (callback)
            callback(this.getState());
        this.onReset();
    }
    onReset() {
    }
    clearLock() {
        this.internalRequestPerforming = false;
    }
    //Libera elementos utilizados por el VIEW
    clear(callback) {
        //let currentSize = this.list.length;
        this.reset();
        if (callback)
            callback(this.getState());
    }
    //Actualiza el estado del provider manualmente para realizar posteriormente un fetch
    prepare(callback) {
        this.isFetchingData = true;
        this.isTimeout = false;
        this.isShrinking = false;
        if (callback)
            callback(this.getState());
    }
    fetchWithTimeoutCheck(successCallback, timeoutCallback) {
        //Carga datos y actualiza el estado del view con respecto al estado del provider
        this.fetch((state) => successCallback(state));
        //Escucha cambios en el provider a raiz de posibles T.O.
        this.handleTimeout((state) => timeoutCallback(state));
    }
    fetchWithTOCheckAndPageControl(successCallback, timeoutCallback, skipNextPageFetching) {
        //Carga datos y actualiza el estado del view con respecto al estado del provider
        this.fetch((state) => successCallback(state), skipNextPageFetching);
        //Escucha cambios en el provider a raiz de posibles T.O.
        this.handleTimeout((state) => timeoutCallback(state));
    }
    isHandleShrinking() {
        return this.isShrinking;
    }
    fetch(callback, skipNextPageFetching) {
        this.fetchInfinite(callback, null, skipNextPageFetching);
    }
    fetchInfinite(callback, shrinkCallback, skipNextPageFetching) {
        //Si esta esperando respuesta del server cancela otros request
        if (this.internalRequestPerforming) {
            //console.log(this.constructor.name + " fetchInfinite -> ESPERANDO POR DATOS...");
            if (callback)
                callback(this.getState());
            return;
        }
        //Si esta en modo preview
        if (this.previewModeCacheOn && this.firstPagePreviewMode) {
            this.isFetchingData = false;
            this.isTimeout = false;
            if (this.firstPagePreviewList.length > 0) {
                this.list = [...this.firstPagePreviewList];
                this.firstPagePreviewList = [];
            }
            else if (this.firstPagePreviewRemainingList.length > 0) {
                this.list = this.list.concat([...this.firstPagePreviewRemainingList]);
                this.firstPagePreviewRemainingList = [];
                this.firstPagePreviewMode = false;
                this.prepareNextPage();
            }
            //Si ha habido algun cambio, notifica
            this.onStateChanged();
            if (callback)
                callback(this.getState());
        }
        else {
            this.isFetchingData = true;
            this.isTimeout = false;
            let temporalPage = this.pageId + 1;
            this.performFetch(temporalPage).subscribe((resultList) => {
                //Siempre y cuando el request este en el tiempo aceptable de espeta
                if (!this.isTimeout) {
                    //Procesa los datos
                    this.isFetchingData = false;
                    //Se encontro informacion?
                    let receivedPageSize = resultList ? resultList.length : 0;
                    if (receivedPageSize > 0) {
                        //Deja la pagina actual en firme (que si tiene datos)
                        this.pageId = temporalPage;
                        this.isShrinking = false;
                        //Agrega los nuevos resultados de la pagina al model
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        ////////////////////////////////////////
                        //Si es la primera pagina mantiene un preview
                        if (this.previewModeCacheOn) {
                            if (this.pageId === 1 && this.list.length > this.previewPageSize) {
                                this.firstPagePreviewList = this.list.slice(0, this.previewPageSize);
                                this.firstPagePreviewRemainingList = this.list.slice(this.previewPageSize, this.list.length);
                                this.firstPagePreviewMode = true;
                                if (!this.preLoadMode && this.firstPagePreviewList.length > 0) {
                                    this.list = [...this.firstPagePreviewList];
                                    this.firstPagePreviewList = [];
                                }
                            }
                        }
                        //Carga en cache para paginacion, la siguiente pagina
                        if (!skipNextPageFetching) {
                            this.prepareNextPage();
                        }
                        //Si ha habido algun cambio, notifica
                        this.onStateChanged();
                        if (callback)
                            callback(this.getState());
                    }
                    else {
                        try {
                            if (callback)
                                callback(this.getFinalState());
                        }
                        catch (e) { }
                        if (this.onReachedFinalCallback)
                            this.onReachedFinalCallback(this.getFinalState());
                    }
                }
                else {
                    if (callback)
                        callback(this.getState());
                }
            });
        }
    }
    printList(prefix, listItems) {
        if (listItems.length > 0) {
            console.log("  ");
            listItems.forEach((value) => {
                console.log(prefix + "  Cod: " + value.productCode + " Desc: " + value.description);
            });
        }
    }
    performShrink(callback) {
        let shrinkFlag = false;
        //Manejo restringido de carga de datos para IOS, dado que de iOS 12+ a mucho procesamiento se reinicia el WebView
        if (this.platform && this.platform.is('ios')) {
            if (this.list.length >= __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].app.defaultMaxItemsInViewIOS) {
                shrinkFlag = true;
                //let from = this.list.length;
                this.list.splice(0, this.list.length - 2 /*50*/);
                //let to = this.list.length;
                if (callback)
                    callback(this.getState());
            }
        }
        else {
            if (this.list.length >= __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].app.defaultMaxItemsInView) {
                shrinkFlag = true;
                // let from = this.list.length;
                this.list.splice(0, this.list.length - 50);
                //let to = this.list.length;
                if (callback)
                    callback(this.getState());
            }
        }
        return shrinkFlag;
    }
    prepareNextPage() {
        return __awaiter(this, void 0, void 0, function* () {
            setTimeout(() => {
                this.performFetch((this.pageId + 1), true).subscribe();
            }, 1000);
        });
    }
    performFetch(fetchPageId, fetchForCache) {
        return new __WEBPACK_IMPORTED_MODULE_0_rxjs__["Observable"](observer => {
            //Verifica si existe en el cache de paginas
            if (!fetchForCache && this.nextPage && this.nextPage.length > 0) {
                let tempData = [...this.nextPage];
                this.nextPage = [];
                observer.next(tempData);
                observer.complete();
            }
            else {
                //this.internalRequestPerforming = true;
                this.retrievePage(fetchPageId).subscribe((resultList) => {
                    this.internalRequestPerforming = false;
                    if (fetchForCache) {
                        let hasData = resultList && resultList.length > 0;
                        this.onNextPageRetrieved(hasData);
                        if (hasData) {
                            this.nextPage = resultList;
                        }
                    }
                    observer.next(resultList);
                    observer.complete();
                });
            }
        });
    }
    //Realiza la descarga de los datos
    onNextPageRetrieved(hasData) {
        if (this.onNextPageRetrievedCallback)
            this.onNextPageRetrievedCallback(hasData);
    }
    onStateChanged() {
        if (this.onStateChangedCallback)
            this.onStateChangedCallback(this.getState());
    }
    //Refresca las variables de datos X segundos despues, en el caso de que este lento el servicio y haya tardado mas del tiempo
    //en que se mostro la pantalla
    handleTimeout(callback) {
        clearTimeout(this.timerId);
        this.timerId = setTimeout(() => {
            if (this.isFetchingData) {
                this.isTimeout = true;
                this.isFetchingData = false;
                if (callback)
                    callback(this.getState());
            }
        }, __WEBPACK_IMPORTED_MODULE_1__config_config__["a" /* AppConfig */].app.defaultDataLoadWaitVisualTimeout);
    }
    getState(dataRetrievedForPageIsEmpty) {
        let state = {
            isTimeout: this.isTimeout,
            isFetchingData: this.isFetchingData,
            list: this.list,
            pageId: this.pageId,
            dataRetrievedForPageIsEmpty: dataRetrievedForPageIsEmpty
        };
        return state;
    }
    getFinalState() {
        this.isTimeout = false;
        this.isFetchingData = false;
        return this.getState(true);
    }
    isEmpty() {
        return !(this.list && this.list.length > 0);
    }
    getCurrentPageId() {
        return this.pageId;
    }
    setCurrentPageId(pageId) {
        return this.pageId = pageId;
    }
    getData() {
        return this.list;
    }
    setData(data) {
        this.list = data;
    }
    takeStateSnapshot() {
        this.snapshot = [...this.list];
        this.snapshotPageId = this.pageId;
    }
    restoreStateSnapshot() {
        this.list = this.snapshot ? this.snapshot : [];
        this.snapshot = [];
        this.pageId = this.snapshotPageId;
        this.snapshotPageId = 0;
        this.isFetchingData = false;
        this.isTimeout = false;
    }
    setSortBy(sortBy) {
        this.sortBy = sortBy;
        this.pageId = 0;
    }
    getSortBy() {
        return this.sortBy;
    }
    finishProcessing() {
        this.isTimeout = false;
        this.isFetchingData = false;
    }
    getSummary() {
        return "";
    }
    isProcessingRequest() {
        return this.internalRequestPerforming;
    }
    setOnReachedFinalCallback(onReachedFinalCallback) {
        this.onReachedFinalCallback = onReachedFinalCallback;
    }
    setOnNextPageRetrievedCallback(onNextPageRetrievedCallback) {
        this.onNextPageRetrievedCallback = onNextPageRetrievedCallback;
    }
    setOnStateChangedCallback(onStateChangedCallback) {
        this.onStateChangedCallback = onStateChangedCallback;
    }
    isInFirstPagePreviewMode() {
        return this.firstPagePreviewMode;
    }
    setKeepEmpty(keepEmpty) {
        this.keepEmpty = keepEmpty;
    }
    isKeepEmpty() {
        return this.keepEmpty;
    }
    setOneTimeFetch(oneTimeFetch) {
        this.oneTimeFetch = oneTimeFetch;
    }
    isOneTimeFetch() {
        return this.oneTimeFetch;
    }
    setPreviewPageSize(previewPageSize) {
        this.previewPageSize = previewPageSize;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = DataSet;

//# sourceMappingURL=base-dataset.js.map

/***/ }),

/***/ 299:
/***/ (function(module, exports) {

function webpackEmptyAsyncContext(req) {
	// Here Promise.resolve().then() is used instead of new Promise() to prevent
	// uncatched exception popping up in devtools
	return Promise.resolve().then(function() {
		throw new Error("Cannot find module '" + req + "'.");
	});
}
webpackEmptyAsyncContext.keys = function() { return []; };
webpackEmptyAsyncContext.resolve = webpackEmptyAsyncContext;
module.exports = webpackEmptyAsyncContext;
webpackEmptyAsyncContext.id = 299;

/***/ }),

/***/ 3:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const AppConfig = {
    app: {
        version: "1.0.73",
        timeout: 40000,
        latencyTimeout: 15000,
        language: "es",
        defaultTabColor: "#002856",
        defaultCountry: "CR",
        defaultCurrency: "CRC",
        defaultGender: "O",
        defaultYES: "S",
        defaultNO: "N",
        currencyCRC: "CRC",
        currencyUSD: "USD",
        currencyEUR: "EUR",
        currencyCRCSymbol: "₡",
        currencyUSDSymbol: "$",
        currencyEURSymbol: "€",
        defaultDate: new Date().getTime(),
        imageLoaderEnableSpinner: false,
        imageLoaderWidth: "100",
        imageLoaderHeight: "100",
        imageLoaderDisplay: "block",
        imageLoaderUseImageTag: true,
        imageLoaderBackgroundSize: "contain",
        imageLoaderBackgroundRepeat: "no-repeat",
        imageLoaderFallbackUrl: "assets/images/general/ImageLoader.jpg",
        imageLoaderCacheDirectoryName: "efast-cache",
        imageLoaderConcurrency: 15,
        imageLoaderMaximumCacheSize: 100 * 1024 * 1024,
        imageLoaderMaximumCacheAge: 7 * 24 * 60 * 60 * 1000,
        imageLoaderEnableFallbackAsPlaceholder: true,
        imageLoaderReturnType: "uri",
        googleWebClientID: "162091850270-d4td9q1b4og842akjpv60ojuij7te4oc.apps.googleusercontent.com",
        defaultProfileImage: "assets/images/profile/profile.png",
        defaultProfileImageType: "base64",
        promoFeaturedOffersCode: "1",
        promoDailyOffersCode: "2",
        promoRegularOffersCode: "3",
        defaultDataLoadWaitVisualTimeout: 30000,
        defaultPage: 1,
        defaultPageSize: 50,
        defaultWishListPageSize: 300,
        defaultShrinkChunkSize: 10,
        defaultShrinkChunkSizeIOS: 10,
        defaultMaxItemsInView: 300,
        defaultMaxItemsInViewIOS: 300,
        phoneRegEx: /[0-9]{8}/,
        idTypePerson: "F",
        idTypePersonRegEx: /[0-9]{9}/,
        idTypePersonLen: 9,
        idTypeLegal: "J",
        idTypeLegalRegEx: /[0-9]{10}/,
        idTypeLegalLen: 10,
        idTypeResident: "R",
        idTypeResidentMinRegEx: /[0-9]{11}/,
        idTypeResidentMaxRegEx: /[0-9]{12}/,
        idTypeResidentMinLen: 11,
        idTypeResidentMaxLen: 12,
        idTypeOther: "O",
        idTypeOtherRegEx: /[a-zA-Z0-9]{11}/,
        idTypeOtherLen: 11,
        idTypePassport: "P",
        idTypePassportRegEx: /[a-zA-Z]{20}/,
        idTypePassportLen: 20,
        provinceZoneType: "province",
        cantonZoneType: "canton",
        districtZoneType: "district",
        wardZoneType: "ward",
        greenPayConfig: "greenPayConfig",
        loginMethodEmail: "email",
        loginMethodGoogle: "google",
        loginMethodFacebook: "facebook",
        loginMethodApple: "apple",
        loginMethodAppleToken: "efast-apple-token",
        giftCatdDefaultMessage: "¡Disfruta esta tarjeta de regalo de E-Fast!",
        scrollTapsToPagination: 8,
        popUpAutoCloseTO: 300000,
    },
    rootParams: {
        loginMethod: "$loginMethod",
        principal: "$principal",
        errorLog: "$errors",
        localSearchTermsLog: "$searchTermLog",
    },
    err: {
        HTTP_ERROR: "000",
        CONNECTIVITY_ERROR: "001",
        AVATAR_LOADING_ERROR: "002",
        USER_NOT_FOUND_ERROR: "003",
        USER_CANNOT_BE_CREATED_ERROR: "004",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN: "005",
        OPERATION_CANNOT_BE_PERFORMED: "006",
        DATASTORE_ERROR: "007",
        USER_NOT_FOUND_IN_FB_ERROR: "008",
        FB_CONNECTIVITY_ERROR: "009",
        GOOGLE_CANNOT_COMPLETE_SIGN: "010",
        GOOGLE_CANNOT_COMPLETE_LOGOUT: "011",
        FB_CANNOT_COMPLETE_SIGN: "012",
        FB_CANNOT_COMPLETE_LOGOUT: "013",
        FB_CANNOT_RETRIEVE_USER_INFO: "014",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_API_NOT_CONNECTED: "015",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_CANCELED: "016",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_DEVELOPER_ERROR: "017",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_ERROR: "018",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_INTERNAL_ERROR: "019",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_INTERRUPTED: "020",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_INVALID_ACCOUNT: "021",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_NETWORK_ERROR: "022",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_RESOLUTION_REQUIRED: "023",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_SERVICE_DISABLED: "024",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_SERVICE_VERSION_UPDATE_REQUIRED: "025",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_SIGN_IN_REQUIRED: "026",
        SOCIAL_NETWORK_CANNOT_COMPLETE_SIGN_TIMEOUT: "027",
        APPLE_CANNOT_COMPLETE_SIGN: "028",
        checkout: {
            ES001_ERR: "ES001",
            ES001_ERR_MSG: "No se pudo obtener la información de la orden para el pago",
            ES002_ERR: "ES002",
            ES002_ERR_MSG: "La información de la orden para el pago no está completa",
            ES003_ERR: "ES003",
            ES003_ERR_MSG: "El pago se realizó satisfactoriamente, pero no se pudo actualizar la orden",
            ES004_ERR: "ES004",
            ES004_ERR_MSG: "La orden no se pudo verificar, por favor reintente nuevamente ingresando de nuevo al carrito de compras.",
        },
    },
    event: {
        NOTIFICATIONS_PROCESSED: "notifications-processed",
        CONNECTION_ESTABLISHED: "restore-session-when-internet",
        SESSSION_RESTORE: "security-session-restore",
        SESSSION_RESET: "security-session-reset",
        GLOBAL_MENU_OPTION_REQUESTED: "sidebar-changed",
        GLOBAL_MENU_SEARCH_OPTION_REQUESTED: "sidebar-changed-search",
        GLOBAL_MENU_CART_OPTION_REQUESTED: "sidebar-changed-cart",
        SIDEBAR_MENU_OPTION_REQUESTED: "sidebar-menu-requested",
        REWARDS_CHANGED: "rewards-changed",
        GLOBAL_CARRUSEL_CHANGED: "global_carrusel-changed",
        APP_PLATFORM_RESUME: "global-app-resume",
        APP_PLATFORM_PAUSE: "global-app-pause",
        APP_PLATFORM_ALERT_CLOSE: "global-dialog-alert-close",
        BOOTSTRAP_SERVICES_READY: "global-data-initialized",
        PUSH_NOTIFICATION_ENTER: "global-push-notification-enter",
        PUSH_NOTIFICATION_READY: "global-push-notification-ready",
        AUTH_SESSSION_STARTED: "security-auth-session-started",
        AUTH_SESSSION_FINISHED: "security-auth-session-finished",
        PAYMENT_CONFIG_LOADED: "payment-config-loaded",
        GUEST_SESSSION_STARTED: "security-guest-session-started",
        LOBBY_SUGGESTED_DATA_PROVIDER_READY: "lobby-suggested-initialized",
        LOBBY_SUGGESTED_CLEARED: "lobby-suggested-cleared",
        LOBBY_SUGGESTED_MAIN_CARRUSEL_LOADED: "lobby-suggested-main-carrusel-loaded",
        LOBBY_SUGGESTED_FEATURED_CARRUSEL_LOADED: "lobby-suggested-featured-carrusel-loaded",
        LOBBY_SUGGESTED_NEW_CARRUSEL_LOADED: "lobby-suggested-new-carrusel-loaded",
        LOBBY_FAVORITES_LOADED: "lobby-favorites-loaded",
        LOBBY_OTHER_SECTION_LOADED: "lobby-other-section-loaded",
        LOBBY_OTHER_SECTION_CLEARED: "lobby-other-section-cleared",
        LOBBY_PROMOS_TO_FINALIZED_LOADED: "lobby-promos-to-finalized-loaded",
        LOBBY_PROMOS_DAILY_OFFERS_LOADED: "lobby-promos-daily-loaded",
        LOBBY_PROMOS_REGULAR_OFFERS_LOADED: "lobby-promos-regular-loaded",
        LOBBY_PROMOS_REGULAR_OFFERS_READY: "lobby-promos-regular-ready",
        LOBBY_PROMOS_FEATURED_OFFERS_READY: "lobby-promos-featured-ready",
        LOBBY_CATEGORIES_READY: "lobby-categories-ready",
        LOBBY_CATEGORIES_SILENTLY_LOADED: "lobby-categories-silently-loaded",
        LOBBY_MISUPER_LAZY_LOADED: "lobby-misuper-lazy-loaded",
        LOBBY_SEASONS_READY: "lobby-seasons-ready",
        WISHLIST_LOADED: "wishlist-seasons-loaded",
        PRODUCT_HISTORY_LOADED: "product-history-loaded",
        SCROLL_NORMAL_POSITION: "scroll-normal-position",
        SCROLL_MIN_POSITION: "scroll-min-position",
        SCROLL_TRANSITION_POSITION: "scroll-transition-position",
        FLEX_HOME_TAB_CHANGED: "flex-tab-changed",
        FLEX_HOME_OPEN_SEARCH_REQUESTED: "flex-open_search-requested",
        FLEX_HOME_OPEN_CART_REQUESTED: "flex-open_cart-requested",
        FLEX_HOME_CURRENT_TAB_TABBED: "flex-same-tab-selected",
        FLEX_HOME_CURRENT_TAB_REFRESH_ON_FOCUS: "flex-tab-focus",
        FLEX_HOME_SUGGEDTED_TAB_FORCE_REFRESH_FROM_SIDEBAR: "flex-tab-refresh-focus",
        FLEX_HOME_CURRENT_TAB_GAIN_FOCUS: "flex-tab-get-focus",
        FLEX_HOME_RESPONSE_TO_FAVS_CHANGE: "flex-tab-will-appear",
        FLEX_HOME_CURRENT_TAB_LOST_FOCUS: "flex-tab-lost-focus",
        FRESH_SESSION_STARTS: "fresh-seccion-start",
        FLEX_HOME_INITIALIZE: "flex-home-initialize",
        MY_INTEREST_CATEGORY_CHANGED: "flex-my_interest_category-changed",
        AVATAR_CHANGED: "avatar-changed",
        SHOPPING_CART_REFRESHED: "order-cart-changed",
        SHOPPING_CART_CASH_ADDED: "order-cart_cash-added",
        SHOPPING_CART_SINPE_ADDED: "order-cart_sinpe-added",
        SHOPPING_CART_PURCHASE_TIMER_RESET: "order-cart-purchase-timer-cleared",
        SHOPPING_CART_PURCHASE_TIMER_EXECUTING: "order-cart-purchase-timer-executed",
        SHOPPING_CART_PURCHASE_TIMER_EXPIRED: "order-cart-purchase-timer-expired",
        SHOPPING_CART_PURCHASE_TIMER_EXPIRED_ACTION_CONTINUE: "order-cart-purchase-timer-expired-action-continue",
        SHOPPING_CART_PURCHASE_TIMER_EXPIRED_ACTION_ABORT: "order-cart-purchase-timer-expired-action-abort",
        SHOPPING_CART_PURCHASE_TIMER_EXPIRED_ACTION_TIMEOUT: "order-cart-purchase-timer-expired-action-timeout",
        SHOPPING_CART_CALCULATION: "order-cart-calculated",
        ITEM_CHANGED_IN_CART_LIST: "item-added-cart-list",
        ITEM_CHANGED_IN_SAVED_LIST: "item-added-saved-list",
        ITEM_CHANGED_IN_WISHLIST_LIST: "item-added-wish-list",
        GEO_ZONES_LOADED: "geo-zones-loaded",
        HOME_MAIN_TAB_WILL_ENTER: "main-home-tab-will-enter",
    },
    session: {
        HOME_SECTIONS: "efast-session-cache-home-sections",
        PRODUCT_ATTRIBUTES: "efast-session-cache-product-attributes",
        PRODUCT_CATEGORY: "efast-session-cache-product-category",
        USER_PRODUCT_CATEGORY: "efast-session-cache-user-product-category",
        DELIVERY_ADDRESS: "efast-session-cache-addresses",
        PAYMENT_OPTION: "efast-session-payment-option",
        WISH_LIST: "efast-session-cache-wishlist",
        FLEX_HOME_ACTIVE: "efast-session-active-home",
        FLEX_HOME_CURRENT_COLOR: "efast-session-current-color",
        FLEX_HOME_ACTIVE_SECTION_ID: "efast-session-current-color",
        REWARDS_CONFIGURATION: "efast-session-rewards-configuration",
        GLOBAL_CARRUSEL: "efast-session-global-carrusel-configuration",
        REWARDS_LOADED: "efast-session-rewards-loaded",
        GLOBAL_CARRUSEL_LOADED: "efast-session-global-carrusel-loaded",
        GROUP_PRODUCT_CACHE: "efast-session-group-product-cache",
        LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED: "efast-session-tab-change-cancelation",
        LOBBY_FORCE_AUTOCHANGE_TO_DEFAULT_TAB: "efast-session-force-autochange",
        NAVIGATION_STATEFUL_RETURN: "efast-session-stateful-return",
        DEVICE_UNIQUE_ID_REGISTERED: "efast-device_uniqueid_registered",
        DEVICE_UNIQUE_IMEI_REGISTERED: "efast-device_uniqueimei_registered",
        DEVICE_UNIQUE_ID: "efast-device_uniqueid",
        DEVICE_UNIQUE_ID_TYPE: "efast-device_uniqueid_type",
        DEVICE_UNIQUE_ID_TYPE_UUID: "efast-device_uniqueid_type_UUID",
        DEVICE_UNIQUE_ID_TYPE_IMEI: "efast-device_uniqueid_type_IMEI",
        DEVICE_UNIQUE_IMEI: "efast-device_uniqueimei",
        BACKUP_CART_ORDER: "efast-backup-cart_order",
        SEARCH_HISTORY: "efast-search-history",
    },
    cart: {
        TIMER_EXPIRATION_ACTION_ABORT: "abort",
        TIMER_EXPIRATION_ACTION_TIMEOUT: "TO",
        TIMER_BACKEND_EXPIRATION_ACTION_TIMEOUT: "BTO",
        CART_TIMER_MINUTES: 15,
        SELECTED_ADDRESS: "cart-selected-address",
        SELECTED_FREIGHT: "cart-selected-freight",
        SELECTED_SUBSIDIARY_PROVINCE: "cart-selected-province",
        SELECTED_SUBSIDIARY_CANTON: "cart-selected-canton",
        SELECTED_SUBSIDIARY_DETAIL: "cart-selected-detail",
        SELECTED_CARD: "cart-selected-card",
        RESULT_ALL_ADDED: 0,
        RESULT_ADDED_WITH_PENDING: 1,
        RESULT_NOT_AVAILABLE: 2,
        RESULT_ERROR: 3,
        ITEM_INSERTED: "inserted",
        ITEM_UPDATED: "updated",
    },
    lobby: {
        TAB: "tab",
        SUGGESTED_TYPE: "DE_TODO_UN_POCO",
        FAVS_TYPE: "FAVORITOS",
        PROMOS_TYPE: "PROMOCIONES",
        CATEGORIES_TYPE: "CATEGORÍAS",
        CATEGORIES_TILDE_TYPE: "CATEGORIAS",
        SEASONS_TYPE: "TEMPORADAS",
        OTHERS_TYPE: "OTROS",
        MISUPER_TYPE: "MI_SUPER",
    },
    templates: {
        PROMOS_TYPE: "PROMOCIONES",
        CATEGORIES_TYPE: "CATEGORIAS",
    },
    order: {
        SELECTED_ORDER: "selectedOrderForView",
        RECEIVED_STATUS: "REC",
        RECEIVED_STATUS_DESCRIPTION: "Orden de compra recibida",
        PROCESSING_STATUS: "PROC",
        PROCESSING_STATUS_DESCRIPTION: "Facturación completa",
        READY_STATUS: "ALISTO",
        READY_STATUS_DESCRIPTION: "Pedido en proceso de alisto",
        PACKAGE_STATUS: "EMP",
        PACKAGE_STATUS_DESCRIPTION: "Pedido empacado",
        ONRUTE_STATUS: "RUTA",
        ONRUTE_STATUS_DESCRIPTION: "Pedido en Ruta",
        DELIVERED: "ENT",
        DELIVERED_DESCRIPTION: "PEDIDO ENTREGADO",
    },
    sorting: {
        COLOR: "COLOR",
        RATING_0_5: "CALIFICACION ASC",
        RATING_5_0: "CALIFICACION DESC",
        PRICE: "PRECIO",
        BRAND: "MARCA",
    },
};
/* harmony export (immutable) */ __webpack_exports__["a"] = AppConfig;

//# sourceMappingURL=config.js.map

/***/ }),

/***/ 307:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/**
 * @author Coliand Studio
 * @version 1.0
 */
class LoggerUtils {
    /**
    * Realiza el logging de un mensaje a consola
    * @param {any} target Es la clase que llama el loguer.
    * @param {string} message El mensaje que se desea loguear.
    */
    static isDebugEnable() {
        return (LoggerUtils.loggerMode == LoggerUtils.DEBUG);
    }
    /**
    * Realiza el logging de un mensaje a consola
    * @param {any} target Es la clase que llama el loguer.
    * @param {string} message El mensaje que se desea loguear.
    */
    static log(target, message) {
        if (LoggerUtils.loggerMode == LoggerUtils.DEBUG) {
            console.log("[INFO] " + target.constructor.name + ": " + message);
        }
    }
    /**
    * Realiza el logging de un mensaje a consola
    * @param {any} target Es la clase que llama el loguer.
    * @param {string} message El mensaje que se desea loguear.
    */
    static logWithSpaceSeparator(target, message) {
        if (LoggerUtils.loggerMode == LoggerUtils.DEBUG) {
            console.log("");
            console.log("[INFO] " + target.constructor.name + ": " + message);
            console.log("");
        }
    }
    /**
    * Realiza el logging de un mensaje a consola
    * @param {any} target Es la clase que llama el loguer.
    * @param {string} message El mensaje que se desea loguear.
    */
    static logWithDashSeparator(target, message) {
        if (LoggerUtils.loggerMode == LoggerUtils.DEBUG) {
            console.log("");
            console.log("=====================================================================");
            console.log("[INFO] " + target.constructor.name + ": " + message);
            console.log("=====================================================================");
            console.log("");
        }
    }
    static logWS(target, message) {
        if (LoggerUtils.loggerMode == LoggerUtils.DEBUG) {
            console.log("=====================================================================");
            console.log("[WS] " + target.constructor.name + ": " + message);
            console.log("=====================================================================");
        }
    }
    static logWSResult(target, message) {
        if (LoggerUtils.loggerMode == LoggerUtils.DEBUG) {
            console.log("=====================================================================");
            console.log("......[WS RESULT] " + target.constructor.name + ": " + message);
            console.log("=====================================================================");
        }
    }
    static logWithLineSeparator(target, message) {
        LoggerUtils.logWithDashSeparator(target, message);
    }
    /**
    * Realiza el logging de un mensaje de error a consola
    * @param {any} target Es la clase que llama el loguer.
    * @param {string} message El mensaje que se desea loguear.
    */
    static logError(target, message) {
        console.log("=====================================================================");
        console.log("[ERROR] " + target.constructor.name + ": " + message);
        console.log("=====================================================================");
    }
    /**
    * Realiza el guardado en el log de los calls
    * @param {any} target Es la clase que llama el loguer.
    * @param {string} message El mensaje que se desea loguear.
    */
    static logWSCall(type, URL, retry, timeout, start, finish) {
        let wsMetadata = "[" + new Date().toLocaleString() + "] " + type + " [" + (finish.getTime() - start.getTime()) + "ms] " + URL + ": [TO:" + timeout + " ] ";
        LoggerUtils.wsLogger.push(wsMetadata);
        console.log("[WS Call] " + wsMetadata);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = LoggerUtils;

/**
* Constantes con los posibles valores para logger mode
*/
LoggerUtils.DEBUG = "debug";
LoggerUtils.PRODUCTION = "production";
LoggerUtils.wsLogger = new Array();
/**
* Propiedad que especifica si el logger esta en modo debug o production
* Para desarrollo se utiliza en modo debug
*/
LoggerUtils.loggerMode = LoggerUtils.DEBUG;
//# sourceMappingURL=logger.utils.js.map

/***/ }),

/***/ 353:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"../modules/home/pages/home-categories-template/home-categories-template.module": [
		1231,
		47
	],
	"../modules/home/pages/home-categories/home-categories.module": [
		1232,
		46
	],
	"../modules/home/pages/home-favs/home-favs.module": [
		1233,
		45
	],
	"../modules/home/pages/home-misuper/home-misuper.module": [
		1234,
		44
	],
	"../modules/home/pages/home-offers/home-offers.module": [
		1240,
		49
	],
	"../modules/home/pages/home-promos-template/home-promos-template.module": [
		1235,
		43
	],
	"../modules/home/pages/home-promos/home-promos.module": [
		1237,
		42
	],
	"../modules/home/pages/home-seasonal/home-seasonal.module": [
		1236,
		41
	],
	"../modules/home/pages/home-section/home-section.module": [
		1238,
		40
	],
	"../modules/home/pages/home-suggested/home-suggested.module": [
		1239,
		38
	],
	"../modules/notifications/pages/notification-center.module": [
		1241,
		110
	],
	"../modules/notifications/pages/notifications-deals-details/notifications-deals-details.module": [
		1242,
		111
	],
	"../modules/notifications/pages/notifications-deals/notifications-deals.module": [
		1243,
		37
	],
	"../modules/notifications/pages/notifications-general/notifications-general.module": [
		1244,
		36
	],
	"../modules/notifications/pages/notifications-orders/notifications-orders.module": [
		1245,
		35
	],
	"../modules/notifications/pages/notifications-rewards/notifications-rewards.module": [
		1246,
		34
	],
	"../modules/notifications/pages/notifications-setup/notifications-setup.module": [
		1247,
		109
	],
	"../modules/orders/pages/cart/cart.module": [
		1248,
		4
	],
	"../modules/orders/pages/cart/payment-confirm/payment-confirm.module": [
		1249,
		108
	],
	"../modules/orders/pages/cart/payment-result-error/payment-result-error.module": [
		1250,
		33
	],
	"../modules/orders/pages/cart/payment-result/payment-result.module": [
		1252,
		32
	],
	"../modules/orders/pages/cart/payment-sinpe-modal/payment-sinpe-modal.module": [
		1251,
		31
	],
	"../modules/orders/pages/cart/payment-sinpe/payment-sinpe.module": [
		1254,
		17
	],
	"../modules/orders/pages/cart/payment-step1/payment-step1.module": [
		1255,
		107
	],
	"../modules/orders/pages/cart/payment-step2-subsidiary-finder/payment-step2-subsidiary-finder.module": [
		1253,
		106
	],
	"../modules/orders/pages/cart/payment-step2-subsidiary/payment-step2-subsidiary.module": [
		1256,
		30
	],
	"../modules/orders/pages/cart/payment-step2/payment-step2.module": [
		1257,
		105
	],
	"../modules/orders/pages/cart/payment-step3/payment-step3.module": [
		1259,
		29
	],
	"../modules/orders/pages/order-date-chooser/order-date-chooser.module": [
		1258,
		104
	],
	"../modules/orders/pages/order-detail/order-detail.module": [
		1260,
		103
	],
	"../modules/orders/pages/order-detail/order-info/order-info.module": [
		1261,
		102
	],
	"../modules/orders/pages/order-detail/order-tracking/order-tracking.module": [
		1263,
		101
	],
	"../modules/orders/pages/orders/orders.module": [
		1262,
		28
	],
	"../modules/products/pages/product-detail/product-detail.module": [
		1265,
		16
	],
	"../modules/products/pages/product-listing-filtered/product-listing-filtered.module": [
		1264,
		48
	],
	"../modules/products/pages/product-listing/product-listing.module": [
		1266,
		3
	],
	"../modules/products/pages/product-reviews/product-reviews.module": [
		1267,
		100
	],
	"../modules/products/pages/product-search/live-search/live-search.module": [
		1268,
		9
	],
	"../modules/products/pages/product-search/search-categories-family/search-categories-family.module": [
		1270,
		27
	],
	"../modules/products/pages/product-search/search-categories-subfamily/search-categories-subfamily.module": [
		1269,
		26
	],
	"../modules/products/pages/product-search/search-categories/search-categories.module": [
		1271,
		99
	],
	"../modules/products/pages/product-search/search-filter/search-filter.module": [
		1272,
		98
	],
	"../modules/products/pages/product-search/search/search.module": [
		1273,
		97
	],
	"../modules/products/pages/product-tabbed-listing/product-tabbed-listing.module": [
		1275,
		96
	],
	"../modules/products/pages/product-tabbed-merq-listing/product-tabbed-merq-listing.module": [
		1274,
		8
	],
	"../modules/products/pages/product-tabbed-merq-ondemand-listing/product-tabbed-merq-ondemand-listing.module": [
		1277,
		2
	],
	"../modules/products/pages/product-viewer/product-viewer.module": [
		1278,
		56
	],
	"../modules/products/pages/wishlist/edit-wishlist/edit-wishlist.module": [
		1276,
		95
	],
	"../modules/products/pages/wishlist/wishlist-detail/wishlist-detail.module": [
		1280,
		39
	],
	"../modules/products/pages/wishlist/wishlist.module": [
		1279,
		1
	],
	"../modules/profile/pages/address/address-book-selection/address-book-selection.module": [
		1281,
		25
	],
	"../modules/profile/pages/address/address-book/address-book.module": [
		1282,
		24
	],
	"../modules/profile/pages/address/address-finder/address-finder.module": [
		1284,
		94
	],
	"../modules/profile/pages/address/edit-address/edit-address.module": [
		1283,
		15
	],
	"../modules/profile/pages/address/edit-region/edit-region.module": [
		1287,
		93
	],
	"../modules/profile/pages/close-account/close-account.module": [
		1285,
		92
	],
	"../modules/profile/pages/edit-avatar/edit-avatar.module": [
		1305,
		91
	],
	"../modules/profile/pages/edit-email/edit-email.module": [
		1286,
		90
	],
	"../modules/profile/pages/edit-password/edit-password.module": [
		1289,
		55
	],
	"../modules/profile/pages/edit-profile-fe/edit-profile-fe.module": [
		1288,
		14
	],
	"../modules/profile/pages/edit-profile-identification/edit-profile-identification.module": [
		1293,
		13
	],
	"../modules/profile/pages/edit-profile/edit-profile.module": [
		1292,
		12
	],
	"../modules/profile/pages/invite-friend/invite-friend.module": [
		1290,
		23
	],
	"../modules/profile/pages/payment/edit-payment-option/edit-payment-option.module": [
		1291,
		11
	],
	"../modules/profile/pages/payment/payment-option-selection/payment-option-selection.module": [
		1294,
		89
	],
	"../modules/profile/pages/payment/payment-option/payment-option.module": [
		1295,
		22
	],
	"../modules/profile/pages/profile-products/product-category-setup/product-category-setup.module": [
		1296,
		88
	],
	"../modules/profile/pages/profile-products/product-history/product-history.module": [
		1297,
		87
	],
	"../modules/profile/pages/profile-products/review-products/product-purchased/products-purchased.module": [
		1303,
		86
	],
	"../modules/profile/pages/profile-products/review-products/product-rating/product-rating.module": [
		1298,
		85
	],
	"../modules/profile/pages/profile-products/review-products/review-order-detail/review-order-detail.module": [
		1299,
		84
	],
	"../modules/profile/pages/profile-products/review-products/review-order-notes/review-order-notes.module": [
		1300,
		83
	],
	"../modules/profile/pages/profile-products/review-products/review-order/review-order.module": [
		1301,
		21
	],
	"../modules/profile/pages/profile.module": [
		1302,
		82
	],
	"../modules/rewards/pages/daily-bonus/daily-bonus.module": [
		1304,
		81
	],
	"../modules/rewards/pages/giftcard-checkout/giftcard-checkout.module": [
		1306,
		80
	],
	"../modules/rewards/pages/giftcard-confirm/giftcard-confirm.module": [
		1308,
		79
	],
	"../modules/rewards/pages/giftcard-sinpe/giftcard-sinpe.module": [
		1307,
		10
	],
	"../modules/rewards/pages/giftcard/giftcard.module": [
		1312,
		78
	],
	"../modules/rewards/pages/reward/reward-dashboard/reward-dashboard.module": [
		1311,
		77
	],
	"../modules/rewards/pages/reward/reward-info/reward-info.module": [
		1309,
		76
	],
	"../modules/rewards/pages/reward/reward-redeem/reward-redeem.module": [
		1310,
		75
	],
	"../modules/rewards/pages/reward/reward.module": [
		1313,
		74
	],
	"../modules/security/pages/change-password/change-password.module": [
		1314,
		54
	],
	"../modules/security/pages/change-security-question-inapp/change-security-question-inapp.module": [
		1315,
		73
	],
	"../modules/security/pages/change-security-question/change-security-question.module": [
		1317,
		72
	],
	"../modules/security/pages/forgot-password-question/forgot-password-question.module": [
		1316,
		71
	],
	"../modules/security/pages/forgot-password/forgot-password.module": [
		1318,
		70
	],
	"../modules/security/pages/login-front/login-front.module": [
		1319,
		53
	],
	"../modules/security/pages/login-inapp/login-inapp.module": [
		1320,
		52
	],
	"../modules/security/pages/login/login.module": [
		1321,
		51
	],
	"../modules/security/pages/security-question-answer/security-question-answer.module": [
		1322,
		69
	],
	"../modules/security/pages/security-questions/security-questions.module": [
		1323,
		68
	],
	"../modules/security/pages/signup/signup-front/signup-front.module": [
		1324,
		7
	],
	"../modules/security/pages/signup/signup-inapp/signup-inapp.module": [
		1327,
		6
	],
	"../modules/security/pages/signup/signup-result/signup-result.module": [
		1326,
		67
	],
	"../modules/security/pages/signup/signup-social-completion/signup-social-completion.module": [
		1325,
		50
	],
	"../modules/security/pages/signup/signup.module": [
		1328,
		5
	],
	"../modules/settings/pages/settings.module": [
		1329,
		66
	],
	"../modules/support/pages/chat/chat.module": [
		1330,
		0
	],
	"../modules/support/pages/contact/contact.module": [
		1331,
		20
	],
	"../modules/support/pages/faqs/faqs.module": [
		1333,
		65
	],
	"../modules/support/pages/information/information.module": [
		1332,
		64
	],
	"../modules/support/pages/log/log.module": [
		1334,
		63
	],
	"../modules/support/pages/refund/refund-list/refund-list.module": [
		1335,
		19
	],
	"../modules/support/pages/refund/refund-policies/refund-policies.module": [
		1336,
		62
	],
	"../modules/support/pages/refund/refund-wizard-picture/refund-wizard-picture.module": [
		1337,
		61
	],
	"../modules/support/pages/refund/refund-wizard-reason/refund-wizard-reason.module": [
		1338,
		60
	],
	"../modules/support/pages/refund/refund-wizard-result/refund-wizard-result.module": [
		1339,
		59
	],
	"../modules/support/pages/refund/refund-wizard/refund-wizard.module": [
		1340,
		18
	],
	"../modules/support/pages/refund/refund.module": [
		1341,
		58
	],
	"../modules/support/pages/topics/topics.module": [
		1342,
		57
	]
};
function webpackAsyncContext(req) {
	var ids = map[req];
	if(!ids)
		return Promise.reject(new Error("Cannot find module '" + req + "'."));
	return __webpack_require__.e(ids[1]).then(function() {
		return __webpack_require__(ids[0]);
	});
};
webpackAsyncContext.keys = function webpackAsyncContextKeys() {
	return Object.keys(map);
};
webpackAsyncContext.id = 353;
module.exports = webpackAsyncContext;

/***/ }),

/***/ 36:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

let ProductListingService = class ProductListingService {
};
ProductListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
], ProductListingService);

//# sourceMappingURL=product-listing-service.js.map

/***/ }),

/***/ 4:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SessionManagerService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_service__ = __webpack_require__(184);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let SessionManagerService = class SessionManagerService {
    constructor(session, events) {
        this.session = session;
        this.events = events;
        this.providers = {};
        //Se ha iniciado un proceso de checkout
        this.checkoutProcessStarted = false;
        this.attributes = {};
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.SESSSION_RESET, (time) => {
            this.resetAll();
        });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.SESSSION_RESTORE, (time) => {
            this.resetAll();
        });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_STARTED, (user, time) => {
        });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.GUEST_SESSSION_STARTED, (time) => {
        });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.resetAll();
        });
    }
    getPrincipal() {
        return this.session.getPrincipal();
    }
    isAuthenticated() {
        return this.session.isAuthenticated();
    }
    setRedirectCallback(redirectCallback) {
        this.redirectCallback = redirectCallback;
    }
    getRedirectCallback() {
        return this.redirectCallback;
    }
    isSessionHalted() {
        let principal = this.getPrincipal();
        return principal ? principal.forceLogout === "S" : false;
    }
    getToken() {
        return this.session.getToken();
    }
    getSession() {
        return this.session;
    }
    set(key, value) {
        this.attributes[key] = value;
    }
    clear(key) {
        this.attributes[key] = null;
    }
    get(key) {
        return this.attributes[key];
    }
    resetAll() {
        this.attributes = {};
        for (var providerId in this.providers) {
            var provider = this.providers[providerId];
            provider.clearDataSet();
        }
    }
    pull(key) {
        var value = this.attributes[key];
        this.attributes[key] = null;
        return value;
    }
    getCurrencySymbol() {
        var currencySymbol = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyCRCSymbol;
        var user = this.session.getPrincipal();
        if (user) {
            switch (user.currency) {
                case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyCRC: {
                    currencySymbol = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyCRCSymbol;
                    break;
                }
                case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyUSD: {
                    currencySymbol = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyUSDSymbol;
                    break;
                }
                case __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyEUR: {
                    currencySymbol = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyEURSymbol;
                    break;
                }
                default: {
                    currencySymbol = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.currencyCRCSymbol;
                }
            }
        }
        return currencySymbol;
    }
    registerDataSet(provider) {
        this.providers[provider.getId()] = provider;
    }
    getDataSet(dataSetId, forceReload) {
        var observable;
        var provider = this.providers[dataSetId];
        if (provider) {
            observable = provider.getDataSet(forceReload);
        }
        if (!observable) {
            observable = new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
                observer.next([]);
                observer.complete();
            });
        }
        return observable;
    }
    refreshDataSet(dataSetId) {
        var observable;
        var provider = this.providers[dataSetId];
        if (provider) {
            observable = provider.getDataSet(true);
        }
        return observable;
    }
    isCheckoutProcessStarted() {
        return this.checkoutProcessStarted;
    }
    setCheckoutProcessStarted(flag) {
        this.checkoutProcessStarted = flag;
    }
    setPushNotificationDeviceId(pushNotificationDeviceId) {
        this.pushNotificationDeviceId = pushNotificationDeviceId;
    }
    getPushNotificationDeviceId() {
        return this.pushNotificationDeviceId;
    }
    setPushNotificationDeviceIdError(pushNotificationDeviceErr) {
        this.pushNotificationDeviceErr = pushNotificationDeviceErr;
    }
    getPushNotificationDeviceErr() {
        return this.pushNotificationDeviceErr;
    }
};
SessionManagerService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_service__["a" /* SessionService */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["Events"]])
], SessionManagerService);

//# sourceMappingURL=session-manager-service.js.map

/***/ }),

/***/ 43:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);


class ViewUtils {
    static getBannerRotationStyle(screenOrientationType) {
        if (screenOrientationType === "landscape-primary" ||
            screenOrientationType === "landscape-secondary") {
            return this.BANNER_LANDSCAPE_STYLE;
        }
        else {
            return this.BANNER_PORTRAIT_STYLE;
        }
    }
    /**
     * Muestra un mensaje de alerta sin capacidad de accion
     * @param {AlertController} alertCtrl Controler utilizado para desplegar el view de alerta.
     * @param {string} message Mensaje que se desea desplegar en el dialogo.
     */
    static showAlertNoAction(alertCtrl, message) {
        let alert = alertCtrl.create({
            //title: ViewUtils.ALERT_TITLE,
            message: message,
        });
        alert.present();
    }
    /**
     * Muestra un mensaje de alerta
     * @param {AlertController} alertCtrl Controler utilizado para desplegar el view de alerta.
     * @param {string} message Mensaje que se desea desplegar en el dialogo.
     */
    static showAlert(alertCtrl, message, callback) {
        let alert = alertCtrl.create({
            //title: ViewUtils.ALERT_TITLE,
            message: message,
            buttons: ["OK"],
        });
        alert.onDidDismiss(() => {
            if (callback) {
                callback();
            }
        });
        alert.present();
    }
    /**
     * Muestra un mensaje de alerta para personalizar boton y accion
     * @param {AlertController} alertCtrl Controler utilizado para desplegar el view de alerta.
     * @param {string} message Mensaje que se desea desplegar en el dialogo.
     */
    static showAlertPersonalized(alertCtrl, title, message, buttonText, callback) {
        let alert = alertCtrl.create({
            //title: title,
            message: message,
            buttons: [buttonText],
        });
        alert.onDidDismiss(() => {
            if (callback) {
                callback();
            }
        });
        alert.present();
    }
    /**
     * Muestra el spiner de procesando
     * @param {LoadingController} loadingCtrl Controler utilizado para mostrar el componente del spiner.
     */
    static showLoading(loader, loadingCtrl, message) {
        if (!message) {
            message = "Por favor espere...";
        }
        loader = loadingCtrl.create({
            content: message,
        });
        loader.present();
    }
    /**
     * Oculta el spiner de procesando
     * @param {Function} callback Funcion utilizada para gestionar un callback al ocultarse el spiner.
     */
    static dismissLoading(loader, callback) {
        if (loader) {
            loader.onDidDismiss(() => {
                if (callback) {
                    callback();
                }
            });
            setTimeout(() => {
                loader.dismiss().catch((e) => console.error(e));
            }, 100);
        }
    }
    static showLoadingCreate(loadingCtrl, message) {
        if (!this.loader) {
            if (!message) {
                message = "Por favor espere...";
            }
            this.loader = loadingCtrl.create({
                content: message,
            });
            this.loader.present();
        }
    }
    static dismissLoadingCreate(callback) {
        if (this.loader) {
            this.loader.onDidDismiss(() => {
                if (callback) {
                    callback();
                }
            });
            setTimeout(() => {
                this.loader
                    .dismiss()
                    .then(() => {
                    this.loader = null;
                })
                    .catch((e) => {
                    console.error(e);
                    this.loader = null;
                });
            }, 100);
        }
    }
    /**
     * Muestra el mensaje de confirmacion
     * @param {AlertController} alertCtrl Controler utilizado para desplegar el view de alerta.
     * @param {Array<Validator>} validators Conjunto de inputs que se desean validar.
     */
    static showConfirm(alertCtrl, message, callback, actionButtonTitle) {
        if (!message) {
            message = "¿Confirma que desea realizar la acción?";
        }
        if (!actionButtonTitle) {
            actionButtonTitle = "Aceptar";
        }
        let alert = alertCtrl.create({
            message: message,
            buttons: [
                {
                    text: "Cancelar",
                    role: "cancel",
                    handler: () => {
                        alert.dismiss();
                    },
                },
                {
                    text: actionButtonTitle,
                    handler: () => {
                        callback();
                    },
                },
            ],
        });
        alert.present();
    }
    static showYesNoConfirmWithTO(alertCtrl, message, yesCallback, noCallback, timeoutCallback, timeout) {
        let timeoutCanceled = false;
        if (!message) {
            message = "¿Confirma que desea realizar la acción?";
        }
        if (!timeout) {
            timeout = __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.popUpAutoCloseTO;
        }
        let alert = alertCtrl.create({
            message: message,
            enableBackdropDismiss: false,
            buttons: [
                {
                    text: "No",
                    role: "cancel",
                    handler: () => {
                        timeoutCanceled = true;
                        alert.dismiss();
                        setTimeout(() => {
                            if (noCallback)
                                noCallback();
                        }, 500);
                    },
                },
                {
                    text: "Si",
                    handler: () => {
                        timeoutCanceled = true;
                        if (yesCallback)
                            yesCallback();
                    },
                },
            ],
        });
        alert.present();
        setTimeout(() => {
            if (!timeoutCanceled) {
                alert.dismiss();
                if (timeoutCallback)
                    timeoutCallback();
            }
        }, timeout);
    }
    static showYesNoConfirmWithTOAndEvent(events, alertCtrl, message, yesCallback, noCallback, timeoutCallback, timeout) {
        let timeoutCanceled = false;
        if (!message) {
            message = "¿Confirma que desea realizar la acción?";
        }
        if (!timeout) {
            timeout = __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.popUpAutoCloseTO;
        }
        let alert = alertCtrl.create({
            message: message,
            enableBackdropDismiss: false,
            buttons: [
                {
                    text: "No",
                    role: "cancel",
                    handler: () => {
                        timeoutCanceled = true;
                        alert.dismiss();
                        setTimeout(() => {
                            setTimeout(() => {
                                events.publish(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].event.APP_PLATFORM_ALERT_CLOSE);
                            }, 500);
                            if (noCallback)
                                noCallback();
                        }, 500);
                    },
                },
                {
                    text: "Si",
                    handler: () => {
                        timeoutCanceled = true;
                        setTimeout(() => {
                            events.publish(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].event.APP_PLATFORM_ALERT_CLOSE);
                        }, 500);
                        if (yesCallback)
                            yesCallback();
                    },
                },
            ],
        });
        alert.present();
        setTimeout(() => {
            if (!timeoutCanceled) {
                alert.dismiss();
                if (timeoutCallback)
                    timeoutCallback();
            }
        }, timeout);
    }
    /**
     * Muestra el mensaje con opciones de callback OK y Cancel
     * @param {AlertController} alertCtrl Controler utilizado para desplegar el view de alerta.
     * @param {Array<Validator>} validators Conjunto de inputs que se desean validar.
     */
    static showYesNoDialog(alertCtrl, message, okCallback, cancelCallback) {
        if (!message) {
            message = "";
        }
        let alert = alertCtrl.create({
            //title: this.ALERT_TITLE,
            message: message,
            buttons: [
                {
                    text: "No",
                    role: "cancel",
                    handler: () => {
                        alert.dismiss();
                        cancelCallback();
                    },
                },
                {
                    text: "Si",
                    handler: () => {
                        okCallback();
                    },
                },
            ],
        });
        alert.present();
    }
    static presentClosableToast(toastCtrl, message, closeButtonText) {
        const toast = toastCtrl.create({
            message: message,
            showCloseButton: true,
            closeButtonText: closeButtonText ? closeButtonText : "OK",
        });
        toast.present();
    }
    static presentToast(toastCtrl, message, duration) {
        if (!duration) {
            duration = 5000;
        }
        const toast = toastCtrl.create({
            message: message,
            duration: duration,
        });
        toast.present();
    }
    static presentToastWithAction(toastCtrl, message, duration, callback) {
        if (!duration) {
            duration = 5000;
        }
        const toast = toastCtrl.create({
            message: message,
            duration: duration,
        });
        toast.onDidDismiss(() => {
            if (callback) {
                callback();
            }
        });
        toast.present();
    }
    static showAuthDialog(alertCtrl, message, okCallback, cancelCallback) {
        if (!message) {
            message = "";
        }
        let alert = alertCtrl.create({
            //title: this.ALERT_TITLE,
            message: message,
            buttons: [
                {
                    text: "Ingresa aquí",
                    handler: () => {
                        okCallback();
                    },
                },
                {
                    text: "Cerrar",
                    role: "cancel",
                    handler: () => {
                        alert.dismiss();
                        if (cancelCallback) {
                            cancelCallback();
                        }
                    },
                },
            ],
        });
        alert.present();
    }
    static getNavBarColor(sessionManager) {
        let activeColor = "#2471A3"; //sessionManager.get(AppConfig.session.FLEX_HOME_CURRENT_COLOR);
        return { "background-color": activeColor, color: "white" };
    }
    static handleNavigation(navCtrl, page, sessionManager) {
        if (page === "Root") {
            if (sessionManager) {
                sessionManager.set(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].session.LOBBY_FORCE_AUTOCHANGE_TO_DEFAULT_TAB, true);
            }
            navCtrl.popToRoot();
        }
        else {
            if (sessionManager) {
                sessionManager.set(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].session.LOBBY_FORCE_AUTOCHANGE_TO_DEFAULT_TAB, false);
            }
            ViewUtils.forwardTo(navCtrl, page);
        }
    }
    //Returns a promise
    static handleNavigationPromise(navCtrl, page, sessionManager) {
        if (page === "Root") {
            if (sessionManager) {
                sessionManager.set(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].session.LOBBY_FORCE_AUTOCHANGE_TO_DEFAULT_TAB, true);
            }
            return navCtrl.popToRoot();
        }
        else {
            if (sessionManager) {
                sessionManager.set(__WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].session.LOBBY_FORCE_AUTOCHANGE_TO_DEFAULT_TAB, false);
            }
            return ViewUtils.forwardToPromise(navCtrl, page);
        }
    }
    static forwardTo(navCtrl, page) {
        navCtrl.popToRoot({ animate: true }).then(() => {
            navCtrl.push(page, {}, { animate: false });
        });
    }
    //Returns a promise
    static forwardToPromise(navCtrl, page) {
        return navCtrl.popToRoot({ animate: true }).then(() => {
            return navCtrl.push(page, {}, { animate: false });
        });
    }
    static popTo(navCtrl, pageName) {
        let page = navCtrl.getViews().find((view) => {
            return view.id == pageName;
        });
        if (page) {
            navCtrl.popTo(page);
        }
    }
    static performImageCaching(cachingService, namespace, source, cache, downloadCallback) {
        let win = window;
        if (source && source.length > 0) {
            for (let i = 0; i < source.length; i++) {
                let imageURL = source[i].image;
                let fileId = namespace + source[i].imageId + ".jpg";
                cachingService.checkIfFileIsDownloaded(fileId).subscribe((result) => {
                    if (result) {
                        let storedFiled = cachingService.getFilePath(fileId);
                        let normalized = win.Ionic.WebView.convertFileSrc(storedFiled);
                        ViewUtils.addImageToCache(normalized, source[i], cache, downloadCallback);
                    }
                    else {
                        //Procede a descargar la imagen del catalogo
                        cachingService
                            .downloadFile(imageURL, fileId)
                            .subscribe((resultDownload) => {
                            //Si ya se ha cargado la imagen, obtiene la ruta y almacena
                            if (resultDownload) {
                                let storedFiled = cachingService.getFilePath(fileId);
                                let normalized = win.Ionic.WebView.convertFileSrc(storedFiled);
                                ViewUtils.addImageToCache(normalized, source[i], cache, downloadCallback);
                            }
                        });
                    }
                });
            }
        }
    }
    static performImageClearCaching(cachingService, namespace, source, cache, downloadCallback) {
        let win = window;
        if (source && source.length > 0) {
            for (let i = 0; i < source.length; i++) {
                let imageURL = source[i].image;
                let fileId = namespace + source[i].imageId + ".jpg";
                cachingService.checkIfFileIsDownloaded(fileId).subscribe((result) => {
                    if (result) {
                        cachingService.clearFile(fileId).subscribe((resultClear) => {
                            if (resultClear) {
                                //Procede a descargar la imagen del catalogo
                                cachingService
                                    .downloadFile(imageURL, fileId)
                                    .subscribe((resultDownload) => {
                                    //Si ya se ha cargado la imagen, obtiene la ruta y almacena
                                    if (resultDownload) {
                                        let storedFiled = cachingService.getFilePath(fileId);
                                        let normalized = win.Ionic.WebView.convertFileSrc(storedFiled);
                                        ViewUtils.addImageToCache(normalized, source[i], cache, downloadCallback);
                                    }
                                });
                            }
                            else {
                                //Devuelve el cacheado (fallback)
                                let storedFiled = cachingService.getFilePath(fileId);
                                let normalized = win.Ionic.WebView.convertFileSrc(storedFiled);
                                ViewUtils.addImageToCache(normalized, source[i], cache, downloadCallback);
                            }
                        });
                    }
                    else {
                        //Procede a descargar la imagen del catalogo
                        cachingService
                            .downloadFile(imageURL, fileId)
                            .subscribe((resultDownload) => {
                            //Si ya se ha cargado la imagen, obtiene la ruta y almacena
                            if (resultDownload) {
                                let storedFiled = cachingService.getFilePath(fileId);
                                let normalized = win.Ionic.WebView.convertFileSrc(storedFiled);
                                ViewUtils.addImageToCache(normalized, source[i], cache, downloadCallback);
                            }
                        });
                    }
                });
            }
        }
    }
    static addImageToCache(image, sourceEntry, cache, downloadCallback) {
        let found = false;
        //Verifica si ya existe la imagen en el cache
        for (let i = 0; i < cache.length; i++) {
            if (image === cache[i].image) {
                found = true;
                break;
            }
        }
        if (!found) {
            let entry = {
                id: sourceEntry.id,
                reference: sourceEntry.reference,
                imageType: sourceEntry.imageType,
                imageId: sourceEntry.imageId,
                image: image,
                showProductCode: sourceEntry.showProductCode,
                showCategoryId: sourceEntry.showCategoryId,
                showFamilyId: sourceEntry.showFamilyId,
                showSubFamilyId: sourceEntry.showSubFamilyId,
                showList: sourceEntry.showList,
                showBrand: sourceEntry.showBrand,
                showProvider: sourceEntry.showProvider,
            };
            cache.push(entry);
            if (downloadCallback) {
                downloadCallback(entry);
            }
        }
    }
    static loginAndRedirect(navCtrl, sessionManager, redirectCallback) {
        sessionManager.setRedirectCallback(redirectCallback);
        this.goToRegistration(navCtrl);
    }
    static convertToDataURLviaCanvas(url, outputFormat) {
        return new Promise((resolve, reject) => {
            let img = new Image();
            img.crossOrigin = "Anonymous";
            img.onload = function () {
                let canvas = document.createElement("CANVAS"), ctx = canvas.getContext("2d"), dataURL;
                canvas.height = img.height;
                canvas.width = img.width;
                ctx.drawImage(img, 0, 0);
                dataURL = canvas.toDataURL(outputFormat);
                //callback(dataURL);
                canvas = null;
                resolve(dataURL);
            };
            img.src = url;
        });
    }
    static checkSharingPermissions2(androidPermissions) {
        // androidPermissions
        //   .requestPermission(androidPermissions.PERMISSION.READ_EXTERNAL_STORAGE)
        //   .then((resultRequestRead) => {
        //     console.log("request read", resultRequestRead);
        //   });
        // androidPermissions
        //   .requestPermission(androidPermissions.PERMISSION.WRITE_EXTERNAL_STORAGE)
        //   .then((resultRequestWrite) => {
        //     console.log("request write", resultRequestWrite);
        //   });
        return androidPermissions.requestPermission(androidPermissions.PERMISSION.READ_MEDIA_IMAGES);
    }
    static checkSharingPermissions(androidPermissions) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"]((observer) => {
            androidPermissions
                .checkPermission(androidPermissions.PERMISSION.READ_EXTERNAL_STORAGE)
                .then((resultCheckRead) => {
                console.log("enter read", resultCheckRead);
                if (!resultCheckRead.hasPermission) {
                    // androidPermissions
                    //   .requestPermission(
                    //     androidPermissions.PERMISSION.READ_MEDIA_IMAGES
                    //   )
                    //   .then((resultCheckRead) => {
                    //     console.log(resultCheckRead);
                    //   })
                    //   .catch((err) => {
                    //     console.log(err);
                    //   });
                    //solicta el permiso
                    androidPermissions
                        .requestPermission(androidPermissions.PERMISSION.READ_EXTERNAL_STORAGE)
                        .then((resultRequestRead) => {
                        console.log("request read", resultRequestRead);
                        if (resultRequestRead.hasPermission) {
                            //se acepto?
                            androidPermissions
                                .checkPermission(androidPermissions.PERMISSION.WRITE_EXTERNAL_STORAGE)
                                .then((resultCheckWrite) => {
                                if (!resultCheckWrite.hasPermission) {
                                    androidPermissions
                                        .requestPermission(androidPermissions.PERMISSION
                                        .WRITE_EXTERNAL_STORAGE)
                                        .then((resultRequestWrite) => {
                                        if (resultRequestWrite.hasPermission) {
                                            observer.next(true);
                                            observer.complete();
                                        }
                                        else {
                                            observer.next(false);
                                            observer.complete();
                                        }
                                    }, (err) => {
                                        observer.next(false);
                                        observer.complete();
                                    })
                                        .catch((error) => {
                                        console.log(error);
                                    });
                                }
                                else {
                                    observer.next(true);
                                    observer.complete();
                                }
                            }, (err) => {
                                observer.next(false);
                                observer.complete();
                            })
                                .catch((error) => {
                                console.log(error);
                            });
                        }
                        else {
                            observer.next(false);
                            observer.complete();
                        }
                    }, (err) => {
                        observer.next(false);
                        observer.complete();
                    })
                        .catch((error) => {
                        console.log(error);
                    });
                }
                else {
                    androidPermissions
                        .requestPermission(androidPermissions.PERMISSION.READ_MEDIA_IMAGES)
                        .then((resultCheckRead) => { });
                    androidPermissions
                        .checkPermission(androidPermissions.PERMISSION.WRITE_EXTERNAL_STORAGE)
                        .then((resultCheckWrite) => {
                        if (!resultCheckWrite.hasPermission) {
                            androidPermissions
                                .requestPermission(androidPermissions.PERMISSION.WRITE_EXTERNAL_STORAGE)
                                .then((resultRequestWrite) => {
                                if (resultRequestWrite.hasPermission) {
                                    observer.next(true);
                                    observer.complete();
                                }
                                else {
                                    observer.next(false);
                                    observer.complete();
                                }
                            }, (err) => {
                                observer.next(false);
                                observer.complete();
                            })
                                .catch((error) => {
                                console.log(error);
                            });
                        }
                        else {
                            observer.next(true);
                            observer.complete();
                        }
                    }, (err) => {
                        console.log(err);
                        observer.next(false);
                        observer.complete();
                    })
                        .catch((error) => {
                        console.log(error);
                    });
                }
            }, (err) => {
                console.log(err);
                observer.next(false);
                observer.complete();
            })
                .catch((error) => {
                console.log(error);
            });
        });
    }
    static performScrollTop(content) {
        // if scrolling, we will wait a bit before scrolling to top so any current scrolling momentum dies down
        // this.content.isScrolling always returns false on iOS for some reason
        const wait = content.isScrolling ? 150 : 0;
        setTimeout(() => content.scrollToTop(200), wait);
    }
    static goToRegistrationFromRoot(appCtrl) {
        appCtrl.getRootNav().push("SignupFrontPage", { flags: "hideRegisration" });
    }
    static goToRegistration(navCtrl) {
        navCtrl.push("SignupFrontPage", { flags: "hideRegisration" });
    }
    /**
     * Deep copy function for TypeScript.
     * @param T Generic type of target/copied value.
     * @param target Target value to be copied.
     */
    static deepCopy(target) {
        if (target === null) {
            return target;
        }
        if (target instanceof Date) {
            return new Date(target.getTime());
        }
        // First part is for array and second part is for Realm.Collection
        // if (target instanceof Array || typeof (target as any).type === 'string') {
        if (typeof target === "object") {
            if (typeof target[Symbol.iterator] === "function") {
                const cp = [];
                if (target.length > 0) {
                    for (const arrayMember of target) {
                        cp.push(ViewUtils.deepCopy(arrayMember));
                    }
                }
                return cp;
            }
            else {
                const targetKeys = Object.keys(target);
                const cp = {};
                if (targetKeys.length > 0) {
                    for (const key of targetKeys) {
                        cp[key] = ViewUtils.deepCopy(target[key]);
                    }
                }
                return cp;
            }
        }
        // Means that object is atomic
        return target;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ViewUtils;

/**
 * Constantes con los posibles valores para logger mode
 */
ViewUtils.ALERT_TITLE = "E-Fast";
/** Valores para banners de los Lobbies */
ViewUtils.BANNER_PORTRAIT_STYLE = {
    "max-height": "400px",
    overflow: "hidden",
    position: "relative",
};
ViewUtils.BANNER_LANDSCAPE_STYLE = {
    "max-height": "800px",
    overflow: "hidden",
    position: "relative",
};
ViewUtils.loader = null;
//# sourceMappingURL=view.utils.js.map

/***/ }),

/***/ 441:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class OfferMapper {
    static convertModelToRequest(model) {
        var request = {
            token: model.token,
            id_oferta: model.offerId,
            id_usuario: model.userId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static isJson(mensaje) {
        try {
            JSON.parse(mensaje);
        }
        catch (e) {
            return false;
        }
        return true;
    }
    static convertResponseToModel(response) {
        let Desc;
        let Titulo;
        if (this.isJson(response.descripcion)) {
            Desc = JSON.parse(response.descripcion);
        }
        else {
            Desc = response.descripcion;
        }
        if (this.isJson(response.titulo)) {
            Titulo = JSON.parse(response.titulo);
        }
        else {
            Titulo = response.titulo;
        }
        var model = {
            offerId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_oferta),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(Desc),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            read: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.leida),
            titulo: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(Titulo)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(OfferMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = OfferMapper;

class OfferTitleMapper {
    static convertModelToRequest(session) {
        var request = {
            token: session.token,
            id_usuario: session.userId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            type: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo_promo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(OfferTitleMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = OfferTitleMapper;

//# sourceMappingURL=offer.model.js.map

/***/ }),

/***/ 442:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);

class GiftCardMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            correo: model.email,
            descripcion: model.description,
            monto: model.amount,
            metodopago: model.paymentMethod,
            id_tarjetaregalo: model.giftCardId,
            codtr: model.paymentAuthorization,
            fecharegistro: model.date,
            fechaenvio: model.deliveryDate,
            codCanje: model.cardPublicCode,
            id_ordencompra: model.purchaseOrderId,
            numero_pago: model.cardAuthorizationNumber,
            id_tarjeta: model.cardId,
            KountSession: model.KountSession
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            status: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            giftCardId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_tarjetaregalo),
            giftCardTypeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_tipotarjetaregalo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            amount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.monto),
            imageType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            gif: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.gif),
            cardPublicCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.codCanje)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(GiftCardMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = GiftCardMapper;

class GiftCardTypeMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            typeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_montotarjeta),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            amount: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.monto),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(GiftCardTypeMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = GiftCardTypeMapper;

//# sourceMappingURL=giftcard.model.js.map

/***/ }),

/***/ 484:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductSimilarDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para el Tab de FAVORITOS
 */
let ProductSimilarDataSet = class ProductSimilarDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setProduct(product) {
        this.product = product;
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            let state = this.getState();
            let data = state.list;
            if (this.isOneTimeFetch() && data == null || data.length === 0) {
                var param = {};
                //param.pageId = fetchPageId;
                param.pageId = null; //Para similares siempre maneja un maximo de 50, se debe mandar en null
                param.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
                param.token = this.sessionManager.getToken();
                param.article = this.product.productCode;
                this.productService.getSimilarProducts(param).subscribe((resultList) => {
                    observer.next(resultList);
                    observer.complete();
                }, error => {
                    observer.next(this.list);
                    observer.complete();
                });
            }
            else {
                observer.next([]);
                observer.complete();
            }
        });
    }
};
ProductSimilarDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], ProductSimilarDataSet);

//# sourceMappingURL=product-similar-dataset.js.map

/***/ }),

/***/ 619:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SocialGoogleService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_google_plus__ = __webpack_require__(620);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




let SocialGoogleService = class SocialGoogleService {
    constructor(gplus //, private errHandler: ErrorService
    ) {
        this.gplus = gplus; //, private errHandler: ErrorService
    }
    login() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let authData = { successful: false };
            var permission = {
                'webClientId': __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.googleWebClientID,
                'offline': true
            };
            //console.log("GOOGLE login... realizando login...");
            this.gplus.login(permission).then(success => {
                //console.log("GOOGLE login... resultado...OK");
                if (success) {
                    authData.accessToken = success.accessToken;
                    authData.expiresIn = success.expires_in;
                    authData.imageUrl = (success.imageUrl && success.imageUrl.trim().length > 0) ? success.imageUrl + "?sz=512" : null;
                    authData.name = success.givenName;
                    authData.lastName = success.familyName;
                    authData.email = success.email.toLowerCase();
                    authData.successful = true;
                    observer.next(authData);
                    observer.complete();
                }
                else {
                    observer.next(authData);
                    observer.complete();
                }
            }).catch(function (error) {
                //console.log("GOOGLE login... ERR : " + JSON.stringify(error));
                //observer.error(this.errHandler.handle(this, AppConfig.err.GOOGLE_CANNOT_COMPLETE_SIGN, error));
                observer.error(error);
            });
        });
    }
    checkIfTokenIsValid() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let authData = { successful: false };
            var permission = {
                'webClientId': __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.googleWebClientID,
                'offline': false
            };
            //console.log("GOOGLE SILENT login... realizando login...");
            this.gplus.trySilentLogin(permission).then(success => {
                //console.log("GOOGLE SILENT login... resultado...OK");
                //console.log("GOOGLE SILENT " + JSON.stringify(success));
                if (success) {
                    authData.accessToken = success.accessToken;
                    authData.expiresIn = success.expires_in;
                    authData.imageUrl = (success.imageUrl && success.imageUrl.trim().length > 0) ? success.imageUrl + "?sz=512" : null;
                    authData.name = success.givenName;
                    authData.lastName = success.familyName;
                    authData.email = success.email.toLowerCase();
                    authData.successful = true;
                    observer.next(authData);
                    observer.complete();
                }
                else {
                    observer.next(authData);
                    observer.complete();
                }
            }).catch(function (error) {
                //console.log("GOOGLE SILENT login... ERR : " + JSON.stringify(error));
                authData.successful = false;
                //4 o -4 es Not logged
                if (error == 4) {
                    observer.next(authData);
                    observer.complete();
                }
                else {
                    //observer.error(this.errHandler.handle(this, AppConfig.err.GOOGLE_CANNOT_COMPLETE_SIGN, error));
                    observer.next(authData);
                    observer.complete();
                }
            });
        });
    }
    logout() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.gplus.logout().then(function (response) {
                //console.log("Google > Session closed!");
                observer.next(true);
                observer.complete();
            }, function (error) {
                //this.errHandler.handle(this, AppConfig.err.GOOGLE_CANNOT_COMPLETE_LOGOUT, error)
                //console.log("Google > Session NOT closed!");
                observer.next(false);
                observer.complete();
            }).catch(function (error) {
                if (error) {
                    //this.errHandler.handle(this, AppConfig.err.GOOGLE_CANNOT_COMPLETE_LOGOUT, error)
                    //console.log("Google > Session NOT closed! C "  + JSON.stringify(error));
                }
                observer.next(false);
                observer.complete();
            });
        });
    }
};
SocialGoogleService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ionic_native_google_plus__["a" /* GooglePlus */] //, private errHandler: ErrorService
    ])
], SocialGoogleService);

//# sourceMappingURL=social-google-service.js.map

/***/ }),

/***/ 621:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SocialFacebookService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_facebook__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




let SocialFacebookService = class SocialFacebookService {
    constructor(facebook //, private errHandler: ErrorService
    ) {
        this.facebook = facebook; //, private errHandler: ErrorService
    }
    login() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let authData = { successful: false };
            //console.log("FB login... realizando login...");
            this.facebook.login(['public_profile', 'email']).then((facebookData) => {
                //console.log("FB login... resultado...OK");
                //console.log("FB " + JSON.stringify(facebookData));
                if (facebookData && facebookData.status == "connected") {
                    let fbID = facebookData.authResponse.userID;
                    let fbToken = facebookData.authResponse.accessToken;
                    this.getUserInfo(fbID, fbToken).subscribe((user) => {
                        if (user) {
                            authData.accessToken = user.socialNetworkUserId;
                            authData.expiresIn = null;
                            authData.imageUrl = user.picture;
                            authData.name = user.name;
                            authData.lastName = user.firstSurname;
                            authData.email = user.email.toLowerCase();
                            authData.successful = true;
                            observer.next(authData);
                            observer.complete();
                        }
                        else {
                            observer.next(authData);
                            observer.complete();
                        }
                    });
                }
                else {
                    observer.next(authData);
                    observer.complete();
                }
            }, (error) => {
                //console.log("FB login... ERR : " + JSON.stringify(error));
                //observer.error(this.errHandler.handle(this, AppConfig.err.FB_CANNOT_COMPLETE_SIGN, error));
                observer.error(error);
            });
        });
    }
    checkIfTokenIsValid() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let authData = { successful: false };
            this.facebook.getLoginStatus().then(res => {
                //console.log("FB SILENT login... resultado...OK");
                //console.log("FB SILENT " + JSON.stringify(res));
                if (res.status === "connected") {
                    authData.successful = true;
                    observer.next(authData);
                    observer.complete();
                }
                else {
                    observer.next(authData);
                    observer.complete();
                }
            }).catch(error => {
                //this.errHandler.handle(this, AppConfig.err.FB_CANNOT_COMPLETE_SIGN, error)
                //console.log("FB SILENT login... ERR : " + JSON.stringify(error));
                observer.next(authData);
                observer.complete();
            });
        });
    }
    logout() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.facebook.logout().then(res => {
                //console.log("FB > Session closed!");
                observer.next(true);
                observer.complete();
            })
                .catch(error => {
                //this.errHandler.handle(this, AppConfig.err.FB_CANNOT_COMPLETE_LOGOUT, error);
                //console.log("FB > Session NOT closed!");
                observer.next(false);
                observer.complete();
            });
        });
    }
    getUserInfo(fbID, fbToken) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.facebook.api("/" + fbID + "?fields=name,picture,gender,birthday,email", ["public_profile"]).then((facebookUser) => {
                //var gender    = facebookUser.gender;
                //var birthday  = facebookUser.birthday;
                var name = facebookUser.name;
                var firstName = facebookUser.first_name;
                var lastName = facebookUser.last_name;
                var email = facebookUser.email.toLowerCase();
                //var picture     = facebookUser.picture;
                if (name && !firstName) {
                    var tokens = name.split(/(\s+)/).filter(function (e) { return e.trim().length > 0; });
                    if (tokens && tokens.length > 1) {
                        name = tokens[0];
                        firstName = tokens[1];
                    }
                }
                var user = {
                    name: name,
                    firstSurname: firstName,
                    secondSurname: lastName,
                    email: email,
                    accessMethod: 'facebook',
                    socialNetworkUserId: fbToken,
                    pictureType: 'url',
                    picture: "https://graph.facebook.com/" + fbID + "/picture?width=512&height=512",
                    country: __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.defaultCountry,
                    currency: __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.defaultCurrency,
                    fingerPrintValidation: 'N',
                    pushNotifications: 'N'
                };
                observer.next(user);
                observer.complete();
            }, (error) => {
                //observer.error(this.errHandler.handle(this, AppConfig.err.FB_CANNOT_RETRIEVE_USER_INFO, error));
                observer.error(error);
            });
        });
    }
};
SocialFacebookService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ionic_native_facebook__["a" /* Facebook */] //, private errHandler: ErrorService
    ])
], SocialFacebookService);

//# sourceMappingURL=social-facebook-service.js.map

/***/ }),

/***/ 622:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SocialAppleService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_jwt_decode__ = __webpack_require__(1170);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_jwt_decode___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_jwt_decode__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let SocialAppleService = class SocialAppleService {
    constructor(//private errHandler: ErrorService, 
        sessionManager) {
        this.sessionManager = sessionManager;
    }
    login() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let authData = { successful: false };
            console.log("SignInWithApple... LLAMANDO");
            cordova.plugins.SignInWithApple.signin({ requestedScopes: [0, 1] }, (succ) => {
                console.log("SignInWithApple...RESULTADO" + JSON.stringify(succ));
                if (succ) {
                    // Obtiene el correo real de la cuenta
                    let jwt = succ.identityToken;
                    let decoded = __WEBPACK_IMPORTED_MODULE_4_jwt_decode___default()(jwt);
                    let appleEmail = decoded.email;
                    authData.accessToken = succ.identityToken;
                    authData.expiresIn = null;
                    authData.imageUrl = null;
                    // Dado que solo la primera vez se obtienen los datos del usuario se proceden a guardan
                    if (succ.fullName.givenName && succ.fullName.givenName.trim().length > 0) {
                        console.log("SignInWithApple...RESULTADO SUCCESS..." + appleEmail);
                        let appleData = appleEmail.toLowerCase() + "|" + succ.fullName.givenName + '|' + succ.fullName.familyName;
                        this.sessionManager.getSession().storeItem("APPLE_LOGIN_INFO", appleData).subscribe(() => {
                            authData.name = succ.fullName.givenName;
                            authData.lastName = succ.fullName.familyName;
                            authData.email = appleEmail.toLowerCase();
                            authData.successful = true;
                            observer.next(authData);
                            observer.complete();
                        });
                    }
                    else {
                        console.log("SignInWithApple...RESULTADO SUCCESS...2" + appleEmail);
                        // Para los casos en que ya no se tienen se consulta los datos almacenados
                        this.sessionManager.getSession().getItem("APPLE_LOGIN_INFO").subscribe((info) => {
                            console.log("SignInWithApple...RESULTADO SUCCESS...ALMACENADO " + info);
                            if (info) {
                                let strTokens = info.split("|");
                                authData.name = strTokens[1];
                                authData.lastName = strTokens[2];
                                authData.email = appleEmail.toLowerCase();
                                authData.successful = true;
                                observer.next(authData);
                                observer.complete();
                            }
                            else {
                                authData.name = "";
                                authData.lastName = "";
                                authData.email = appleEmail.toLowerCase();
                                authData.successful = true;
                                observer.next(authData);
                                observer.complete();
                            }
                        });
                    }
                }
                else {
                    console.log("SignInWithApple...RESULTADO PROBLEM...");
                    observer.next(authData);
                    observer.complete();
                }
            }, (err) => {
                console.log("SignInWithApple... ERROR");
                console.error(err);
                observer.error(err);
            });
        });
    }
    checkIfTokenIsValid(currentToken) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let authData = { successful: false };
            console.log("currentToken == " + currentToken + " !");
            this.sessionManager.getSession().getItem(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.loginMethodAppleToken).subscribe((storedToken) => {
                console.log("storedToken == " + storedToken + " !");
                if (storedToken && currentToken) {
                    authData.successful = currentToken === storedToken;
                }
                observer.next(authData);
                observer.complete();
            });
        });
    }
    logout() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].rootParams.loginMethod, null).subscribe();
            this.sessionManager.getSession().storeItem(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.loginMethodAppleToken, null).subscribe();
            observer.next(true);
            observer.complete();
        });
    }
};
SocialAppleService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */]])
], SocialAppleService);

//# sourceMappingURL=social-apple-service.js.map

/***/ }),

/***/ 63:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__config_config__ = __webpack_require__(3);

/**
 * Clase base de un set de datos paginado
 */
class DataSetNavigator {
    constructor() {
        this.page = [];
        this.totalItems = 0;
        this.chunkSize = 10;
        this.dataNavigated = [];
        this.reachedFinal = false;
        this.reachedFinalWithPending = false;
        this.finalPageItems = [];
        this.initialized = false;
        this.navigatorIndexPointer = 0;
    }
    setPageSize(size) {
        this.chunkSize = size;
    }
    getSourceData() {
        let source = [...this.page];
        let source2 = [...this.dataNavigated];
        return source.concat(source2);
    }
    resetFlags() {
        this.dataNavigated = [];
        this.page = [];
        this.finalPageItems = [];
        this.totalItems = 0;
        this.navigatorIndexPointer = 0;
        this.state = {};
        this.reachedFinal = false;
        this.reachedFinalWithPending = false;
        this.initialized = false;
    }
    setPlatform(platform) {
        this.platform = platform;
        if (this.platform && this.platform.is('ios')) {
            this.chunkSize = __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.defaultShrinkChunkSizeIOS;
        }
        else {
            this.chunkSize = __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.defaultShrinkChunkSize;
        }
    }
    setDataSet(dataSet) {
        this.dataSet = dataSet;
        this.dataSet.turnOffPreviewCache();
        this.resetFlags();
    }
    printList(prefix, listItems) {
        if (listItems.length > 0) {
            listItems.forEach((value) => {
                console.log(prefix + "  Cod: " + value.productCode + " Desc: " + value.description);
            });
        }
    }
    handleDatasetState(datasetState) {
        let dataList = [...datasetState.list];
        //Asegura que la navegacion sea por tractos, aunque el Dataset acumula todos los datos bajados
        //el navegator toma el acercamiento de cargar tractos
        if (this.page && datasetState.list && datasetState.list.length >= this.navigatorIndexPointer) {
            dataList = datasetState.list.slice(this.navigatorIndexPointer, datasetState.list.length);
            this.navigatorIndexPointer = datasetState.list.length;
        }
        this.state = {
            isTimeout: datasetState.isTimeout,
            isFetchingData: datasetState.isFetchingData,
            list: dataList,
            pageId: datasetState.pageId,
            dataRetrievedForPageIsEmpty: datasetState.dataRetrievedForPageIsEmpty
        };
        this.page = this.state.list;
        this.totalItems += this.page.length;
    }
    clear(clearCallback) {
        this.resetFlags();
        //Limpia el provider y actualiza el estado del view
        this.dataSet.clear((state) => {
            this.handleDatasetState(state);
            if (clearCallback)
                clearCallback(this.getEmptyState());
        });
    }
    clearAndPreset(clearCallback) {
        //console.log(this.constructor.name + " clearAndPreset...");
        this.resetFlags();
        //Limpia el provider y actualiza el estado del view
        this.dataSet.clearAndPreset((state) => {
            this.initialized = true;
            this.handleDatasetState(state);
            if (clearCallback)
                clearCallback(this.getEmptyState());
        });
    }
    prepare(clearCallback) {
        this.resetFlags();
        //Limpia el provider y actualiza el estado del view
        this.dataSet.prepare((state) => {
            this.handleDatasetState(state);
            if (clearCallback)
                clearCallback(this.handleNavigatorState());
        });
    }
    getEmptyState() {
        let actualState = this.dataSet.getState();
        this.state = {
            isTimeout: actualState.isTimeout,
            isFetchingData: actualState.isFetchingData,
            list: [],
            pageId: 1,
            dataRetrievedForPageIsEmpty: true
        };
        this.page = [...actualState.list];
        this.totalItems += this.page.length;
        return this.state;
    }
    getState() {
        let state = this.dataSet.getState();
        this.handleDatasetState(state);
        return this.handleNavigatorState();
    }
    sync(fetchCallback) {
        this.resetFlags();
        let state = this.dataSet.getState();
        this.initialized = true;
        this.handleDatasetState(state);
        if (fetchCallback)
            fetchCallback(this.handleNavigatorState());
    }
    fetch(fetchCallback, skipNextPageFetching) {
        this.resetFlags();
        //Limpia el provider y actualiza el estado del view
        this.dataSet.fetch((state) => {
            this.initialized = true;
            this.handleDatasetState(state);
            if (fetchCallback)
                fetchCallback(state.dataRetrievedForPageIsEmpty ? this.getEmptyState() : this.handleNavigatorState());
        }, skipNextPageFetching);
    }
    fetchWithTimeoutCheck(fetchCallback, TOCallback) {
        this.resetFlags();
        //Limpia el provider y actualiza el estado del view
        this.dataSet.fetchWithTimeoutCheck((state) => {
            this.initialized = true;
            this.handleDatasetState(state);
            if (fetchCallback)
                fetchCallback(state.dataRetrievedForPageIsEmpty ? this.getEmptyState() : this.handleNavigatorState());
        }, (state) => {
            this.initialized = true;
            this.handleDatasetState(state);
            if (TOCallback)
                TOCallback(state.dataRetrievedForPageIsEmpty ? this.getEmptyState() : this.handleNavigatorState());
        });
    }
    fetchWithTOCheckAndPageControl(fetchCallback, TOCallback, skipNextPageFetching) {
        this.resetFlags();
        //Limpia el provider y actualiza el estado del view
        this.dataSet.fetchWithTOCheckAndPageControl((state) => {
            this.initialized = true;
            this.handleDatasetState(state);
            if (fetchCallback)
                fetchCallback(state.dataRetrievedForPageIsEmpty ? this.getEmptyState() : this.handleNavigatorState());
        }, (state) => {
            this.initialized = true;
            this.handleDatasetState(state);
            if (TOCallback)
                TOCallback(state.dataRetrievedForPageIsEmpty ? this.getEmptyState() : this.handleNavigatorState());
        }, skipNextPageFetching);
    }
    handleTimeout(handleTimeoutCallback) {
        //Limpia el provider y actualiza el estado del view
        this.dataSet.handleTimeout((state) => {
            this.initialized = true;
            this.handleDatasetState(state);
            if (handleTimeoutCallback)
                handleTimeoutCallback(this.handleNavigatorState());
        });
    }
    gc(onShrink) {
        //Verifica si para iOS llego al maximo de items cargados
        if (this.platform && this.platform.is('ios')) {
            if (this.dataNavigated.length >= __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.defaultMaxItemsInViewIOS) {
                // let from = this.dataNavigated.length;
                this.dataNavigated.splice(0, this.dataNavigated.length - 18);
                //let to = this.dataNavigated.length;
                if (onShrink)
                    onShrink(this.handleNavigatorState());
            }
        }
        else {
            if (this.dataNavigated.length >= __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.defaultMaxItemsInView) {
                //let from = this.dataNavigated.length;
                this.dataNavigated.splice(0, this.dataNavigated.length - 18);
                //let to = this.dataNavigated.length;
                if (onShrink)
                    onShrink(this.handleNavigatorState());
            }
        }
    }
    next(nextCallback, onShrink) {
        if (!this.reachedFinal) {
            //Verifica si para iOS llego al maximo de items cargados
            if (this.platform && this.platform.is('ios')) {
                if (this.dataNavigated.length >= __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.defaultMaxItemsInViewIOS) {
                    //let from = this.dataNavigated.length;
                    this.dataNavigated.splice(0, this.dataNavigated.length - 18);
                    //let to = this.dataNavigated.length;
                    this.handleNext(onShrink);
                }
                else {
                    this.performNext(nextCallback);
                }
            }
            else {
                if (this.dataNavigated.length >= __WEBPACK_IMPORTED_MODULE_0__config_config__["a" /* AppConfig */].app.defaultMaxItemsInView) {
                    //let from = this.dataNavigated.length;
                    // elimina desde el indice 0 al tamaño actual - 18 (quedan 18 items y borra todos los anteriores)
                    this.dataNavigated.splice(0, this.dataNavigated.length - 18);
                    //let to = this.dataNavigated.length;
                    this.handleNext(onShrink);
                }
                else {
                    this.performNext(nextCallback);
                }
            }
        }
        else {
            let temporalState = {
                isTimeout: this.state.isTimeout,
                isFetchingData: this.state.isFetchingData,
                list: this.dataNavigated,
                pageId: this.state.pageId,
                dataRetrievedForPageIsEmpty: true
            };
            this.page = [];
            this.state = {};
            if (nextCallback)
                nextCallback(temporalState);
        }
    }
    performNext(nextCallback) {
        if (!this.initialized) {
            let callback = (state) => {
                this.initialized = true;
                this.handleDatasetState(state);
                if (nextCallback)
                    nextCallback(this.handleNavigatorState());
            };
            this.dataSet.fetchInfinite(callback, null);
        }
        else {
            this.handleNext(nextCallback);
        }
    }
    handleNext(nextCallback) {
        //let stateFound = this.handleNavigatorState();
        this.stateFound = this.handleNavigatorState();
        if (this.stateFound) {
            if (nextCallback)
                nextCallback(this.stateFound);
        }
        else {
            //Siguiente pagina si ya no hay mas chunks en cache
            let callback = (fetchState) => {
                this.handleDatasetState(fetchState);
                if (this.state.dataRetrievedForPageIsEmpty) {
                    this.reachedFinalWithPending = true;
                    this.reachedFinal = true;
                    /////////////////////////////////
                    //let temporalState = this.state;
                    this.temporalState = this.state;
                    this.temporalState.list = this.dataNavigated;
                    this.page = [];
                    this.state = {};
                    if (nextCallback)
                        nextCallback(this.temporalState);
                    /////////////////////////////////
                }
                else {
                    this.page = this.state.list;
                    this.totalItems += this.page.length;
                    if (nextCallback)
                        nextCallback(this.handleNavigatorState());
                }
            };
            this.dataSet.fetchInfinite(callback, null);
            //}
        }
    }
    handleNavigatorState() {
        let temporalState = null;
        if (this.page.length >= this.chunkSize) {
            if (this.dispatchAllSizeLessThanChunkSize()) {
                if (this.page.length < this.chunkSize * 2) {
                    this.dataNavigated = this.dataNavigated.concat([...this.page.splice(0, this.page.length)]);
                }
                else {
                    this.dataNavigated = this.dataNavigated.concat([...this.page.splice(0, this.chunkSize)]);
                }
            }
            else {
                this.dataNavigated = this.dataNavigated.concat([...this.page.splice(0, this.chunkSize)]);
            }
            temporalState = {
                isTimeout: this.state.isTimeout,
                isFetchingData: this.state.isFetchingData,
                list: this.dataNavigated,
                pageId: this.state.pageId,
                dataRetrievedForPageIsEmpty: this.state.dataRetrievedForPageIsEmpty
            };
        }
        else {
            if (this.page.length > 0 /* && this.page.length <= 6*/) {
                this.dataNavigated = this.dataNavigated.concat([...this.page]);
                this.page = [];
                this.state = {};
                temporalState = {
                    isTimeout: this.state.isTimeout,
                    isFetchingData: this.state.isFetchingData,
                    list: this.dataNavigated,
                    pageId: this.state.pageId,
                    dataRetrievedForPageIsEmpty: this.state.dataRetrievedForPageIsEmpty //true --> darcia
                };
                if (this.state.dataRetrievedForPageIsEmpty) {
                    this.reachedFinal = true;
                }
            }
            else {
                this.page = [];
                this.state = {};
            }
        }
        return temporalState;
    }
    performCleaningOnStateChange() {
        let factor = 0;
        if (this.dataNavigated != null && this.dataNavigated.length > 0) {
            if (this.platform && this.platform.is('ios')) {
                //iOS
                //Utiliza un mecanismo alterno this.performCleaningOnGC()
            }
            else {
                //Android
                if (this.dataNavigated.length > 150) {
                    factor = 10;
                    //console.log("performCleaning x10");
                    this.dataNavigated.splice(6, factor);
                }
                else if (this.dataNavigated.length > 100) {
                    factor = 8;
                    //console.log("performCleaning x8");
                    this.dataNavigated.splice(6, factor);
                }
                else if (this.dataNavigated.length > 50) {
                    factor = 4;
                    //console.log("performCleaning x4");
                    this.dataNavigated.splice(6, factor);
                }
                else if (this.dataNavigated.length > 18) {
                    factor = 2;
                    //console.log("performCleaning x2");
                    this.dataNavigated.splice(6, factor);
                }
            }
        }
        return factor;
    }
    performCleaningOnGC() {
        let factor = 0;
        let minLen = 18;
        //En el caso de que el DS no tenga activado cache, amplia el rango de eliminado
        //dado que asume que puede manejar pocos datos
        let isCacheTurnedOff = !this.dataSet.isPreviewCacheTurnedOn();
        //console.log("isCacheTurnedOff = " + isCacheTurnedOff);
        if (isCacheTurnedOff) {
            minLen = 50;
        }
        if (this.dataNavigated != null && this.dataNavigated.length > 0) {
            if (this.platform && this.platform.is('ios')) {
                if (this.dataNavigated.length > minLen) {
                    factor = 4;
                    //console.log("performCleaning x4");
                    this.dataNavigated.splice(0, factor);
                }
            }
        }
        return factor;
    }
    /* Este metodo se utiliza para indicarle al procesador de paginacion si en el caso de que una vez se calcule los
    datos que se van a mandar al view que corresponde al tamano de una pagina, ejm 10 items,  si quedan 3 en memoria y
    esta funcion devuelve true, entonces se devuelve TODO al view, o sea, 13 items.*/
    dispatchAllSizeLessThanChunkSize() {
        return false;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = DataSetNavigator;

//# sourceMappingURL=base-dataset-navigator.js.map

/***/ }),

/***/ 66:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CartManagerService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__purchase_order_service__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__core_provider_greenpay_checkout_service__ = __webpack_require__(286);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__util_number_utils__ = __webpack_require__(276);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ionic_native_facebook__ = __webpack_require__(65);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};











let CartManagerService = class CartManagerService {
    constructor(
        //private platform: Platform,
        orderService, sessionManager, 
        //private alertCtrl: AlertController,
        toastCtrl, 
        //private translate: TranslateService,
        facebook, productService, checkoutService, events) {
        this.orderService = orderService;
        this.sessionManager = sessionManager;
        this.toastCtrl = toastCtrl;
        this.facebook = facebook;
        this.productService = productService;
        this.checkoutService = checkoutService;
        this.events = events;
        //Timer para la compra del carrito
        this.timerId = 0;
        this.subtotal = 0;
        this.tax = 0;
        this.discount = 0;
        this.total = 0;
        this.storedItemsQuantity = 0;
        //Cash payment registered
        this.cashPaymentRegistered = false;
        this.sinpePaymentRegistered = false;
        //Cuando expira el timer del carrito
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_PURCHASE_TIMER_EXPIRED, () => {
            this.handleTimerExpiration(
            /*()=>{
            if(this.expirationCallback){
              this.expirationCallback(AppConfig.cart.TIMER_EXPIRATION_ACTION_ABORT);
            }
          },*/
            () => {
                if (this.expirationCallback) {
                    this.expirationCallback(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.TIMER_EXPIRATION_ACTION_TIMEOUT);
                }
            });
        });
    }
    setExpirationCallback(expirationCallback) {
        this.expirationCallback = expirationCallback;
    }
    initialize() {
        this.fetchActiveOrder().subscribe();
    }
    performInit() {
        return this.fetchActiveOrder();
    }
    clear() {
        this.subtotal = 0;
        this.tax = 0;
        this.discount = 0;
        this.total = 0;
        this.currentOrder = {};
        this.storedItemsQuantity = 0;
        this.clearTimer();
    }
    hasCartExcentProducts() {
        return this.hasExcentProducts;
    }
    clearBackup() {
        this.backUpCurrentOrder = null;
        this.sessionManager
            .getSession()
            .removeItem(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].session.BACKUP_CART_ORDER)
            .subscribe();
    }
    performBackup() {
        this.backUpCurrentOrder = __WEBPACK_IMPORTED_MODULE_9__util_view_utils__["a" /* ViewUtils */].deepCopy(this.currentOrder);
        this.sessionManager
            .getSession()
            .storeItem(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].session.BACKUP_CART_ORDER, this.backUpCurrentOrder)
            .subscribe();
    }
    getBackup() {
        return this.backUpCurrentOrder;
    }
    restoreToBackup() {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            this.addPurchaseLog("CARRITO " +
                this.currentOrder.orderId +
                " - (CUPON) RESTAURAR BACKUP DE CUPON ", this.backUpCurrentOrder);
            this.orderService.modifyPurchaseOrder(this.backUpCurrentOrder).subscribe((result) => {
                var details = this.backUpCurrentOrder.details;
                if (!details) {
                    this.backUpCurrentOrder.details = [];
                    details = this.backUpCurrentOrder.details;
                }
                let observables = [];
                for (let i = 0; i < details.length; i++) {
                    var detail = details[i];
                    observables.push(this.updateOrderDetail(detail));
                }
                __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"].forkJoin(observables).subscribe((result) => {
                    this.currentOrder = __WEBPACK_IMPORTED_MODULE_9__util_view_utils__["a" /* ViewUtils */].deepCopy(this.backUpCurrentOrder);
                    this.calculate();
                    observer.next(true);
                    observer.complete();
                });
                //Error en caso de guardado
            }, (error) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    fetchSavedBackup() {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            this.sessionManager
                .getSession()
                .getItem(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].session.BACKUP_CART_ORDER)
                .subscribe((data) => {
                if (data) {
                    this.backUpCurrentOrder = data;
                }
                observer.next(data != null);
                observer.complete();
            });
        });
    }
    calculate(skipeNotAvailable) {
        this.hasExcentProducts = false;
        this.subtotal = 0;
        this.tax = 0;
        this.discount = 0;
        this.total = 0;
        this.saveCartStoredItemsQuantity();
        for (let i = 0; i < this.currentOrder.details.length; i++) {
            var item = this.currentOrder.details[i];
            //Si el detalle de la orden tiene un producto valido
            if (item.relatedProduct) {
                //Si el producto no tiene disponible no suma al total
                if (!skipeNotAvailable) {
                    if (item.relatedProduct.availableUnits === 0) {
                        continue;
                    }
                }
                this.subtotal += item.relatedProduct.priceWithNoTax * item.quantity;
                this.tax += item.tax ? item.tax : 0;
                this.discount += item.discount ? item.discount : 0;
                //Si hay algun producto sin impuesto
                if (item.relatedProduct.tax === 0) {
                    this.hasExcentProducts = true;
                }
            }
        }
        //Si no hay descuento asociado a los detalles y existe un descuento general, toma ese.
        this.discount += this.currentOrder.discount;
        //Incrementa el total para sumar el rubro de flete
        if (this.currentOrder.freight) {
            this.subtotal +=
                this.currentOrder.freight.amountWithNoTax > 0
                    ? this.currentOrder.freight.amountWithNoTax
                    : 0;
            this.tax += this.currentOrder.freight ? this.currentOrder.freight.tax : 0; //Mas el impuesto del flete
        }
        this.total = this.subtotal + this.tax - this.discount;
        this.discount = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(this.discount);
        this.subtotal = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(this.subtotal);
        this.tax = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(this.tax);
        this.total = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(this.total);
        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_CALCULATION);
    }
    //Lleva control de cantidad total de items en el carrito
    saveCartStoredItemsQuantity() {
        this.storedItemsQuantity = 0;
        if (this.currentOrder && this.currentOrder.details) {
            for (let i = 0; i < this.currentOrder.details.length; i++) {
                if (this.currentOrder.details[i].quantity) {
                    this.storedItemsQuantity += this.currentOrder.details[i].quantity;
                }
            }
        }
        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_REFRESHED, this.storedItemsQuantity);
    }
    getStoredItemsQuantity() {
        return this.storedItemsQuantity;
    }
    getSubTotal() {
        return this.subtotal;
    }
    getTax() {
        return this.tax;
    }
    getDisccount() {
        return this.discount;
    }
    getFreight() {
        return this.currentOrder ? this.currentOrder.deliveryCost : 0;
    }
    getTotal() {
        return this.total;
    }
    isCartEmpty() {
        return this.currentOrder.details && this.currentOrder.details.length === 0;
    }
    fetchActiveOrder(skipCreation) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            this.clear();
            this.fetchPendingOrder().subscribe((order) => {
                if (order) {
                    this.currentOrder = order;
                    this.fetchOrderDetails(this.currentOrder).subscribe((list) => {
                        observer.next(this.currentOrder);
                        observer.complete();
                    });
                }
                else {
                    if (!skipCreation) {
                        this.createOrder().subscribe((result) => {
                            if (result) {
                                return this.fetchActiveOrder(true).subscribe();
                            }
                            else {
                                observer.next(this.currentOrder);
                                observer.complete();
                            }
                        });
                    }
                    else {
                        observer.next(this.currentOrder);
                        observer.complete();
                    }
                }
            });
        });
    }
    //Consulta una orden que este en estado Pendiente (REG)
    fetchPendingOrder() {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            var order = {};
            order.userId = this.sessionManager.getPrincipal().userId;
            order.token = this.sessionManager.getToken();
            order.orderStatus = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].order.RECEIVED_STATUS;
            this.orderService.getPurchaseOrders(order).subscribe((list) => {
                var result = null;
                if (list && list.length > 0) {
                    for (let i = 0; i < list.length; i++) {
                        if (list[i].orderStatus === __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].order.RECEIVED_STATUS) {
                            result = list[i];
                            break;
                        }
                    }
                }
                observer.next(result);
                observer.complete();
            }, (error) => {
                observer.next(null);
                observer.complete();
            });
        });
    }
    createOrder() {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            var date = new Date();
            this.currentOrder = {};
            this.currentOrder.userId = this.sessionManager.getPrincipal().userId;
            this.currentOrder.token = this.sessionManager.getToken();
            this.currentOrder.creationDate = date.getTime();
            this.currentOrder.confirmationDate = date.getTime();
            this.currentOrder.earlyPurchaseDiscount = 0;
            this.currentOrder.currency = this.sessionManager.getPrincipal().currency;
            this.currentOrder.subtotal = 0;
            this.currentOrder.tax = 0;
            this.currentOrder.taxPercentage = 0;
            this.currentOrder.discount = 0;
            this.currentOrder.discountPercentage = 0;
            this.currentOrder.deliveryCost = 0;
            this.currentOrder.total = 0;
            this.currentOrder.orderStatus = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].order.RECEIVED_STATUS;
            this.currentOrder.addressId = null;
            this.currentOrder.paymentMethod = null;
            this.currentOrder.cardId = null;
            this.currentOrder.coupon = null;
            this.currentOrder.productQuantity = 0;
            this.currentOrder.deliveryDate = date.getTime();
            this.currentOrder.freightId = null;
            //this.currentOrder.freightAmount = 0;
            this.currentOrder.onTime = null;
            this.orderService.addPurchaseOrder(this.currentOrder).subscribe((result) => {
                observer.next(true);
                observer.complete();
            }, (error) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    modifyOrder(order) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            order.userId = this.sessionManager.getPrincipal().userId;
            order.token = this.sessionManager.getToken();
            this.orderService.modifyPurchaseOrder(this.currentOrder).subscribe((result) => {
                observer.next(true);
                observer.complete();
            }, (error) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    setCreditCard(card) {
        this.currentOrder.creditCardAlias = card.cardNumber;
        this.currentOrder.creditCardBrand = card.issuer;
    }
    setDeliveryAddress(address) {
        this.currentOrder.addressDescription =
            address.zone.province.provinceName +
                " " +
                address.zone.canton.cantonName +
                " " +
                address.zone.district.districtName +
                " " +
                address.direction;
    }
    setPromotion(coupon) {
        this.currentOrder.coupon = coupon;
    }
    /**
     *
     * @param Guarda la orden de compra a lo que se tiene al momento
     */
    saveDraft() {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Carga datos de sesion para todo el proceso
            this.currentOrder.userId = this.sessionManager.getPrincipal().userId;
            this.currentOrder.token = this.sessionManager.getToken();
            //Obtiene los datos seleccionados en el carrito
            let card = this.currentOrder.card;
            let freight = this.currentOrder.freight;
            this.currentOrder.amountToCharge = this.total;
            this.currentOrder.description = "OC " + this.currentOrder.orderId;
            this.currentOrder.deliveryCompany = freight
                ? freight.deliveryCompany
                : this.currentOrder.deliveryCompany;
            this.currentOrder.freightId = freight
                ? freight.freightId
                : this.currentOrder.freightId;
            this.currentOrder.coupon = null;
            //this.currentOrder.freightAmount = freight.amount;
            this.currentOrder.deliveryCost = freight
                ? freight.amount
                : this.currentOrder.deliveryCost;
            this.currentOrder.productQuantity = this.storedItemsQuantity;
            this.currentOrder.subtotal = this.subtotal;
            this.currentOrder.tax = this.tax;
            this.currentOrder.discount = this.discount;
            this.currentOrder.total = this.total;
            this.currentOrder.deliveryDate = freight
                ? freight.deliveryDate
                : this.currentOrder.deliveryDate;
            this.currentOrder.paymentMethod = card
                ? card.issuer === "cash"
                    ? "efectivo"
                    : "tarjeta"
                : null;
            //Guarda los datos actuales de la orden
            this.orderService.modifyPurchaseOrder(this.currentOrder).subscribe((result) => {
                observer.next(this.currentOrder);
                observer.complete();
                //Error en caso de guardado
            }, (error) => {
                observer.next(null);
                observer.complete();
            });
        });
    }
    /**
     *
     * @param fixedAmount Especifica de manera fija el monto a cobrarle a la tarjeta. Si no se manda toma el calculado para la orden
     */
    checkoutOrderSinpe(kount, user) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Estructura de resultado
            let checkoutResult = {};
            checkoutResult.result = false;
            //Carga datos de sesion para todo el proceso
            this.currentOrder.userId = this.sessionManager.getPrincipal().userId;
            this.currentOrder.token = this.sessionManager.getToken();
            this.currentOrder.KountSession = kount;
            //Obtiene los datos seleccionados en el carrito
            let card = this.currentOrder.card;
            let freight = this.currentOrder.freight;
            this.currentOrder.amountToCharge = this.total;
            this.currentOrder.description = "OC " + this.currentOrder.orderId;
            this.currentOrder.deliveryCompany = this.currentOrder.forceFreightAsFree
                ? this.currentOrder.deliveryCompany
                : freight.deliveryCompany;
            this.currentOrder.freightId = this.currentOrder.forceFreightAsFree
                ? this.currentOrder.freightId
                : freight.freightId;
            this.currentOrder.deliveryCost = this.currentOrder.forceFreightAsFree
                ? 0
                : freight.amount;
            this.currentOrder.productQuantity = this.storedItemsQuantity;
            this.currentOrder.subtotal = this.subtotal;
            this.currentOrder.tax = this.tax;
            this.currentOrder.discount = this.discount;
            this.currentOrder.total = this.total;
            this.currentOrder.deliveryDate = this.currentOrder.forceFreightAsFree
                ? this.currentOrder.deliveryDate
                : freight.deliveryDate;
            this.currentOrder.paymentMethod =
                card.issuer === "cash"
                    ? "efectivo"
                    : card.issuer === "sinpe"
                        ? "sinpe"
                        : "tarjeta";
            this.currentOrder.confirmationDate = new Date().getTime();
            this.validateConsistencyOfDetails();
            //Valida que la orden venga consistente (con detalles
            if (!this.currentOrder.details ||
                this.currentOrder.details.length === 0) {
                this.addPurchaseLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (VALIDACION DETALLES SINPE)", this.currentOrder);
                checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES004_ERR;
                checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES004_ERR_MSG;
                observer.next(checkoutResult);
                observer.complete();
            }
            //Bitacora de datos
            this.addPurchaseLog("CARRITO " +
                this.currentOrder.orderId +
                " - CHECKOUT (GUARDADO INICIAL PROCESO SINPE)", this.currentOrder);
            //Guarda los datos actuales de la orden
            this.orderService.modifyPurchaseOrder(this.currentOrder).subscribe((result) => {
                //Bitacora de datos
                this.addPurchaseLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (GUARDADO INICIAL PROCESO: OK SINPE)", this.currentOrder);
                //Ejecuta el pago y guardado en firme
                this.performCheckoutSinpe(freight, card, user).subscribe((paymentResult) => {
                    checkoutResult = paymentResult;
                    observer.next(checkoutResult);
                    observer.complete();
                });
                //Error en caso de guardado
            }, (error) => {
                checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR;
                checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR_MSG;
                //Bitacora de datos
                this.addPurchaseLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (GUARDADO INICIAL PROCESO: ERROR SINPE)", this.currentOrder);
                //Bitacora de datos
                this.addLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (GUARDADO INICIAL PROCESO: ERROR SINPE)", JSON.stringify(error));
                observer.next(checkoutResult);
                observer.complete();
            });
        });
    }
    /**
     *
     * @param fixedAmount Especifica de manera fija el monto a cobrarle a la tarjeta. Si no se manda toma el calculado para la orden
     */
    checkoutOrder(kount, user) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Estructura de resultado
            let checkoutResult = {};
            checkoutResult.result = false;
            //Carga datos de sesion para todo el proceso
            this.currentOrder.userId = this.sessionManager.getPrincipal().userId;
            this.currentOrder.token = this.sessionManager.getToken();
            this.currentOrder.KountSession = kount;
            //Obtiene los datos seleccionados en el carrito
            let card = this.currentOrder.card;
            let freight = this.currentOrder.freight;
            this.currentOrder.amountToCharge = this.total;
            this.currentOrder.description = "OC " + this.currentOrder.orderId;
            this.currentOrder.deliveryCompany = this.currentOrder.forceFreightAsFree
                ? this.currentOrder.deliveryCompany
                : freight.deliveryCompany;
            this.currentOrder.freightId = this.currentOrder.forceFreightAsFree
                ? this.currentOrder.freightId
                : freight.freightId;
            this.currentOrder.deliveryCost = this.currentOrder.forceFreightAsFree
                ? 0
                : freight.amount;
            this.currentOrder.productQuantity = this.storedItemsQuantity;
            this.currentOrder.subtotal = this.subtotal;
            this.currentOrder.tax = this.tax;
            this.currentOrder.discount = this.discount;
            this.currentOrder.total = this.total;
            this.currentOrder.deliveryDate = this.currentOrder.forceFreightAsFree
                ? this.currentOrder.deliveryDate
                : freight.deliveryDate;
            this.currentOrder.paymentMethod =
                card.issuer === "cash"
                    ? "efectivo"
                    : card.issuer === "sinpe"
                        ? "sinpe"
                        : "tarjeta";
            this.currentOrder.confirmationDate = new Date().getTime();
            this.validateConsistencyOfDetails();
            //Valida que la orden venga consistente (con detalles
            if (!this.currentOrder.details ||
                this.currentOrder.details.length === 0) {
                this.addPurchaseLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (VALIDACION DETALLES)", this.currentOrder);
                checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES004_ERR;
                checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES004_ERR_MSG;
                observer.next(checkoutResult);
                observer.complete();
            }
            //Bitacora de datos
            this.addPurchaseLog("CARRITO " +
                this.currentOrder.orderId +
                " - CHECKOUT (GUARDADO INICIAL PROCESO)", this.currentOrder);
            //Guarda los datos actuales de la orden
            this.orderService.modifyPurchaseOrder(this.currentOrder).subscribe((result) => {
                //Bitacora de datos
                this.addPurchaseLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (GUARDADO INICIAL PROCESO: OK)", this.currentOrder);
                //Ejecuta el pago y guardado en firme
                this.performCheckout(freight, card, user).subscribe((paymentResult) => {
                    checkoutResult = paymentResult;
                    observer.next(checkoutResult);
                    observer.complete();
                });
                //Error en caso de guardado
            }, (error) => {
                checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR;
                checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR_MSG;
                //Bitacora de datos
                this.addPurchaseLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (GUARDADO INICIAL PROCESO: ERROR)", this.currentOrder);
                //Bitacora de datos
                this.addLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (GUARDADO INICIAL PROCESO: ERROR)", JSON.stringify(error));
                observer.next(checkoutResult);
                observer.complete();
            });
        });
    }
    performCheckoutSinpe(freight, card, user) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Estructura de resultado
            let checkoutResult = {};
            checkoutResult.result = false;
            //Consulta la informacion que se va a mandar a Greenpay
            this.orderService
                .getPurchaseOrderPaymentInfo(this.currentOrder)
                .subscribe((paymentInfo) => {
                if (paymentInfo) {
                    //Bitacora de datos
                    this.addPurchaseLog("CARRITO " +
                        this.currentOrder.orderId +
                        " - CHECKOUT (OCPAGO: OK)", paymentInfo);
                    //Datos del checkout
                    this.currentOrder.amountToCharge =
                        paymentInfo.amountToCharge && paymentInfo.amountToCharge > 0
                            ? paymentInfo.amountToCharge
                            : this.total;
                    this.currentOrder.description = paymentInfo.description;
                    this.currentOrder.deliveryCompany = this.currentOrder
                        .forceFreightAsFree
                        ? this.currentOrder.deliveryCompany
                        : freight.deliveryCompany;
                    this.currentOrder.freightId = this.currentOrder.forceFreightAsFree
                        ? this.currentOrder.freightId
                        : freight.freightId;
                    this.currentOrder.deliveryCost = this.currentOrder
                        .forceFreightAsFree
                        ? 0
                        : freight.amount;
                    this.currentOrder.productQuantity = this.storedItemsQuantity;
                    this.currentOrder.subtotal = this.subtotal;
                    this.currentOrder.tax = this.tax;
                    this.currentOrder.total = this.total;
                    this.currentOrder.deliveryDate = this.currentOrder
                        .forceFreightAsFree
                        ? this.currentOrder.deliveryDate
                        : freight.deliveryDate;
                    this.currentOrder.paymentMethod = "sinpe";
                    //card.issuer === "cash" ? "efectivo" : "tarjeta";
                    this.currentOrder.confirmationDate = new Date().getTime();
                    //Guarda los datos de la orden
                    this.addPurchaseLog("CARRITO " +
                        this.currentOrder.orderId +
                        " - CHECKOUT (CAMBIO DE ESTADO)", this.currentOrder);
                    this.currentOrder.paymentDone = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.defaultYES;
                    this.currentOrder.orderStatus = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].order.PROCESSING_STATUS;
                    this.orderService
                        .modifyPurchaseOrder(this.currentOrder)
                        .subscribe((result) => {
                        this.addPurchaseLog("CARRITO " +
                            this.currentOrder.orderId +
                            " - CHECKOUT (CAMBIO DE ESTADO: OK)", result);
                        checkoutResult.result = true;
                        observer.next(checkoutResult);
                        observer.complete();
                    }, (error) => {
                        this.addPurchaseLog("CARRITO " +
                            this.currentOrder.orderId +
                            " - CHECKOUT (CAMBIO DE ESTADO: ERROR)", this.currentOrder);
                        this.addLog("CARRITO " +
                            this.currentOrder.orderId +
                            " - CHECKOUT (CAMBIO DE ESTADO: ERROR)", JSON.stringify(error));
                        checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR;
                        checkoutResult.message =
                            __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR_MSG;
                        observer.next(checkoutResult);
                        observer.complete();
                    });
                }
                else {
                    //Bitacora de datos
                    this.addPurchaseLog("CARRITO " +
                        this.currentOrder.orderId +
                        " - CHECKOUT (OCPAGO: ERROR)", paymentInfo);
                    checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES002_ERR;
                    checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES002_ERR_MSG;
                    observer.next(checkoutResult);
                    observer.complete();
                }
            }, (error) => {
                checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES001_ERR;
                checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES001_ERR_MSG;
                this.addLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (OCPAGO: ERROR)", JSON.stringify(error));
                observer.next(checkoutResult);
                observer.complete();
            });
        });
    }
    performCheckout(freight, card, user) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            //Estructura de resultado
            let checkoutResult = {};
            checkoutResult.result = false;
            //Consulta la informacion que se va a mandar a Greenpay
            this.orderService
                .getPurchaseOrderPaymentInfo(this.currentOrder)
                .subscribe((paymentInfo) => {
                if (paymentInfo) {
                    //Bitacora de datos
                    this.addPurchaseLog("CARRITO " +
                        this.currentOrder.orderId +
                        " - CHECKOUT (OCPAGO: OK)", paymentInfo);
                    //Datos del checkout
                    this.currentOrder.amountToCharge =
                        paymentInfo.amountToCharge && paymentInfo.amountToCharge > 0
                            ? paymentInfo.amountToCharge
                            : this.total;
                    this.currentOrder.description = paymentInfo.description;
                    this.currentOrder.deliveryCompany = this.currentOrder
                        .forceFreightAsFree
                        ? this.currentOrder.deliveryCompany
                        : freight.deliveryCompany;
                    this.currentOrder.freightId = this.currentOrder.forceFreightAsFree
                        ? this.currentOrder.freightId
                        : freight.freightId;
                    this.currentOrder.deliveryCost = this.currentOrder
                        .forceFreightAsFree
                        ? 0
                        : freight.amount;
                    this.currentOrder.productQuantity = this.storedItemsQuantity;
                    this.currentOrder.subtotal = this.subtotal;
                    this.currentOrder.tax = this.tax;
                    this.currentOrder.total = this.total;
                    this.currentOrder.deliveryDate = this.currentOrder
                        .forceFreightAsFree
                        ? this.currentOrder.deliveryDate
                        : freight.deliveryDate;
                    this.currentOrder.paymentMethod =
                        card.issuer === "cash" ? "efectivo" : "tarjeta";
                    this.currentOrder.confirmationDate = new Date().getTime();
                    //Si es pago en efectivo omite el pago cont arjeta
                    if (card.issuer != "cash") {
                        //Procede con el checkout
                        this.checkoutService
                            .checkout(this.currentOrder, card, user)
                            .subscribe((paymentResult) => {
                            //Bitacora de datos
                            this.addLog("CARRITO " +
                                this.currentOrder.orderId +
                                " - CHECKOUT (RESULTADO GREENPAY)", JSON.stringify(paymentResult));
                            //Validacion del resultado contra GreenPay
                            if (paymentResult.orderId && paymentResult.authorization) {
                                //Guardado de autorizacion
                                this.currentOrder.paymentDone = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.defaultYES;
                                this.currentOrder.paymentAuthorization =
                                    paymentResult.authorization;
                                checkoutResult.orderId = paymentResult.orderId;
                                checkoutResult.authorization =
                                    paymentResult.authorization;
                                //Guarda los datos de la orden de pago
                                this.currentOrder.orderStatus =
                                    __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].order.PROCESSING_STATUS;
                                //Bitacora de datos
                                this.addPurchaseLog("CARRITO " +
                                    this.currentOrder.orderId +
                                    " - CHECKOUT (CAMBIO DE ESTADO)", this.currentOrder);
                                this.orderService
                                    .modifyPurchaseOrder(this.currentOrder)
                                    .subscribe((result) => {
                                    //Bitacora de datos
                                    this.addPurchaseLog("CARRITO " +
                                        this.currentOrder.orderId +
                                        " - CHECKOUT (CAMBIO DE ESTADO: OK)", result);
                                    checkoutResult.result = true;
                                    observer.next(checkoutResult);
                                    observer.complete();
                                }, (error) => {
                                    //Bitacora de datos
                                    this.addPurchaseLog("CARRITO " +
                                        this.currentOrder.orderId +
                                        " - CHECKOUT (CAMBIO DE ESTADO: ERROR)", this.currentOrder);
                                    this.addLog("CARRITO " +
                                        this.currentOrder.orderId +
                                        " - CHECKOUT (CAMBIO DE ESTADO: ERROR)", JSON.stringify(error));
                                    checkoutResult.error =
                                        __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR;
                                    checkoutResult.message =
                                        __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR_MSG;
                                    observer.next(checkoutResult);
                                    observer.complete();
                                });
                            }
                            else {
                                this.currentOrder.paymentDone = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.defaultNO;
                                checkoutResult.message = paymentResult.error
                                    ? paymentResult.error
                                    : "";
                                this.addLog("CARRITO " +
                                    this.currentOrder.orderId +
                                    " - CHECKOUT (GREENPAY)", JSON.stringify(checkoutResult));
                                observer.next(checkoutResult);
                                observer.complete();
                            }
                        });
                    }
                    else {
                        //Guarda los datos de la orden
                        this.addPurchaseLog("CARRITO " +
                            this.currentOrder.orderId +
                            " - CHECKOUT (CAMBIO DE ESTADO)", this.currentOrder);
                        this.currentOrder.paymentDone = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].app.defaultYES;
                        this.currentOrder.orderStatus =
                            __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].order.PROCESSING_STATUS;
                        this.orderService
                            .modifyPurchaseOrder(this.currentOrder)
                            .subscribe((result) => {
                            this.addPurchaseLog("CARRITO " +
                                this.currentOrder.orderId +
                                " - CHECKOUT (CAMBIO DE ESTADO: OK)", result);
                            checkoutResult.result = true;
                            observer.next(checkoutResult);
                            observer.complete();
                        }, (error) => {
                            this.addPurchaseLog("CARRITO " +
                                this.currentOrder.orderId +
                                " - CHECKOUT (CAMBIO DE ESTADO: ERROR)", this.currentOrder);
                            this.addLog("CARRITO " +
                                this.currentOrder.orderId +
                                " - CHECKOUT (CAMBIO DE ESTADO: ERROR)", JSON.stringify(error));
                            checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR;
                            checkoutResult.message =
                                __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES003_ERR_MSG;
                            observer.next(checkoutResult);
                            observer.complete();
                        });
                    }
                }
                else {
                    //Bitacora de datos
                    this.addPurchaseLog("CARRITO " +
                        this.currentOrder.orderId +
                        " - CHECKOUT (OCPAGO: ERROR)", paymentInfo);
                    checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES002_ERR;
                    checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES002_ERR_MSG;
                    observer.next(checkoutResult);
                    observer.complete();
                }
            }, (error) => {
                checkoutResult.error = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES001_ERR;
                checkoutResult.message = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].err.checkout.ES001_ERR_MSG;
                this.addLog("CARRITO " +
                    this.currentOrder.orderId +
                    " - CHECKOUT (OCPAGO: ERROR)", JSON.stringify(error));
                observer.next(checkoutResult);
                observer.complete();
            });
        });
    }
    fetchOrderDetails(order) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            order.userId = this.sessionManager.getPrincipal().userId;
            order.token = this.sessionManager.getToken();
            this.orderService.getPurchaseOrderDetail(order).subscribe((list) => {
                this.currentOrder.details = list;
                this.saveCartStoredItemsQuantity();
                observer.next(this.currentOrder.details);
                observer.complete();
            }, (error) => {
                observer.next([]);
                observer.complete();
            });
        });
    }
    getProductForDetail(detail) {
        let user = this.sessionManager.getPrincipal();
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            var param = {};
            param.userId = user ? user.userId : null;
            param.token = user ? user.token : null;
            param.article = detail.productCode;
            this.productService.getProduct(param).subscribe((product) => {
                observer.next({ detail: detail, product: product });
                observer.complete();
            });
        });
    }
    //Al entrar en el paso 1 del carrito ya está apartado el producto, no hace falta verificar de nuevo su disponibilidad
    // = cantidad = unidades disponibles
    getProductForDetailFixedQuantity(detail) {
        let user = this.sessionManager.getPrincipal();
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            var param = {};
            param.userId = user ? user.userId : null;
            param.token = user ? user.token : null;
            param.article = detail.productCode;
            this.productService.getProduct(param).subscribe((product) => {
                //se coloca la cantidad como unidades disponibles ya que estas cantidades ya están bloqueadas en la base de datos
                product.availableUnits = detail.quantity;
                detail.availableUnits = detail.quantity;
                var available = "N";
                if (detail.availableUnits > 0) {
                    available = "S";
                }
                product.isAvailable = available;
                observer.next({ detail: detail, product: product });
                observer.complete();
            });
        });
    }
    addOrUpdateDetail(product, quantity) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            var result = {};
            var orderDetail = null;
            var details = this.currentOrder.details;
            if (!details) {
                this.currentOrder.details = [];
                details = this.currentOrder.details;
            }
            for (let i = 0; i < details.length; i++) {
                if (product.productCode === details[i].productCode) {
                    orderDetail = details[i];
                    break;
                }
            }
            //Disponibilidad
            let availableUnitsInStock = product.availableUnits;
            result.unitsAvailable = availableUnitsInStock;
            //El producto ya se ha agregado al carrito?
            if (orderDetail) {
                let currentAddedUnits = orderDetail.quantity;
                let totalQuantityWanted = currentAddedUnits + quantity;
                //Hay disponible para cubrir todo
                if (totalQuantityWanted <= availableUnitsInStock) {
                    this.updateOrderDetailQuantity(orderDetail, product, totalQuantityWanted).subscribe((flag) => {
                        if (flag) {
                            result.result = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.RESULT_ALL_ADDED;
                            result.unitsAdded = quantity;
                            result.unitsPending = 0;
                            result.itemAlreadyInCar = totalQuantityWanted;
                        }
                        else {
                            result.result = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.RESULT_ERROR;
                        }
                        result.action = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.ITEM_UPDATED;
                        observer.next(result);
                        observer.complete();
                    });
                    //No hay disponible para cubrir todo
                }
                else if (totalQuantityWanted > availableUnitsInStock) {
                    //Si no hay unidades del todo, no deja
                    result.result = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.RESULT_NOT_AVAILABLE;
                    result.action = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.ITEM_UPDATED;
                    observer.next(result);
                    observer.complete();
                }
                //Producto no existe en el carrito
            }
            else {
                if (quantity <= availableUnitsInStock) {
                    this.addOrderDetail(product, quantity).subscribe((flag) => {
                        if (flag) {
                            result.result = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.RESULT_ALL_ADDED;
                            result.unitsAdded = quantity;
                            result.unitsPending = 0;
                        }
                        else {
                            result.result = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.RESULT_ERROR;
                        }
                        result.action = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.ITEM_INSERTED;
                        observer.next(result);
                        observer.complete();
                    });
                }
                else if (quantity > availableUnitsInStock) {
                    result.result = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.RESULT_NOT_AVAILABLE;
                    result.action = __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.ITEM_INSERTED;
                    observer.next(result);
                    observer.complete();
                }
            }
        });
    }
    findOrderDetailForProduct(product) {
        var orderDetail = null;
        var details = this.currentOrder.details;
        if (!details) {
            this.currentOrder.details = [];
            details = this.currentOrder.details;
        }
        for (let i = 0; i < details.length; i++) {
            if (product.productCode === details[i].productCode) {
                orderDetail = details[i];
                break;
            }
        }
        return orderDetail;
    }
    /*private trackNotAvailableProduct(product: Product, requestQuantity: number){
          var params : ProductWithNotAvailable = {};
          params.userId = this.sessionManager.getPrincipal().userId;
          params.token = this.sessionManager.getToken();
          params.article = product.productCode;
          params.requestedQuantity = requestQuantity;
          params.availableQuantity = product.availableUnits;
  
          this.productService.registerProductWithoutAvailable(params).subscribe((result: ProductWithNotAvailable) => {
  
          },
          error => {
  
          });
    }*/
    addOrderDetail(product, quantity) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            var orderDetail = {};
            orderDetail.userId = this.sessionManager.getPrincipal().userId;
            orderDetail.token = this.sessionManager.getToken();
            orderDetail.orderId = this.currentOrder.orderId;
            orderDetail.productCode = product.productCode;
            orderDetail.sequence = this.currentOrder.details
                ? this.currentOrder.details.length + 1
                : 1;
            orderDetail.quantity = quantity;
            orderDetail.price = product.priceWithNoTax ? product.priceWithNoTax : 0; //Precio sin impuesto
            orderDetail.subtotal = orderDetail.price * quantity;
            //orderDetail.discount = (product.discountPercentage ? product.discountPercentage : 0);
            orderDetail.tax = product.tax ? product.tax * quantity : 0;
            orderDetail.totalLine = orderDetail.subtotal + orderDetail.tax;
            //Redondeo de montos
            orderDetail.discount = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(orderDetail.discount);
            orderDetail.subtotal = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(orderDetail.subtotal);
            orderDetail.totalLine = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(orderDetail.totalLine);
            orderDetail.relatedProduct = product;
            this.orderService.addPurchaseOrderDetail(orderDetail).subscribe((result) => {
                if (result.status && result.status > 0) {
                    observer.next(false);
                    observer.complete();
                }
                else {
                    this.currentOrder.details.push(orderDetail);
                    this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_CART_LIST);
                    this.saveCartStoredItemsQuantity();
                    observer.next(true);
                    observer.complete();
                }
            }, (error) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    updateOrderDetailQuantity(detail, product, quantity) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            detail.userId = this.sessionManager.getPrincipal().userId;
            detail.token = this.sessionManager.getToken();
            detail.orderId = this.currentOrder.orderId;
            detail.quantity = quantity;
            detail.price = product.priceWithNoTax ? product.priceWithNoTax : 0; //Precio sin impuesto
            detail.subtotal = detail.price * quantity;
            //detail.discount = (product.discountPercentage ? product.discountPercentage : 0);
            detail.tax = product.tax ? product.tax * quantity : 0;
            detail.totalLine = detail.subtotal + detail.tax;
            //Redondeo de montos
            detail.discount = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(detail.discount);
            detail.subtotal = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(detail.subtotal);
            detail.totalLine = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(detail.totalLine);
            detail.relatedProduct = product;
            this.orderService.modifyPurchaseOrderDetail(detail).subscribe((result) => {
                if (result.status && result.status > 0) {
                    observer.next(false);
                    observer.complete();
                }
                else {
                    observer.next(true);
                    observer.complete();
                }
            }, (error) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    updateOrderDetail(detail) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            this.orderService.modifyPurchaseOrderDetail(detail).subscribe((result) => {
                if (result.status && result.status > 0) {
                    //Si hubo un error
                    observer.next(false);
                    observer.complete();
                }
                else {
                    observer.next(true);
                    observer.complete();
                }
            }, (error) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    removeOrderDetail(detail) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            this.orderService.deleteProductPurchaseOrder(detail).subscribe((result) => {
                if (result.status && result.status > 0) {
                    observer.next(false);
                    observer.complete();
                }
                else {
                    if (this.currentOrder.details.length > 0) {
                        this.currentOrder.details.forEach((item, index) => {
                            if (item.productCode === detail.productCode)
                                this.currentOrder.details.splice(index, 1);
                        });
                        this.saveCartStoredItemsQuantity();
                        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_CART_LIST);
                    }
                    observer.next(true);
                    observer.complete();
                }
            }, (error) => {
                observer.next(false);
                observer.complete();
            });
        });
    }
    saveQuantityForDetailInSession(detail) {
        if (detail.relatedProduct) {
            //Actualiza precios e impuesto del producto original
            detail.price = detail.relatedProduct.priceWithNoTax
                ? detail.relatedProduct.priceWithNoTax
                : 0; //Precio sin impuesto
            detail.tax = detail.relatedProduct.tax
                ? detail.relatedProduct.tax * detail.quantity
                : 0;
        }
        detail.subtotal = detail.price * detail.quantity;
        detail.totalLine = detail.subtotal + detail.tax;
    }
    //Actualiza la informacion de los detalles
    saveDetailState(callback) {
        if (this.currentOrder &&
            this.currentOrder.details &&
            this.currentOrder.details.length > 0) {
            var details = this.currentOrder.details;
            if (!details) {
                this.currentOrder.details = [];
                details = this.currentOrder.details;
            }
            let observables = [];
            for (let i = 0; i < details.length; i++) {
                var detail = details[i];
                //Valida que lo que se vaya a comprar este en stock
                //Entonces si el producto actualmente tiene un disponible que es inferior a lo del carrito
                //le pone lo que hay en stock.
                let stockProduct = detail.relatedProduct;
                if (stockProduct.availableUnits < detail.quantity) {
                    detail.quantity = stockProduct.availableUnits;
                }
                /////////////////////////////////////////////////////////////////////////
                //Consolidacion de precios
                //Actualiza los precios nuevamente basado en las cantidades
                detail.price = stockProduct.priceWithNoTax
                    ? stockProduct.priceWithNoTax
                    : 0; //Precio sin impuesto
                detail.subtotal = detail.price * detail.quantity;
                //detail.discount = (stockProduct.discountPercentage ? stockProduct.discountPercentage : 0);
                detail.tax = stockProduct.tax ? stockProduct.tax * detail.quantity : 0;
                detail.totalLine = detail.subtotal + detail.tax;
                //Redondeo de montos
                detail.discount = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(detail.discount);
                detail.subtotal = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(detail.subtotal);
                detail.totalLine = __WEBPACK_IMPORTED_MODULE_8__util_number_utils__["a" /* NumberUtils */].roundWithPrecision(detail.totalLine);
                /////////////////////////////////////////////////////////////////////////
                detail.userId = this.sessionManager.getPrincipal().userId;
                detail.token = this.sessionManager.getToken();
                detail.orderId = this.currentOrder.orderId;
                observables.push(this.updateOrderDetail(detail));
            }
            __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"].forkJoin(observables).subscribe((result) => {
                if (callback)
                    callback();
            });
        }
        else {
            if (callback)
                callback();
        }
    }
    //Congela las cantidades relacionadas a los detalles
    lockDetailState(callback) {
        if (this.currentOrder.details && this.currentOrder.details.length > 0) {
            let observables = [];
            for (let i = 0; i < this.currentOrder.details.length; i++) {
                var detail = this.currentOrder.details[i];
                //Valida que lo que se vaya a comprar este en stock
                //Entonces si el producto actualmente tiene un disponible que es inferior a lo del carrito
                //le pone lo que hay en stock.
                let stockProduct = detail.relatedProduct;
                if (stockProduct.availableUnits < detail.quantity) {
                    detail.quantity = stockProduct.availableUnits;
                }
                detail.userId = this.sessionManager.getPrincipal().userId;
                detail.token = this.sessionManager.getToken();
                detail.orderId = this.currentOrder.orderId;
                observables.push(this.orderService.lockPurchaseOrderDetail(detail));
            }
            __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"].forkJoin(observables).subscribe((result) => {
                let list = [];
                for (var i = 0; i < result.length; i++) {
                    var lockedProduct = result[i];
                    if (lockedProduct && lockedProduct.status == 0) {
                        list.push(lockedProduct);
                    }
                }
                if (callback)
                    callback(list);
            });
        }
        else {
            if (callback)
                callback();
        }
    }
    //Libera las cantidades bloqueadas relacionadas a los detalles
    //de la orden que se cancela
    releaseDetailState(callback) {
        return this.releaseCustomDetailState(this.currentOrder.details, callback);
    }
    releaseCustomDetailState(reserved, callback) {
        if (reserved && reserved.length > 0) {
            let observables = [];
            for (let i = 0; i < reserved.length; i++) {
                var detail = reserved[i];
                detail.userId = this.sessionManager.getPrincipal().userId;
                detail.token = this.sessionManager.getToken();
                detail.orderId = this.currentOrder.orderId;
                observables.push(this.orderService.releasePurchaseOrderDetail(detail));
                //observables.push(this.orderService.releasePurchaseOrderDetailViaNative(detail));
            }
            __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"].forkJoin(observables).subscribe((result) => {
                let list = [];
                for (var i = 0; i < result.length; i++) {
                    var releasedProduct = result[i];
                    if (releasedProduct && releasedProduct.status == 0) {
                        list.push(releasedProduct);
                    }
                }
                if (callback)
                    callback(list);
            });
        }
        else {
            if (callback)
                callback();
        }
    }
    //Libera las cantidades bloqueadas relacionadas a los detalles
    //de la orden que se cancela
    releaseDetailStateNative(callback) {
        if (this.currentOrder.details && this.currentOrder.details.length > 0) {
            let observables = [];
            for (let i = 0; i < this.currentOrder.details.length; i++) {
                var detail = this.currentOrder.details[i];
                //Valida que lo que se vaya a comprar este en stock
                //Entonces si el producto actualmente tiene un disponible que es inferior a lo del carrito
                //le pone lo que hay en stock.
                let stockProduct = detail.relatedProduct;
                if (stockProduct.availableUnits < detail.quantity) {
                    detail.quantity = stockProduct.availableUnits;
                }
                detail.userId = this.sessionManager.getPrincipal().userId;
                detail.token = this.sessionManager.getToken();
                detail.orderId = this.currentOrder.orderId;
                observables.push(this.orderService.releasePurchaseOrderDetailViaNative(detail));
            }
            __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"].forkJoin(observables).subscribe((result) => {
                if (callback)
                    callback();
            });
        }
        else {
            if (callback)
                callback();
        }
    }
    //Realiza las operaciones del inicio de la compra
    startPurchase(callback) {
        this.sessionManager.setCheckoutProcessStarted(true);
        //Bloquea las cantidades del pedido y arranca el timer del carrito
        this.lockDetailState((acceptedProducts) => {
            let acceptedLength = acceptedProducts ? acceptedProducts.length : 0;
            let currentOrderDetailLength = this.currentOrder.details
                ? this.currentOrder.details.length
                : 0;
            //Todos los productos se pudieron bloquear
            if (acceptedLength === currentOrderDetailLength) {
                //Guardar las cantidades especificadas, en el caso de que haya cambio
                this.saveDetailState(() => {
                    setTimeout(() => {
                        let params = {
                            fb_content_id: "Orden de Campra " + this.currentOrder.orderId,
                            fb_content_type: "Carrito",
                            fb_num_items: this.currentOrder.productQuantity,
                            fb_payment_info_available: "1",
                        };
                        this.facebook
                            .logEvent("fb_mobile_initiated_checkout", params)
                            .then(() => { })
                            .catch((e) => console.log(e));
                    }, 1000);
                    //Inicia el timer del carrito
                    this.startTimer();
                    if (callback)
                        callback(true, true, acceptedProducts);
                });
            }
            else {
                //Procedo cancelado, pero mantiene los reservados esperando respuesta del usuario
                let hasAvailableToPurchase = acceptedLength > 0 && currentOrderDetailLength - acceptedLength > 0;
                if (callback)
                    callback(false, hasAvailableToPurchase, acceptedProducts);
            }
        });
    }
    proceedPurchase(callback) {
        //Guardar las cantidades especificadas, en el caso de que haya cambio
        this.saveDetailState(() => {
            //Inicia el timer del carrito
            this.startTimer();
            if (callback)
                callback();
        });
    }
    cancelPurchase(acceptedProducts, callback) {
        //Guardar las cantidades especificadas, en el caso de que haya cambio
        this.releaseCustomDetailState(acceptedProducts, () => {
            if (callback)
                callback();
        });
    }
    handleTimerExpiration(/*callback, */ timeoutCallback) {
        this.clearTimer();
        //Libera productos bloqueados para la orden
        this.sessionManager.setCheckoutProcessStarted(false);
        this.releaseDetailState();
        this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_PURCHASE_TIMER_EXPIRED_ACTION_TIMEOUT);
        //Activa cambios de navegacion del llamador
        if (timeoutCallback)
            timeoutCallback();
    }
    stopPurchase(callback) {
        this.sessionManager.setCheckoutProcessStarted(false);
        this.clearTimer();
        this.releaseDetailState(() => {
            if (callback)
                callback();
        });
    }
    /*****************************************************************
     * Manejo del timer para los tiempos de vigencia del carrito
     *****************************************************************/
    startTimer() {
        this.clearTimer();
        //Fecha actual mas N minutos configurados
        let topTimeToPurchase = new Date(new Date().getTime() + __WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.CART_TIMER_MINUTES * 60000);
        //Iniciar el timer
        this.timerId = Number(setInterval(() => {
            var now = new Date().getTime();
            var distance = topTimeToPurchase.getTime() - now;
            // Time calculations for days, hours, minutes and seconds
            //var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
            var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
            var seconds = Math.floor((distance % (1000 * 60)) / 1000);
            this.cartPurchaseTime =
                (minutes < 10 ? "0" + minutes : minutes) +
                    ":" +
                    (seconds < 10 ? "0" + seconds : seconds);
            if (distance < 0) {
                this.cartPurchaseTime = "00:00";
            }
            this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_PURCHASE_TIMER_EXECUTING, this.cartPurchaseTime);
            //Tiempo de compra ha expirado
            if (this.cartPurchaseTime === "00:00") {
                this.clearTimer(true);
                this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_PURCHASE_TIMER_EXPIRED, this.cartPurchaseTime);
            }
        }, 1000));
    }
    clearTimer(skipEventDispatching) {
        this.cartPurchaseTime = "00:00";
        if (!skipEventDispatching) {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_PURCHASE_TIMER_RESET);
        }
        //Resetea el timer
        if (this.timerId) {
            clearInterval(this.timerId);
        }
    }
    getTimerState() {
        return this.cartPurchaseTime;
    }
    applyCoupon(cupon) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            cupon.userId = this.sessionManager.getPrincipal().userId;
            cupon.token = this.sessionManager.getToken();
            this.orderService.applyCoupon(cupon).subscribe((data) => {
                //El cupon es correcto y fue aplicado
                if (data && data.status === 0) {
                    data.couponApplied = true;
                    this.fetchOrderWithCoupon().subscribe((order) => {
                        order.couponApplied = true;
                        observer.next(order);
                        observer.complete();
                    });
                }
                else {
                    data.couponApplied = false;
                    observer.next(data);
                    observer.complete();
                }
            }, (error) => {
                observer.next(null);
                observer.complete();
            });
        });
    }
    fetchOrderWithCoupon() {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"]((observer) => {
            this.fetchPendingOrder().subscribe((order) => {
                if (order) {
                    this.currentOrder = order;
                    this.fetchOrderDetails(this.currentOrder).subscribe((list) => {
                        observer.next(this.currentOrder);
                        observer.complete();
                    });
                }
            });
        });
    }
    setCashPaymentRegistered(cashPaymentRegistered) {
        this.cashPaymentRegistered = cashPaymentRegistered;
    }
    isCashPaymentRegistered() {
        return this.cashPaymentRegistered;
    }
    setSinpePaymentRegistered(sinpePaymentRegistered) {
        this.sinpePaymentRegistered = sinpePaymentRegistered;
    }
    isSinpePaymentRegistered() {
        return this.sinpePaymentRegistered;
    }
    /** Se ejecuta cuando la app retoma foco y tiene el control total del proceso de carrito */
    checkForCheckoutProcessOnResume() {
        if (this.sessionManager.isCheckoutProcessStarted()) {
            this.fetchPendingOrder().subscribe((order) => {
                if (order) {
                    if (order.expired === "S") {
                        this.sessionManager.setCheckoutProcessStarted(false);
                        this.clearTimer();
                        //los productos ya fueron liberados por el backend, por lo que no hay necesidad de realizar manualmente el proceso
                        if (this.expirationCallback) {
                            this.expirationCallback(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].cart.TIMER_BACKEND_EXPIRATION_ACTION_TIMEOUT);
                        }
                    }
                }
            });
        }
    }
    addLog(functionality, message) {
        try {
            this.orderService.addSimpleLog(functionality, message).subscribe();
        }
        catch (e) {
            console.log(e);
        }
    }
    addPurchaseLog(functionality, order) {
        try {
            this.orderService.addPurchaseLog(functionality, order).subscribe();
        }
        catch (e) {
            console.log(e);
        }
    }
    // Elimina los items inconsistentes o que tiene cantidad 0
    validateConsistencyOfDetails() {
        if (this.currentOrder.details && this.currentOrder.details.length > 0) {
            let itemsToRemove = [];
            for (let i = 0; i < this.currentOrder.details.length; i++) {
                var item = this.currentOrder.details[i];
                if (item.quantity < 1) {
                    itemsToRemove.push(i);
                }
                //Verifica que no se encuentre duplicado, en el caso que se encuentre duplicado
                // lo marca para eliminar el item.
                /*for(let j = 0; j < this.currentOrder.details.length; j++) {
                  var subitem : PurchaseOrderDetail = this.currentOrder.details[i];
                  if(item.productCode === subitem.productCode) {
                    // Unifica las cantidades
                    item.quantity = (item.quantity + subitem.quantity);
                    itemsToRemove.push(j);
                  }
                }*/
            }
            if (itemsToRemove.length > 0) {
                for (var i = itemsToRemove.length - 1; i >= 0; i--) {
                    this.currentOrder.details.splice(itemsToRemove[i], 1);
                }
            }
        }
    }
};
CartManagerService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__purchase_order_service__["a" /* PurchaseOrderService */],
        __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_10__ionic_native_facebook__["a" /* Facebook */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */],
        __WEBPACK_IMPORTED_MODULE_7__core_provider_greenpay_checkout_service__["a" /* GreenPayCheckoutService */],
        __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["Events"]])
], CartManagerService);

//# sourceMappingURL=cart-manager-service.js.map

/***/ }),

/***/ 666:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Startup; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__modules_session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_session_session_datasets_product_category_dataset_service__ = __webpack_require__(667);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_session_session_datasets_delivery_address_dataset_service__ = __webpack_require__(668);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_session_session_datasets_payment_option_dataset_service__ = __webpack_require__(669);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_session_session_datasets_product_category_user_dataset_service__ = __webpack_require__(670);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_session_session_datasets_wishlist_dataset_service__ = __webpack_require__(671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_session_session_datasets_product_attribute_dataset_service__ = __webpack_require__(672);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_session_session_datasets_home_section_dataset_service__ = __webpack_require__(673);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};









let Startup = class Startup {
    constructor(sessionManager, deliveryAddressDataSet, paymentOptionDataSet, categoryDataSet, userCategoryDataSet, wishlistDataSet, attributeDataSet, homeSectionDataSet) {
        this.sessionManager = sessionManager;
        this.deliveryAddressDataSet = deliveryAddressDataSet;
        this.paymentOptionDataSet = paymentOptionDataSet;
        this.categoryDataSet = categoryDataSet;
        this.userCategoryDataSet = userCategoryDataSet;
        this.wishlistDataSet = wishlistDataSet;
        this.attributeDataSet = attributeDataSet;
        this.homeSectionDataSet = homeSectionDataSet;
    }
    onStart() {
        return __awaiter(this, void 0, void 0, function* () {
            //Registra catalogos de datos que van a estar disponibles en el cache
            this.sessionManager.registerDataSet(this.deliveryAddressDataSet);
            this.sessionManager.registerDataSet(this.paymentOptionDataSet);
            this.sessionManager.registerDataSet(this.categoryDataSet);
            this.sessionManager.registerDataSet(this.userCategoryDataSet);
            this.sessionManager.registerDataSet(this.wishlistDataSet);
            this.sessionManager.registerDataSet(this.attributeDataSet);
            this.sessionManager.registerDataSet(this.homeSectionDataSet);
        });
    }
};
Startup = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__modules_session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_3__modules_session_session_datasets_delivery_address_dataset_service__["a" /* DeliveryAddressSessionDataSetService */],
        __WEBPACK_IMPORTED_MODULE_4__modules_session_session_datasets_payment_option_dataset_service__["a" /* PaymentOptionSessionDataSetService */],
        __WEBPACK_IMPORTED_MODULE_2__modules_session_session_datasets_product_category_dataset_service__["a" /* ProductCategorySessionDataSetService */],
        __WEBPACK_IMPORTED_MODULE_5__modules_session_session_datasets_product_category_user_dataset_service__["a" /* ProductUserCategorySessionDataSetService */],
        __WEBPACK_IMPORTED_MODULE_6__modules_session_session_datasets_wishlist_dataset_service__["a" /* WishlistSessionDataSetService */],
        __WEBPACK_IMPORTED_MODULE_7__modules_session_session_datasets_product_attribute_dataset_service__["a" /* ProductAttributeSessionDataSetService */],
        __WEBPACK_IMPORTED_MODULE_8__modules_session_session_datasets_home_section_dataset_service__["a" /* HomeSectionSessionDataSetService */]])
], Startup);

//# sourceMappingURL=startup.js.map

/***/ }),

/***/ 667:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductCategorySessionDataSetService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_category_service__ = __webpack_require__(117);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let ProductCategorySessionDataSetService = class ProductCategorySessionDataSetService extends __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__["a" /* SessionDataSet */] {
    constructor(sessionManager, 
        //private errHandler: ErrorService,
        categoryService) {
        super();
        this.sessionManager = sessionManager;
        this.categoryService = categoryService;
    }
    getId() {
        return __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.PRODUCT_CATEGORY;
    }
    getDataSet(forceReload) {
        return this.getProductCategories(forceReload);
    }
    clearDataSet() {
        console.log("Session Reset! Limpiando... " + this.getId());
        this.sessionManager.getSession().removeItem(this.getId()).subscribe();
    }
    getProductCategories(forceReload) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (forceReload) {
                this.refreshProductCategories().subscribe((list) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }
            else {
                this.sessionManager.getSession().getItem(this.getId()).subscribe((list) => {
                    if (list && list.length > 0) {
                        observer.next(list);
                        observer.complete();
                    }
                    else {
                        this.refreshProductCategories().subscribe((list) => {
                            observer.next(list);
                            observer.complete();
                        }, error => {
                            observer.error(error);
                        });
                    }
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
    refreshProductCategories() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.categoryService.getCategories(this.sessionManager.getSession().toModel()).subscribe((list) => {
                this.sessionManager.getSession().storeItem(this.getId(), list).subscribe((flag) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }, error => {
                observer.error(error);
            });
        });
    }
};
ProductCategorySessionDataSetService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_category_service__["a" /* ProductCategoryService */]])
], ProductCategorySessionDataSetService);

//# sourceMappingURL=product-category-dataset-service.js.map

/***/ }),

/***/ 668:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeliveryAddressSessionDataSetService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__profile_providers_address_service__ = __webpack_require__(278);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let DeliveryAddressSessionDataSetService = class DeliveryAddressSessionDataSetService extends __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__["a" /* SessionDataSet */] {
    constructor(sessionManager, 
        //private errHandler: ErrorService,
        addressService) {
        super();
        this.sessionManager = sessionManager;
        this.addressService = addressService;
    }
    getId() {
        return __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.DELIVERY_ADDRESS;
    }
    getDataSet(forceReload) {
        return this.getDeliveryAddress(forceReload);
    }
    clearDataSet() {
        console.log("Session Reset! Limpiando... " + this.getId());
        this.sessionManager.getSession().removeItem(this.getId()).subscribe();
    }
    //Obtencion del catalogo de direcciones
    getDeliveryAddress(forceReload) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (forceReload) {
                this.refreshDeliveryAddress().subscribe((list) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }
            else {
                this.sessionManager.getSession().getItem(this.getId()).subscribe((list) => {
                    if (list && list.length > 0) {
                        observer.next(list);
                        observer.complete();
                    }
                    else {
                        this.refreshDeliveryAddress().subscribe((list) => {
                            observer.next(list);
                            observer.complete();
                        }, error => {
                            observer.error(error);
                        });
                    }
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
    //Refrescado del catalogo direcciones
    refreshDeliveryAddress() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.addressService.getShippingAddress(this.sessionManager.getSession().toModel()).subscribe((list) => {
                this.sessionManager.getSession().storeItem(this.getId(), list).subscribe((flag) => {
                    observer.next(list);
                    observer.complete();
                });
            }, error => {
                observer.error(error);
            });
        });
    }
};
DeliveryAddressSessionDataSetService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__profile_providers_address_service__["a" /* AddressService */]])
], DeliveryAddressSessionDataSetService);

//# sourceMappingURL=delivery-address-dataset-service.js.map

/***/ }),

/***/ 669:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PaymentOptionSessionDataSetService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__profile_providers_card_service__ = __webpack_require__(275);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ngx_translate_core__ = __webpack_require__(42);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let PaymentOptionSessionDataSetService = class PaymentOptionSessionDataSetService extends __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__["a" /* SessionDataSet */] {
    constructor(sessionManager, 
        //private errHandler: ErrorService,
        cardService, translate) {
        super();
        this.sessionManager = sessionManager;
        this.cardService = cardService;
        this.translate = translate;
    }
    getId() {
        return __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.PAYMENT_OPTION;
    }
    getDataSet(forceReload) {
        return this.getPaymentOptions(forceReload);
    }
    clearDataSet() {
        console.log("Session Reset! Limpiando... " + this.getId());
        this.sessionManager.getSession().removeItem(this.getId()).subscribe();
    }
    //Obtencion del catalogo de direcciones
    getPaymentOptions(forceReload) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"]((observer) => {
            if (forceReload) {
                this.refreshPaymentOptions().subscribe((list) => {
                    observer.next(list);
                    observer.complete();
                }, (error) => {
                    observer.error(error);
                });
            }
            else {
                this.sessionManager
                    .getSession()
                    .getItem(this.getId())
                    .subscribe((list) => {
                    if (list && list.length > 0) {
                        observer.next(list);
                        observer.complete();
                    }
                    else {
                        this.refreshPaymentOptions().subscribe((list) => {
                            observer.next(list);
                            observer.complete();
                        }, (error) => {
                            observer.error(error);
                        });
                    }
                }, (error) => {
                    observer.error(error);
                });
            }
        });
    }
    //Refrescado del catalogo direcciones
    refreshPaymentOptions() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"]((observer) => {
            //Consulta todas las tarjetas de ccredito
            this.cardService
                .getCards(this.sessionManager.getSession().toModel())
                .subscribe((list) => {
                if (list && list.length > 0) {
                    var cardList = list;
                    for (var i = 0; i < cardList.length; i++) {
                        var currentCard = cardList[i];
                        if (currentCard.issuer === "cash") {
                            currentCard.cardNumberMask =
                                this.translate.instant("paymentMethod.cash");
                            currentCard.description = this.translate.instant("paymentMethod.cashLabel");
                        }
                        else if (currentCard.issuer === "sinpe") {
                            currentCard.cardNumberMask = this.translate.instant("paymentMethod.sinpe");
                            currentCard.description = this.translate.instant("paymentMethod.sinpeLabel");
                        }
                        else {
                            /*currentCard.cardNumberMask = currentCard.cardNumber.replace(/\d(?=\d{4})/g, "*");
                                          var segments = currentCard.cardNumberMask.match(/.{1,4}/g);
                                          currentCard.cardNumberMask = segments.join(" ");*/
                            currentCard.cardNumberMask =
                                "XXXX-XXXX-XXXX-" + currentCard.cardNumber;
                            currentCard.description = this.translate.instant("paymentMethod.creditCard");
                            if (currentCard.issuer) {
                                if (currentCard.issuer.toLocaleLowerCase().indexOf("visa") >
                                    -1) {
                                    currentCard.logo = "assets/images/payment/visa-logo.png";
                                }
                                else if (currentCard.issuer.toLocaleLowerCase().indexOf("master") >
                                    -1) {
                                    currentCard.logo =
                                        "assets/images/payment/mastercard-logo.png";
                                }
                            }
                        }
                    }
                }
                this.sessionManager
                    .getSession()
                    .storeItem(this.getId(), list)
                    .subscribe((flag) => {
                    observer.next(list);
                    observer.complete();
                });
            }, (error) => {
                observer.error(error);
            });
        });
    }
};
PaymentOptionSessionDataSetService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__profile_providers_card_service__["a" /* CardService */],
        __WEBPACK_IMPORTED_MODULE_6__ngx_translate_core__["c" /* TranslateService */]])
], PaymentOptionSessionDataSetService);

//# sourceMappingURL=payment-option-dataset-service.js.map

/***/ }),

/***/ 670:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductUserCategorySessionDataSetService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_category_service__ = __webpack_require__(117);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let ProductUserCategorySessionDataSetService = class ProductUserCategorySessionDataSetService extends __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__["a" /* SessionDataSet */] {
    constructor(sessionManager, 
        //private errHandler: ErrorService,
        categoryService) {
        super();
        this.sessionManager = sessionManager;
        this.categoryService = categoryService;
    }
    getId() {
        return __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.USER_PRODUCT_CATEGORY;
    }
    getDataSet(forceReload) {
        return this.getUserProductCategories(forceReload);
    }
    clearDataSet() {
        console.log("Session Reset! Limpiando... " + this.getId());
        this.sessionManager.getSession().removeItem(this.getId()).subscribe();
    }
    //Obtencion del catalogo de sesion de categorias de productos delusuario
    getUserProductCategories(forceReload) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (forceReload) {
                this.refreshUserProductCategories().subscribe((list) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }
            else {
                this.sessionManager.getSession().getItem(this.getId()).subscribe((list) => {
                    if (list && list.length > 0) {
                        observer.next(list);
                        observer.complete();
                    }
                    else {
                        this.refreshUserProductCategories().subscribe((list) => {
                            observer.next(list);
                            observer.complete();
                        }, error => {
                            observer.error(error);
                        });
                    }
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
    //Refrescado del catalogo de sesion de categorias de productos delusuario
    refreshUserProductCategories() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.categoryService.getUserCategories(this.sessionManager.getSession().toModel()).subscribe((list) => {
                this.sessionManager.getSession().storeItem(this.getId(), list).subscribe((flag) => {
                    observer.next(list);
                    observer.complete();
                });
            }, error => {
                observer.error(error);
            });
        });
    }
};
ProductUserCategorySessionDataSetService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_category_service__["a" /* ProductCategoryService */]])
], ProductUserCategorySessionDataSetService);

//# sourceMappingURL=product-category-user-dataset-service.js.map

/***/ }),

/***/ 671:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WishlistSessionDataSetService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_wishlist_wish_list_service__ = __webpack_require__(115);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let WishlistSessionDataSetService = class WishlistSessionDataSetService extends __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__["a" /* SessionDataSet */] {
    constructor(sessionManager, 
        //private errHandler: ErrorService,
        wishListService) {
        super();
        this.sessionManager = sessionManager;
        this.wishListService = wishListService;
    }
    getId() {
        return __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.WISH_LIST;
    }
    getDataSet(forceReload) {
        return this.getWishLists(forceReload);
    }
    clearDataSet() {
        this.sessionManager.getSession().removeItem(this.getId()).subscribe();
    }
    //Obtencion del catalogo de listas de deseos
    getWishLists(forceReload) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (forceReload) {
                this.refreshWishLists().subscribe((list) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                    ;
                });
            }
            else {
                this.sessionManager.getSession().getItem(this.getId()).subscribe((list) => {
                    if (list && list.length > 0) {
                        observer.next(list);
                        observer.complete();
                    }
                    else {
                        this.refreshWishLists().subscribe((list) => {
                            observer.next(list);
                            observer.complete();
                        }, error => {
                            observer.error(error);
                            ;
                        });
                    }
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
    //Refrescado del catalogo de listas de deseos
    refreshWishLists() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var params = {};
            params.userId = this.sessionManager.getPrincipal().userId;
            params.token = this.sessionManager.getToken();
            params.pageId = 1;
            params.pageRows = 100;
            this.wishListService.getWhishList(params).subscribe((list) => {
                this.sessionManager.getSession().storeItem(this.getId(), list).subscribe((flag) => {
                    observer.next(list);
                    observer.complete();
                });
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
};
WishlistSessionDataSetService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_wishlist_wish_list_service__["a" /* WishListService */]])
], WishlistSessionDataSetService);

//# sourceMappingURL=wishlist-dataset-service.js.map

/***/ }),

/***/ 672:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductAttributeSessionDataSetService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let ProductAttributeSessionDataSetService = class ProductAttributeSessionDataSetService extends __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__["a" /* SessionDataSet */] {
    constructor(sessionManager, 
        //private errHandler: ErrorService,
        productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
    getId() {
        return __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.PRODUCT_ATTRIBUTES;
    }
    getDataSet(forceReload) {
        return this.getProductAttribute(forceReload);
    }
    clearDataSet() {
        console.log("Session Reset! Limpiando... " + this.getId());
        this.sessionManager.getSession().removeItem(this.getId()).subscribe();
    }
    getProductAttribute(forceReload) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (forceReload) {
                this.refreshProductAttributes().subscribe((list) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }
            else {
                this.sessionManager.getSession().getItem(this.getId()).subscribe((list) => {
                    if (list && list.length > 0) {
                        observer.next(list);
                        observer.complete();
                    }
                    else {
                        this.refreshProductAttributes().subscribe((list) => {
                            observer.next(list);
                            observer.complete();
                        }, error => {
                            observer.error(error);
                        });
                    }
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
    refreshProductAttributes() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.productService.getAttributes(this.sessionManager.getSession().toModel()).subscribe((list) => {
                this.sessionManager.getSession().storeItem(this.getId(), list).subscribe((flag) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }, error => {
                observer.error(error);
            });
        });
    }
};
ProductAttributeSessionDataSetService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], ProductAttributeSessionDataSetService);

//# sourceMappingURL=product-attribute-dataset-service.js.map

/***/ }),

/***/ 673:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSectionSessionDataSetService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__home_providers_home_section_service__ = __webpack_require__(148);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let HomeSectionSessionDataSetService = class HomeSectionSessionDataSetService extends __WEBPACK_IMPORTED_MODULE_2__session_dataset_service__["a" /* SessionDataSet */] {
    constructor(sessionManager, sectionService) {
        super();
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
    }
    getId() {
        return __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].session.HOME_SECTIONS;
    }
    getDataSet(forceReload) {
        return this.getHomeSections(forceReload);
    }
    clearDataSet() {
        console.log("Session Reset! Limpiando... " + this.getId());
        this.sessionManager.getSession().removeItem(this.getId()).subscribe();
    }
    getHomeSections(forceReload) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            if (forceReload) {
                this.refreshHomeSections().subscribe((list) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }
            else {
                this.sessionManager.getSession().getItem(this.getId()).subscribe((list) => {
                    if (list && list.length > 0) {
                        observer.next(list);
                        observer.complete();
                    }
                    else {
                        this.refreshHomeSections().subscribe((list) => {
                            observer.next(list);
                            observer.complete();
                        }, error => {
                            observer.error(error);
                        });
                    }
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
    refreshHomeSections() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            this.sectionService.getSections(this.sessionManager.getSession().toModel()).subscribe((list) => {
                this.sessionManager.getSession().storeItem(this.getId(), list).subscribe((flag) => {
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }, error => {
                observer.error(error);
            });
        });
    }
};
HomeSectionSessionDataSetService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__home_providers_home_section_service__["a" /* HomeSectionService */]])
], HomeSectionSessionDataSetService);

//# sourceMappingURL=home-section-dataset-service.js.map

/***/ }),

/***/ 675:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return VersionCheckPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular_platform_platform__ = __webpack_require__(14);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let VersionCheckPage = class VersionCheckPage {
    constructor(platform) {
        this.platform = platform;
    }
};
VersionCheckPage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'page-version-check',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\version-check\version-check.html"*/'<ion-content class="onboarding">\n\n\n\n    <img class="image" src="assets/images/general/logo-horizontal.png" alt="">\n\n\n\n      <div class="bottom">\n\n        <span class="title"><label class="lg-txt">La app no es compatible con la versi&oacute;n actual <br>de su sistema operativo. <br><br><span showWhen="android,windows">Debe contar con Android 6 o superior.</span><span showWhen="ios">Debe contar con iOS 12.2 o superior.</span></label></span>\n\n      </div>\n\n\n\n      <div class="footer-button" text-center>\n\n            <ion-icon class="empty-icon" name="appstore" tappable ></ion-icon>\n\n      </div>\n\n\n\n</ion-content>\n\n'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\security\pages\version-check\version-check.html"*/,
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular_platform_platform__["a" /* Platform */]])
], VersionCheckPage);

//# sourceMappingURL=version-check.js.map

/***/ }),

/***/ 677:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AppRateService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




let AppRateService = class AppRateService {
    constructor(rest) {
        this.rest = rest;
    }
    checkAppRate(usuario) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramString = "usuario=" + usuario;
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_APPRATE, paramString).subscribe((response) => {
                let ValorarApp = false;
                ValorarApp = response == "S";
                observer.next(ValorarApp);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
AppRateService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], AppRateService);

//# sourceMappingURL=apprate-service.js.map

/***/ }),

/***/ 680:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductSeasonsListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductSeasonsListingService = class ProductSeasonsListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSeasonId(seasonId) {
        this.seasonId = seasonId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            var params = {};
            params.userId = session && session.userId > 0 ? session.userId : null;
            params.token = session && session.token > 0 ? session.token : null;
            params.seasonId = this.seasonId;
            params.pageId = this.pageId;
            params.pageRows = this.pageRows;
            this.productService.getSeasonProducts(params).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    for (let i = 0; i < resultList.length; i++) {
                        this.list.push(resultList[i]);
                    }
                    this.pageId++;
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    /** Stateles call */
    statelessFetchSeasonProducts(seasonId, index) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var season = {};
            var tempList = [];
            var params = {};
            if (this.sessionManager.isAuthenticated()) {
                params.userId = this.sessionManager.getPrincipal().userId;
                params.token = this.sessionManager.getToken();
            }
            params.seasonId = seasonId;
            params.pageId = this.pageId;
            params.pageRows = this.pageRows;
            this.productService.getSeasonProducts(params).subscribe((list) => {
                tempList = list;
                season.seasonId = seasonId;
                season.products = tempList;
                season.index = index;
                observer.next(season);
                observer.complete();
            }, error => {
                observer.next(season);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductSeasonsListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__product_product_service__["a" /* ProductService */]])
], ProductSeasonsListingService);

//# sourceMappingURL=product-seasons-listing-service.js.map

/***/ }),

/***/ 681:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductFavoriteListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductFavoriteListingService = class ProductFavoriteListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = false;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    resetPage() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = true;
    }
    clear() {
        this.resetPage();
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = this.pageId;
            params.pageRows = this.pageRows;
            this.productService.getFavoritedProducts(params).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    //Si esta en TRUE la paginacion es manejada automaticamente, de lo contrario
                    //se ha dicho explicitamente que reinicie y cargue de manera silenciosa la paggina inicial
                    if (this.pageReseted) {
                        this.list = resultList;
                        this.pageId++;
                        this.pageReseted = false;
                    }
                    else {
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        this.pageId++;
                    }
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductFavoriteListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__product_product_service__["a" /* ProductService */]])
], ProductFavoriteListingService);

//# sourceMappingURL=product-favorites-listing-service.js.map

/***/ }),

/***/ 682:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return TimeoutInterceptor; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_operators__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_operators___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_operators__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};


const DEFAULT_TIMEOUT = new __WEBPACK_IMPORTED_MODULE_0__angular_core__["InjectionToken"]('defaultTimeout');
/* harmony export (immutable) */ __webpack_exports__["a"] = DEFAULT_TIMEOUT;

let TimeoutInterceptor = class TimeoutInterceptor {
    constructor(defaultTimeout) {
        this.defaultTimeout = defaultTimeout;
    }
    intercept(req, next) {
        const timeoutValue = Number(req.headers.get('timeout')) || this.defaultTimeout;
        return next.handle(req).pipe(Object(__WEBPACK_IMPORTED_MODULE_1_rxjs_operators__["timeout"])(timeoutValue));
    }
};
TimeoutInterceptor = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __param(0, Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Inject"])(DEFAULT_TIMEOUT)),
    __metadata("design:paramtypes", [Number])
], TimeoutInterceptor);

//# sourceMappingURL=timeout-interceptor.js.map

/***/ }),

/***/ 683:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_lodash__ = __webpack_require__(1140);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_lodash___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_lodash__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_jquery__ = __webpack_require__(1141);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_jquery___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_jquery__);


class ScrollTopHandler {
    constructor(content, platform) {
        this.content = content;
        this.platform = platform;
        this.scrolling = false;
        // optional, to prevent scroll top triggered too many times
        this.scrollTop = Object(__WEBPACK_IMPORTED_MODULE_0_lodash__["throttle"])(this.scrollTop, 500, { leading: true, trailing: false });
    }
    scrollTop() {
        if (!this.scrollEl) {
            this.scrollEl = __WEBPACK_IMPORTED_MODULE_1_jquery___default()(this.content.getScrollElement());
        }
        // scroll top in progress
        if (this.scrolling) {
            return;
        }
        // page has not been scrolled down
        if (this.scrollEl.scrollTop() === 0) {
            return;
        }
        this.scrolling = true;
        // need to stop scroll momentum on ios before scroll top
        if (this.platform.is('ios')) {
            // disable and stop scroll momentum
            this.scrollEl.css('-webkit-overflow-scrolling', 'auto');
            this.scrollEl.css('overflow', 'hidden');
            setTimeout(() => {
                // re-enable scroll momentum
                this.scrollEl.css('-webkit-overflow-scrolling', 'touch');
                this.scrollEl.css('overflow', '');
                this.triggerScrollTop();
            }, 50);
        }
        else {
            this.triggerScrollTop();
        }
    }
    triggerScrollTop() {
        this.scrollEl.animate({ scrollTop: 0 }, 300, () => { this.scrolling = false; });
        // use this method may trigger ev.timeStamps error...
        // this.content
        //   .scrollToTop(300)
        //   .then(() => {
        //     this.scrolling = false;
        //   });
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ScrollTopHandler;

//# sourceMappingURL=scroll-top-handler.js.map

/***/ }),

/***/ 684:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
class NetUtils {
    static isOnline() {
        return navigator.onLine;
    }
    static isOffline() {
        return !navigator.onLine;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = NetUtils;

//# sourceMappingURL=network.utils.js.map

/***/ }),

/***/ 685:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SearchFamilyDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let SearchFamilyDataSet = class SearchFamilyDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
    setFilterData(categoryCode, familyCode, subfamilyCode) {
        this.categoryCode = categoryCode;
        this.familyCode = familyCode;
        this.subfamilyCode = subfamilyCode;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            var params = {};
            params.page = fetchPageId;
            params.records = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            params.categoryCode = this.categoryCode;
            params.familyCode = this.familyCode;
            params.subfamilyCode = this.subfamilyCode;
            if (this.sessionManager.isAuthenticated()) {
                params.userId = this.sessionManager.getPrincipal().userId;
                params.token = this.sessionManager.getToken();
            }
            this.productService.searchByCategoryAndFamily(params).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
};
SearchFamilyDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], SearchFamilyDataSet);

//# sourceMappingURL=search-family-dataset.js.map

/***/ }),

/***/ 686:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SecurityQuestionsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__profile_model_security_question_model__ = __webpack_require__(1175);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__ = __webpack_require__(1176);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let SecurityQuestionsService = class SecurityQuestionsService {
    constructor(rest) {
        this.rest = rest;
    }
    getSecurityQuestions() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SECURITY_QUESTIONS).subscribe((list) => {
                if (list) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__profile_model_security_question_model__["a" /* SecurityQuestionMapper */].mapResponseList(list));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    getUserSecurityQuestions(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_USER_SECURITY_QUESTIONS, paramsString).subscribe((list) => {
                if (list) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertResponseListToModelList(list));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    addUserSecurityQuestion(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_USER_SECURITY_ADD_QUESTION, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertResponseToModel(item));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    modifyUserSecurityQuestion(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_USER_SECURITY_MODIFY_QUESTION, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertResponseToModel(item));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
    deleteSecurityUserQuestion(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_DELETE_SECURITY_USER_QUESTION, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__profile_model_security_question_user_model__["a" /* SecurityUserQuestionMapper */].convertResponseToModel(item));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
};
SecurityQuestionsService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], SecurityQuestionsService);

//# sourceMappingURL=security-questions-service.js.map

/***/ }),

/***/ 687:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SearchBannerDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





/**
 * Fuente de datos para los banners
 */
let SearchBannerDataSet = class SearchBannerDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
    setBannerBrand(banner) {
        this.bannerBrand = banner;
    }
    setBannerList(banner) {
        this.bannerList = banner;
    }
    setBannerProvider(banner) {
        this.bannerProvider = banner;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            let pagedModel = this.sessionManager.getSession().toModel();
            pagedModel.pageId = fetchPageId;
            let job;
            if (this.bannerBrand) {
                job = this.productService.getBannerProductBrandList(pagedModel, this.bannerBrand);
            }
            else if (this.bannerList) {
                job = this.productService.getBannerProductList(pagedModel, this.bannerList);
            }
            else {
                job = this.productService.getBannerProductProviderList(pagedModel, this.bannerProvider);
            }
            job.subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
};
SearchBannerDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__["a" /* ProductService */]])
], SearchBannerDataSet);

//# sourceMappingURL=search-banner-dataset.js.map

/***/ }),

/***/ 688:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TermsConditionsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_term_condition_model__ = __webpack_require__(1174);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let TermsConditionsService = class TermsConditionsService {
    constructor(rest) {
        this.rest = rest;
    }
    getTermAndCondition(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_term_condition_model__["a" /* TermConditionMapper */].convertModelToRequest(session);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_TERMS_CONDITIONS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_term_condition_model__["a" /* TermConditionMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
TermsConditionsService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], TermsConditionsService);

//# sourceMappingURL=terms-conditions.js.map

/***/ }),

/***/ 689:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SinpeService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_common_http__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_sinpe_model__ = __webpack_require__(1159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__util_string_utils__ = __webpack_require__(7);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/*
  Generated class for the SinpeServiceProvider provider.

  See https://angular.io/guide/dependency-injection for more info on providers
  and Angular DI.
*/
let SinpeService = class SinpeService {
    constructor(rest, http) {
        this.rest = rest;
        this.http = http;
    }
    getToken(params) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"]((observer) => {
            this.rest.postExternal(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_GET_TOKEN, params).subscribe((response) => {
                const mappedResponse = {
                    id_caja: response.caja_id,
                    token: response.access_token,
                    expiresIn: response.expires_in,
                    refreshToken: response.refresh_token,
                };
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_sinpe_model__["a" /* SinpeMapper */].convertResponseToModel(mappedResponse));
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    getSinpeInfo() {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"]((observer) => {
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_GET_INFO).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_sinpe_model__["a" /* SinpeMapper */].convertResponseToModel(response));
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    getSinpePhone() {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"]((observer) => {
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_GET_PHONE_NUMBER).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_sinpe_model__["a" /* SinpeMapper */].convertResponseToModel(response));
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    checkSinpePayment(params, headers) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"]((observer) => {
            this.rest
                .postExternal(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_CONSULTA_PAGO, params, headers)
                .subscribe((response) => {
                const mappedResponse = {
                    codRespuesta: response.codRespuesta,
                    descripcionTransaccion: response.descripcion,
                    pagosLista: response.pagos,
                };
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_sinpe_model__["a" /* SinpeMapper */].convertResponseToModel(mappedResponse));
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    //Hecho diferente porque debe ser sincronico
    pairSinpePayment(params, headers) {
        return this.http.post(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_VINCULAR_PAGO, params, {
            headers,
        });
        // return new Observable((observer) => {
        //   this.rest
        //     .postExternal(RESTConfig.WS_SINPE_VINCULAR_PAGO, params, headers)
        //     .subscribe(
        //       (response) => {
        //         const mappedResponse: SinpeResponse = {
        //           codRespuesta: response.codRespuesta,
        //           descripcionTransaccion: response.descripcion,
        //           pagosLista: response.pagos,
        //         };
        //         observer.next(SinpeMapper.convertResponseToModel(mappedResponse));
        //         observer.complete();
        //       },
        //       (error) => {
        //         observer.error(error);
        //       }
        //     );
        // });
    }
    verifySinpeServiceStatus() {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"]((observer) => {
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_GET_STATUS).subscribe((response) => {
                console.log("SERVICE ESTADO ==>>>", response.estado);
                const mappedResponse = {
                    estado: response.estado,
                };
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_sinpe_model__["a" /* SinpeMapper */].convertResponseToModel(mappedResponse));
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    SaveSinpePayment(params) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"]((observer) => {
            this.rest
                .get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_SAVE_TRANSACTION, __WEBPACK_IMPORTED_MODULE_6__util_string_utils__["a" /* StringUtils */].objectToQueryString(params))
                .subscribe((response) => {
                observer.next();
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
    SaveSinpePaymentLog(params) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"]((observer) => {
            this.rest
                .get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_SINPE_SAVE_TRANSACTION_LOG, __WEBPACK_IMPORTED_MODULE_6__util_string_utils__["a" /* StringUtils */].objectToQueryString(params))
                .subscribe((response) => {
                observer.next();
                observer.complete();
            }, (error) => {
                observer.error(error);
            });
        });
    }
};
SinpeService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */], __WEBPACK_IMPORTED_MODULE_0__angular_common_http__["b" /* HttpClient */]])
], SinpeService);

//# sourceMappingURL=sinpe-service.js.map

/***/ }),

/***/ 690:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/**
 * Revision 1.0.20170321
 * Utility class that provides date utilities.
 *
 * @author Coliand Studio
 * @version 1.0.20170321
 *
 */
class DateUtils {
    /**
     * Utility method that allows to format a date returning string value formatted
     * @return {string} date as string value formatted.
     * @param {date} dateToFormat
     * @param {string} format
     * @param {string} delimiter
     */
    static dateFormatTo(dateToFormat, format, delimiter) {
        format = DateUtils.setFormat(format);
        delimiter = DateUtils.setDelimiter(delimiter);
        return DateUtils.parseFormat('' + dateToFormat.getFullYear(), DateUtils.MONTH_NUMBER[dateToFormat.getMonth() + 1], DateUtils.DAYS_NUMBER[dateToFormat.getDate()], format, delimiter);
    }
    /**
     * Utility method that allows to format a date in string form returning string value formatted
     * @return {string} date as string value formatted.
     * @param {string} stringDateToFormat
     * @param {string} inputFormat
     * @param {string} inputDelimiter
     * @param {string} outputFormat
     * @param {string} outputDelimiter
     */
    static stringFormatTo(stringDate, inputFormat, inputDelimiter, outputFormat, outputDelimiter) {
        if (!DateUtils.isValidFormat(inputFormat)) {
            return '';
        }
        if (!DateUtils.isValidDelimiter(inputDelimiter)) {
            return '';
        }
        inputFormat = DateUtils.setFormat(inputFormat);
        inputDelimiter = DateUtils.setDelimiter(inputDelimiter);
        outputFormat = DateUtils.setFormat(outputFormat);
        outputDelimiter = DateUtils.setDelimiter(outputDelimiter);
        var stringDateTokens = stringDate.split(inputDelimiter);
        if (stringDateTokens.length > 2) {
            switch (inputFormat) {
                case DateUtils.FORMAT.DD_MM_YYYY: {
                    return DateUtils.parseFormat(stringDateTokens[2], stringDateTokens[1], stringDateTokens[0], outputFormat, outputDelimiter);
                }
                case DateUtils.FORMAT.YYYY_MM_DD: {
                    return DateUtils.parseFormat(stringDateTokens[0], stringDateTokens[1], stringDateTokens[2], outputFormat, outputDelimiter);
                }
                default: {
                    return DateUtils.parseFormat(stringDateTokens[2], stringDateTokens[1], stringDateTokens[0], outputFormat, outputDelimiter);
                }
            }
        }
        return '';
    }
    /**
     * Utility method that allows to parse date tokens values
     * @return {string} date as string value formatted.
     * @param {string} year
     * @param {string} month
     * @param {string} day
     * @param {string} outputFormat
     * @param {string} outputDelimiter
     */
    static parseFormat(year, month, day, outputFormat, outputDelimiter) {
        switch (outputFormat) {
            case DateUtils.FORMAT.DD_MM_YYYY: {
                return day + outputDelimiter + month + outputDelimiter + year;
            }
            case DateUtils.FORMAT.YYYY_MM_DD: {
                return year + outputDelimiter + month + outputDelimiter + day;
            }
            default: {
                return day + outputDelimiter + month + outputDelimiter + year;
            }
        }
    }
    static parseISOString(s) {
        var parts = s.match(/\d+/g);
        return new Date(parts[0], parts[1] - 1, parts[2], parts[3], parts[4], parts[5]);
    }
    static parseISODate(s) {
        var parts = s.match(/\d+/g);
        return new Date(parts[0], parts[1] - 1, parts[2]);
    }
    static setDelimiter(delimiter) {
        if (delimiter) {
            switch (delimiter) {
                case DateUtils.DELIMITER.DASH: {
                    return DateUtils.DELIMITER.DASH;
                }
                case DateUtils.DELIMITER.SLASH: {
                    return DateUtils.DELIMITER.SLASH;
                }
                default: {
                    return DateUtils.DELIMITER.DASH;
                }
            }
        }
        return DateUtils.DELIMITER.DASH;
    }
    static isValidDelimiter(delimiter) {
        if (delimiter) {
            switch (delimiter) {
                case DateUtils.DELIMITER.DASH: {
                    return true;
                }
                case DateUtils.DELIMITER.SLASH: {
                    return true;
                }
                default: {
                    return false;
                }
            }
        }
        return false;
    }
    static setFormat(format) {
        if (format) {
            switch (format) {
                case DateUtils.FORMAT.DD_MM_YYYY: {
                    return DateUtils.FORMAT.DD_MM_YYYY;
                }
                case DateUtils.FORMAT.YYYY_MM_DD: {
                    return DateUtils.FORMAT.YYYY_MM_DD;
                }
                default: {
                    return DateUtils.FORMAT.DD_MM_YYYY;
                }
            }
        }
        return DateUtils.FORMAT.DD_MM_YYYY;
    }
    static isValidFormat(format) {
        if (format) {
            switch (format) {
                case DateUtils.FORMAT.DD_MM_YYYY: {
                    return true;
                }
                case DateUtils.FORMAT.YYYY_MM_DD: {
                    return true;
                }
                default: {
                    return false;
                }
            }
        }
        return false;
    }
    static diffMinutes(dt2, dt1) {
        var diff = (dt2.getTime() - dt1.getTime()) / 1000;
        diff /= 60;
        return Math.abs(Math.round(diff));
    }
    static simpleFormatDate(date, includeYear) {
        var monthNames = [
            "Ene", "Feb", "Mar",
            "Abr", "May", "Jun", "Jul",
            "Ago", "Set", "Oct",
            "Nov", "Dic"
        ];
        var day = date.getDate();
        var monthIndex = date.getMonth();
        var year = date.getFullYear();
        if (includeYear) {
            return day + ' ' + monthNames[monthIndex] + ' ' + year;
        }
        else {
            return day + ' ' + monthNames[monthIndex];
        }
    }
    static getLongDateFormat(date) {
        var dayNames = [
            "Domingo", "Lunes", "Martes", "Miércoles",
            "Jueves", "Viernes", "Sábado"
        ];
        var monthNames = [
            "Enero", "Febrero", "Marzo",
            "Abril", "Mayo", "Junio", "Julio",
            "Agosto", "Setiembre", "Octubre",
            "Noviembre", "Diciembre"
        ];
        var day = date.getDate();
        var dayOfWeek = date.getDay();
        var monthIndex = date.getMonth();
        //var year = date.getFullYear();
        return dayNames[dayOfWeek] + " " + day + " de " + monthNames[monthIndex];
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = DateUtils;

DateUtils.DAYS_NUMBER = { 1: '01', 2: '02', 3: '03', 4: '04', 5: '05', 6: '06', 7: '07', 8: '08', 9: '09', 10: '10', 11: '11', 12: '12', 13: '13', 14: '14', 15: '15', 16: '16', 17: '17', 18: '18', 19: '19', 20: '20', 21: '21', 22: '22', 23: '23', 24: '24', 25: '25', 26: '26', 27: '27', 28: '28', 29: '29', 30: '30', 31: '31' };
DateUtils.MONTH_NUMBER = { 1: '01', 2: '02', 3: '03', 4: '04', 5: '05', 6: '06', 7: '07', 8: '08', 9: '09', 10: '10', 11: '11', 12: '12' };
DateUtils.DELIMITER = { DASH: '-', SLASH: '/' };
DateUtils.FORMAT = {
    DD_MM_YYYY: 'DD-MM-YYYY',
    YYYY_MM_DD: 'YYYY-MM-DD'
};
//# sourceMappingURL=date.utils.js.map

/***/ }),

/***/ 691:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RefundService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_refund_model__ = __webpack_require__(1178);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__util_rest_native_client__ = __webpack_require__(104);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let RefundService = class RefundService {
    constructor(rest, nativeRest) {
        this.rest = rest;
        this.nativeRest = nativeRest;
    }
    getSubjects(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_refund_model__["a" /* RefundMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_REFUND_SUBJECT, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_refund_model__["a" /* RefundMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getSubjectDetails(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_refund_model__["a" /* RefundMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_REFUND_SUBJECT_DETAIL, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_refund_model__["a" /* RefundMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getRefundReasons(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_refund_model__["c" /* RefundReasonMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_REFUND_REASONS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_refund_model__["c" /* RefundReasonMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    createRefundOrder(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_refund_model__["b" /* RefundOrderMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_REFUND_ORDER, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_refund_model__["b" /* RefundOrderMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getRefundOrderList(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_refund_model__["b" /* RefundOrderMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_REFUND_ORDER_LIST, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_refund_model__["b" /* RefundOrderMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    addRefundImage(refund) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var request = __WEBPACK_IMPORTED_MODULE_4__model_refund_model__["b" /* RefundOrderMapper */].convertModelToPostRequest(refund);
            this.nativeRest.post(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_REFUND_ADD_IMAGE, request).subscribe((response) => {
                observer.next(refund);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
RefundService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */],
        __WEBPACK_IMPORTED_MODULE_5__util_rest_native_client__["a" /* NativeRESTClient */]])
], RefundService);

//# sourceMappingURL=refund-service.js.map

/***/ }),

/***/ 692:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GiftCardService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__ = __webpack_require__(442);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let GiftCardService = class GiftCardService {
    constructor(rest) {
        this.rest = rest;
    }
    //Consultar los tipos de tarjetas de regalo
    getGiftCardTypes(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["b" /* GiftCardTypeMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_GIFT_CARD_TYPE, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["b" /* GiftCardTypeMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consultar los montos de tarjetas de regalo
    getGiftCards(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_GIFT_CARD, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    //Guardar una tarjetas de regalo
    saveGiftCard(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_ADD_GIFT_CARD, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertResponseToModel(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consultar las tarjetas de regalo de un usuario
    getUserGiftCard(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_USER_GIFT_CARDS, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    //Enviar una tarjeta de regalo
    sendGiftCard(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SEND_GIFT_CARD, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_giftcard_model__["a" /* GiftCardMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
GiftCardService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], GiftCardService);

//# sourceMappingURL=giftcard-service.js.map

/***/ }),

/***/ 693:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeRegularOffersDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_dataset__ = __webpack_require__(29);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Fuente de datos para el Tab de SECCION DE PROMOCIONES REGULARES
 */
let HomeRegularOffersDataSet = class HomeRegularOffersDataSet extends __WEBPACK_IMPORTED_MODULE_6__base_dataset__["a" /* DataSet */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
        this.events.publish(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].event.LOBBY_PROMOS_REGULAR_OFFERS_READY);
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.productService.getPromoProducts(session, __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.promoRegularOffersCode, fetchPageId, __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultPageSize)
                .subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomeRegularOffersDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__["a" /* ProductService */]])
], HomeRegularOffersDataSet);

//# sourceMappingURL=home-regular-offers-dataset.js.map

/***/ }),

/***/ 695:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomePage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic2_super_tabs__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__security_providers_login_service__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ionic_native_screen_orientation__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ionic_native_status_bar__ = __webpack_require__(112);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









let HomePage = class HomePage {
    constructor(navCtrl, statusBar, translate, authService, toastCtrl, alertCtrl, sessionManager, screenOrientation) {
        this.navCtrl = navCtrl;
        this.statusBar = statusBar;
        this.translate = translate;
        this.authService = authService;
        this.toastCtrl = toastCtrl;
        this.alertCtrl = alertCtrl;
        this.sessionManager = sessionManager;
        this.screenOrientation = screenOrientation;
        this.page1 = 'HomeSuggestedPage';
        this.page2 = 'HomeFavsPage';
        this.page3 = 'HomeOffersPage';
        this.page4 = 'HomeCategoriesPage';
        this.page5 = 'HomeSeasonalPage';
        this.homeSuggestedLoaded = false;
        this.homeFavsLoaded = false;
        this.homePromosLoaded = false;
        this.homeCategoryLoaded = false;
        this.homeSeasonLoaded = false;
        this.navbarStyle = "blue";
        //this.homeSectionDataProvider.fetchData();
        this.homeSuggestedLoaded = true;
    }
    ionViewWillEnter() {
    }
    ionViewDidEnter() {
        if (this.sessionManager.isSessionHalted()) {
            __WEBPACK_IMPORTED_MODULE_4__util_view_utils__["a" /* ViewUtils */].showAlert(this.alertCtrl, this.translate.instant('messages.sessionExpired'), () => {
                let user = this.sessionManager.getPrincipal();
                this.authService.logout(user).subscribe((result) => {
                    if (result) {
                        this.navCtrl.setRoot('LoginPage');
                    }
                    else {
                        __WEBPACK_IMPORTED_MODULE_4__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.closeSessionProblem"));
                    }
                });
            });
        }
    }
    onTabSelect(ev) {
        if (ev.id === "homeSuggestedTab") {
            this.navbarStyle = "blue";
            if (!this.homeSuggestedLoaded) {
                //this.homeSectionDataProvider.fetchData();
                this.homeSuggestedLoaded = true;
            }
        }
        else if (ev.id === "homeFavsTab") {
            this.navbarStyle = "blue";
            if (!this.homeFavsLoaded) {
                //this.homeFavoritesService.fetchData();
                this.homeFavsLoaded = true;
            }
        }
        else if (ev.id === "homePromosTab") {
            this.navbarStyle = "red";
            if (!this.homePromosLoaded) {
                //this.homePromosService.fetchData();
                this.homePromosLoaded = true;
            }
        }
        else if (ev.id === "homeCategoriesTab") {
            this.navbarStyle = "blue";
            if (!this.homeCategoryLoaded) {
                //this.homeCategoryService.fetchData();
                this.homeCategoryLoaded = true;
            }
        }
        else if (ev.id === "homeSeasonalTab") {
            this.navbarStyle = "warm-yellow";
            if (!this.homeSeasonLoaded) {
                //this.homeSeasonService.fetchData();
                this.homeSeasonLoaded = true;
            }
        }
    }
    slideToIndex(index) {
        this.superTabs.slideTo(index);
    }
    openSearch() {
        this.changeStatusBarColor();
        this.navCtrl.push('SearchPage');
    }
    openSearchByCategory() {
        this.changeStatusBarColor();
        this.navCtrl.push('SearchCategoriesPage');
    }
    openCart() {
        this.changeStatusBarColor();
        this.navCtrl.push('CartPage');
    }
    changeStatusBarColor() {
        this.statusBar.backgroundColorByHexString("#2471a3");
        this.statusBar.styleBlackTranslucent();
    }
};
__decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_2_ionic2_super_tabs__["a" /* SuperTabs */]),
    __metadata("design:type", __WEBPACK_IMPORTED_MODULE_2_ionic2_super_tabs__["a" /* SuperTabs */])
], HomePage.prototype, "superTabs", void 0);
HomePage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'page-home',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\home\pages\home.html"*/'<ion-header no-border no-shadow class="{{navbarStyle}}">\n\n  <script src="https://static.greenpay.me/collector/1.0.1/GDataCollector.min.js"></script>\n\n  <ion-navbar transparent>\n\n    <button ion-button menuToggle color="light"><ion-icon name="md-menu"></ion-icon></button>\n\n    <ion-title color="light"><span class="title-bar"><img class="title-image" height="40" alt="logo" src="assets/images/general/logo-horizontal.png"></span></ion-title>\n\n    <ion-buttons end>\n\n      <!--button ion-button button-clear icon-only class="button button-action button-clear" tappable (click)="openSearchByCategory()">\n\n        <ion-icon name="md-filing" style="font-size: 30px; color:white"></ion-icon>\n\n      </button-->\n\n      <button ion-button button-clear icon-only class="button button-action button-clear" tappable (click)="openSearch()">\n\n        <ion-icon name="md-search" style="font-size: 30px; color:white"></ion-icon>\n\n      </button>\n\n      <button ion-button button-clear icon-only class="button button-clear" tappable (click)="openCart()">\n\n        <ion-icon name="md-cart" style="font-size: 30px; color:white"></ion-icon>\n\n        <div class="shopping-cart"></div>\n\n      </button>\n\n    </ion-buttons>\n\n  </ion-navbar>\n\n\n\n \n\n</ion-header>\n\n\n\n<ion-content no-bounce >\n\n\n\n  <super-tabs id="mainTabs"\n\n    toolbarColor="light"\n\n    toolbarBackground="{{navbarStyle}}"\n\n    indicatorColor="light"\n\n    scrollTabs\n\n    [config]="{ sideMenu: \'left\' }" (tabSelect)="onTabSelect($event)" no-border no-shadow>\n\n    <super-tab [root]="page1" title="De todo un poco" id="homeSuggestedTab"></super-tab>\n\n    <super-tab [root]="page2" title="Favoritos" id="homeFavsTab"></super-tab>\n\n    <super-tab [root]="page3" title="Promociones" id="homePromosTab"></super-tab>\n\n    <super-tab [root]="page4" title="Categorias" id="homeCategoriesTab"></super-tab>\n\n    <super-tab [root]="page5" title="Temporadas" id="homeSeasonalTab"></super-tab>\n\n  </super-tabs>\n\n\n\n</ion-content>\n\n'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\home\pages\home.html"*/
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavController"],
        __WEBPACK_IMPORTED_MODULE_8__ionic_native_status_bar__["a" /* StatusBar */],
        __WEBPACK_IMPORTED_MODULE_5__ngx_translate_core__["c" /* TranslateService */],
        __WEBPACK_IMPORTED_MODULE_6__security_providers_login_service__["a" /* LoginService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["AlertController"],
        __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_7__ionic_native_screen_orientation__["a" /* ScreenOrientation */]])
], HomePage);

//# sourceMappingURL=home.js.map

/***/ }),

/***/ 697:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GroupedOffersDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__tabbed_dataset__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__home_providers_home_offers_service__ = __webpack_require__(281);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let GroupedOffersDataSet = class GroupedOffersDataSet extends __WEBPACK_IMPORTED_MODULE_4__tabbed_dataset__["a" /* TabbedDataSet */] {
    constructor(sessionManager, offerService) {
        super();
        this.sessionManager = sessionManager;
        this.offerService = offerService;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.defaultPageSize;
            this.offerService.getProductForGroupSection(params, this.groupCode).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
GroupedOffersDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__home_providers_home_offers_service__["a" /* HomeOffersService */]])
], GroupedOffersDataSet);

//# sourceMappingURL=home-grouped-offers-dataset.js.map

/***/ }),

/***/ 698:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeFeaturedOffersDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_dataset__ = __webpack_require__(29);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Fuente de datos para el Tab de SECCION DE PROMOCIONES REGULARES
 */
let HomeFeaturedOffersDataSet = class HomeFeaturedOffersDataSet extends __WEBPACK_IMPORTED_MODULE_6__base_dataset__["a" /* DataSet */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
        this.events.publish(__WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].event.LOBBY_PROMOS_FEATURED_OFFERS_READY);
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.productService.getPromoProducts(session, __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.promoFeaturedOffersCode, fetchPageId, __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultPageSize)
                .subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomeFeaturedOffersDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_3__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__products_providers_product_product_service__["a" /* ProductService */]])
], HomeFeaturedOffersDataSet);

//# sourceMappingURL=home-featured-offers-dataset.js.map

/***/ }),

/***/ 7:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
class StringUtils {
    /**
     * Utility method that allows to parse values into string argument following {s0} for string values or {n0} for numeric values.
     * @return {string} argument formatted.
     * @param {string} stringToFormat
     * @param {any[]} args
     */
    static format(stringToFormat, args) {
        stringToFormat = stringToFormat.replace(/{s(\d+)}/g, function (match, number) {
            return typeof args[number] != 'undefined' ? args[number] : match;
        });
        stringToFormat = stringToFormat.replace(/{n(\d+)}/g, function (match, number) {
            return typeof args[number] != 'undefined' ? args[number] : match;
        });
        return stringToFormat;
    }
    /**
     * Utility method that validates value is not NULL or UNDEFINED.
     * @return {string} argument formatted.
     * @param {string} stringToFormat
     * @param {any[]} args
     */
    static validateNullOrUndefined(value) {
        if (typeof value != 'undefined') {
            return value;
        }
        else {
            return null;
        }
    }
    /**
     * Utility method that eliminates any non-desired character from string
     * @param {string} stringToEvaluate
     * @param {string[]} toRemove
     */
    static removeCharacters(stringToEvaluate, toRemove) {
        if (stringToEvaluate && toRemove && toRemove.length > 0) {
            toRemove.forEach(replaceable => {
                stringToEvaluate = stringToEvaluate.replace(replaceable, '');
            });
        }
        return stringToEvaluate;
    }
    /**
     * Utility method that evaluates if a pattern is present or not in string
     * @param {string} stringToEvaluate
     * @param {string} regex
     */
    static isPatternPresent(stringToEvaluate, regex) {
        if (stringToEvaluate && regex) {
            if (stringToEvaluate.match(regex)) {
                return true;
            }
            else {
                return false;
            }
        }
        return false;
    }
    /**
     * Utility method that evaluates if a pattern is present or not in string
     * @param {string} stringToEvaluate
     * @param {string} regex
     */
    static getHash(stringToEvaluate) {
        if (stringToEvaluate && stringToEvaluate.length > 0) {
            return stringToEvaluate.split("").reduce(function (a, b) { a = ((a << 5) - a) + b.charCodeAt(0); return a & a; }, 0);
        }
        return 0;
    }
    static objectToQueryString(obj) {
        var str = [];
        for (var p in obj) {
            if (obj.hasOwnProperty(p)) {
                if (obj[p] == null) {
                    str.push(encodeURIComponent(p) + "=");
                }
                else {
                    str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                }
            }
        }
        return str.join("&");
    }
    static isValidEmail(email) {
        var result = true;
        if (!StringUtils.isEmpty(email)) {
            var re = /\S+@\S+\.\S+/;
            result = re.test(email);
        }
        return result;
    }
    static isEmpty(value) {
        var result = !value;
        if (typeof value == 'string' || value instanceof String) {
            result = value.trim().length === 0;
        }
        return result;
    }
    static isNotEmpty(value) {
        return !StringUtils.isEmpty(value);
    }
    static areEmpty(values) {
        var result = false;
        if (values) {
            for (var i = 0; i < values.length; i++) {
                if (StringUtils.isEmpty(values[i])) {
                    result = true;
                    break;
                }
            }
        }
        return result;
    }
    static isValidPassword(password) {
        var result = true;
        if (StringUtils.isEmpty(password)) {
            result = false;
        }
        if (password.trim().length < 7 || password.trim().length > 12) {
            result = false;
        }
        if (!StringUtils.hasLowerCase(password)) {
            result = false;
        }
        if (!StringUtils.hasLowerCase(password)) {
            result = false;
        }
        if (!StringUtils.hasUpperCase(password)) {
            result = false;
        }
        return result;
    }
    static hasLowerCase(str) {
        return (/[a-z]/.test(str));
    }
    static hasUpperCase(str) {
        return (/[A-Z]/.test(str));
    }
    static formatCreditCard(value) {
        var v = value.replace(/\s+/g, '').replace(/[^0-9]/gi, '');
        var matches = v.match(/\d{4,16}/g);
        var match = matches && matches[0] || '';
        var parts = [];
        for (var i = 0, len = match.length; i < len; i += 4) {
            parts.push(match.substring(i, i + 4));
        }
        if (parts.length) {
            return parts.join(' ');
        }
        else {
            return value;
        }
    }
    static getCardType(number) {
        // visa
        var re = new RegExp("^4");
        if (number.match(re) != null)
            return "Visa";
        // Mastercard
        // Updated for Mastercard 2017 BINs expansion
        if (/^(5[1-5][0-9]{14}|2(22[1-9][0-9]{12}|2[3-9][0-9]{13}|[3-6][0-9]{14}|7[0-1][0-9]{13}|720[0-9]{12}))$/.test(number))
            return "MasterCard";
        // AMEX
        re = new RegExp("^3[47]");
        if (number.match(re) != null)
            return "Amex";
        // Discover
        re = new RegExp("^(6011|622(12[6-9]|1[3-9][0-9]|[2-8][0-9]{2}|9[0-1][0-9]|92[0-5]|64[4-9])|65)");
        if (number.match(re) != null)
            return "Discover";
        // Diners
        re = new RegExp("^36");
        if (number.match(re) != null)
            return "Diners";
        // Diners - Carte Blanche
        re = new RegExp("^30[0-5]");
        if (number.match(re) != null)
            return "Diners-carteblanche";
        // JCB
        re = new RegExp("^35(2[89]|[3-8][0-9])");
        if (number.match(re) != null)
            return "Jcb";
        // Visa Electron
        re = new RegExp("^(4026|417500|4508|4844|491(3|7))");
        if (number.match(re) != null)
            return "visa-electron";
        return "nodef";
    }
    // takes the form field value and returns true on valid number
    static isValidCC(value) {
        try {
            // accept only digits, dashes or spaces
            if (/[^0-9-\s]+/.test(value))
                return false;
            // The Luhn Algorithm. It's so pretty.
            var nCheck = 0, bEven = false;
            value = value.replace(/\D/g, "");
            for (var n = value.length - 1; n >= 0; n--) {
                var cDigit = value.charAt(n), nDigit = parseInt(cDigit, 10);
                if (bEven) {
                    if ((nDigit *= 2) > 9)
                        nDigit -= 9;
                }
                nCheck += nDigit;
                bEven = !bEven;
            }
            return (nCheck % 10) == 0;
        }
        catch (e) {
            console.log(e);
        }
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = StringUtils;

//# sourceMappingURL=string-utils.js.map

/***/ }),

/***/ 700:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FreightService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_freight_model__ = __webpack_require__(1161);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let FreightService = class FreightService {
    constructor(rest) {
        this.rest = rest;
    }
    //Servicio de Fletes
    consultFreight(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_freight_model__["a" /* FreightMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_FREIGHT, paramsString).subscribe((response) => {
                if (response && response.length > 0 && response[0].id_flete > 0) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_freight_model__["a" /* FreightMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
FreightService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], FreightService);

//# sourceMappingURL=freight-service.js.map

/***/ }),

/***/ 701:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SearchDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let SearchDataSet = class SearchDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.searchResultsQuantity = 0;
        this.searchPaginationId = null;
        this.allowFiltering = false;
        this.newEngine = false;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    onReset() {
        this.searchResultsQuantity = 0;
        this.searchPaginationId = null;
    }
    setCriteria(criteria) {
        this.criteria = criteria;
    }
    useNewSearchEngine(newEngine) {
        this.newEngine = newEngine;
    }
    isFilteringAllowed() {
        return (this.allowFiltering ? this.allowFiltering === 'S' : false);
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            var search = {};
            search.criterion = this.criteria;
            search.pageId = fetchPageId;
            search.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            search.sortBy = this.getSortBy();
            search.searchPaginationId = this.searchPaginationId;
            if (this.sessionManager.isAuthenticated()) {
                search.userId = this.sessionManager.getPrincipal().userId;
                search.token = this.sessionManager.getToken();
            }
            //setTimeout(() => {
            this.searchResultsQuantity = 0;
            if (this.newEngine) {
                this.productService.searchNew(search).subscribe((resultList) => {
                    if (resultList && resultList.length > 0) {
                        this.searchResultsQuantity = resultList.length;
                        this.searchPaginationId = resultList[0].searchPaginationId;
                        this.allowFiltering = resultList[0].allowFiltering;
                    }
                    observer.next(resultList);
                    observer.complete();
                }, error => {
                    observer.next(this.list);
                    observer.complete();
                });
            }
            else {
                this.productService.search(search).subscribe((resultList) => {
                    if (resultList && resultList.length > 0) {
                        this.searchResultsQuantity = resultList.length;
                        this.searchPaginationId = resultList[0].searchPaginationId;
                        this.allowFiltering = resultList[0].allowFiltering;
                    }
                    observer.next(resultList);
                    observer.complete();
                }, error => {
                    observer.next(this.list);
                    observer.complete();
                });
            }
        });
    }
    getSummary() {
        let message;
        if (this.searchResultsQuantity > 0) {
            message = this.searchResultsQuantity + " resultados con '" + this.criteria + "'";
        }
        else {
            message = "Resultados con '" + this.criteria + "'";
        }
        return message;
    }
};
SearchDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], SearchDataSet);

//# sourceMappingURL=search-dataset.js.map

/***/ }),

/***/ 702:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SearchSimilarDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let SearchSimilarDataSet = class SearchSimilarDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.searchResultsQuantity = 0;
        this.searchPaginationId = null;
    }
    onReset() {
        this.searchResultsQuantity = 0;
        this.searchPaginationId = null;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setCriteria(criteria) {
        this.criteria = criteria;
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            var search = {};
            search.criterion = this.criteria;
            search.pageId = fetchPageId;
            search.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            search.sortBy = this.getSortBy();
            search.searchPaginationId = this.searchPaginationId;
            if (this.sessionManager.isAuthenticated()) {
                search.userId = this.sessionManager.getPrincipal().userId;
                search.token = this.sessionManager.getToken();
            }
            //setTimeout(() => {
            this.productService.searchSimilar(search).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    this.searchResultsQuantity = resultList[0].searchQuantity;
                    this.searchPaginationId = resultList[0].searchPaginationId;
                }
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
            //},15000);
        });
    }
    getSummary() {
        let message;
        if (this.searchResultsQuantity > 0) {
            message = this.searchResultsQuantity + " BÚSQUEDAS RELACIONADAS CON '" + this.criteria + "'";
        }
        else {
            message = "BÚSQUEDAS RELACIONADAS CON '" + this.criteria + "'";
        }
        return message;
    }
};
SearchSimilarDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], SearchSimilarDataSet);

//# sourceMappingURL=search-similar-dataset.js.map

/***/ }),

/***/ 704:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ChatService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_operators_map__ = __webpack_require__(68);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_operators_map___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_operators_map__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_common_http__ = __webpack_require__(64);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




class ChatMessage {
}
/* unused harmony export ChatMessage */

class UserInfo {
}
/* unused harmony export UserInfo */

let ChatService = class ChatService {
    constructor(http, events) {
        this.http = http;
        this.events = events;
    }
    mockNewMsg(msg) {
        //let user = this.sessionManager.getPrincipal();
        const mockMsg = {
            messageId: Date.now().toString(),
            userId: '210000198410281948',
            userName: 'Hancock',
            userAvatar: './assets/chat/to-user.png',
            toUserId: '140000198202211138',
            time: Date.now(),
            message: msg.message,
            status: 'success',
            type: "response"
        };
        setTimeout(() => {
            this.events.publish('chat:received', mockMsg, Date.now());
        }, Math.random() * 1800);
    }
    getMsgList() {
        const msgListUrl = 'assets/chat/mock/msg-list.json';
        return this.http.get(msgListUrl)
            .pipe(Object(__WEBPACK_IMPORTED_MODULE_2_rxjs_operators_map__["map"])(response => response.array));
    }
    sendMsg(msg) {
        return new Promise(resolve => setTimeout(() => resolve(msg), Math.random() * 1000))
            .then(() => this.mockNewMsg(msg));
    }
    getUserInfo() {
        const userInfo = {
            id: '140000198202211138',
            name: 'Luff',
            avatar: 'assets/chat/user.jpg'
        };
        return new Promise(resolve => resolve(userInfo));
    }
};
ChatService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__angular_common_http__["b" /* HttpClient */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"]])
], ChatService);

//# sourceMappingURL=chat-service.js.map

/***/ }),

/***/ 705:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FAQsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_faqs_model__ = __webpack_require__(1177);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let FAQsService = class FAQsService {
    constructor(rest) {
        this.rest = rest;
    }
    getFAQs(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_faqs_model__["a" /* FAQMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_FAQs, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_faqs_model__["a" /* FAQMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getFAQDetail(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_faqs_model__["a" /* FAQMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_FAQs_DETAIL, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_faqs_model__["a" /* FAQMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
FAQsService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], FAQsService);

//# sourceMappingURL=faqs-service.js.map

/***/ }),

/***/ 706:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomePromosTemplateSectionTabbedBackwardDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__home_promos_template_tabbed_dataset__ = __webpack_require__(161);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__products_providers_section_section_service__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomePromosTemplateSectionTabbedBackwardDataSet = class HomePromosTemplateSectionTabbedBackwardDataSet extends __WEBPACK_IMPORTED_MODULE_0__home_promos_template_tabbed_dataset__["a" /* HomePromosTemplateTabbedDataSet */] {
    constructor(sessionManager, sectionService) {
        super(sessionManager, sectionService);
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
    }
};
HomePromosTemplateSectionTabbedBackwardDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_1__products_providers_section_section_service__["a" /* SectionService */]])
], HomePromosTemplateSectionTabbedBackwardDataSet);

//# sourceMappingURL=home-promos-template-section-tabbed-backward-dataset.js.map

/***/ }),

/***/ 707:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CategoryTemplateCachingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__caching_service__ = __webpack_require__(103);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let CategoryTemplateCachingService = class CategoryTemplateCachingService extends __WEBPACK_IMPORTED_MODULE_1__caching_service__["a" /* CachingService */] {
    constructor() {
        super();
    }
};
CategoryTemplateCachingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], CategoryTemplateCachingService);

//# sourceMappingURL=category-template-caching-service.js.map

/***/ }),

/***/ 708:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSectionGroupSectionTabbedBackwardDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__home_providers_home_category_template_service__ = __webpack_require__(118);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__home_section_group_tabbed_dataset__ = __webpack_require__(162);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeSectionGroupSectionTabbedBackwardDataSet = class HomeSectionGroupSectionTabbedBackwardDataSet extends __WEBPACK_IMPORTED_MODULE_2__home_section_group_tabbed_dataset__["a" /* HomeSectionGroupTabbedDataSet */] {
    constructor(sessionManager, categoryTemplateService) {
        super(sessionManager, categoryTemplateService);
        this.sessionManager = sessionManager;
        this.categoryTemplateService = categoryTemplateService;
    }
};
HomeSectionGroupSectionTabbedBackwardDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_1__home_providers_home_category_template_service__["a" /* HomeCategoryTemplateService */]])
], HomeSectionGroupSectionTabbedBackwardDataSet);

//# sourceMappingURL=home-section-group-section-tabbed-backward-dataset.js.map

/***/ }),

/***/ 709:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSectionGroupSectionTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__home_providers_home_category_template_service__ = __webpack_require__(118);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__home_section_group_tabbed_dataset__ = __webpack_require__(162);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeSectionGroupSectionTabbedDataSet = class HomeSectionGroupSectionTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_2__home_section_group_tabbed_dataset__["a" /* HomeSectionGroupTabbedDataSet */] {
    constructor(sessionManager, categoryTemplateService) {
        super(sessionManager, categoryTemplateService);
        this.sessionManager = sessionManager;
        this.categoryTemplateService = categoryTemplateService;
    }
};
HomeSectionGroupSectionTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_1__home_providers_home_category_template_service__["a" /* HomeCategoryTemplateService */]])
], HomeSectionGroupSectionTabbedDataSet);

//# sourceMappingURL=home-section-group-section-tabbed-dataset.js.map

/***/ }),

/***/ 71:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_product_utils__ = __webpack_require__(89);


class ProductMapper {
    static convertModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            pagina: model.pageId,
            registros: model.pageRows,
            categoria: model.categoryCode,
            tipo: model.promoType,
            articulo: model.article,
            id_busqueda: model.searchPaginationId
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertSearchTermModelToRequest(model) {
        var request = {
            id_usuario: model.userId,
            token: model.token,
            descripcion: model.description
        };
        return __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var product = {
            productCode: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            description: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            details: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.detalle),
            image: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            price: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio),
            realPrice: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.preciosd),
            tax: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto),
            discountPercentage: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuento),
            isPromo: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.espromo),
            isInWishList: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.deseo),
            promoExpiration: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.finalizapromo),
            isGroup: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.grupo),
            groupCriteria: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.criteriogrupo),
            groupValue: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.valoragrupa),
            groupedItems: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.itemsagrupados),
            groupLabel: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.etiquetagrupo),
            availableUnits: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.udsdisponibles),
            availableInDays: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.diasdisponible),
            isAvailable: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.disponible),
            searchQuantity: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantidadRegistros),
            state: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.estado),
            message: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.mensaje),
            searchPaginationId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_busqueda),
            priceWithNoTax: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio_siv),
            excent: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.exento),
            maxQuantityToSell: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.max_venta),
            icon: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.icono),
            iconColor: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.icono_color),
            iconEffect: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.efecto),
            promoText: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.texto_promo),
            quantityText: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.texto_cantidad),
            tabGroup: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.pasillo),
            tabSection: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.seccion),
            tabSectionName: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion_pasillo),
            allowFiltering: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.permitefiltrado)
        };
        //Realiza calculos del producto, como descuentos, impuestos, etc.
        __WEBPACK_IMPORTED_MODULE_1__util_product_utils__["a" /* ProductUtils */].handleDefaults(product);
        return product;
    }
    static convertResponseListToModelList(list, callback) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                let model = ProductMapper.convertResponseToModel(item);
                result.push(model);
                if (callback) {
                    callback(model);
                }
            });
        }
        return result;
    }
    static convertResponseSearchAttListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                var attr = {
                    attributeId: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(item.id_atributo),
                    atributte: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(item.atributo),
                    order: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(item.orden)
                };
                result.push(attr);
            });
        }
        return result;
    }
    static convertResponseSearchAttValueListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                var attr = {
                    atributteDetail: __WEBPACK_IMPORTED_MODULE_0__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(item.detalle)
                };
                result.push(attr);
            });
        }
        return result;
    }
    static convertResponseListToProductsInWishListModel(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                let product = ProductMapper.convertResponseToModel(item);
                product.isInWishList = "S";
                result.push(product);
            });
        }
        return result;
    }
    static convertResponseMerqueoListToModelList(linkToGroup, list, callback) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                let model = ProductMapper.convertResponseToModel(item);
                model.tabGroup = linkToGroup; //Fuerza el enlazado a un pasillo especifico
                result.push(model);
                if (callback) {
                    callback(model);
                }
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductMapper;

//# sourceMappingURL=product.model.js.map

/***/ }),

/***/ 711:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeCategoryService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__products_providers_product_product_category_service__ = __webpack_require__(117);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



let HomeCategoryService = class HomeCategoryService {
    constructor(//private sessionManager: SessionManagerService,
        categoryService) {
        this.categoryService = categoryService;
        this.categoryCache = [];
    }
    loadFamiliesForCategory(session, category) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            let foundItem = this.categoryCache.filter(x => x.code == category.code)[0];
            if (foundItem) {
                category.families = foundItem.families;
                observer.next();
                observer.complete();
            }
            else {
                this.getFamilies(session, category).subscribe((families) => {
                    category.families = families;
                    let cache = {
                        code: category.code,
                        families: families
                    };
                    this.categoryCache.push(cache);
                    observer.next();
                    observer.complete();
                });
            }
        });
    }
    getFamilies(session, category) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            this.categoryService.getFamilies(session, category.code).subscribe((list) => {
                observer.next(list);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
HomeCategoryService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__products_providers_product_product_category_service__["a" /* ProductCategoryService */]])
], HomeCategoryService);

//# sourceMappingURL=home-category-service.js.map

/***/ }),

/***/ 712:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeCategorySectionTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__home_category_tabbed_dataset__ = __webpack_require__(164);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeCategorySectionTabbedDataSet = class HomeCategorySectionTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_3__home_category_tabbed_dataset__["a" /* HomeCategoryTabbedDataSet */] {
    constructor(sessionManager, productService) {
        super(sessionManager, productService);
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
};
HomeCategorySectionTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_2__products_providers_product_product_service__["a" /* ProductService */]])
], HomeCategorySectionTabbedDataSet);

//# sourceMappingURL=home-category-section-tabbed-dataset.js.map

/***/ }),

/***/ 713:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeCategorySectionTabbedBackwardDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__home_category_tabbed_dataset__ = __webpack_require__(164);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeCategorySectionTabbedBackwardDataSet = class HomeCategorySectionTabbedBackwardDataSet extends __WEBPACK_IMPORTED_MODULE_3__home_category_tabbed_dataset__["a" /* HomeCategoryTabbedDataSet */] {
    constructor(sessionManager, productService) {
        super(sessionManager, productService);
        this.sessionManager = sessionManager;
        this.productService = productService;
    }
};
HomeCategorySectionTabbedBackwardDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_2__products_providers_product_product_service__["a" /* ProductService */]])
], HomeCategorySectionTabbedBackwardDataSet);

//# sourceMappingURL=home-category-section-tabbed-backward-dataset.js.map

/***/ }),

/***/ 714:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeFavsDataSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let HomeFavsDataSetNavigator = class HomeFavsDataSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
};
HomeFavsDataSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], HomeFavsDataSetNavigator);

//# sourceMappingURL=home-favs-dataset-navigator.js.map

/***/ }),

/***/ 715:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeMiSuperDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__home_providers_home_misuper_service__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__ = __webpack_require__(79);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeMiSuperDataSet = class HomeMiSuperDataSet extends __WEBPACK_IMPORTED_MODULE_5__tabbed_dataset__["a" /* TabbedDataSet */] {
    constructor(sessionManager, misuperService) {
        super();
        this.sessionManager = sessionManager;
        this.misuperService = misuperService;
        //this.setPreviewPageSize(50); //Muestra una cantidad para preview
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setSectionListToQuery(sections) {
        this.sectionListToQuery = "";
        if (sections != null && sections.length > 0) {
            for (let i = 0; i < sections.length; i++) {
                let section = sections[i];
                this.sectionListToQuery += (section.code + ",");
            }
        }
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.defaultPageSize;
            let useList = false;
            let section;
            if (!this.sectionCode) {
                section = this.sectionListToQuery;
                useList = true;
            }
            else {
                section = this.sectionCode;
            }
            this.misuperService.getMiSuperProductSection(params, this.groupCode, section, useList).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomeMiSuperDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__home_providers_home_misuper_service__["a" /* HomeMiSuperService */]])
], HomeMiSuperDataSet);

//# sourceMappingURL=home-misuper-dataset.js.map

/***/ }),

/***/ 716:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeMiSuperSectionTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__home_misuper_tabbed_dataset__ = __webpack_require__(241);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__home_providers_home_misuper_service__ = __webpack_require__(76);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeMiSuperSectionTabbedDataSet = class HomeMiSuperSectionTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_2__home_misuper_tabbed_dataset__["a" /* HomeMiSuperTabbedDataSet */] {
    constructor(sessionManager, misuperService) {
        super(sessionManager, misuperService);
        this.sessionManager = sessionManager;
        this.misuperService = misuperService;
    }
};
HomeMiSuperSectionTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_3__home_providers_home_misuper_service__["a" /* HomeMiSuperService */]])
], HomeMiSuperSectionTabbedDataSet);

//# sourceMappingURL=home-misuper-section-tabbed-dataset.js.map

/***/ }),

/***/ 717:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeMiSuperSectionTabbedBackwardDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__home_misuper_tabbed_dataset__ = __webpack_require__(241);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__home_providers_home_misuper_service__ = __webpack_require__(76);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeMiSuperSectionTabbedBackwardDataSet = class HomeMiSuperSectionTabbedBackwardDataSet extends __WEBPACK_IMPORTED_MODULE_2__home_misuper_tabbed_dataset__["a" /* HomeMiSuperTabbedDataSet */] {
    constructor(sessionManager, misuperService) {
        super(sessionManager, misuperService);
        this.sessionManager = sessionManager;
        this.misuperService = misuperService;
    }
};
HomeMiSuperSectionTabbedBackwardDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_3__home_providers_home_misuper_service__["a" /* HomeMiSuperService */]])
], HomeMiSuperSectionTabbedBackwardDataSet);

//# sourceMappingURL=home-misuper-section-tabbed-backward-dataset.js.map

/***/ }),

/***/ 718:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PromosTemplateCachingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__caching_service__ = __webpack_require__(103);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let PromosTemplateCachingService = class PromosTemplateCachingService extends __WEBPACK_IMPORTED_MODULE_1__caching_service__["a" /* CachingService */] {
    constructor() {
        super();
    }
};
PromosTemplateCachingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], PromosTemplateCachingService);

//# sourceMappingURL=promos-template-caching-service.js.map

/***/ }),

/***/ 719:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomePromosTemplateSectionTabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__home_promos_template_tabbed_dataset__ = __webpack_require__(161);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomePromosTemplateSectionTabbedDataSet = class HomePromosTemplateSectionTabbedDataSet extends __WEBPACK_IMPORTED_MODULE_1__home_promos_template_tabbed_dataset__["a" /* HomePromosTemplateTabbedDataSet */] {
    constructor(sessionManager, sectionService) {
        super(sessionManager, sectionService);
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
    }
};
HomePromosTemplateSectionTabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__["a" /* SectionService */]])
], HomePromosTemplateSectionTabbedDataSet);

//# sourceMappingURL=home-promos-template-section-tabbed-dataset.js.map

/***/ }),

/***/ 720:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomePromosTemplateFeaturedOffersDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_dataset__ = __webpack_require__(29);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para el Tab de SECCION DE PROMOCIONES REGULARES
 */
let HomePromosTemplateFeaturedOffersDataSet = class HomePromosTemplateFeaturedOffersDataSet extends __WEBPACK_IMPORTED_MODULE_5__base_dataset__["a" /* DataSet */] {
    constructor(
        //private events: Events,
        sessionManager, sectionService) {
        super();
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setSectionId(sectionId) {
        this.sectionId = sectionId;
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.sectionService.getProductsBySectionTypeResume(session, this.sectionId, __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.promoFeaturedOffersCode, fetchPageId, 2).subscribe((products) => {
                observer.next(products);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
HomePromosTemplateFeaturedOffersDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__["a" /* SectionService */]])
], HomePromosTemplateFeaturedOffersDataSet);

//# sourceMappingURL=home-promos-template-offers-dataset.js.map

/***/ }),

/***/ 721:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomePromosTemplateRegularOffersDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_dataset__ = __webpack_require__(29);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para el Tab de SECCION DE PROMOCIONES REGULARES
 */
let HomePromosTemplateRegularOffersDataSet = class HomePromosTemplateRegularOffersDataSet extends __WEBPACK_IMPORTED_MODULE_5__base_dataset__["a" /* DataSet */] {
    constructor(
        //private events: Events,
        sessionManager, sectionService) {
        super();
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    setSectionId(sectionId) {
        this.sectionId = sectionId;
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.sectionService.getProductsBySectionTypeResume(session, this.sectionId, __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.promoRegularOffersCode, fetchPageId, __WEBPACK_IMPORTED_MODULE_3__config_config__["a" /* AppConfig */].app.defaultPageSize).subscribe((products) => {
                observer.next(products);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
};
HomePromosTemplateRegularOffersDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_4__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_0__products_providers_section_section_service__["a" /* SectionService */]])
], HomePromosTemplateRegularOffersDataSet);

//# sourceMappingURL=home-promos-template-regular-offers-dataset.js.map

/***/ }),

/***/ 722:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSeasonsDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_ionic_angular__ = __webpack_require__(8);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







/**
 * Fuente de datos para el Tab de TEMPORADAS
 */
let HomeSeasonsDataSet = class HomeSeasonsDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, events, productService) {
        super();
        this.sessionManager = sessionManager;
        this.events = events;
        this.productService = productService;
        //Lista de datos
        this.seasons = [];
        //La lista de temporadas se ha inicializado con datos
        this.seasonsInitialized = false;
    }
    //Seccion de productos que se desea cargar
    setSeasonId(seasonId) {
        this.seasonId = seasonId;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider para la categoria especificada
    //Este metodo se usa para cuando el DataSet esta en modo stateFull y realizando paginacion
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            this.getSeasonProductsData(this.seasonId, fetchPageId, 0).subscribe((seasonFetched) => {
                observer.next(seasonFetched.products);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
    //Esta funcionalidad se utiliza para extender el comportamiento estandar del DataSet, dado
    //que se lleva el control de multiples detalles de productos por cada Temporadas
    initializeSeasons(callback) {
        this.seasons = [];
        this.prepare();
        this.productService.getSeasons(this.sessionManager.getSession().toModel()).subscribe((list) => {
            this.seasons = list;
            this.loadSeasons();
        });
    }
    performInitSeasons() {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            this.initializeSeasons();
            observer.next();
            observer.complete();
        });
    }
    loadSeasons(callback) {
        if (this.seasons && this.seasons.length > 0) {
            let observables = [];
            for (var i = 0; i < this.seasons.length; i++) {
                observables.push(this.getSeasonProductsData(this.seasons[i].seasonId, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage, i));
            }
            __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"].forkJoin(observables).subscribe(data => {
                for (var i = 0; i < data.length; i++) {
                    var fetchedCategory = data[i];
                    var index = fetchedCategory.index;
                    var list = fetchedCategory.products;
                    var season = this.seasons[index];
                    season.products = [];
                    season.featureProducts = [];
                    if (list && list.length > 0) {
                        season.products = list;
                        if (season.products.length >= 4) {
                            season.featureProducts = season.products.slice(0, 6);
                        }
                    }
                    if (index + 1 === this.seasons.length) {
                        //Se ha realizado una carga inicial de las categorias
                        this.seasonsInitialized = true;
                        //Indica al DataSet que el estado de procesamiento/recuperacion de datos ha finalizado
                        this.finishProcessing();
                        this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.LOBBY_SEASONS_READY, this.seasons);
                        if (callback) {
                            callback(this.getSeasonsState());
                        }
                    }
                }
            });
        }
        else {
            this.events.publish(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.LOBBY_SEASONS_READY, this.seasons);
        }
    }
    //Realiza la consulta propia del provider para la temporada especificada
    getSeasonProductsData(seasonId, fetchPageId, index) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            var season = {};
            var tempList = [];
            var params = {};
            if (this.sessionManager.isAuthenticated()) {
                params.userId = this.sessionManager.getPrincipal().userId;
                params.token = this.sessionManager.getToken();
            }
            params.seasonId = seasonId;
            params.pageId = fetchPageId;
            params.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            this.productService.getSeasonProducts(params).subscribe((list) => {
                tempList = list;
                season.seasonId = seasonId;
                season.products = tempList;
                season.index = index;
                observer.next(season);
                observer.complete();
            }, error => {
                observer.next(season);
                observer.complete();
            });
        });
    }
    clearAndPreload(callback) {
        this.clear();
        this.seasonId = 0;
        this.seasons = [];
        let state = this.getSeasonsState();
        state["seasons"] = [];
        if (callback)
            callback(state);
        this.initializeSeasons();
    }
    fetchSeasons(callback) {
        if (callback)
            callback(this.getSeasonsState());
    }
    getSeasonsState() {
        let state = this.getState();
        state["seasons"] = this.seasons;
        return state;
    }
    prepareSeasons(callback) {
        this.prepare(callback);
        if (this.seasonsInitialized) {
            this.finishProcessing();
            if (callback)
                callback(this.getSeasonsState());
        }
        else {
            if (callback)
                callback(this.getSeasonsState());
        }
    }
};
HomeSeasonsDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_6_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], HomeSeasonsDataSet);

//# sourceMappingURL=home-seasons-dataset.js.map

/***/ }),

/***/ 723:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSectionDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__home_providers_home_section_service__ = __webpack_require__(148);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let HomeSectionDataSet = class HomeSectionDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, sectionService) {
        super();
        this.sessionManager = sessionManager;
        this.sectionService = sectionService;
        //this.setPreviewPageSize(50); //Muestra una cantidad para preview
    }
    //Seccion de productos que se desea cargar
    setSectionId(sectionId) {
        this.sectionId = sectionId;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"](observer => {
            var params = {};
            let session = this.sessionManager.getSession().toModel();
            params.userId = session && session.userId > 0 ? session.userId : null;
            params.token = session && session.token > 0 ? session.token : null;
            params.page = fetchPageId;
            params.records = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPageSize;
            params.sectionId = this.sectionId;
            this.sectionService.getSectionsProducts(params).subscribe((resultList) => {
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
HomeSectionDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_3__home_providers_home_section_service__["a" /* HomeSectionService */]])
], HomeSectionDataSet);

//# sourceMappingURL=home-section-dataset.js.map

/***/ }),

/***/ 724:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSectionDataSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let HomeSectionDataSetNavigator = class HomeSectionDataSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
};
HomeSectionDataSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], HomeSectionDataSetNavigator);

//# sourceMappingURL=home-section-dataset-navigator.js.map

/***/ }),

/***/ 725:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeSuggestedDataSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let HomeSuggestedDataSetNavigator = class HomeSuggestedDataSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
    /* Este metodo se utiliza para indicarle al procesador de paginacion si en el caso de que una vez se calcule los
  datos que se van a mandar al view que corresponde al tamano de una pagina, ejm 10 items,  si quedan 3 en memoria y
  esta funcion devuelve true, entonces se devuelve TODO al view, o sea, 13 items.*/
    dispatchAllSizeLessThanChunkSize() {
        return true;
    }
};
HomeSuggestedDataSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], HomeSuggestedDataSetNavigator);

//# sourceMappingURL=home-suggested-dataset-navigator.js.map

/***/ }),

/***/ 726:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PromosDailyService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let PromosDailyService = class PromosDailyService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = false;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    resetPage() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.pageReseted = true;
    }
    clear() {
        this.resetPage();
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let session = this.sessionManager.getSession().toModel();
            this.productService.getPromoProducts(session, __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.promoDailyOffersCode, this.pageId, this.pageRows).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    //Si esta en TRUE la paginacion es manejada automaticamente, de lo contrario
                    //se ha dicho explicitamente que reinicie y cargue de manera silenciosa la paggina inicial
                    if (this.pageReseted) {
                        this.list = resultList;
                        this.pageId++;
                        this.pageReseted = false;
                    }
                    else {
                        for (let i = 0; i < resultList.length; i++) {
                            this.list.push(resultList[i]);
                        }
                        this.pageId++;
                    }
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
PromosDailyService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__product_product_service__["a" /* ProductService */]])
], PromosDailyService);

//# sourceMappingURL=promos-daily-listing-service.js.map

/***/ }),

/***/ 727:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NotificationDeailsDetailPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__util_view_utils__ = __webpack_require__(43);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




let NotificationDeailsDetailPage = class NotificationDeailsDetailPage {
    constructor(navCtrl, sessionManager, appCtrl, navParams) {
        this.navCtrl = navCtrl;
        this.sessionManager = sessionManager;
        this.appCtrl = appCtrl;
        this.navParams = navParams;
        this.currencySymbol = this.sessionManager.getCurrencySymbol();
    }
    ionViewWillEnter() {
        this.item = this.navParams.get("notification");
    }
    fireOpenProduct(product) {
        this.appCtrl.getRootNav().push('ProductDetailPage', { product: product });
    }
    navbarBackground() {
        return __WEBPACK_IMPORTED_MODULE_3__util_view_utils__["a" /* ViewUtils */].getNavBarColor(this.sessionManager);
    }
};
NotificationDeailsDetailPage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'page-notifications-deals-detail',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\notifications\pages\notifications-deals-details\notifications-deals-details.html"*/'<ion-header no-border class="header-ion-header" [ngStyle]="navbarBackground()">\n\n  <ion-navbar no-border transparent class="home-nav">\n\n    <button ion-button menuToggle color="light">\n\n      <ion-icon name="md-menu"></ion-icon>\n\n    </button>\n\n    <ion-title class="header-ion-title" color="light">\n\n      <div class="header-title-bar">\n\n        <img showWhen="android,windows" class="header-title-image" height="40" alt="logo"\n\n          src="assets/images/general/Logo-E-Fast.png">\n\n        <img showWhen="ios" height="40" alt="logo" src="assets/images/general/Logo-E-Fast.png">\n\n      </div>\n\n    </ion-title>\n\n  </ion-navbar>\n\n  <ion-toolbar no-border class="header-toolbar-title lg-txt">\n\n    NOVEDADES Y PROMOS\n\n  </ion-toolbar>\n\n</ion-header>\n\n\n\n<ion-content>\n\n\n\n  <ion-card class="productDetail" *ngIf="item">\n\n    <ion-row wrap>\n\n      <ion-col col-12 text-wrap text-left class="notification">\n\n        <span *ngIf="item.read">\n\n          <ion-icon name="md-pricetags"></ion-icon>&nbsp;<b>{{item.message}}</b>\n\n        </span>\n\n        <ion-icon class="new-notification" *ngIf="!item.read" name="md-notifications"></ion-icon><span\n\n          class="new-notification" *ngIf="!item.read">&nbsp;<b>{{item.message}}</b></span>\n\n      </ion-col>\n\n    </ion-row>\n\n\n\n    <ion-card-content *ngIf="item.details && item.details.length > 0">\n\n      <ion-row wrap class="product-thumbnail-items-sugg">\n\n        <ion-col col-6 *ngFor="let item of item.details">\n\n          <!--se coloca col-12 ya que el display:flex hace que el div reduzca su tamaño mientras carga-->\n\n          <!--no margin y no-padding son necesarios ya que col-12 agrega padding y margin-->\n\n          <div no-margin no-padding col-12\n\n            [ngClass]="item.discountPercentage && item.discountPercentage > 0 ? \'listing listing-featured\' : \'listing\'">\n\n            <div no-margin no-padding col-12 class="image">\n\n              <img-loader src="{{item.image}}" tappable [useImg]="true" (click)="fireOpenProduct(item)"></img-loader>\n\n            </div>\n\n            <h2 text-left tappable (click)="fireOpenProduct(item)"><label class="md-txt">{{item.description}}</label>\n\n            </h2>\n\n            <h3 text-left tappable class="h3-group-label" (click)="fireOpenProduct(item)" *ngIf="item.groupLabel">\n\n              <label class="md-txt">{{item.groupLabel | uppercase }}</label>\n\n            </h3>\n\n            <div class="price-line">\n\n              <div *ngIf="item.icon" [style.color]="item.iconColor ? item.iconColor : \'danger\'">\n\n                <ion-icon [ngClass]="item.iconEffect ? (\'icon-anim \' + item.iconEffect) : \'icon-anim\'"\n\n                  name="{{item.icon}}"></ion-icon>\n\n                <h3 class="h3-normal-anim" *ngIf="item.discountPercentage === 0" text-left tappable>\n\n                  <label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label>\n\n                </h3>\n\n                <h3 class="h3-discount-anim" *ngIf="item.discountPercentage > 0" text-left tappable>\n\n                  <span><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></span>\n\n                </h3>\n\n              </div>\n\n              <ng-container *ngIf="!item.icon">\n\n                <h3 class="h3-normal" *ngIf="item.discountPercentage === 0" text-left tappable>\n\n                  <label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label>\n\n                </h3>\n\n                <h3 class="h3-discount" *ngIf="item.discountPercentage > 0" text-left tappable>\n\n                  <span><label class="md-txt-lg">{{item.discountPercentage}}%</label></span>\n\n                  <span><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></span>\n\n                </h3>\n\n              </ng-container>\n\n            </div>\n\n          </div>\n\n        </ion-col>\n\n      </ion-row>\n\n    </ion-card-content>\n\n\n\n  </ion-card>\n\n</ion-content>'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\notifications\pages\notifications-deals-details\notifications-deals-details.html"*/,
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavController"],
        __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["App"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavParams"]])
], NotificationDeailsDetailPage);

//# sourceMappingURL=notifications-deals-details.js.map

/***/ }),

/***/ 728:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NotificationDealsDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__notifications_providers_offers_service__ = __webpack_require__(167);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let NotificationDealsDataSet = class NotificationDealsDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, offerService) {
        super();
        this.sessionManager = sessionManager;
        this.offerService = offerService;
    }
    setDealCode(dealCode) {
        this.dealCode = dealCode;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            let offerParams = {};
            offerParams.token = this.sessionManager.getToken();
            offerParams.userId = this.sessionManager.getPrincipal().userId;
            offerParams.offerId = this.dealCode;
            offerParams.pageId = fetchPageId;
            offerParams.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            this.offerService.getOfferDetail(offerParams).subscribe((list) => {
                observer.next(list);
                observer.complete();
            }, error => {
                observer.next([]);
                observer.complete();
            });
        });
    }
};
NotificationDealsDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__notifications_providers_offers_service__["a" /* OffersService */]])
], NotificationDealsDataSet);

//# sourceMappingURL=notification-deals-dataset.js.map

/***/ }),

/***/ 729:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return NotificationSettingsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__model_notification_settings_model__ = __webpack_require__(1153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_notifications_TYPE_model__ = __webpack_require__(1154);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let NotificationSettingsService = class NotificationSettingsService {
    constructor(rest) {
        this.rest = rest;
    }
    //Consulta la configuración de notificaciones
    getNotificationsType(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_notifications_TYPE_model__["a" /* NotificationTypeMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_CONFIGURATION_TYPE, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_5__model_notifications_TYPE_model__["a" /* NotificationTypeMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consulta la configuración de notificaciones
    getNotificationsConfig(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_notification_settings_model__["a" /* NotificationSettingsMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_CONSULT_CONFIGURATION, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_notification_settings_model__["a" /* NotificationSettingsMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    //Consulta la configuración de notificaciones
    saveNotificationsConfig(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_3__model_notification_settings_model__["a" /* NotificationSettingsMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_MODIFY_NOTIFICATION_SETTINGS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_3__model_notification_settings_model__["a" /* NotificationSettingsMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
NotificationSettingsService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], NotificationSettingsService);

//# sourceMappingURL=notification-settings-service.js.map

/***/ }),

/***/ 73:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
class SessionDataSet {
}
/* harmony export (immutable) */ __webpack_exports__["a"] = SessionDataSet;

//# sourceMappingURL=session-dataset-service.js.map

/***/ }),

/***/ 730:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SubsidiaryService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_subsidiary_model__ = __webpack_require__(1160);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let SubsidiaryService = class SubsidiaryService {
    constructor(rest) {
        this.rest = rest;
    }
    getProvinces(session) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_subsidiary_model__["a" /* SubsidiaryMapper */].convertModelToRequest(session);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SUBSIDIARY_PROVINCES, paramsString).subscribe((response) => {
                if (response && response.length > 0) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_subsidiary_model__["a" /* SubsidiaryMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getCantons(session, province) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_subsidiary_model__["a" /* SubsidiaryMapper */].convertModelToRequest(session, province);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SUBSIDIARY_CANTONS, paramsString).subscribe((response) => {
                if (response && response.length > 0) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_subsidiary_model__["a" /* SubsidiaryMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getSubsidiaries(session, province, cantone) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_subsidiary_model__["a" /* SubsidiaryMapper */].convertModelToRequest(session, province, cantone);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_SUBSIDIARY_LIST, paramsString).subscribe((response) => {
                if (response && response.length > 0) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_subsidiary_model__["a" /* SubsidiaryMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
SubsidiaryService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], SubsidiaryService);

//# sourceMappingURL=subsidiaries-service.js.map

/***/ }),

/***/ 731:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductListingFilteredPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__util_view_utils__ = __webpack_require__(43);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_wishlist_wish_list_helper_service__ = __webpack_require__(270);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__providers_product_product_helper_service__ = __webpack_require__(271);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__home_pages_home_utils__ = __webpack_require__(272);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__util_scroll_top_handler__ = __webpack_require__(683);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__datasets_product_listing_dataset_navigator__ = __webpack_require__(283);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__datasets_product_listing_similar_dataset_navigator__ = __webpack_require__(284);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_14_rxjs__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};















let ProductListingFilteredPage = class ProductListingFilteredPage {
    constructor(platform, appCtrl, navCtrl, navParams, sessionManager, toastCtrl, alertCtrl, wishListHelper, translate, actionSheetCtrl, productHelper, loadingCtrl, changeDetector, 
        // private ga: GoogleAnalytics,
        events, productService, cartManager, dataSetNavigator, dataSetSimilarNavigator) {
        this.platform = platform;
        this.appCtrl = appCtrl;
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.sessionManager = sessionManager;
        this.toastCtrl = toastCtrl;
        this.alertCtrl = alertCtrl;
        this.wishListHelper = wishListHelper;
        this.translate = translate;
        this.actionSheetCtrl = actionSheetCtrl;
        this.productHelper = productHelper;
        this.loadingCtrl = loadingCtrl;
        this.changeDetector = changeDetector;
        this.events = events;
        this.productService = productService;
        this.cartManager = cartManager;
        this.dataSetNavigator = dataSetNavigator;
        this.dataSetSimilarNavigator = dataSetSimilarNavigator;
        //ID del timer que se utiliza en el View para los cronos de promos por finalizar
        this.timerId = 0;
        this.activateTimers = false;
        this.activateOrdering = false;
        //Variables que se actualizan del DataSet, para modificar el View
        this.list = [];
        this.isTimeout = false;
        this.isFetchingData = true;
        this.listSimilar = [];
        this.showSimilarSection = false;
        this.isFetchingSimilarData = true;
        this.firstSimilarFetchedDone = false;
        this.showQuickAccessButton = false;
        //Maneja el auto refrescado
        this.skipAutoRefresh = false;
        //Llego a la ultima pagina
        this.reachedFinalPage = false;
        this.reachedSimilarsFinalPage = false;
        this.isInfiniteScrollFired = false;
        this.dataSetWarningShown = false;
        this.filters = [];
        this.showOrdering = false;
        this.showBackFiltersButton = false;
        this.showBackFiltersButtonQty = 0;
        //Moneda actual de la sesion
        this.currencySymbol = this.sessionManager.getCurrencySymbol();
        let deregisterFunction = this.platform.registerBackButtonAction(() => {
            this.handleAndroidBackButton(deregisterFunction);
        });
    }
    /*****************************************************************
     * Ciclo de vida del View
     *****************************************************************/
    ngOnInit() {
        //Manejo de binginds de manera manual, por performance
        this.changeDetector.detach();
        this.scrollTopHandler = new __WEBPACK_IMPORTED_MODULE_9__util_scroll_top_handler__["a" /* ScrollTopHandler */](this.content, this.platform);
    }
    ionViewDidLoad() {
        this.filters = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.APP_PLATFORM_ALERT_CLOSE, () => {
            this.fixScroll();
        });
        //Manejo de limpieza de memoria de datos
        this.content.ionScrollStart.subscribe((event) => {
            if (this.showSimilarSection) {
                if (event.directionY === "down" && this.platform.is('ios') && !this.reachedSimilarsFinalPage) {
                    setTimeout(() => {
                        this.dataSetSimilarNavigator.gc((state) => {
                            this.reachedSimilarsFinalPage = state.dataRetrievedForPageIsEmpty || state.list.length < 6;
                            this.list = state.list;
                            this.changeDetector.detectChanges();
                        });
                    }, 200);
                }
            }
            else {
                if (event.directionY === "down" && this.platform.is('ios') && !this.reachedFinalPage) {
                    setTimeout(() => {
                        this.dataSetNavigator.gc((state) => {
                            this.reachedFinalPage = state.dataRetrievedForPageIsEmpty || state.list.length < 6;
                            this.list = state.list;
                            this.changeDetector.detectChanges();
                        });
                    }, 200);
                }
            }
        });
        //Cuando el carrito se actualiza
        this.cartStoredItems = this.cartManager.getStoredItemsQuantity();
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.SHOPPING_CART_REFRESHED, (cartStoredItems) => {
            //Setea la cantidad de items
            this.cartStoredItems = cartStoredItems;
            this.changeDetector.detectChanges();
        });
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].event.ITEM_CHANGED_IN_WISHLIST_LIST, (event) => {
            if (this.selectedProduct && event && event.product.productCode === this.selectedProduct.productCode) {
                this.selectedProduct.isInWishList = event.product.isInWishList;
            }
            this.changeDetector.detectChanges();
        });
    }
    ionViewWillEnter() {
        this.showSearchFilters = false;
        this.isInfiniteScrollFired = false;
        //Esta bandera cancela la actualizacion del estado del View, y es cargada
        //por la pantalla detalle del producto
        if (!this.skipAutoRefresh) {
            this.authenticated = this.sessionManager.isAuthenticated();
            this.title = this.navParams.get("title");
            this.subtitle = this.navParams.get("subtitle");
            this.activateTimers = this.navParams.get("activateTimers");
            this.activateOrdering = this.navParams.get("activateOrdering");
            this.dataSet = this.navParams.get("dataSet");
            this.dataSetSimilar = this.navParams.get("dataSetSimilar");
            this.showQuickAccessButton = this.navParams.get("showQuickAccessButton");
            this.showSearchFilters = this.navParams.get("showSearchFilters");
            this.searchFilter = this.navParams.get("searchFilter");
            this.showOrdering = this.navParams.get("showOrdering");
            this.showBackFiltersButton = this.navParams.get("showBackFiltersButton");
            this.showBackFiltersButtonQty = this.navParams.get("showBackFiltersButtonQty");
            this.dataSet.setPlatform(this.platform);
            this.dataSetNavigator.setDataSet(this.dataSet);
            this.dataSetNavigator.setPlatform(this.platform);
            this.reachedFinalPage = false;
            this.reachedSimilarsFinalPage = false;
            this.showSimilarSection = false;
            this.firstSimilarFetchedDone = false;
            this.similarSubtitle = "";
            this.triggerScrollTop();
            //Notifica cambios de bindings al framework relacionados a titulos
            this.changeDetector.detectChanges();
            //En caso de proveerse un DataSet adicional, siempre lo mantiene vacio
            if (this.dataSetSimilar) {
                this.dataSetSimilar.setPlatform(this.platform);
                this.dataSetSimilarNavigator.setPlatform(this.platform);
                this.dataSetSimilarNavigator.setDataSet(this.dataSetSimilar);
                this.dataSetSimilarNavigator.clear();
            }
            //Guarda un snapshot del estado actual del DataSet
            this.dataSet.takeStateSnapshot();
            //Si el dataset viene con datos
            if (!this.dataSet.isEmpty()) {
                //Dado que el dataSet puede venir precargado aprovecha esta data para desplegarlade inicio
                this.dataSetNavigator.sync((state) => {
                    this.reachedFinalPage = state.dataRetrievedForPageIsEmpty || state.list.length < 6;
                    this.fixScroll();
                    setTimeout(() => {
                        this.updateViewState(state);
                    }, 500);
                });
                //this.updateViewState(this.dataSetNavigator.getState());
                //En caso de proveerse un DataSet adicional, y no hay muchos datos, carga de una vez el set
                if (this.dataSetSimilar) {
                    if (this.list.length <= 6) {
                        this.showSimilarSection = true;
                        this.changeDetector.detectChanges();
                    }
                    //Carga datos y actualiza el estado del view con respecto al estado del provider
                    this.dataSetSimilarNavigator.fetch((state) => {
                        this.firstSimilarFetchedDone = true;
                        this.fixScroll();
                        setTimeout(() => {
                            this.updateSimilarViewState(state);
                        }, 500);
                    });
                }
            }
            else {
                //Utiliza el mismo callback en caso de SUCESS o en caso de TIMEOUT
                if (this.dataSet.isKeepEmpty()) {
                    this.updateViewState(this.dataSetNavigator.getEmptyState());
                    if (this.dataSetSimilar) {
                        if (this.list.length <= 6) {
                            this.showSimilarSection = true;
                            this.changeDetector.detectChanges();
                        }
                        //Carga datos y actualiza el estado del view con respecto al estado del provider
                        this.dataSetSimilarNavigator.fetch((state) => {
                            this.firstSimilarFetchedDone = true;
                            this.fixScroll();
                            setTimeout(() => {
                                this.updateSimilarViewState(state);
                            }, 500);
                        });
                    }
                }
                else {
                    let callback = (state) => {
                        this.fixScroll();
                        setTimeout(() => {
                            this.updateViewState(state);
                        }, 500);
                    };
                    //Carga datos y actualiza el estado del view con respecto al estado del provider
                    this.dataSetNavigator.fetchWithTimeoutCheck(callback, callback);
                }
            }
        }
        else {
            this.skipAutoRefresh = false;
        }
    }
    ionViewDidEnter() {
        this.navBar.backButtonClick = () => {
            this.handlBackNavigation();
        };
    }
    ionViewWillLeave() {
        if (!this.skipAutoRefresh) {
            //Reset del timer
            this.clearTimer();
            //Limpia el provider y actualiza el estado del view
            this.dataSetNavigator.clear((state) => this.updateViewState(state));
            //En caso de proveerse un DataSet adicional, siempre lo mantiene vacio
            if (this.dataSetSimilar) {
                this.dataSetSimilarNavigator.clear((state) => this.updateSimilarViewState(state));
            }
            //Restaura el DataSet al estado original
            this.dataSet.restoreStateSnapshot();
        }
    }
    handlBackNavigation() {
        if (this.showBackFiltersButton) {
            this.navCtrl.pop({ animate: false });
            this.navCtrl.pop({ animate: false });
            this.navCtrl.pop({ animate: false });
        }
        else {
            this.navCtrl.pop();
        }
    }
    handleAndroidBackButton(deregisterFunction) {
        this.handlBackNavigation();
    }
    performLazyLoad(item) {
        item.imageShow = true;
        this.changeDetector.detectChanges();
    }
    selectFilters() {
        if (this.filters.length === 0) {
            this.fetchAttributes(() => {
                this.navCtrl.push('SearchFilterPage', { filter: this.searchFilter, filterCriterias: this.filters }, { animate: false });
            });
        }
        else {
            this.navCtrl.push('SearchFilterPage', { filter: this.searchFilter, filterCriterias: this.filters }, { animate: false });
        }
    }
    fetchAttributes(callback) {
        const loading = this.loadingCtrl.create();
        loading.present();
        this.productService.getFilterAttributes(this.searchFilter).subscribe((attributes) => {
            let tempFilters = [];
            attributes.forEach((value) => {
                tempFilters.push({
                    id: value.attributeId,
                    description: value.atributte
                });
            });
            let observables = [];
            tempFilters.forEach((value) => {
                observables.push(this.fetchAttributeValues(value));
            });
            __WEBPACK_IMPORTED_MODULE_14_rxjs__["Observable"].forkJoin(observables)
                .subscribe(data => {
                this.filters = data;
                loading.dismiss();
                if (callback)
                    callback();
            });
        });
    }
    fetchAttributeValues(item) {
        return new __WEBPACK_IMPORTED_MODULE_14_rxjs__["Observable"](observer => {
            this.searchFilter.filterAttr = item.id.toString();
            this.productService.getFilterAttributeValues(this.searchFilter).subscribe((values) => {
                let details = [];
                values.forEach((value) => {
                    details.push({
                        id: item.id,
                        description: value.atributteDetail
                    });
                });
                item.details = details;
                observer.next(item);
                observer.complete();
            });
        });
    }
    handleFiltersBack() {
        this.navCtrl.pop({ animate: false });
    }
    updateViewState(providerState) {
        if (providerState) {
            this.isTimeout = providerState.isTimeout;
            this.isFetchingData = providerState.isFetchingData;
            this.list = providerState.list;
            //Manejo de filtros
            if (this.searchFilter && this.list.length > 0) {
                this.searchFilter.searchPaginationId = this.list[0].searchPaginationId;
            }
            this.startTimer();
            //Notifica cambios de bindings al framework
            this.changeDetector.detectChanges();
        }
    }
    updateSimilarViewState(providerState) {
        if (providerState) {
            this.isFetchingSimilarData = providerState.isFetchingData;
            this.listSimilar = providerState.list;
            this.similarSubtitle = this.dataSetSimilar.getSummary();
            //Notifica cambios de bindings al framework
            this.changeDetector.detectChanges();
        }
    }
    navbarBackground() {
        return __WEBPACK_IMPORTED_MODULE_4__util_view_utils__["a" /* ViewUtils */].getNavBarColor(this.sessionManager);
    }
    /*****************************************************************
     * Manejo del timer para los tiempos a expirar en los productos
     *****************************************************************/
    startTimer() {
        this.clearTimer();
        if (this.activateTimers && this.list && this.list.length > 0) {
            this.timerId = Number(setInterval(() => { this.renderTimers(); }, 1000));
        }
    }
    renderTimers() {
        for (let i = 0; i < this.list.length; i++) {
            let product = this.list[i];
            if (product.promoExpiration > 0) {
                var countDownDate = product.promoExpiration;
                var now = new Date().getTime();
                var distance = countDownDate - now;
                // Time calculations for days, hours, minutes and seconds
                //var days = Math.floor(distance / (1000 * 60 * 60 * 24));
                var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
                var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
                var seconds = Math.floor((distance % (1000 * 60)) / 1000);
                if (hours > 0) {
                    product.promoTimerExpression = (hours < 9 ? "0" + hours : hours) + ":" + (minutes < 9 ? "0" + minutes : minutes) + ":" + (seconds < 9 ? "0" + seconds : seconds);
                }
                else {
                    product.promoTimerExpression = (minutes < 9 ? "0" + minutes : minutes) + ":" + (seconds < 9 ? "0" + seconds : seconds);
                }
                if (distance < 0) {
                    product.promoTimerExpression = "EXPIRADO";
                }
            }
        }
        this.changeDetector.detectChanges();
    }
    clearTimer() {
        //Resetea el timer
        if (this.timerId) {
            clearInterval(this.timerId);
        }
    }
    /*****************************************************************
     * Manejo de informacion, paginacion y control de data para el View
     *****************************************************************/
    //Utilizado por el ngFor para almacenar en memoria cada item mediante el ID devuelto
    trackByFn(index, item) {
        let id = +item.productCode;
        return id;
    }
    /*****************************************************************
     * Manejo de eventos que se disparan en el View
     *****************************************************************/
    triggerScrollTop() {
        this.scrollTopHandler.scrollTop();
    }
    triggerScrollBottom() {
        this.scrollTopHandler.scroll();
    }
    //Muestra las opciones de listas de deseos
    fireWishListAction(item) {
        __WEBPACK_IMPORTED_MODULE_8__home_pages_home_utils__["a" /* HomeUtils */].handleWishList(this.sessionManager.isAuthenticated(), this.wishListHelper, this.alertCtrl, this.translate, this.navCtrl, item);
    }
    openCart() {
        this.skipAutoRefresh = true;
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].session.LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED, true);
        this.navCtrl.push('CartPage');
    }
    fireOpenProduct(product) {
        this.selectedProduct = product;
        this.skipAutoRefresh = true;
        this.appCtrl.getRootNav().push('ProductDetailPage', { product: product });
    }
    fireProductMenu(item) {
        this.productHelper.showProductMenu(this.appCtrl, this.navCtrl, this.actionSheetCtrl, item);
    }
    fireOpenCategories() {
        this.appCtrl.getRootNav().push('ProductCategorySetupPage');
    }
    fireInfiniteScroll(infiniteScroll) {
        //console.log("fireInfiniteScroll LISTING...("+this.reachedFinalPage+")");
        this.isInfiniteScrollFired = true;
        this.changeDetector.detectChanges();
        this.isTimeout = false;
        if (this.showSimilarSection) {
            if (this.firstSimilarFetchedDone) {
                setTimeout(() => {
                    let callback = (state) => {
                        this.reachedSimilarsFinalPage = state.dataRetrievedForPageIsEmpty || state.list.length < 6;
                        this.updateSimilarViewState(state);
                    };
                    let onShrink = (state) => {
                        this.reachedSimilarsFinalPage = state.dataRetrievedForPageIsEmpty || state.list.length < 6;
                        this.listSimilar = state.list;
                        this.changeDetector.detectChanges();
                        this.content.resize();
                        setTimeout(() => {
                            if (!this.platform.is('ios'))
                                this.content.scrollToBottom(0);
                            this.dataSetSimilarNavigator.next(callback, null);
                        }, 1000);
                        __WEBPACK_IMPORTED_MODULE_4__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.updatingData"), 2200);
                    };
                    this.dataSetSimilarNavigator.next(callback, onShrink);
                    infiniteScroll.complete();
                }, 500);
            }
        }
        else {
            setTimeout(() => {
                let callback = (state) => {
                    this.reachedFinalPage = state.dataRetrievedForPageIsEmpty || state.list.length < 6;
                    this.updateViewState(state);
                    this.handleSimilarPanelActivation();
                };
                let onShrink = (state) => {
                    this.reachedFinalPage = state.dataRetrievedForPageIsEmpty || state.list.length < 6;
                    this.list = state.list;
                    this.changeDetector.detectChanges();
                    this.content.resize();
                    setTimeout(() => {
                        this.handleSimilarPanelActivation();
                        if (!this.platform.is('ios'))
                            this.content.scrollToBottom(0);
                        this.dataSetNavigator.next(callback, null);
                    }, 1000);
                    __WEBPACK_IMPORTED_MODULE_4__util_view_utils__["a" /* ViewUtils */].presentToast(this.toastCtrl, this.translate.instant("messages.updatingData"), 2200);
                };
                this.dataSetNavigator.next(callback, onShrink);
                infiniteScroll.complete();
            }, 500);
        }
    }
    handleSimilarPanelActivation() {
        if (this.reachedFinalPage) {
            if (this.dataSetSimilar) {
                this.showSimilarSection = true;
                this.firstSimilarFetchedDone = true;
                this.changeDetector.detectChanges();
                this.dataSetSimilarNavigator.fetch((state) => {
                    this.updateSimilarViewState(state);
                });
            }
        }
    }
    fireScrollToBottom() {
        this.changeDetector.detectChanges();
        if (!this.platform.is('ios')) {
            setTimeout(() => {
                this.content.scrollToBottom(0);
            }, 200);
        }
    }
    finishFakeImages() {
        this.isTimeout = false;
        this.changeDetector.detectChanges();
    }
    fireOrdering() {
        let buttonList = [];
        buttonList = [
            {
                text: this.translate.instant('search.sortByColor'),
                cssClass: 'action-sheet-button',
                icon: !this.platform.is('ios') ? 'color-palette' : null,
                handler: () => {
                    const loading = this.loadingCtrl.create();
                    loading.present();
                    this.dataSet.setSortBy(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].sorting.COLOR);
                    this.dataSetNavigator.fetch((state) => {
                        this.updateViewState(state);
                        this.subtitle = this.translate.instant('search.sortByColorLabel');
                        loading.dismiss();
                    });
                }
            },
            {
                text: this.translate.instant('search.sortByRatingDesc'),
                cssClass: 'action-sheet-button',
                icon: !this.platform.is('ios') ? 'star' : null,
                handler: () => {
                    const loading = this.loadingCtrl.create();
                    loading.present();
                    this.dataSet.setSortBy(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].sorting.RATING_5_0);
                    this.dataSetNavigator.fetch((state) => {
                        this.updateViewState(state);
                        this.subtitle = this.translate.instant('search.sortByRatingDescLabel');
                        loading.dismiss();
                    });
                }
            },
            {
                text: this.translate.instant('search.sortByRatingAsc'),
                cssClass: 'action-sheet-button',
                icon: !this.platform.is('ios') ? 'star-outline' : null,
                handler: () => {
                    const loading = this.loadingCtrl.create();
                    loading.present();
                    this.dataSet.setSortBy(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].sorting.RATING_0_5);
                    this.dataSetNavigator.fetch((state) => {
                        this.updateViewState(state);
                        this.subtitle = this.translate.instant('search.sortByRatingAscLabel');
                        loading.dismiss();
                    });
                }
            },
            {
                text: this.translate.instant('search.sortByPrice'),
                cssClass: 'action-sheet-button',
                icon: !this.platform.is('ios') ? 'pricetag' : null,
                handler: () => {
                    const loading = this.loadingCtrl.create();
                    loading.present();
                    this.dataSet.setSortBy(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].sorting.PRICE);
                    this.dataSetNavigator.fetch((state) => {
                        this.updateViewState(state);
                        this.subtitle = this.translate.instant('search.sortByPriceLabel');
                        loading.dismiss();
                    });
                }
            },
            {
                text: this.translate.instant('search.sortByBrand'),
                cssClass: 'action-sheet-button',
                icon: !this.platform.is('ios') ? 'flag' : null,
                handler: () => {
                    const loading = this.loadingCtrl.create();
                    loading.present();
                    this.dataSet.setSortBy(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].sorting.BRAND);
                    this.dataSetNavigator.fetch((state) => {
                        this.updateViewState(state);
                        this.subtitle = this.translate.instant('search.sortByBrandLabel');
                        loading.dismiss();
                    });
                }
            },
            {
                text: "Cancelar",
                cssClass: 'action-sheet-cancel-button',
                icon: !this.platform.is('ios') ? 'close' : null,
                handler: () => {
                    actionSheet.dismiss();
                }
            }
        ];
        const actionSheet = this.actionSheetCtrl.create({
            cssClass: 'avatar-action-sheet',
            title: this.translate.instant('search.sortBy'),
            buttons: buttonList
        });
        actionSheet.present();
    }
    handleNavigation(page) {
        //Cancela autorefresh
        this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_6__config_config__["a" /* AppConfig */].session.LOBBY_AUTOCHANGE_TO_DEFAULT_TAB_DISABLED, true);
        __WEBPACK_IMPORTED_MODULE_4__util_view_utils__["a" /* ViewUtils */].handleNavigation(this.navCtrl, page, this.sessionManager);
    }
    fixScroll() {
        if (this.platform.is('ios')) {
            setTimeout(function () {
                document.getElementById('button_wa').click();
            }, 500);
        }
    }
};
__decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Content"]),
    __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Content"])
], ProductListingFilteredPage.prototype, "content", void 0);
__decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["ViewChild"])('navbar'),
    __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Navbar"])
], ProductListingFilteredPage.prototype, "navBar", void 0);
ProductListingFilteredPage = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
        selector: 'product-listing-filtered',template:/*ion-inline-start:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\products\pages\product-listing-filtered\product-listing-filtered.html"*/'<ion-header no-border class="header-ion-header" [ngStyle]="navbarBackground()">\n\n    <ion-navbar #navbar no-border transparent class="home-nav">\n\n        <button ion-button menuToggle color="light">\n\n            <ion-icon name="md-menu"></ion-icon>\n\n        </button>\n\n        <ion-title class="header-ion-title" color="light">\n\n            <div class="header-title-bar">\n\n                <img showWhen="android,windows" class="header-title-image" height="40" alt="logo"\n\n                    src="assets/images/general/Logo-E-Fast.png">\n\n                <img showWhen="ios" height="40" alt="logo" src="assets/images/general/Logo-E-Fast.png">\n\n            </div>\n\n        </ion-title>\n\n        <ion-buttons end>\n\n            <button ion-button button-clear icon-only class="button button-clear" tappable (click)="openCart()">\n\n                <ion-icon name="md-cart" style="font-size: 30px; color:white"></ion-icon>\n\n                <div class="shopping-cart"><span class="badge badge-assertive header-badge"\n\n                        style="color:white">{{cartStoredItems}}</span></div>\n\n            </button>\n\n        </ion-buttons>\n\n        <!--\n\n        <ion-buttons end *ngIf="activateOrdering">\n\n            <button ion-button icon-only tappable color="light" (click)="fireOrdering()">\n\n                <span ion-text>Ordenar</span>\n\n            </button>\n\n        </ion-buttons>-->\n\n    </ion-navbar>\n\n    <ion-toolbar *ngIf="title" no-border class="header-toolbar-title lg-txt" (click)="triggerScrollTop()">\n\n        {{title}}\n\n    </ion-toolbar>\n\n    <ion-toolbar *ngIf="showSearchFilters && list.length > 0" no-border>\n\n        <button ion-button clear class="filter-button" tappable (click)="selectFilters()">\n\n            Filtros&nbsp;&nbsp;<ion-icon name="md-arrow-down"></ion-icon>\n\n        </button>\n\n    </ion-toolbar>\n\n    <ion-toolbar *ngIf="showBackFiltersButton" no-border>\n\n        <button ion-button clear class="filter-button" tappable (click)="handleFiltersBack()">\n\n            Filtros <ng-container *ngIf="this.showBackFiltersButtonQty > 0">({{this.showBackFiltersButtonQty}})\n\n            </ng-container>&nbsp;&nbsp;<ion-icon name="md-arrow-down"></ion-icon>\n\n        </button>\n\n    </ion-toolbar>\n\n</ion-header>\n\n\n\n<ion-content no-padding no-border no-bounce has-bouncing="false">\n\n\n\n    <div *ngIf="subtitle" class="header-page-title">\n\n        {{subtitle}}<button ion-button outline item-end id=\'button_wa\'\n\n            style=\'margin: 0; padding: 0; border: 0; height: 0;\'>&nbsp;</button>\n\n    </div>\n\n\n\n    <div class="home-content">\n\n        <!-- Skeleton structure mientras carga -->\n\n        <ion-card no-padding *ngIf="isFetchingData">\n\n            <ion-card-content no-padding>\n\n                <ion-row wrap class="items">\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                    <ion-col col-6>\n\n                        <div class="listing fake-item">\n\n                            <div class="fake-image-container">\n\n                                <div class="fake-image"></div>\n\n                            </div>\n\n                            <h2></h2>\n\n                            <h3></h3>\n\n                        </div>\n\n                    </ion-col>\n\n                </ion-row>\n\n            </ion-card-content>\n\n        </ion-card>\n\n\n\n        <ng-container *ngIf="!isFetchingData">\n\n            <!-- Se encontraron datos, despliega items -->\n\n            <ion-card class="productDetail" *ngIf="list.length > 0">\n\n                <ion-card-content no-padding>\n\n                    <ion-row wrap class="product-thumbnail-items-sugg">\n\n                        <ion-col col-6 *ngFor="let item of list;trackBy: trackByFn" (deferLoad)="performLazyLoad(item)">\n\n                            <!--se coloca col-12 ya que el display:flex hace que el div reduzca su tamaño mientras carga-->\n\n                            <!--no margin y no-padding son necesarios ya que col-12 agrega padding y margin-->\n\n                            <div no-margin no-padding col-12\n\n                                [ngClass]="item.discountPercentage > 0 ? \'listing listing-featured\' : \'listing\'">\n\n                                <div no-margin no-padding col-12 class="image">\n\n                                    <span *ngIf="item.promoExpiration > 0"\n\n                                        class="code-promo">{{item.promoTimerExpression}}</span>\n\n                                    <div class="wishlist-corner" tappable (click)="fireWishListAction(item)">\n\n                                        <ion-icon name="heart-outline" *ngIf="item.isInWishList == \'N\'"></ion-icon>\n\n                                        <ion-icon name="heart" *ngIf="item.isInWishList == \'S\'"></ion-icon>\n\n                                    </div>\n\n                                    <ng-container *ngIf="item.imageShow">\n\n                                        <img [src]="item.image" tappable (click)="fireOpenProduct(item)" />\n\n                                    </ng-container>\n\n                                    <!--<img-loader src="{{item.image}}" tappable [useImg]="true" (click)="fireOpenProduct(item)"></img-loader>-->\n\n                                </div>\n\n                                <h2 text-left tappable (click)="fireOpenProduct(item)"><label\n\n                                    class="md-txt">{{item.description}}</label></h2>\n\n                                <h3 text-left class="h3-group-label" tappable (click)="fireOpenProduct(item)"\n\n                                    *ngIf="item.groupLabel"><label\n\n                                    class="md-txt">{{item.groupLabel | uppercase }}</label></h3>\n\n                                <div class="price-line">\n\n                                    <div *ngIf="item.icon" [style.color]="item.iconColor ? item.iconColor : \'danger\'">\n\n                                        <ion-icon\n\n                                            [ngClass]="item.iconEffect ? (\'icon-anim \' + item.iconEffect) : \'icon-anim\'"\n\n                                            name="{{item.icon}}"></ion-icon>\n\n                                        <h3 class="h3-normal-anim" *ngIf="item.discountPercentage === 0" text-left\n\n                                            tappable><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></h3>\n\n                                        <h3 class="h3-discount-anim" *ngIf="item.discountPercentage > 0" text-left\n\n                                            tappable>\n\n                                            <span><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></span>\n\n                                        </h3>\n\n                                    </div>\n\n                                    <ng-container *ngIf="!item.icon">\n\n                                        <h3 class="h3-normal" *ngIf="item.discountPercentage === 0" text-left tappable>\n\n                                            <label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></h3>\n\n                                        <h3 class="h3-discount" *ngIf="item.discountPercentage > 0" text-left tappable>\n\n                                            <span><label class="md-txt-lg">{{item.discountPercentage}}%</label></span>\n\n                                            <span><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></span>\n\n                                        </h3>\n\n                                    </ng-container>\n\n                                    <ion-icon name="ios-more" class="thumbnail-product-options" tappable\n\n                                        (click)="fireProductMenu(item)"></ion-icon>\n\n                                </div>\n\n                                <div class="thumbnail-option-section"\n\n                                    *ngIf="(item.isAvailable === \'N\' && item.availableInDays > 0)">\n\n                                    <ion-row *ngIf="item.availableInDays > 0">\n\n                                        <ion-col text-left col-9 class="availavility-notice">\n\n                                            <ng-container *ngIf="item.isAvailable === \'N\' && item.availableInDays > 0">\n\n                                                <span *ngIf="item.availableInDays === 1">Disponible en\n\n                                                    {{item.availableInDays}} d&iacute;a.</span>\n\n                                                <span *ngIf="item.availableInDays > 1">Disponible en\n\n                                                    {{item.availableInDays}} d&iacute;as.</span>\n\n                                            </ng-container>\n\n                                        </ion-col>\n\n                                        <ion-col text-right></ion-col>\n\n                                    </ion-row>\n\n                                </div>\n\n                            </div>\n\n                        </ion-col>\n\n                        <ng-container\n\n                            *ngIf="!isTimeout && !showSimilarSection && isInfiniteScrollFired && !reachedFinalPage">\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                            <!--   <ion-col col-6>\n\n                              <div class="listing fake-item">\n\n                                  <div class="fake-image-container">\n\n                                      <div class="fake-image"></div>\n\n                                  </div>\n\n                                  <h2></h2>\n\n                                  <h3></h3>\n\n                              </div>\n\n                            </ion-col>\n\n                            <ion-col col-6>\n\n                              <div class="listing fake-item">\n\n                                  <div class="fake-image-container">\n\n                                      <div class="fake-image"></div>\n\n                                  </div>\n\n                                  <h2></h2>\n\n                                  <h3></h3>\n\n                              </div>\n\n                            </ion-col> -->\n\n                        </ng-container>\n\n                    </ion-row>\n\n                </ion-card-content>\n\n            </ion-card>\n\n            <!-- No se encontraron datos, despliega mensaje informativo -->\n\n            <ion-card no-padding *ngIf="list.length === 0">\n\n                <ion-card-content no-padding>\n\n                    <div class="empty-message" padding>\n\n                        <ion-row *ngIf="isTimeout">\n\n                            <ion-col text-center>\n\n                                <ion-icon class="empty-icon" name="ios-sync-outline" tappable></ion-icon><br>\n\n                                <label class="lg-txt">¿Tienes conexi&oacute;n de internet?</label>\n\n                            </ion-col>\n\n                        </ion-row>\n\n                        <ion-row *ngIf="!isTimeout">\n\n                            <ion-col text-center>\n\n                                <ion-icon class="empty-icon" name="ios-search-outline" tappable></ion-icon><br>\n\n                                <label class="lg-txt">No encontramos informaci&oacute;n de productos.</label>\n\n                            </ion-col>\n\n                        </ion-row>\n\n                    </div>\n\n                </ion-card-content>\n\n            </ion-card>\n\n        </ng-container>\n\n\n\n\n\n        <ng-container *ngIf="showSimilarSection">\n\n            <!-- Skeleton structure mientras carga -->\n\n            <ng-container *ngIf="isFetchingSimilarData">\n\n                <div class="header-page-title lg-txt">\n\n                    BÚSCANDO ITEMS RELACIONADOS\n\n                </div>\n\n                <ion-card no-padding>\n\n                    <ion-card-content no-padding>\n\n                        <ion-row wrap class="items">\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                            <ion-col col-6>\n\n                                <div class="listing fake-item">\n\n                                    <div class="fake-image-container">\n\n                                        <div class="fake-image"></div>\n\n                                    </div>\n\n                                    <h2></h2>\n\n                                    <h3></h3>\n\n                                </div>\n\n                            </ion-col>\n\n                        </ion-row>\n\n                    </ion-card-content>\n\n                </ion-card>\n\n            </ng-container>\n\n            <ng-container *ngIf="!isFetchingSimilarData">\n\n                <div class="header-page-title md-txt-lg">\n\n                    {{similarSubtitle}}\n\n                </div>\n\n                <!-- Se encontraron datos, despliega items -->\n\n                <ion-card class="productDetail" *ngIf="listSimilar.length > 0">\n\n                    <ion-card-content no-padding>\n\n                        <ion-row wrap class="product-thumbnail-items-sugg">\n\n                            <ion-col col-6 *ngFor="let item of listSimilar;trackBy: trackByFn"\n\n                                (deferLoad)="performLazyLoad(item)">\n\n                                <!--se coloca col-12 ya que el display:flex hace que el div reduzca su tamaño mientras carga-->\n\n                                <!--no margin y no-padding son necesarios ya que col-12 agrega padding y margin-->\n\n                                <div no-margin no-padding col-12\n\n                                    [ngClass]="item.discountPercentage > 0 ? \'listing listing-featured\' : \'listing\'">\n\n                                    <div no-margin no-padding col-12 class="image">\n\n                                        <span *ngIf="item.promoExpiration > 0"\n\n                                            class="code-promo">{{item.promoTimerExpression}}</span>\n\n                                        <div class="wishlist-corner" tappable (click)="fireWishListAction(item)">\n\n                                            <ion-icon name="heart-outline" *ngIf="item.isInWishList == \'N\'"></ion-icon>\n\n                                            <ion-icon name="heart" *ngIf="item.isInWishList == \'S\'"></ion-icon>\n\n                                        </div>\n\n                                        <ng-container *ngIf="item.imageShow">\n\n                                            <img [src]="item.image" tappable (click)="fireOpenProduct(item)" />\n\n                                        </ng-container>\n\n                                        <!--<img-loader src="{{item.image}}" tappable [useImg]="true" (click)="fireOpenProduct(item)"></img-loader>-->\n\n                                    </div>\n\n                                    <h2 text-left tappable (click)="fireOpenProduct(item)"><label\n\n                                        class="md-txt">{{item.description}}</label></h2>\n\n                                    <h3 text-left class="h3-group-label" tappable (click)="fireOpenProduct(item)"\n\n                                        *ngIf="item.groupLabel"><label\n\n                                        class="md-txt">{{item.groupLabel | uppercase }}</label></h3>\n\n                                    <div class="price-line">\n\n                                        <div *ngIf="item.icon"\n\n                                            [style.color]="item.iconColor ? item.iconColor : \'danger\'">\n\n                                            <ion-icon\n\n                                                [ngClass]="item.iconEffect ? (\'icon-anim \' + item.iconEffect) : \'icon-anim\'"\n\n                                                name="{{item.icon}}"></ion-icon>\n\n                                            <h3 class="h3-normal-anim" *ngIf="item.discountPercentage === 0" text-left\n\n                                                tappable><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></h3>\n\n                                            <h3 class="h3-discount-anim" *ngIf="item.discountPercentage > 0" text-left\n\n                                                tappable>\n\n                                                <span><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></span>\n\n                                            </h3>\n\n                                        </div>\n\n                                        <ng-container *ngIf="!item.icon">\n\n                                            <h3 class="h3-normal" *ngIf="item.discountPercentage === 0" text-left\n\n                                                tappable><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></h3>\n\n                                            <h3 class="h3-discount" *ngIf="item.discountPercentage > 0" text-left\n\n                                                tappable>\n\n                                                <span><label class="md-txt-lg">{{item.discountPercentage}}%</label></span>\n\n                                                <span><label class="md-txt-lg">{{currencySymbol}}{{item.price | number: \'1.0-0\'}}</label></span>\n\n                                            </h3>\n\n                                        </ng-container>\n\n                                        <ion-icon name="ios-more" class="thumbnail-product-options" tappable\n\n                                            (click)="fireProductMenu(item)"></ion-icon>\n\n                                    </div>\n\n                                    <div class="thumbnail-option-section"\n\n                                        *ngIf="(item.isAvailable === \'N\' && item.availableInDays > 0)">\n\n                                        <ion-row *ngIf="item.availableInDays > 0">\n\n                                            <ion-col text-left col-9 class="availavility-notice">\n\n                                                <ng-container\n\n                                                    *ngIf="item.isAvailable === \'N\' && item.availableInDays > 0">\n\n                                                    <span *ngIf="item.availableInDays === 1">Disponible en\n\n                                                        {{item.availableInDays}} d&iacute;a.</span>\n\n                                                    <span *ngIf="item.availableInDays > 1">Disponible en\n\n                                                        {{item.availableInDays}} d&iacute;as.</span>\n\n                                                </ng-container>\n\n                                            </ion-col>\n\n                                            <ion-col text-right></ion-col>\n\n                                        </ion-row>\n\n                                    </div>\n\n                                </div>\n\n                            </ion-col>\n\n                            <ng-container\n\n                                *ngIf="!isTimeout && showSimilarSection && isInfiniteScrollFired && !reachedSimilarsFinalPage">\n\n                                <ion-col col-6>\n\n                                    <div class="listing fake-item">\n\n                                        <div class="fake-image-container">\n\n                                            <div class="fake-image"></div>\n\n                                        </div>\n\n                                        <h2></h2>\n\n                                        <h3></h3>\n\n                                    </div>\n\n                                </ion-col>\n\n                                <ion-col col-6>\n\n                                    <div class="listing fake-item">\n\n                                        <div class="fake-image-container">\n\n                                            <div class="fake-image"></div>\n\n                                        </div>\n\n                                        <h2></h2>\n\n                                        <h3></h3>\n\n                                    </div>\n\n                                </ion-col>\n\n                                <ion-col col-6>\n\n                                    <div class="listing fake-item">\n\n                                        <div class="fake-image-container">\n\n                                            <div class="fake-image"></div>\n\n                                        </div>\n\n                                        <h2></h2>\n\n                                        <h3></h3>\n\n                                    </div>\n\n                                </ion-col>\n\n                                <ion-col col-6>\n\n                                    <div class="listing fake-item">\n\n                                        <div class="fake-image-container">\n\n                                            <div class="fake-image"></div>\n\n                                        </div>\n\n                                        <h2></h2>\n\n                                        <h3></h3>\n\n                                    </div>\n\n                                </ion-col>\n\n                            </ng-container>\n\n                        </ion-row>\n\n                    </ion-card-content>\n\n                </ion-card>\n\n            </ng-container>\n\n        </ng-container>\n\n\n\n    </div>\n\n\n\n    <ion-infinite-scroll *ngIf="!isFetchingData && (!reachedFinalPage || !reachedSimilarsFinalPage)"\n\n        (ionInfinite)="fireInfiniteScroll($event)" threshold="550px">\n\n        <ion-infinite-scroll-content loadingSpinner="null"></ion-infinite-scroll-content>\n\n    </ion-infinite-scroll>\n\n\n\n    <ion-fab right bottom *ngIf="showQuickAccessButton">\n\n        <button ion-fab class="button-option">\n\n            <ion-icon name="apps"></ion-icon>\n\n        </button>\n\n        <ion-fab-list side="top">\n\n            <button ion-fab class="button-detail-option" tappable (click)="handleNavigation(\'Root\')">\n\n                <ion-icon name="md-home"></ion-icon>\n\n            </button>\n\n        </ion-fab-list>\n\n    </ion-fab>\n\n\n\n</ion-content>'/*ion-inline-end:"C:\Users\ezuniga\Documents\Desarrollo\EfastStore\AppE-fast\app\src\modules\products\pages\product-listing-filtered\product-listing-filtered.html"*/,
        changeDetection: __WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectionStrategy"].OnPush
    }),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Platform"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["App"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavParams"],
        __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ToastController"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["AlertController"],
        __WEBPACK_IMPORTED_MODULE_5__providers_wishlist_wish_list_helper_service__["a" /* WishListHelperService */],
        __WEBPACK_IMPORTED_MODULE_3__ngx_translate_core__["c" /* TranslateService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ActionSheetController"],
        __WEBPACK_IMPORTED_MODULE_7__providers_product_product_helper_service__["a" /* ProductHelperService */],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["LoadingController"],
        __WEBPACK_IMPORTED_MODULE_0__angular_core__["ChangeDetectorRef"],
        __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_13__providers_product_product_service__["a" /* ProductService */],
        __WEBPACK_IMPORTED_MODULE_10__orders_providers_cart_manager_service__["a" /* CartManagerService */],
        __WEBPACK_IMPORTED_MODULE_11__datasets_product_listing_dataset_navigator__["a" /* ProductListingDataSetNavigator */],
        __WEBPACK_IMPORTED_MODULE_12__datasets_product_listing_similar_dataset_navigator__["a" /* ProductListingSimilarSetNavigator */]])
], ProductListingFilteredPage);

//# sourceMappingURL=product-listing-filtered.js.map

/***/ }),

/***/ 735:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SearchFilterDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__ = __webpack_require__(17);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






/**
 * Fuente de datos para los Tabs Dinamicos (OTROS)
 */
let SearchFilterDataSet = class SearchFilterDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    constructor(sessionManager, productService) {
        super();
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.searchResultsQuantity = 0;
        this.searchPaginationId = null;
    }
    //Evento que se ejecuta al inicializarse
    onInitialize() {
    }
    onReset() {
        this.searchResultsQuantity = 0;
        this.searchPaginationId = null;
    }
    setCriteria(criteria) {
        this.criteria = criteria;
    }
    setFilterCriteria(filter) {
        this.attribute = filter;
    }
    setSearchId(searchPaginationId) {
        this.searchPaginationId = searchPaginationId;
    }
    //Realiza la consulta propia del provider
    retrievePage(fetchPageId) {
        return new __WEBPACK_IMPORTED_MODULE_3_rxjs__["Observable"](observer => {
            var search = {};
            search.criterion = this.criteria;
            search.pageId = fetchPageId;
            search.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPageSize;
            search.sortBy = this.getSortBy();
            search.searchPaginationId = this.searchPaginationId;
            search.filterAttr = this.attribute;
            if (this.sessionManager.isAuthenticated()) {
                search.userId = this.sessionManager.getPrincipal().userId;
                search.token = this.sessionManager.getToken();
            }
            //setTimeout(() => {
            this.searchResultsQuantity = 0;
            this.productService.searchFiltered(search).subscribe((resultList) => {
                if (resultList && resultList.length > 0) {
                    this.searchResultsQuantity = resultList[0].searchQuantity;
                    this.searchPaginationId = resultList[0].searchPaginationId;
                }
                observer.next(resultList);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
            //},15000);
        });
    }
    getSummary() {
        let message;
        if (this.searchResultsQuantity > 0) {
            //message = this.searchResultsQuantity + " resultados con '"+this.criteria+"' filtrado por '"+this.attribute.atributte+"'";
            message = this.searchResultsQuantity + " resultados con '" + this.criteria + "'";
        }
        else {
            message = "Resultados con '" + this.criteria + "'";
        }
        return message;
    }
};
SearchFilterDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__products_providers_product_product_service__["a" /* ProductService */]])
], SearchFilterDataSet);

//# sourceMappingURL=search-filter-dataset.js.map

/***/ }),

/***/ 736:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TabbedSectionBackwardDataSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let TabbedSectionBackwardDataSetNavigator = class TabbedSectionBackwardDataSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
};
TabbedSectionBackwardDataSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], TabbedSectionBackwardDataSetNavigator);

//# sourceMappingURL=tabbed-section-backward-dataset-navigator.js.map

/***/ }),

/***/ 737:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TabbedDataSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let TabbedDataSetNavigator = class TabbedDataSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
};
TabbedDataSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], TabbedDataSetNavigator);

//# sourceMappingURL=tabbed-dataset-navigator.js.map

/***/ }),

/***/ 738:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TabbedSectionDataSetNavigator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__ = __webpack_require__(63);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


let TabbedSectionDataSetNavigator = class TabbedSectionDataSetNavigator extends __WEBPACK_IMPORTED_MODULE_1__base_dataset_navigator__["a" /* DataSetNavigator */] {
    constructor() {
        super();
        //this.setPlatform(currentPlatform);
    }
};
TabbedSectionDataSetNavigator = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [])
], TabbedSectionDataSetNavigator);

//# sourceMappingURL=tabbed-section-dataset-navigator.js.map

/***/ }),

/***/ 739:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductWishlistListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__wishlist_wish_list_service__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductWishlistListingService = class ProductWishlistListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, wishListService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.wishListService = wishListService;
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultWishListPageSize;
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_4__config_config__["a" /* AppConfig */].app.defaultWishListPageSize;
        this.list = [];
    }
    getData() {
        return this.list;
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    setWishListId(wishListId) {
        this.wishListId = wishListId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        this.list = [];
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var params = {};
            params.userId = this.sessionManager.getPrincipal().userId;
            params.token = this.sessionManager.getToken();
            params.wishListId = this.wishListId;
            params.pageId = this.pageId;
            params.pageRows = this.pageRows;
            this.wishListService.getWhishListProducts(params).subscribe((products) => {
                if (products && products.length > 0) {
                    this.list = products;
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /** Stateles call */
    fetchWishListProducts(wishListId, index) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var tempList = [];
            var params = {};
            params.userId = this.sessionManager.getPrincipal().userId;
            params.token = this.sessionManager.getToken();
            params.wishListId = wishListId;
            params.pageId = this.pageId;
            params.pageRows = this.pageRows;
            this.wishListService.getWhishListProducts(params).subscribe((products) => {
                tempList = products;
                params.products = tempList;
                params.index = index;
                observer.next(params);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductWishlistListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_5__wishlist_wish_list_service__["a" /* WishListService */]])
], ProductWishlistListingService);

//# sourceMappingURL=product-wishlist-listing-service.js.map

/***/ }),

/***/ 74:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ErrorService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



let ErrorService = class ErrorService {
    constructor(sessionManager, translate) {
        this.sessionManager = sessionManager;
        this.translate = translate;
    }
    handle(origin, errCode, originalError) {
        let errorMessage = "";
        try {
            errorMessage = this.translate.instant("error." + errCode);
            let errorLog = errorMessage + (originalError ? " [" + JSON.stringify(originalError) + "] " : "");
            let fullError = "[ERROR] " + origin.constructor.name + " : " + errorLog;
            console.log("Error -> " + fullError);
            this.sessionManager.getSession().saveError(fullError).subscribe();
        }
        catch (e) { }
        return new Error(errorMessage);
    }
    handleErrWithMessage(origin, errCode, originalError) {
        let errorMessage = "";
        try {
            errorMessage = this.translate.instant("error." + errCode);
            let errorLog = errorMessage + (originalError ? " [" + JSON.stringify(originalError) + "] " : "");
            let fullError = "[ERROR] " + origin.constructor.name + " : " + errorLog;
            console.log("Error -> " + fullError);
            this.sessionManager.getSession().saveError(fullError).subscribe();
        }
        catch (e) { }
        return new Error(errorMessage);
    }
    handleWS(origin, errCode, originalError, wsURL) {
        let errorMessage = "";
        try {
            var d = new Date();
            var datestring = d.getDate() + "/" + (d.getMonth() + 1) + "/" + d.getFullYear() + " " + d.getHours() + ":" + d.getMinutes();
            errorMessage = this.translate.instant("error." + errCode);
            let errorLog = " [" + errorMessage + "] " + (originalError ? " " + JSON.stringify(originalError) + " " : "");
            let fullError = "[ERROR] [" + datestring + "] " + origin.constructor.name + ": " + wsURL + " " + errorLog;
            this.sessionManager.getSession().saveError(fullError).subscribe();
        }
        catch (e) { }
        return originalError ? originalError : new Error(errorMessage);
    }
    log(message) {
        try {
            var d = new Date();
            var datestring = d.getDate() + "/" + (d.getMonth() + 1) + "/" + d.getFullYear() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
            let fullError = "[INFO] [" + datestring + "] " + message;
            this.sessionManager.getSession().saveError(fullError).subscribe();
        }
        catch (e) {
            console.log(e);
        }
    }
};
ErrorService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_1__ngx_translate_core__["c" /* TranslateService */]])
], ErrorService);

//# sourceMappingURL=error-service.js.map

/***/ }),

/***/ 740:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InviteFriendService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__model_invite_friend_model__ = __webpack_require__(1173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let InviteFriendService = class InviteFriendService {
    constructor(//private errHandler: ErrorService,
        rest) {
        this.rest = rest;
    }
    //invitar  amigo
    sendFriendInvitation(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            //Compone los parametros del WS
            var request = __WEBPACK_IMPORTED_MODULE_2__model_invite_friend_model__["a" /* InviteFriendMapper */].convertModelToRequest(params);
            //Realiza la consulta del webservice
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_INVITE_FRIEND, request).subscribe((response) => {
                if (response && response.length > 0) {
                    var item = response[0];
                    observer.next(__WEBPACK_IMPORTED_MODULE_2__model_invite_friend_model__["a" /* InviteFriendMapper */].convertResponseToModel(item));
                    observer.complete();
                }
            }, 
            //Si hubo algun error
                error => {
                observer.error(error);
            });
        });
    }
};
InviteFriendService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__util_rest_client__["a" /* RESTClient */]])
], InviteFriendService);

//# sourceMappingURL=invite-friend-service.js.map

/***/ }),

/***/ 741:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GreenPayTokenizerService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_http__ = __webpack_require__(142);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_aes_js__ = __webpack_require__(443);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_aes_js___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_aes_js__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_node_jsencrypt__ = __webpack_require__(444);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_node_jsencrypt___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_node_jsencrypt__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__error_service__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__greenpay_config_service__ = __webpack_require__(116);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










let GreenPayTokenizerService = class GreenPayTokenizerService {
    constructor(http, sessionManager, greenPayConfigService, logService) {
        this.http = http;
        this.sessionManager = sessionManager;
        this.greenPayConfigService = greenPayConfigService;
        this.logService = logService;
        this.rsa = new __WEBPACK_IMPORTED_MODULE_3_node_jsencrypt__();
    }
    tokenize(card) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            this.greenPayConfigService.getConfig().subscribe((config) => {
                this.sessionManager.set(__WEBPACK_IMPORTED_MODULE_7__config_config__["a" /* AppConfig */].app.greenPayConfig, config);
                this.config = config;
                let user = this.sessionManager.getPrincipal();
                let orderId = "eFast-" + user.userId + "-" + new Date().getTime() / 1000;
                //Order data
                let orderRequestData = {
                    secret: this.config.secretid,
                    merchantId: this.config.merchantid,
                    requestId: orderId,
                };
                //Card data
                let cardData = {
                    card: {
                        cardHolder: card.cardName,
                        expirationDate: {
                            month: card.expirationMonth,
                            year: card.expirationYear,
                        },
                        cardNumber: card.cardNumber,
                        cvc: card.ccvCode,
                        nickname: new Date().getTime().toString(),
                    },
                };
                this.createTokenOrder(orderRequestData).subscribe(() => {
                    this.prepareTokenization(cardData).subscribe((data) => {
                        let tokenizedData = JSON.parse(data);
                        if (tokenizedData.status >= 200 &&
                            tokenizedData.status <= 299 &&
                            tokenizedData.result) {
                            let tokenInfo = {};
                            tokenInfo.token = tokenizedData.result.token;
                            tokenInfo.lastDigits = tokenizedData.result.last_digits;
                            tokenInfo.bin = tokenizedData.result.bin;
                            tokenInfo.brand = tokenizedData.brand;
                            tokenInfo.nickname = tokenizedData.nickname;
                            tokenInfo.expirationDate = tokenizedData.expiration_date;
                            observer.next(tokenInfo);
                            observer.complete();
                        }
                        else {
                            try {
                                this.logService.log("WEBSERVICE: WS_TOKENIZE_ORDER L2 [   Resultado ERR   ] [ DETAIL: " +
                                    JSON.stringify(tokenizedData) +
                                    "   ]");
                            }
                            catch (e) { }
                            observer.error("Tarjeta invalida");
                        }
                    }, (error) => {
                        observer.error(error);
                    });
                }, (error) => {
                    observer.error(error);
                });
            }, (error) => {
                observer.error(error);
            });
        });
    }
    createTokenOrder(data) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            let header = {};
            this.http.setDataSerializer("json");
            this.http.setHeader("*", "Accept", "application/json");
            this.http.setHeader("*", "Content-Type", "application/json");
            this.http
                .post(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_GREENPAY_TOKENIZE_ORDER, data, header)
                .then((response) => {
                if (response.status === 200) {
                    this.security = JSON.parse(response.data);
                    this.createdOn = new Date();
                    observer.next(response.data);
                    observer.complete();
                }
                else {
                    this.security = null;
                    this.createdOn = null;
                    observer.error();
                }
            })
                .catch((error) => {
                try {
                    this.logService.log("WEBSERVICE: WS_TOKENIZE_ORDER   [   Resultado ERR   ] [ DETAIL: " +
                        JSON.stringify(error) +
                        "   ]");
                }
                catch (e) { }
                this.security = null;
                this.createdOn = null;
                observer.error(error.error);
            });
        });
    }
    createCardToken(data, accessToken) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            let header = {};
            this.http.setDataSerializer("json");
            this.http.setHeader("*", "Accept", "application/json");
            this.http.setHeader("*", "Content-Type", "application/json");
            this.http.setHeader("*", "liszt-token", accessToken);
            this.http
                .post(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_GREENPAY_TOKENIZE_CARD, data, header)
                .then((response) => {
                if (response.status === 200) {
                    observer.next(response.data);
                    observer.complete();
                }
                else {
                    observer.error();
                }
            })
                .catch((error) => {
                try {
                    this.logService.log("WEBSERVICE: WS_TOKENIZE_CARD   [   Resultado ERR   ] [ DETAIL: " +
                        JSON.stringify(error) +
                        "   ]");
                }
                catch (e) { }
                observer.error(error.error);
            });
        });
    }
    prepareTokenization(cardData) {
        return new __WEBPACK_IMPORTED_MODULE_5_rxjs_Observable__["Observable"]((observer) => {
            try {
                this.rsa.setPublicKey(this.config.publickey);
                const body = this.ciperPack(cardData, this.security.session);
                this.createCardToken(body, this.security.token).subscribe((data) => {
                    observer.next(data);
                    observer.complete();
                }, (error) => {
                    console.log("err 20");
                    console.log(error);
                    observer.error(error);
                });
            }
            catch (error) {
                console.log("err 21");
                observer.error(error);
            }
        });
    }
    cipherGenerateAESPairs() {
        var key = [];
        var iv;
        for (let k = 0; k < 16; k++) {
            key.push(Math.floor(Math.random() * 255));
        }
        for (let k = 0; k < 16; k++) {
            iv = Math.floor(Math.random() * 255);
        }
        return {
            k: key,
            s: iv,
        };
    }
    ciperPack(obj, session, pair_) {
        var pair = pair_ !== undefined ? pair_ : this.cipherGenerateAESPairs();
        var textBytes = __WEBPACK_IMPORTED_MODULE_2_aes_js__["utils"].utf8.toBytes(JSON.stringify(obj));
        var aesCtr = new __WEBPACK_IMPORTED_MODULE_2_aes_js__["ModeOfOperation"].ctr(pair.k, new __WEBPACK_IMPORTED_MODULE_2_aes_js__["Counter"](pair.s));
        var encryptedBytes = aesCtr.encrypt(textBytes);
        var encryptedHex = __WEBPACK_IMPORTED_MODULE_2_aes_js__["utils"].hex.fromBytes(encryptedBytes);
        var returnObj = {
            session: session,
            ld: encryptedHex,
            lk: this.rsa.encrypt(JSON.stringify(pair)),
        };
        return returnObj;
    }
};
GreenPayTokenizerService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_http__["a" /* HTTP */],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_9__greenpay_config_service__["a" /* GreenPayConfigService */],
        __WEBPACK_IMPORTED_MODULE_8__error_service__["a" /* ErrorService */]])
], GreenPayTokenizerService);

//# sourceMappingURL=greenpay-tokenizer-service.js.map

/***/ }),

/***/ 742:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ProductHistoryListingService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__product_listing_service__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__ = __webpack_require__(4);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







let ProductHistoryListingService = class ProductHistoryListingService extends __WEBPACK_IMPORTED_MODULE_3__product_listing_service__["a" /* ProductListingService */] {
    constructor(events, sessionManager, productService) {
        super();
        this.events = events;
        this.sessionManager = sessionManager;
        this.productService = productService;
        this.pageId = 1;
        this.pageRows = 30;
        this.list = [];
        this.events.subscribe(__WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].event.AUTH_SESSSION_FINISHED, (user, time) => {
            this.clear();
        });
    }
    clear() {
        this.pageId = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPage;
        this.pageRows = __WEBPACK_IMPORTED_MODULE_5__config_config__["a" /* AppConfig */].app.defaultPageSize;
        this.list = [];
    }
    getData() {
        return this.list;
    }
    setData(dataList) {
        this.clear();
        this.list = [...dataList];
    }
    isEmpty() {
        return !this.list || this.list.length === 0;
    }
    setPage(pageId) {
        this.pageId = pageId;
    }
    setSortBy(sortBy) {
        //no soportado
    }
    fetchData() {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var params = this.sessionManager.getSession().toModel();
            params.pageId = this.pageId;
            params.pageRows = this.pageRows;
            this.productService.getRecentViewedProducts(params).subscribe((list) => {
                if (list && list.length > 0) {
                    for (let i = 0; i < list.length; i++) {
                        this.list.push(list[i]);
                    }
                    this.pageId++;
                }
                observer.next(this.list);
                observer.complete();
            }, error => {
                observer.next(this.list);
                observer.complete();
            });
        });
    }
    getListStatus() {
        return this.list.length + " items";
    }
};
ProductHistoryListingService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Events"],
        __WEBPACK_IMPORTED_MODULE_6__session_session_manager_service__["a" /* SessionManagerService */],
        __WEBPACK_IMPORTED_MODULE_4__product_product_service__["a" /* ProductService */]])
], ProductHistoryListingService);

//# sourceMappingURL=product-history-listing-service.js.map

/***/ }),

/***/ 743:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TopicsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_topic_model__ = __webpack_require__(1179);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





let TopicsService = class TopicsService {
    constructor(rest) {
        this.rest = rest;
    }
    getTopics(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_topic_model__["a" /* TopicMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_QUERY_TOPICS, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_topic_model__["a" /* TopicMapper */].convertResponseListToModelList(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getTopicsDetails(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_topic_model__["a" /* TopicMapper */].convertModelToRequest(params);
            this.rest.getFirst(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_QUERY_TOPICS_DETAIL, paramsString).subscribe((response) => {
                if (response) {
                    observer.next(__WEBPACK_IMPORTED_MODULE_4__model_topic_model__["a" /* TopicMapper */].convertResponseToModel(response));
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
};
TopicsService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */]])
], TopicsService);

//# sourceMappingURL=topics-service.js.map

/***/ }),

/***/ 744:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__ = __webpack_require__(745);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__app_module__ = __webpack_require__(749);



Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["enableProdMode"])();
Object(__WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__["a" /* platformBrowserDynamic */])().bootstrapModule(__WEBPACK_IMPORTED_MODULE_2__app_module__["a" /* AppModule */]);
//# sourceMappingURL=main.js.map

/***/ }),

/***/ 749:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export createTranslateLoader */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AppModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__modules_datasets_home_promos_template_section_tabbed_backward_dataset__ = __webpack_require__(706);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__modules_datasets_home_promos_template_section_tabbed_dataset__ = __webpack_require__(719);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_datasets_home_promos_template_tabbed_dataset__ = __webpack_require__(161);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_core_provider_caching_promos_template_caching_service__ = __webpack_require__(718);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_core_provider_caching_category_template_caching_service__ = __webpack_require__(707);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_products_providers_section_section_service__ = __webpack_require__(75);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_datasets_home_section_group_section_tabbed_backward_dataset__ = __webpack_require__(708);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_home_providers_home_category_template_service__ = __webpack_require__(118);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_datasets_home_section_group_tabbed_dataset__ = __webpack_require__(162);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ionic_native_status_bar__ = __webpack_require__(112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__ionic_native_splash_screen__ = __webpack_require__(663);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_google_plus__ = __webpack_require__(620);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__angular_platform_browser__ = __webpack_require__(56);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__angular_platform_browser_animations__ = __webpack_require__(1197);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__angular_common_http__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__ngx_translate_core__ = __webpack_require__(42);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__ngx_translate_http_loader__ = __webpack_require__(1199);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19_ionic_image_loader__ = __webpack_require__(269);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__ionic_native_device__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__ionic_native_network__ = __webpack_require__(665);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22_ion2_calendar__ = __webpack_require__(694);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22_ion2_calendar___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_22_ion2_calendar__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__app_component__ = __webpack_require__(1201);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__ionic_native_facebook__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__ionic_native_native_storage__ = __webpack_require__(308);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__config_startup__ = __webpack_require__(666);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__modules_home_pages_home__ = __webpack_require__(695);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__modules_security_pages_onboarding_onboarding__ = __webpack_require__(1212);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__modules_core_provider_error_service__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__modules_session_session_service__ = __webpack_require__(184);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__modules_session_session_manager_service__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__modules_security_providers_social_facebook_service__ = __webpack_require__(621);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__modules_security_providers_social_google_service__ = __webpack_require__(619);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__modules_security_providers_login_service__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__modules_security_providers_user_service__ = __webpack_require__(111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__modules_home_providers_home_category_service__ = __webpack_require__(711);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__modules_home_providers_home_seasons_service__ = __webpack_require__(1213);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__modules_home_providers_home_favorites_service__ = __webpack_require__(1214);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__modules_products_providers_product_product_category_service__ = __webpack_require__(117);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__modules_products_providers_product_product_service__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__modules_products_providers_product_listing_product_category_listing_service__ = __webpack_require__(1215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__modules_products_providers_product_listing_product_seasons_listing_service__ = __webpack_require__(680);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_44__modules_products_providers_product_listing_product_favorites_listing_service__ = __webpack_require__(681);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_45__modules_products_providers_product_listing_product_suggested_listing_service__ = __webpack_require__(1216);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_46__modules_products_providers_product_listing_product_wishlist_listing_service__ = __webpack_require__(739);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_47__modules_products_providers_product_listing_product_history_listing_service__ = __webpack_require__(742);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_48__modules_products_providers_product_listing_product_default_listing_service__ = __webpack_require__(1217);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_49__modules_products_providers_product_listing_promos_finalizing_listing_service__ = __webpack_require__(1218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_50__modules_products_providers_product_listing_promos_daily_listing_service__ = __webpack_require__(726);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_51__modules_products_providers_product_listing_promos_regular_listing_service__ = __webpack_require__(1219);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_52__modules_products_providers_wishlist_wish_list_service__ = __webpack_require__(115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_53__modules_products_providers_wishlist_wish_list_helper_service__ = __webpack_require__(270);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_54__modules_profile_providers_invite_friend_service__ = __webpack_require__(740);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_55__modules_profile_providers_card_service__ = __webpack_require__(275);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_56__modules_profile_providers_address_service__ = __webpack_require__(278);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_57__modules_orders_providers_purchase_order_service__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_58_ionic2_super_tabs__ = __webpack_require__(159);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_59__ionic_native_camera__ = __webpack_require__(703);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_60__modules_support_providers_chat_message_service__ = __webpack_require__(1220);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_61__modules_support_providers_faqs_service__ = __webpack_require__(705);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_62__modules_notifications_providers_notifications_service__ = __webpack_require__(158);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_63__modules_notifications_providers_notification_settings_service__ = __webpack_require__(729);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_64__modules_session_session_datasets_delivery_address_dataset_service__ = __webpack_require__(668);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_65__modules_session_session_datasets_payment_option_dataset_service__ = __webpack_require__(669);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_66__modules_session_session_datasets_product_category_user_dataset_service__ = __webpack_require__(670);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_67__modules_session_session_datasets_wishlist_dataset_service__ = __webpack_require__(671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_68__modules_security_providers_security_questions_service__ = __webpack_require__(686);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_69__modules_rewards_providers_rewards_service__ = __webpack_require__(1222);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_70__modules_session_session_datasets_product_category_dataset_service__ = __webpack_require__(667);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_71__modules_notifications_providers_offers_service__ = __webpack_require__(167);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_72__modules_orders_providers_cart_manager_service__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_73__modules_support_providers_topics_service__ = __webpack_require__(743);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_74__util_rest_native_client__ = __webpack_require__(104);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_75__ionic_native_http__ = __webpack_require__(142);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_76__modules_home_providers_home_section_service__ = __webpack_require__(148);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_77__modules_products_providers_product_listing_product_family_listing_service__ = __webpack_require__(1225);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_78__modules_orders_providers_freight_service__ = __webpack_require__(700);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_79__modules_home_pages_home_flex__ = __webpack_require__(160);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_80__modules_session_session_datasets_home_section_dataset_service__ = __webpack_require__(673);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_81__modules_session_session_datasets_product_attribute_dataset_service__ = __webpack_require__(672);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_82__modules_products_providers_product_listing_product_section_listing_service__ = __webpack_require__(1226);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_83__ionic_native_social_sharing__ = __webpack_require__(285);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_84__modules_profile_providers_geozone_service__ = __webpack_require__(273);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_85__util_timer_timer_manager__ = __webpack_require__(1227);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_86__modules_core_provider_greenpay_tokenizer_service__ = __webpack_require__(741);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_87__modules_core_provider_greenpay_config_service__ = __webpack_require__(116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_88__modules_core_provider_greenpay_checkout_service__ = __webpack_require__(286);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_89__modules_security_pages_offline_offline__ = __webpack_require__(267);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_90__modules_products_providers_product_product_helper_service__ = __webpack_require__(271);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_91__modules_products_providers_product_listing_product_similar_listing_service__ = __webpack_require__(1228);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_92__modules_products_providers_product_listing_product_search_listing_service__ = __webpack_require__(1229);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_93__modules_rewards_providers_giftcard_service__ = __webpack_require__(692);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_94__modules_support_providers_refund_service__ = __webpack_require__(691);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_95__modules_core_provider_image_caching_service__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_96__ionic_native_file_transfer__ = __webpack_require__(440);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_97__util_timeout_interceptor__ = __webpack_require__(682);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_98__config_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_99__ionic_native_clipboard__ = __webpack_require__(699);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_100__modules_support_providers_terms_conditions__ = __webpack_require__(688);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_101__ionic_native_screen_orientation__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_102__ionic_native_email_composer__ = __webpack_require__(485);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_103__ionic_native_android_permissions__ = __webpack_require__(239);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_104__modules_datasets_home_section_dataset__ = __webpack_require__(723);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_105__modules_datasets_home_regular_offers_dataset__ = __webpack_require__(693);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_106__modules_datasets_home_featured_offers_dataset__ = __webpack_require__(698);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_107__modules_security_pages_startup_startup__ = __webpack_require__(268);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_108__modules_datasets_home_suggested_dataset__ = __webpack_require__(274);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_109__modules_datasets_home_favs_dataset__ = __webpack_require__(165);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_110__modules_datasets_home_seasons_dataset__ = __webpack_require__(722);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_111__modules_datasets_home_categories_dataset__ = __webpack_require__(287);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_112__modules_datasets_search_family_dataset__ = __webpack_require__(685);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_113__modules_datasets_search_dataset__ = __webpack_require__(701);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_114__modules_datasets_search_banner_dataset__ = __webpack_require__(687);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_115__modules_datasets_product_history_dataset__ = __webpack_require__(288);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_116__modules_datasets_product_similar_dataset__ = __webpack_require__(484);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_117__modules_datasets_search_similar_dataset__ = __webpack_require__(702);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_118__ionic_native_in_app_browser__ = __webpack_require__(277);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_119__modules_support_providers_version_service__ = __webpack_require__(279);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_120__ionic_native_mobile_accessibility__ = __webpack_require__(674);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_121__modules_home_providers_home_misuper_service__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_122__modules_datasets_home_misuper_dataset__ = __webpack_require__(715);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_123__modules_datasets_home_category_tabbed_dataset__ = __webpack_require__(164);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_124__modules_home_providers_home_offers_service__ = __webpack_require__(281);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_125__modules_datasets_home_grouped_offers_dataset__ = __webpack_require__(697);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_126__modules_orders_providers_subsidiaries_service__ = __webpack_require__(730);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_127__modules_core_provider_caching_misuper_caching_service__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_128__modules_core_provider_caching_category_caching_service__ = __webpack_require__(163);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_129__ionic_native_google_analytics__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_130__modules_datasets_home_suggested_dataset_navigator__ = __webpack_require__(725);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_131__modules_datasets_home_section_dataset_navigator__ = __webpack_require__(724);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_132__modules_datasets_home_favs_dataset_navigator__ = __webpack_require__(714);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_133__modules_datasets_product_listing_dataset_navigator__ = __webpack_require__(283);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_134__modules_datasets_product_listing_similar_dataset_navigator__ = __webpack_require__(284);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_135__modules_security_pages_version_check_version_check__ = __webpack_require__(675);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_136__ionic_native_unique_device_id__ = __webpack_require__(289);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_137__modules_security_providers_device_uniqueid_service__ = __webpack_require__(282);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_138__ionic_native_uid__ = __webpack_require__(623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_139__modules_support_providers_chat_service__ = __webpack_require__(704);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_140__modules_datasets_tabbed_dataset_navigator__ = __webpack_require__(737);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_141__modules_core_provider_caching_transient_caching_service__ = __webpack_require__(1230);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_142__modules_datasets_home_category_section_tabbed_dataset__ = __webpack_require__(712);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_143__modules_datasets_tabbed_section_dataset_navigator__ = __webpack_require__(738);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_144__modules_datasets_home_category_section_tabbed_backward_dataset__ = __webpack_require__(713);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_145__modules_datasets_tabbed_section_backward_dataset_navigator__ = __webpack_require__(736);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_146__modules_datasets_home_misuper_section_tabbed_dataset__ = __webpack_require__(716);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_147__modules_datasets_home_misuper_section_tabbed_backward_dataset__ = __webpack_require__(717);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_148__modules_datasets_home_misuper_tabbed_dataset__ = __webpack_require__(241);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_149__modules_datasets_search_filter_dataset__ = __webpack_require__(735);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_150__modules_products_pages_product_listing_filtered_product_listing_filtered__ = __webpack_require__(731);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_151__modules_notifications_pages_notifications_deals_details_notifications_deals_details__ = __webpack_require__(727);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_152__ionic_native_push__ = __webpack_require__(676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_153__modules_security_providers_social_apple_service__ = __webpack_require__(622);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_154__modules_datasets_home_section_group_section_tabbed_dataset__ = __webpack_require__(709);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_155__modules_datasets_home_promos_template_offers_dataset__ = __webpack_require__(720);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_156__modules_datasets_home_promos_template_regular_offers_dataset__ = __webpack_require__(721);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_157__modules_datasets_notification_deals_dataset__ = __webpack_require__(728);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_158__awesome_cordova_plugins_app_rate_ngx__ = __webpack_require__(678);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_159__modules_support_providers_apprate_service__ = __webpack_require__(677);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_160__modules_support_providers_param_service__ = __webpack_require__(240);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_161__ionic_native_in_app_review_ngx__ = __webpack_require__(679);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_162__modules_orders_providers_sinpe_service__ = __webpack_require__(689);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_163_ngx_spellchecker__ = __webpack_require__(732);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_164__ionic_storage__ = __webpack_require__(733);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_165__angular_http__ = __webpack_require__(734);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};









//Core/Framework














//Views

//Providers














































































































































function createTranslateLoader(http) {
    return new __WEBPACK_IMPORTED_MODULE_18__ngx_translate_http_loader__["a" /* TranslateHttpLoader */](http, "./assets/i18n/", ".json");
}
let AppModule = class AppModule {
};
AppModule = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_13__angular_core__["NgModule"])({
        declarations: [
            __WEBPACK_IMPORTED_MODULE_23__app_component__["a" /* MyApp */],
            __WEBPACK_IMPORTED_MODULE_28__modules_home_pages_home__["a" /* HomePage */],
            __WEBPACK_IMPORTED_MODULE_79__modules_home_pages_home_flex__["a" /* HomeFlexPage */],
            __WEBPACK_IMPORTED_MODULE_29__modules_security_pages_onboarding_onboarding__["a" /* OnboardingPage */],
            __WEBPACK_IMPORTED_MODULE_89__modules_security_pages_offline_offline__["a" /* OfflinePage */],
            __WEBPACK_IMPORTED_MODULE_107__modules_security_pages_startup_startup__["a" /* StartupPage */],
            __WEBPACK_IMPORTED_MODULE_135__modules_security_pages_version_check_version_check__["a" /* VersionCheckPage */],
        ],
        imports: [
            __WEBPACK_IMPORTED_MODULE_165__angular_http__["b" /* HttpModule */],
            __WEBPACK_IMPORTED_MODULE_16__angular_common_http__["c" /* HttpClientModule */],
            __WEBPACK_IMPORTED_MODULE_163_ngx_spellchecker__["a" /* SpellCheckerModule */],
            __WEBPACK_IMPORTED_MODULE_9_ionic_angular__["IonicModule"].forRoot(__WEBPACK_IMPORTED_MODULE_23__app_component__["a" /* MyApp */], {
                backButtonText: "",
                scrollAssist: false,
                autoFocusAssist: false,
            }, {
                links: [
                    { loadChildren: '../modules/home/pages/home-categories-template/home-categories-template.module#HomeCategoriesPageModule', name: 'HomeCategoriesTemplatePage', segment: 'home-categories-template', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-categories/home-categories.module#HomeCategoriesPageModule', name: 'HomeCategoriesPage', segment: 'home-categories', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-favs/home-favs.module#HomeFavsPageModule', name: 'HomeFavsPage', segment: 'home-favs', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-misuper/home-misuper.module#HomeMiSuperPagePageModule', name: 'HomeMiSuperPage', segment: 'home-misuper', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-promos-template/home-promos-template.module#HomePromosTemplatePageModule', name: 'HomePromosTemplatePage', segment: 'home-promos-template', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-seasonal/home-seasonal.module#HomeSeasonalPageModule', name: 'HomeSeasonalPage', segment: 'home-seasonal', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-promos/home-promos.module#HomePromosPageModule', name: 'HomePromosPage', segment: 'home-promos', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-section/home-section.module#HomeSectionPageModule', name: 'HomeSectionPage', segment: 'home-section', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-suggested/home-suggested.module#HomeSuggestedPageModule', name: 'HomeSuggestedPage', segment: 'home-suggested', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/home/pages/home-offers/home-offers.module#HomeOffersPageModule', name: 'HomeOffersPage', segment: 'home-offers', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/notifications/pages/notification-center.module#NotificationCenterPageModule', name: 'NotificationCenterPage', segment: 'notification-center', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/notifications/pages/notifications-deals-details/notifications-deals-details.module#NotificationDealsPageModule', name: 'NotificationDeailsDetailPage', segment: 'notifications-deals-details', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/notifications/pages/notifications-deals/notifications-deals.module#NotificationDealsPageModule', name: 'NotificationDealsPage', segment: 'notifications-deals', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/notifications/pages/notifications-general/notifications-general.module#NotificationGeneralPageModule', name: 'NotificationGeneralPage', segment: 'notifications-general', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/notifications/pages/notifications-orders/notifications-orders.module#NotificationOrdersPageModule', name: 'NotificationOrdersPage', segment: 'notifications-orders', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/notifications/pages/notifications-rewards/notifications-rewards.module#NotificationRewardsPageModule', name: 'NotificationRewardsPage', segment: 'notifications-rewards', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/notifications/pages/notifications-setup/notifications-setup.module#NotificationSetupPageModule', name: 'NotificationSetupPage', segment: 'notifications-setup', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/cart.module#CartPageModule', name: 'CartPage', segment: 'cart', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-confirm/payment-confirm.module#PaymentConfirmPageModule', name: 'PaymentConfirmPage', segment: 'payment-confirm', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-result-error/payment-result-error.module#PaymentResultErrorPageModule', name: 'PaymentResultErrorPage', segment: 'payment-result-error', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-sinpe-modal/payment-sinpe-modal.module#PaymentSinpeModalPageModule', name: 'PaymentSinpeModalPage', segment: 'payment-sinpe-modal', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-result/payment-result.module#PaymentResultPageModule', name: 'PaymentResultPage', segment: 'payment-result', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-step2-subsidiary-finder/payment-step2-subsidiary-finder.module#SubsidiaryFinderPageModule', name: 'SubsidiaryFinderPage', segment: 'payment-step2-subsidiary-finder', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-sinpe/payment-sinpe.module#PaymentSinpePageModule', name: 'PaymentSinpePage', segment: 'payment-sinpe', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-step1/payment-step1.module#PaymentStep1PageModule', name: 'PaymentStep1Page', segment: 'payment-step1', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-step2-subsidiary/payment-step2-subsidiary.module#PaymentStep2SubsidiaryPageModule', name: 'PaymentStep2SubsidiaryPage', segment: 'payment-step2-subsidiary', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-step2/payment-step2.module#PaymentStep2PageModule', name: 'PaymentStep2Page', segment: 'payment-step2', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/order-date-chooser/order-date-chooser.module#OrdersDateChooserPageModule', name: 'OrdersDateChooserPage', segment: 'order-date-chooser', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/cart/payment-step3/payment-step3.module#PaymentStep3PageModule', name: 'PaymentStep3Page', segment: 'payment-step3', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/order-detail/order-detail.module#OrderDetailPageModule', name: 'OrderDetailPage', segment: 'order-detail', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/order-detail/order-info/order-info.module#OrderInfoPageModule', name: 'OrderInfoPage', segment: 'order-info', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/orders/orders.module#OrdersPageModule', name: 'OrdersPage', segment: 'orders', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/orders/pages/order-detail/order-tracking/order-tracking.module#OrderTrackingPageModule', name: 'OrderTrackingPage', segment: 'order-tracking', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-listing-filtered/product-listing-filtered.module#ProductListingFilteredPageModule', name: 'ProductListingFilteredPage', segment: 'product-listing-filtered', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-detail/product-detail.module#ProductDetailPageModule', name: 'ProductDetailPage', segment: 'product-detail', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-listing/product-listing.module#ProductListingPageModule', name: 'ProductListingPage', segment: 'product-listing', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-reviews/product-reviews.module#ProductReviewsPageModule', name: 'ProductReviewsPage', segment: 'product-reviews', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-search/live-search/live-search.module#LiveSearchPageModule', name: 'LiveSearchPage', segment: 'live-search', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-search/search-categories-subfamily/search-categories-subfamily.module#SearchCategoriesSubFamilyPageModule', name: 'SearchCategoriesSubFamilyPage', segment: 'search-categories-subfamily', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-search/search-categories-family/search-categories-family.module#SearchCategoriesFamilyPageModule', name: 'SearchCategoriesFamilyPage', segment: 'search-categories-family', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-search/search-categories/search-categories.module#SearchCategoriesPageModule', name: 'SearchCategoriesPage', segment: 'search-categories', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-search/search-filter/search-filter.module#SearchFilterPageModule', name: 'SearchFilterPage', segment: 'search-filter', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-search/search/search.module#SearchPageModule', name: 'SearchPage', segment: 'search', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-tabbed-merq-listing/product-tabbed-merq-listing.module#ProductTabbedMercListingPageModule', name: 'ProductTabbedMercListingPage', segment: 'product-tabbed-merq-listing', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-tabbed-listing/product-tabbed-listing.module#ProductTabbedListingPageModule', name: 'ProductTabbedListingPage', segment: 'product-tabbed-listing', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/wishlist/edit-wishlist/edit-wishlist.module#EditWishListPageModule', name: 'EditWishListPage', segment: 'edit-wishlist', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-tabbed-merq-ondemand-listing/product-tabbed-merq-ondemand-listing.module#ProductTabbedMercOnDemandListingPageModule', name: 'ProductTabbedMercOnDemandListingPage', segment: 'product-tabbed-merq-ondemand-listing', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/product-viewer/product-viewer.module#ProductViewerPageModule', name: 'ProductViewerPage', segment: 'product-viewer', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/wishlist/wishlist.module#WishlistPageModule', name: 'WishlistPage', segment: 'wishlist', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/products/pages/wishlist/wishlist-detail/wishlist-detail.module#WishlistDetailPageModule', name: 'WishlistDetailPage', segment: 'wishlist-detail', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/address/address-book-selection/address-book-selection.module#AddressBookSelectionPageModule', name: 'AddressBookSelectionPage', segment: 'address-book-selection', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/address/address-book/address-book.module#AddressBookPageModule', name: 'AddressBookPage', segment: 'address-book', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/address/edit-address/edit-address.module#EditAddressPageModule', name: 'EditAddressPage', segment: 'edit-address', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/address/address-finder/address-finder.module#AddressFinderPageModule', name: 'AddressFinderPage', segment: 'address-finder', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/close-account/close-account.module#CloseAccountPageModule', name: 'CloseAccountPage', segment: 'close-account', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/edit-email/edit-email.module#EditEmailPageModule', name: 'EditEmailPage', segment: 'edit-email', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/address/edit-region/edit-region.module#EditRegionPageModule', name: 'EditRegionPage', segment: 'edit-region', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/edit-profile-fe/edit-profile-fe.module#EditProfileFEPageModule', name: 'EditProfileFEPage', segment: 'edit-profile-fe', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/edit-password/edit-password.module#EditPasswordPageModule', name: 'EditPasswordPage', segment: 'edit-password', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/invite-friend/invite-friend.module#InviteFriendPageModule', name: 'InviteFriendPage', segment: 'invite-friend', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/payment/edit-payment-option/edit-payment-option.module#EditPaymentOptionPageModule', name: 'EditPaymentOptionPage', segment: 'edit-payment-option', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/edit-profile/edit-profile.module#EditProfilePageModule', name: 'EditProfilePage', segment: 'edit-profile', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/edit-profile-identification/edit-profile-identification.module#EditProfileIdentificationPageModule', name: 'EditProfileIdentificationPage', segment: 'edit-profile-identification', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/payment/payment-option-selection/payment-option-selection.module#PaymentOptionSelectionPageModule', name: 'PaymentOptionSelectionPage', segment: 'payment-option-selection', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/payment/payment-option/payment-option.module#PaymentOptionPageModule', name: 'PaymentOptionPage', segment: 'payment-option', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile-products/product-category-setup/product-category-setup.module#ProductCategorySetupPageModule', name: 'ProductCategorySetupPage', segment: 'product-category-setup', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile-products/product-history/product-history.module#ProductHistoryPageModule', name: 'ProductHistoryPage', segment: 'product-history', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile-products/review-products/product-rating/product-rating.module#RecentProductHistoryPageModule', name: 'ProductRatingPage', segment: 'product-rating', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile-products/review-products/review-order-detail/review-order-detail.module#ReviewOrderDetailModule', name: 'ReviewOrderDetailPage', segment: 'review-order-detail', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile-products/review-products/review-order-notes/review-order-notes.module#ReviewOrderNotesModule', name: 'ReviewOrderNotesPage', segment: 'review-order-notes', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile-products/review-products/review-order/review-order.module#ReviewOrderPageModule', name: 'ReviewOrderPage', segment: 'review-order', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile.module#ProfilePageModule', name: 'ProfilePage', segment: 'profile', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/profile-products/review-products/product-purchased/products-purchased.module#ProductsPurchasedPageModule', name: 'ProductsPurchasedPage', segment: 'products-purchased', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/daily-bonus/daily-bonus.module#DailyBonusPageModule', name: 'DailyBonusPage', segment: 'daily-bonus', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/profile/pages/edit-avatar/edit-avatar.module#EditAvatarPageModule', name: 'EditAvatarPage', segment: 'edit-avatar', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/giftcard-checkout/giftcard-checkout.module#GiftCardCheckoutPagePageModule', name: 'GiftCardCheckoutPage', segment: 'giftcard-checkout', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/giftcard-sinpe/giftcard-sinpe.module#GiftcardSinpePageModule', name: 'GiftcardSinpePage', segment: 'giftcard-sinpe', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/giftcard-confirm/giftcard-confirm.module#GiftCardConfirmPageModule', name: 'GiftCardConfirmPage', segment: 'giftcard-confirm', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/reward/reward-info/reward-info.module#RewardsInfoPageModule', name: 'RewardInfoPage', segment: 'reward-info', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/reward/reward-redeem/reward-redeem.module#RewardRedeemPageModule', name: 'RewardRedeemPage', segment: 'reward-redeem', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/reward/reward-dashboard/reward-dashboard.module#RewardDashboardPageModule', name: 'RewardDashboardPage', segment: 'reward-dashboard', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/giftcard/giftcard.module#GiftCardPageModule', name: 'GiftCardPage', segment: 'giftcard', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/rewards/pages/reward/reward.module#RewardPageModule', name: 'RewardPage', segment: 'reward', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/change-password/change-password.module#ChangePasswordPageModule', name: 'ChangePasswordPage', segment: 'change-password', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/change-security-question-inapp/change-security-question-inapp.module#ChangeSecurityQuestionInAppPageModule', name: 'ChangeSecurityQuestionInAppPage', segment: 'change-security-question-inapp', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/forgot-password-question/forgot-password-question.module#ForgotPasswordQuestionPageModule', name: 'ForgotPasswordQuestionPage', segment: 'forgot-password-question', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/change-security-question/change-security-question.module#ChangeSecurityQuestionPageModule', name: 'ChangeSecurityQuestionPage', segment: 'change-security-question', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/forgot-password/forgot-password.module#ForgotPasswordPageModule', name: 'ForgotPasswordPage', segment: 'forgot-password', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/login-front/login-front.module#LoginPageFrontModule', name: 'LoginFrontPage', segment: 'login-front', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/login-inapp/login-inapp.module#LoginInAppPageModule', name: 'LoginInAppPage', segment: 'login-inapp', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/login/login.module#LoginPageModule', name: 'LoginPage', segment: 'login', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/security-question-answer/security-question-answer.module#SecurityQuestionAnswerPageModule', name: 'SecurityQuestionAnswerPage', segment: 'security-question-answer', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/security-questions/security-questions.module#SecurityQuestionsPageModule', name: 'SecurityQuestionsPage', segment: 'security-questions', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/signup/signup-front/signup-front.module#SignupFrontPageModule', name: 'SignupFrontPage', segment: 'signup-front', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/signup/signup-social-completion/signup-social-completion.module#SignupSocialCompletionModule', name: 'SignupSocialCompletionPage', segment: 'signup-social-completion', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/signup/signup-result/signup-result.module#SignupResultPageModule', name: 'SignupResultPage', segment: 'signup-result', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/signup/signup-inapp/signup-inapp.module#SignupInAppPageModule', name: 'SignupInAppPage', segment: 'signup-inapp', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/security/pages/signup/signup.module#SignupPageModule', name: 'SignupPage', segment: 'signup', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/settings/pages/settings.module#SettingsPageModule', name: 'SettingsPage', segment: 'settings', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/chat/chat.module#ChatModule', name: 'Chat', segment: 'chat', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/contact/contact.module#ContactPageModule', name: 'ContactPage', segment: 'contact', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/information/information.module#InformationPageModule', name: 'InformationPage', segment: 'information', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/faqs/faqs.module#FAQsPageModule', name: 'FAQsPage', segment: 'faqs', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/log/log.module#LogPageModule', name: 'LogPage', segment: 'log', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/refund/refund-list/refund-list.module#RefundListPageModule', name: 'RefundListPage', segment: 'refund-list', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/refund/refund-policies/refund-policies.module#RefundPoliciesPageModule', name: 'RefundPoliciesPage', segment: 'refund-policies', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/refund/refund-wizard-picture/refund-wizard-picture.module#RefundWizardPicturePageModule', name: 'RefundWizardPicturePage', segment: 'refund-wizard-picture', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/refund/refund-wizard-reason/refund-wizard-reason.module#RefundWizardReasonPageModule', name: 'RefundWizardReasonPage', segment: 'refund-wizard-reason', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/refund/refund-wizard-result/refund-wizard-result.module#RefundWizardResultPageModule', name: 'RefundWizardResultPage', segment: 'refund-wizard-result', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/refund/refund-wizard/refund-wizard.module#RefundPoliciesPageModule', name: 'RefundWizardPage', segment: 'refund-wizard', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/refund/refund.module#RefundPageModule', name: 'RefundPage', segment: 'refund', priority: 'low', defaultHistory: [] },
                    { loadChildren: '../modules/support/pages/topics/topics.module#TopicsPageModule', name: 'TopicsPage', segment: 'topics', priority: 'low', defaultHistory: [] }
                ]
            }),
            __WEBPACK_IMPORTED_MODULE_19_ionic_image_loader__["b" /* IonicImageLoader */].forRoot(),
            __WEBPACK_IMPORTED_MODULE_17__ngx_translate_core__["b" /* TranslateModule */].forRoot({
                loader: {
                    provide: __WEBPACK_IMPORTED_MODULE_17__ngx_translate_core__["a" /* TranslateLoader */],
                    useFactory: createTranslateLoader,
                    deps: [__WEBPACK_IMPORTED_MODULE_16__angular_common_http__["b" /* HttpClient */]],
                },
            }),
            __WEBPACK_IMPORTED_MODULE_58_ionic2_super_tabs__["b" /* SuperTabsModule */].forRoot(),
            __WEBPACK_IMPORTED_MODULE_14__angular_platform_browser__["a" /* BrowserModule */],
            __WEBPACK_IMPORTED_MODULE_15__angular_platform_browser_animations__["a" /* BrowserAnimationsModule */],
            __WEBPACK_IMPORTED_MODULE_164__ionic_storage__["a" /* IonicStorageModule */].forRoot()
        ],
        bootstrap: [__WEBPACK_IMPORTED_MODULE_9_ionic_angular__["IonicApp"]],
        entryComponents: [
            __WEBPACK_IMPORTED_MODULE_23__app_component__["a" /* MyApp */],
            __WEBPACK_IMPORTED_MODULE_28__modules_home_pages_home__["a" /* HomePage */],
            __WEBPACK_IMPORTED_MODULE_79__modules_home_pages_home_flex__["a" /* HomeFlexPage */],
            __WEBPACK_IMPORTED_MODULE_29__modules_security_pages_onboarding_onboarding__["a" /* OnboardingPage */],
            __WEBPACK_IMPORTED_MODULE_89__modules_security_pages_offline_offline__["a" /* OfflinePage */],
            __WEBPACK_IMPORTED_MODULE_107__modules_security_pages_startup_startup__["a" /* StartupPage */],
            __WEBPACK_IMPORTED_MODULE_135__modules_security_pages_version_check_version_check__["a" /* VersionCheckPage */],
        ],
        providers: [
            __WEBPACK_IMPORTED_MODULE_158__awesome_cordova_plugins_app_rate_ngx__["a" /* AppRate */],
            __WEBPACK_IMPORTED_MODULE_163_ngx_spellchecker__["b" /* SpellCheckerService */],
            __WEBPACK_IMPORTED_MODULE_161__ionic_native_in_app_review_ngx__["a" /* InAppReview */],
            __WEBPACK_IMPORTED_MODULE_160__modules_support_providers_param_service__["a" /* ParamService */],
            __WEBPACK_IMPORTED_MODULE_159__modules_support_providers_apprate_service__["a" /* AppRateService */],
            __WEBPACK_IMPORTED_MODULE_10__ionic_native_status_bar__["a" /* StatusBar */],
            __WEBPACK_IMPORTED_MODULE_11__ionic_native_splash_screen__["a" /* SplashScreen */],
            { provide: __WEBPACK_IMPORTED_MODULE_13__angular_core__["ErrorHandler"], useClass: __WEBPACK_IMPORTED_MODULE_9_ionic_angular__["IonicErrorHandler"] },
            __WEBPACK_IMPORTED_MODULE_25__ionic_native_native_storage__["a" /* NativeStorage */],
            __WEBPACK_IMPORTED_MODULE_75__ionic_native_http__["a" /* HTTP */],
            [{ provide: __WEBPACK_IMPORTED_MODULE_16__angular_common_http__["a" /* HTTP_INTERCEPTORS */], useClass: __WEBPACK_IMPORTED_MODULE_97__util_timeout_interceptor__["b" /* TimeoutInterceptor */], multi: true }],
            [{ provide: __WEBPACK_IMPORTED_MODULE_97__util_timeout_interceptor__["a" /* DEFAULT_TIMEOUT */], useValue: __WEBPACK_IMPORTED_MODULE_98__config_config__["a" /* AppConfig */].app.timeout }],
            __WEBPACK_IMPORTED_MODULE_20__ionic_native_device__["a" /* Device */],
            __WEBPACK_IMPORTED_MODULE_21__ionic_native_network__["a" /* Network */],
            __WEBPACK_IMPORTED_MODULE_59__ionic_native_camera__["a" /* Camera */],
            __WEBPACK_IMPORTED_MODULE_99__ionic_native_clipboard__["a" /* Clipboard */],
            __WEBPACK_IMPORTED_MODULE_24__ionic_native_facebook__["a" /* Facebook */],
            __WEBPACK_IMPORTED_MODULE_12__ionic_native_google_plus__["a" /* GooglePlus */],
            __WEBPACK_IMPORTED_MODULE_118__ionic_native_in_app_browser__["a" /* InAppBrowser */],
            __WEBPACK_IMPORTED_MODULE_120__ionic_native_mobile_accessibility__["a" /* MobileAccessibility */],
            __WEBPACK_IMPORTED_MODULE_129__ionic_native_google_analytics__["a" /* GoogleAnalytics */],
            __WEBPACK_IMPORTED_MODULE_26__util_rest_client__["a" /* RESTClient */],
            __WEBPACK_IMPORTED_MODULE_74__util_rest_native_client__["a" /* NativeRESTClient */],
            __WEBPACK_IMPORTED_MODULE_22_ion2_calendar__["CalendarModule"],
            __WEBPACK_IMPORTED_MODULE_83__ionic_native_social_sharing__["a" /* SocialSharing */],
            __WEBPACK_IMPORTED_MODULE_27__config_startup__["a" /* Startup */],
            __WEBPACK_IMPORTED_MODULE_30__modules_core_provider_error_service__["a" /* ErrorService */],
            __WEBPACK_IMPORTED_MODULE_31__modules_session_session_service__["a" /* SessionService */],
            __WEBPACK_IMPORTED_MODULE_32__modules_session_session_manager_service__["a" /* SessionManagerService */],
            __WEBPACK_IMPORTED_MODULE_33__modules_security_providers_social_facebook_service__["a" /* SocialFacebookService */],
            __WEBPACK_IMPORTED_MODULE_34__modules_security_providers_social_google_service__["a" /* SocialGoogleService */],
            __WEBPACK_IMPORTED_MODULE_153__modules_security_providers_social_apple_service__["a" /* SocialAppleService */],
            __WEBPACK_IMPORTED_MODULE_35__modules_security_providers_login_service__["a" /* LoginService */],
            __WEBPACK_IMPORTED_MODULE_36__modules_security_providers_user_service__["a" /* UserService */],
            __WEBPACK_IMPORTED_MODULE_68__modules_security_providers_security_questions_service__["a" /* SecurityQuestionsService */],
            __WEBPACK_IMPORTED_MODULE_108__modules_datasets_home_suggested_dataset__["a" /* HomeSuggestedDataSet */],
            __WEBPACK_IMPORTED_MODULE_104__modules_datasets_home_section_dataset__["a" /* HomeSectionDataSet */],
            __WEBPACK_IMPORTED_MODULE_105__modules_datasets_home_regular_offers_dataset__["a" /* HomeRegularOffersDataSet */],
            __WEBPACK_IMPORTED_MODULE_106__modules_datasets_home_featured_offers_dataset__["a" /* HomeFeaturedOffersDataSet */],
            __WEBPACK_IMPORTED_MODULE_111__modules_datasets_home_categories_dataset__["a" /* HomeCategoriesDataSet */],
            __WEBPACK_IMPORTED_MODULE_109__modules_datasets_home_favs_dataset__["a" /* HomeFavsDataSet */],
            __WEBPACK_IMPORTED_MODULE_110__modules_datasets_home_seasons_dataset__["a" /* HomeSeasonsDataSet */],
            __WEBPACK_IMPORTED_MODULE_112__modules_datasets_search_family_dataset__["a" /* SearchFamilyDataSet */],
            __WEBPACK_IMPORTED_MODULE_113__modules_datasets_search_dataset__["a" /* SearchDataSet */],
            __WEBPACK_IMPORTED_MODULE_117__modules_datasets_search_similar_dataset__["a" /* SearchSimilarDataSet */],
            __WEBPACK_IMPORTED_MODULE_114__modules_datasets_search_banner_dataset__["a" /* SearchBannerDataSet */],
            __WEBPACK_IMPORTED_MODULE_115__modules_datasets_product_history_dataset__["a" /* ProductHistoryDataSet */],
            __WEBPACK_IMPORTED_MODULE_116__modules_datasets_product_similar_dataset__["a" /* ProductSimilarDataSet */],
            __WEBPACK_IMPORTED_MODULE_122__modules_datasets_home_misuper_dataset__["a" /* HomeMiSuperDataSet */],
            __WEBPACK_IMPORTED_MODULE_123__modules_datasets_home_category_tabbed_dataset__["a" /* HomeCategoryTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_8__modules_datasets_home_section_group_tabbed_dataset__["a" /* HomeSectionGroupTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_154__modules_datasets_home_section_group_section_tabbed_dataset__["a" /* HomeSectionGroupSectionTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_6__modules_datasets_home_section_group_section_tabbed_backward_dataset__["a" /* HomeSectionGroupSectionTabbedBackwardDataSet */],
            __WEBPACK_IMPORTED_MODULE_2__modules_datasets_home_promos_template_tabbed_dataset__["a" /* HomePromosTemplateTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_1__modules_datasets_home_promos_template_section_tabbed_dataset__["a" /* HomePromosTemplateSectionTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_0__modules_datasets_home_promos_template_section_tabbed_backward_dataset__["a" /* HomePromosTemplateSectionTabbedBackwardDataSet */],
            __WEBPACK_IMPORTED_MODULE_7__modules_home_providers_home_category_template_service__["a" /* HomeCategoryTemplateService */],
            __WEBPACK_IMPORTED_MODULE_124__modules_home_providers_home_offers_service__["a" /* HomeOffersService */],
            __WEBPACK_IMPORTED_MODULE_125__modules_datasets_home_grouped_offers_dataset__["a" /* GroupedOffersDataSet */],
            __WEBPACK_IMPORTED_MODULE_37__modules_home_providers_home_category_service__["a" /* HomeCategoryService */],
            __WEBPACK_IMPORTED_MODULE_38__modules_home_providers_home_seasons_service__["a" /* HomeSeasonsService */],
            __WEBPACK_IMPORTED_MODULE_39__modules_home_providers_home_favorites_service__["a" /* HomeFavoritesService */],
            __WEBPACK_IMPORTED_MODULE_121__modules_home_providers_home_misuper_service__["a" /* HomeMiSuperService */],
            __WEBPACK_IMPORTED_MODULE_40__modules_products_providers_product_product_category_service__["a" /* ProductCategoryService */],
            __WEBPACK_IMPORTED_MODULE_41__modules_products_providers_product_product_service__["a" /* ProductService */],
            __WEBPACK_IMPORTED_MODULE_5__modules_products_providers_section_section_service__["a" /* SectionService */],
            __WEBPACK_IMPORTED_MODULE_42__modules_products_providers_product_listing_product_category_listing_service__["a" /* ProductByCategoryService */],
            __WEBPACK_IMPORTED_MODULE_43__modules_products_providers_product_listing_product_seasons_listing_service__["a" /* ProductSeasonsListingService */],
            __WEBPACK_IMPORTED_MODULE_44__modules_products_providers_product_listing_product_favorites_listing_service__["a" /* ProductFavoriteListingService */],
            __WEBPACK_IMPORTED_MODULE_45__modules_products_providers_product_listing_product_suggested_listing_service__["a" /* ProductSuggestedListingService */],
            __WEBPACK_IMPORTED_MODULE_46__modules_products_providers_product_listing_product_wishlist_listing_service__["a" /* ProductWishlistListingService */],
            __WEBPACK_IMPORTED_MODULE_47__modules_products_providers_product_listing_product_history_listing_service__["a" /* ProductHistoryListingService */],
            __WEBPACK_IMPORTED_MODULE_48__modules_products_providers_product_listing_product_default_listing_service__["a" /* ProductDefaultListingService */],
            __WEBPACK_IMPORTED_MODULE_92__modules_products_providers_product_listing_product_search_listing_service__["a" /* ProductSearchListingService */],
            __WEBPACK_IMPORTED_MODULE_49__modules_products_providers_product_listing_promos_finalizing_listing_service__["a" /* PromosFinalizingListingService */],
            __WEBPACK_IMPORTED_MODULE_77__modules_products_providers_product_listing_product_family_listing_service__["a" /* ProductFamilyListingService */],
            __WEBPACK_IMPORTED_MODULE_50__modules_products_providers_product_listing_promos_daily_listing_service__["a" /* PromosDailyService */],
            __WEBPACK_IMPORTED_MODULE_51__modules_products_providers_product_listing_promos_regular_listing_service__["a" /* PromosRegularService */],
            __WEBPACK_IMPORTED_MODULE_52__modules_products_providers_wishlist_wish_list_service__["a" /* WishListService */],
            __WEBPACK_IMPORTED_MODULE_53__modules_products_providers_wishlist_wish_list_helper_service__["a" /* WishListHelperService */],
            __WEBPACK_IMPORTED_MODULE_64__modules_session_session_datasets_delivery_address_dataset_service__["a" /* DeliveryAddressSessionDataSetService */],
            __WEBPACK_IMPORTED_MODULE_65__modules_session_session_datasets_payment_option_dataset_service__["a" /* PaymentOptionSessionDataSetService */],
            __WEBPACK_IMPORTED_MODULE_70__modules_session_session_datasets_product_category_dataset_service__["a" /* ProductCategorySessionDataSetService */],
            __WEBPACK_IMPORTED_MODULE_66__modules_session_session_datasets_product_category_user_dataset_service__["a" /* ProductUserCategorySessionDataSetService */],
            __WEBPACK_IMPORTED_MODULE_80__modules_session_session_datasets_home_section_dataset_service__["a" /* HomeSectionSessionDataSetService */],
            __WEBPACK_IMPORTED_MODULE_81__modules_session_session_datasets_product_attribute_dataset_service__["a" /* ProductAttributeSessionDataSetService */],
            __WEBPACK_IMPORTED_MODULE_67__modules_session_session_datasets_wishlist_dataset_service__["a" /* WishlistSessionDataSetService */],
            __WEBPACK_IMPORTED_MODULE_72__modules_orders_providers_cart_manager_service__["a" /* CartManagerService */],
            __WEBPACK_IMPORTED_MODULE_54__modules_profile_providers_invite_friend_service__["a" /* InviteFriendService */],
            __WEBPACK_IMPORTED_MODULE_55__modules_profile_providers_card_service__["a" /* CardService */],
            __WEBPACK_IMPORTED_MODULE_56__modules_profile_providers_address_service__["a" /* AddressService */],
            __WEBPACK_IMPORTED_MODULE_57__modules_orders_providers_purchase_order_service__["a" /* PurchaseOrderService */],
            __WEBPACK_IMPORTED_MODULE_60__modules_support_providers_chat_message_service__["a" /* ChatMessageService */],
            __WEBPACK_IMPORTED_MODULE_61__modules_support_providers_faqs_service__["a" /* FAQsService */],
            __WEBPACK_IMPORTED_MODULE_73__modules_support_providers_topics_service__["a" /* TopicsService */],
            __WEBPACK_IMPORTED_MODULE_62__modules_notifications_providers_notifications_service__["a" /* NotificationService */],
            __WEBPACK_IMPORTED_MODULE_63__modules_notifications_providers_notification_settings_service__["a" /* NotificationSettingsService */],
            __WEBPACK_IMPORTED_MODULE_71__modules_notifications_providers_offers_service__["a" /* OffersService */],
            __WEBPACK_IMPORTED_MODULE_93__modules_rewards_providers_giftcard_service__["a" /* GiftCardService */],
            __WEBPACK_IMPORTED_MODULE_69__modules_rewards_providers_rewards_service__["a" /* RewardsService */],
            __WEBPACK_IMPORTED_MODULE_84__modules_profile_providers_geozone_service__["a" /* GeoZoneService */],
            __WEBPACK_IMPORTED_MODULE_78__modules_orders_providers_freight_service__["a" /* FreightService */],
            __WEBPACK_IMPORTED_MODULE_76__modules_home_providers_home_section_service__["a" /* HomeSectionService */],
            __WEBPACK_IMPORTED_MODULE_82__modules_products_providers_product_listing_product_section_listing_service__["a" /* ProductSectionListingService */],
            __WEBPACK_IMPORTED_MODULE_85__util_timer_timer_manager__["a" /* TimerManager */],
            __WEBPACK_IMPORTED_MODULE_87__modules_core_provider_greenpay_config_service__["a" /* GreenPayConfigService */],
            __WEBPACK_IMPORTED_MODULE_86__modules_core_provider_greenpay_tokenizer_service__["a" /* GreenPayTokenizerService */],
            __WEBPACK_IMPORTED_MODULE_88__modules_core_provider_greenpay_checkout_service__["a" /* GreenPayCheckoutService */],
            __WEBPACK_IMPORTED_MODULE_90__modules_products_providers_product_product_helper_service__["a" /* ProductHelperService */],
            __WEBPACK_IMPORTED_MODULE_91__modules_products_providers_product_listing_product_similar_listing_service__["a" /* ProductSimilarListingService */],
            __WEBPACK_IMPORTED_MODULE_94__modules_support_providers_refund_service__["a" /* RefundService */],
            __WEBPACK_IMPORTED_MODULE_95__modules_core_provider_image_caching_service__["a" /* ImageCachingService */],
            __WEBPACK_IMPORTED_MODULE_96__ionic_native_file_transfer__["a" /* FileTransfer */],
            __WEBPACK_IMPORTED_MODULE_100__modules_support_providers_terms_conditions__["a" /* TermsConditionsService */],
            __WEBPACK_IMPORTED_MODULE_101__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
            __WEBPACK_IMPORTED_MODULE_102__ionic_native_email_composer__["a" /* EmailComposer */],
            __WEBPACK_IMPORTED_MODULE_103__ionic_native_android_permissions__["a" /* AndroidPermissions */],
            __WEBPACK_IMPORTED_MODULE_119__modules_support_providers_version_service__["a" /* VersionService */],
            __WEBPACK_IMPORTED_MODULE_126__modules_orders_providers_subsidiaries_service__["a" /* SubsidiaryService */],
            __WEBPACK_IMPORTED_MODULE_127__modules_core_provider_caching_misuper_caching_service__["a" /* MiSuperCachingService */],
            __WEBPACK_IMPORTED_MODULE_128__modules_core_provider_caching_category_caching_service__["a" /* CategoryCachingService */],
            __WEBPACK_IMPORTED_MODULE_4__modules_core_provider_caching_category_template_caching_service__["a" /* CategoryTemplateCachingService */],
            __WEBPACK_IMPORTED_MODULE_3__modules_core_provider_caching_promos_template_caching_service__["a" /* PromosTemplateCachingService */],
            __WEBPACK_IMPORTED_MODULE_130__modules_datasets_home_suggested_dataset_navigator__["a" /* HomeSuggestedDataSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_131__modules_datasets_home_section_dataset_navigator__["a" /* HomeSectionDataSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_132__modules_datasets_home_favs_dataset_navigator__["a" /* HomeFavsDataSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_133__modules_datasets_product_listing_dataset_navigator__["a" /* ProductListingDataSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_134__modules_datasets_product_listing_similar_dataset_navigator__["a" /* ProductListingSimilarSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_140__modules_datasets_tabbed_dataset_navigator__["a" /* TabbedDataSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_136__ionic_native_unique_device_id__["a" /* UniqueDeviceID */],
            __WEBPACK_IMPORTED_MODULE_137__modules_security_providers_device_uniqueid_service__["a" /* UniqueIdService */],
            __WEBPACK_IMPORTED_MODULE_138__ionic_native_uid__["a" /* Uid */],
            __WEBPACK_IMPORTED_MODULE_139__modules_support_providers_chat_service__["a" /* ChatService */],
            __WEBPACK_IMPORTED_MODULE_141__modules_core_provider_caching_transient_caching_service__["a" /* TransientCachingService */],
            __WEBPACK_IMPORTED_MODULE_143__modules_datasets_tabbed_section_dataset_navigator__["a" /* TabbedSectionDataSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_145__modules_datasets_tabbed_section_backward_dataset_navigator__["a" /* TabbedSectionBackwardDataSetNavigator */],
            __WEBPACK_IMPORTED_MODULE_142__modules_datasets_home_category_section_tabbed_dataset__["a" /* HomeCategorySectionTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_144__modules_datasets_home_category_section_tabbed_backward_dataset__["a" /* HomeCategorySectionTabbedBackwardDataSet */],
            __WEBPACK_IMPORTED_MODULE_148__modules_datasets_home_misuper_tabbed_dataset__["a" /* HomeMiSuperTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_146__modules_datasets_home_misuper_section_tabbed_dataset__["a" /* HomeMiSuperSectionTabbedDataSet */],
            __WEBPACK_IMPORTED_MODULE_147__modules_datasets_home_misuper_section_tabbed_backward_dataset__["a" /* HomeMiSuperSectionTabbedBackwardDataSet */],
            __WEBPACK_IMPORTED_MODULE_149__modules_datasets_search_filter_dataset__["a" /* SearchFilterDataSet */],
            __WEBPACK_IMPORTED_MODULE_150__modules_products_pages_product_listing_filtered_product_listing_filtered__["a" /* ProductListingFilteredPage */],
            __WEBPACK_IMPORTED_MODULE_151__modules_notifications_pages_notifications_deals_details_notifications_deals_details__["a" /* NotificationDeailsDetailPage */],
            __WEBPACK_IMPORTED_MODULE_155__modules_datasets_home_promos_template_offers_dataset__["a" /* HomePromosTemplateFeaturedOffersDataSet */],
            __WEBPACK_IMPORTED_MODULE_156__modules_datasets_home_promos_template_regular_offers_dataset__["a" /* HomePromosTemplateRegularOffersDataSet */],
            __WEBPACK_IMPORTED_MODULE_152__ionic_native_push__["a" /* Push */],
            __WEBPACK_IMPORTED_MODULE_157__modules_datasets_notification_deals_dataset__["a" /* NotificationDealsDataSet */],
            __WEBPACK_IMPORTED_MODULE_162__modules_orders_providers_sinpe_service__["a" /* SinpeService */],
        ],
    })
], AppModule);

//# sourceMappingURL=app.module.js.map

/***/ }),

/***/ 75:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SectionService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__model_section_type_model__ = __webpack_require__(750);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__model_product_model__ = __webpack_require__(71);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






let SectionService = class SectionService {
    constructor(rest) {
        this.rest = rest;
    }
    getSectionTypes(session, sectionId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["f" /* SectionTypeMapper */].convertModelToRequest(session, sectionId);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_PROMO_SECTION_TYPE_LIST, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["f" /* SectionTypeMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta los productos de la Seccion de PROMOS
     */
    getPromoProducts(session, promoType, pageId, pageRows) {
        var filter = {
            userId: session && session.userId > 0 ? session.userId : null,
            token: session && session.token > 0 ? session.token : null,
            promoType: promoType,
            pageId: pageId,
            pageRows: pageRows
        };
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_5__model_product_model__["a" /* ProductMapper */].convertModelToRequest(filter);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_PRODUCTS, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta los productos de la Seccion de PROMOS
     */
    getProductsBySectionTypeResume(session, sectionId, sectionType, pageId, pageRows) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            let pagedModel = {
                pageId: pageId,
                pageRows: pageRows
            };
            var paramsString = __WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["d" /* ProductSectionTypeMapper */].convertModelToRequest(session, sectionId, sectionType, pagedModel);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_PRODUCTS_SECTION_TYPE, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_5__model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta los pasillos de la Seccion de PROMOS por Categoria
     */
    getGroups(session, sectionType) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["a" /* HallwayBySectionMapper */].convertModelToRequest(session, sectionType);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_GROUPS, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["a" /* HallwayBySectionMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta las imagenes por pasillo
     * @param session
     * @param sectionType
     * @param hallwayId
     * @returns
     */
    getImagesByGroup(session, sectionType, hallwayId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["c" /* ImageHallwayMapper */].convertModelToRequest(session, sectionType, hallwayId);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_IMAGES_BY_GROUP, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["c" /* ImageHallwayMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta los pasillos de la Seccion de PROMOS por Categoria
     */
    getSectionsByHallway(session, section, hallwayId) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["e" /* SectionByHallwayMapper */].convertModelToRequest(session, section, hallwayId);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_SECTIONS_BY_HALLWAY, paramsString).subscribe((response) => {
                observer.next(__WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["e" /* SectionByHallwayMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    /**
     * Consulta los productos de la Seccion de CATEGORIAS
     */
    getProductsByHallwaySection(session, lobbyId, sectionCode, hallwayId, pageId, pageRows) {
        return new __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["b" /* HomeProductsByHallwayAndSectionMapper */].convertModelToRequest(session, lobbyId, sectionCode, hallwayId, pageId, pageRows);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_4__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_PROMO_PRODUCTS_BY_SECTION, paramsString).subscribe((response) => {
                if (response) {
                    //Valida respuesta vacia
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_0__model_section_type_model__["b" /* HomeProductsByHallwayAndSectionMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
                ;
            });
        });
    }
};
SectionService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_3__util_rest_client__["a" /* RESTClient */]])
], SectionService);

//# sourceMappingURL=section-service.js.map

/***/ }),

/***/ 750:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_product_utils__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_string_utils__ = __webpack_require__(7);


class SectionTypeMapper {
    static convertModelToRequest(session, sectionId) {
        var request = {
            token: session.token,
            id_seccion: sectionId,
            id_usuario: session.userId
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            sectionType: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.tipo_seccion),
            description: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                result.push(SectionTypeMapper.convertResponseToModel(item));
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["f"] = SectionTypeMapper;

class ProductSectionTypeMapper {
    static convertModelToRequest(session, sectionId, sectionType, page) {
        var request = {
            token: session.token,
            id_seccion: sectionId,
            id_usuario: session.userId,
            tipo_seccion: sectionType,
            pagina: page.pageId,
            registros: page.pageRows
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
}
/* harmony export (immutable) */ __webpack_exports__["d"] = ProductSectionTypeMapper;

class HallwayBySectionMapper {
    static convertModelToRequest(session, sectionId) {
        var request = {
            id_usuario: session.userId,
            token: session.token,
            id_seccion: sectionId
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            hallwayId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pasillo),
            description: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            images: []
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(HallwayBySectionMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = HallwayBySectionMapper;

class ImageHallwayMapper {
    static convertModelToRequest(session, sectionId, hallwayId) {
        var request = {
            id_usuario: session.userId,
            token: session.token,
            id_seccion: sectionId,
            id_pasillo: hallwayId
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            imageId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_imagen),
            url: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.url)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(ImageHallwayMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["c"] = ImageHallwayMapper;

class SectionByHallwayMapper {
    static convertModelToRequest(session, section, hallwayId) {
        var request = {
            id_usuario: session.userId,
            token: session.token,
            id_seccion: section,
            seccion: section,
            id_pasillo: hallwayId
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            sectionId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_seccion),
            hallwayId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pasillo),
            tabId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pestana),
            description: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(SectionByHallwayMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["e"] = SectionByHallwayMapper;

class HomeProductsByHallwayAndSectionMapper {
    static convertModelToRequest(session, lobbyId, sectionId, hallwayId, page, size) {
        var request = {
            id_usuario: session.userId,
            token: session.token,
            id_seccion: lobbyId,
            id_pasillo: sectionId,
            id_pestana: hallwayId,
            pagina: page,
            registros: size
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var product = {
            productCode: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            description: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            details: '',
            image: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            price: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio),
            realPrice: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.preciosd),
            tax: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto),
            discountPercentage: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuento),
            isPromo: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.espromo),
            isInWishList: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.deseo),
            promoExpiration: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.finalizapromo),
            isGroup: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.grupo),
            groupCriteria: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pasillo),
            groupValue: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.etiquetagrupo),
            groupedItems: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.grupo),
            groupLabel: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.etiquetagrupo),
            availableUnits: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.udsdisponibles),
            availableInDays: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.diasdisponible),
            isAvailable: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.disponible),
            searchQuantity: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantidad_disponible),
            state: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            message: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            searchPaginationId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            priceWithNoTax: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            excent: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            maxQuantityToSell: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            icon: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.icono),
            iconColor: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.icono_color),
            iconEffect: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.efecto),
            promoText: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            quantityText: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            tabGroup: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pasillo),
            tabSection: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pestana),
            tabSectionName: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_pestana),
            allowFiltering: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null)
        };
        //Realiza calculos del producto, como descuentos, impuestos, etc.
        __WEBPACK_IMPORTED_MODULE_0__util_product_utils__["a" /* ProductUtils */].handleDefaults(product);
        return product;
    }
    static convertResponseListToModelList(list, callback) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                //let hallwayId: number = item.id_pasillo;
                //item.id_pasillo = item.id_seccion;
                //item.id_seccion = hallwayId;
                let model = HomeProductsByHallwayAndSectionMapper.convertResponseToModel(item);
                result.push(model);
                if (callback) {
                    callback(model);
                }
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = HomeProductsByHallwayAndSectionMapper;

//# sourceMappingURL=section-type.model.js.map

/***/ }),

/***/ 76:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomeMiSuperService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__util_rest_client__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__config_rest_config__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__ = __webpack_require__(1146);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__products_model_product_model__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__core_provider_caching_misuper_caching_service__ = __webpack_require__(166);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_ionic_angular__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__config_config__ = __webpack_require__(3);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};









let HomeMiSuperService = class HomeMiSuperService {
    constructor(rest, cache, events) {
        this.rest = rest;
        this.cache = cache;
        this.events = events;
        this.lazyLoadingDone = false;
    }
    performInit(params) {
        this.groups = [];
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["d" /* MiSuperMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_GROUPS, paramsString).subscribe((response) => {
                if (response) {
                    let list = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["d" /* MiSuperMapper */].convertResponseListToModelList(response);
                    let observables = [];
                    for (var i = 0; i < list.length; i++) {
                        if (list[i].visible === "S") {
                            observables.push(this.getGroupImages(list[i]));
                        }
                    }
                    //Consulta las imagenes de cada grupo
                    if (observables.length > 0) {
                        __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].forkJoin(observables).subscribe(data => {
                            let groups = data;
                            let sectionObservables = [];
                            for (var i = 0; i < groups.length; i++) {
                                sectionObservables.push(this.getGroupSection(groups[i]));
                            }
                            //Consulta las secciones de cada grupo
                            __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].forkJoin(sectionObservables).subscribe(sectionsData => {
                                let sectionGroups = sectionsData;
                                this.groups = sectionGroups;
                                observer.next(sectionGroups);
                                observer.complete();
                            });
                        });
                    }
                    else {
                        observer.next([]);
                        observer.complete();
                    }
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    isLazyLoadingDone() {
        return this.lazyLoadingDone;
    }
    performGroupsInitLazy(params) {
        this.groups = [];
        this.lazyLoadingDone = false;
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["d" /* MiSuperMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_GROUPS, paramsString).subscribe((response) => {
                if (response) {
                    let list = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["d" /* MiSuperMapper */].convertResponseListToModelList(response);
                    let observables = [];
                    for (var i = 0; i < list.length; i++) {
                        if (list[i].visible === "S") {
                            observables.push(this.getGroupImages(list[i]));
                        }
                    }
                    //Consulta las imagenes de cada grupo
                    if (observables.length > 0) {
                        __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].forkJoin(observables).subscribe(data => {
                            this.lazyGroups = data;
                            this.lazyLoadingDone = true;
                            this.events.publish(__WEBPACK_IMPORTED_MODULE_8__config_config__["a" /* AppConfig */].event.LOBBY_MISUPER_LAZY_LOADED);
                            observer.next(this.lazyGroups);
                            observer.complete();
                        });
                    }
                    else {
                        observer.next([]);
                        observer.complete();
                    }
                }
                else {
                    observer.next([]);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    performGroupsSectionsLazyInit(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            let groups = this.lazyGroups;
            let sectionObservables = [];
            for (var i = 0; i < groups.length; i++) {
                sectionObservables.push(this.getGroupSection(groups[i]));
            }
            //Consulta las secciones de cada grupo
            __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"].forkJoin(sectionObservables).subscribe(sectionsData => {
                let sectionGroups = sectionsData;
                this.groups = sectionGroups;
                observer.next(sectionGroups);
                observer.complete();
            });
        });
    }
    getGroups() {
        if (this.groups) {
            //Ordena los grupos
            this.groups.sort(function (a, b) {
                return a.order - b.order;
            });
        }
        return this.groups;
    }
    getGroupImages(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["c" /* MiSuperImageMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_GROUPS_IMAGES, paramsString).subscribe((response) => {
                if (response) {
                    let images = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["c" /* MiSuperImageMapper */].convertResponseListToModelList(response);
                    params.images = images;
                    observer.next(params);
                    observer.complete();
                }
            }, error => {
                observer.error(error);
            });
        });
    }
    getGroupSection(params) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["a" /* MiSuperGroupSectionMapper */].convertModelToRequest(params);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_GROUPS_SECTIONS, paramsString).subscribe((response) => {
                if (response) {
                    let sections = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["a" /* MiSuperGroupSectionMapper */].convertResponseListToModelList(params.code, response);
                    let actualList = [];
                    for (var i = 0; i < sections.length; i++) {
                        if (sections[i].visible === "S") {
                            actualList.push(sections[i]);
                        }
                    }
                    params.sections = actualList;
                }
                else {
                    params.sections = [];
                }
                observer.next(params);
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    getProductForGroupSection(pageModel, groupCode, sectionCode) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["b" /* MiSuperGroupSectionProductsMapper */].convertModelToRequest(pageModel, groupCode, sectionCode);
            this.rest.get(__WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_GROUPS_PRODUCTS, paramsString).subscribe((response) => {
                //Valida respuesta vacia
                if (response) {
                    if (response.length === 1) {
                        if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                            response = [];
                        }
                    }
                }
                observer.next(__WEBPACK_IMPORTED_MODULE_5__products_model_product_model__["a" /* ProductMapper */].convertResponseListToModelList(response));
                observer.complete();
            }, error => {
                observer.error(error);
            });
        });
    }
    getMiSuperProductSection(pageModel, groupCode, sectionCode, asList) {
        return new __WEBPACK_IMPORTED_MODULE_1_rxjs_Observable__["Observable"](observer => {
            var paramsString = __WEBPACK_IMPORTED_MODULE_4__model_home_misuper_model__["b" /* MiSuperGroupSectionProductsMapper */].convertModelToRequest(pageModel, groupCode, sectionCode);
            //ID para cachear la pagina
            let url = __WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_MERQUEO_PRODUCTS;
            if (paramsString) {
                url += ("?" + paramsString);
            }
            //Existe la data cacheada para el grupo
            let cacheList = this.cache.getPage(url);
            if (cacheList && cacheList.length > 0) {
                //console.log("CACHE -> " + url + " ITEMS GUARDADOS: " + cacheList.length);
                observer.next(cacheList);
                observer.complete();
            }
            else {
                this.rest.get(asList ? __WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_MERQUEO_SECTION_LIST_PRODUCTS : __WEBPACK_IMPORTED_MODULE_3__config_rest_config__["a" /* RESTConfig */].WS_LOBBY_MISUPER_MERQUEO_PRODUCTS, paramsString).subscribe((response) => {
                    if (response) {
                        if (response.length === 1) {
                            if (!response[0].articulo || response[0].articulo.trim().length === 0) {
                                response = [];
                            }
                        }
                    }
                    else {
                        response = [];
                    }
                    //console.log("SERVER -> " + url + " ITEMS DESCARGADOS: " + response.length);
                    let list = __WEBPACK_IMPORTED_MODULE_5__products_model_product_model__["a" /* ProductMapper */].convertResponseMerqueoListToModelList(groupCode, response);
                    this.cache.addPage(url, list);
                    observer.next(list);
                    observer.complete();
                }, error => {
                    observer.error(error);
                });
            }
        });
    }
};
HomeMiSuperService = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
    __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__util_rest_client__["a" /* RESTClient */], __WEBPACK_IMPORTED_MODULE_6__core_provider_caching_misuper_caching_service__["a" /* MiSuperCachingService */], __WEBPACK_IMPORTED_MODULE_7_ionic_angular__["Events"]])
], HomeMiSuperService);

//# sourceMappingURL=home-misuper-service.js.map

/***/ }),

/***/ 79:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TabbedDataSet; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_dataset__ = __webpack_require__(29);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


/**
 * Fuente de datos para los Tabs Dinamicos
 */
let TabbedDataSet = class TabbedDataSet extends __WEBPACK_IMPORTED_MODULE_1__base_dataset__["a" /* DataSet */] {
    setGroupCode(groupCode) {
        this.groupCode = groupCode;
    }
    getGroupCode() {
        return this.groupCode;
    }
    setSectionCode(sectionCode) {
        this.sectionCode = sectionCode;
    }
    getSectionCode() {
        return this.sectionCode;
    }
};
TabbedDataSet = __decorate([
    Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
], TabbedDataSet);

//# sourceMappingURL=tabbed-dataset.js.map

/***/ }),

/***/ 790:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util_product_utils__ = __webpack_require__(89);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__util_string_utils__ = __webpack_require__(7);


class HomeSectionGroupsMapper {
    static convertModelToRequest(sectionId, token, userId) {
        var request = {
            id_usuario: userId,
            token: token,
            id_seccion: sectionId
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            groupId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_grupo),
            description: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(HomeSectionGroupsMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["b"] = HomeSectionGroupsMapper;

class HomeSectionsByGroupMapper {
    static convertModelToRequest(groupId, token, userId) {
        var request = {
            id_usuario: userId,
            token: token,
            id_grupo: groupId
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var model = {
            sectionId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_seccion),
            description: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            image: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen)
        };
        return model;
    }
    static convertResponseListToModelList(list) {
        let result = [];
        list.forEach(function (item) {
            result.push(HomeSectionsByGroupMapper.convertResponseToModel(item));
        });
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["c"] = HomeSectionsByGroupMapper;

class HomeProductsByGroupAndSectionMapper {
    static convertModelToRequest(groupId, sectionId, token, userId, page, size) {
        var request = {
            id_usuario: userId,
            token: token,
            id_grupo: groupId,
            grupo: groupId,
            id_seccion: sectionId,
            seccion: sectionId,
            pagina: page,
            registros: size
        };
        return __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].objectToQueryString(request);
    }
    static convertResponseToModel(response) {
        var product = {
            productCode: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.articulo),
            description: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descripcion),
            details: '',
            image: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.imagen),
            imageType: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.multimedio),
            price: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.precio),
            realPrice: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.preciosd),
            tax: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.impuesto),
            discountPercentage: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.descuento),
            isPromo: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.espromo),
            isInWishList: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.deseo),
            promoExpiration: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.finalizapromo),
            isGroup: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.grupo),
            groupCriteria: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_grupo),
            groupValue: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.etiquetagrupo),
            groupedItems: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.grupo),
            groupLabel: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.etiquetagrupo),
            availableUnits: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.udsdisponibles),
            availableInDays: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.diasdisponible),
            isAvailable: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.disponible),
            searchQuantity: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.cantidad_disponible),
            state: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            message: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            searchPaginationId: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            priceWithNoTax: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            excent: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            maxQuantityToSell: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            icon: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.icono),
            iconColor: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.icono_color),
            iconEffect: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.efecto),
            promoText: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            quantityText: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null),
            tabGroup: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_grupo),
            tabSection: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_seccion),
            tabSectionName: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(response.id_seccion),
            allowFiltering: __WEBPACK_IMPORTED_MODULE_1__util_string_utils__["a" /* StringUtils */].validateNullOrUndefined(null)
        };
        //Realiza calculos del producto, como descuentos, impuestos, etc.
        __WEBPACK_IMPORTED_MODULE_0__util_product_utils__["a" /* ProductUtils */].handleDefaults(product);
        return product;
    }
    static convertResponseListToModelList(list, callback) {
        let result = [];
        if (list && list.length > 0) {
            list.forEach(function (item) {
                let model = HomeProductsByGroupAndSectionMapper.convertResponseToModel(item);
                result.push(model);
                if (callback) {
                    callback(model);
                }
            });
        }
        return result;
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = HomeProductsByGroupAndSectionMapper;

//# sourceMappingURL=home-section-group.model.js.map

/***/ }),

/***/ 89:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__number_utils__ = __webpack_require__(276);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__string_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__config_config__ = __webpack_require__(3);



/**
 * Revision 1.0.20170321
 * Utility class that provides number utilities.
 *
 * @author Coliand Studio
 * @version 1.0.20170321
 *
 */
class ProductUtils {
    static randomDate(start, end) {
        return new Date(start.getTime() + Math.random() * (end.getTime() - start.getTime()));
    }
    static handleDefaults(product) {
        if (product) {
            /////////////////////////////////////////
            //Datos de pruebas
            //product.isInWishList = "S";
            //product.isPromo = "S";
            /*let dt = ProductUtils.randomDate(new Date(2025, 0, 1), new Date());
            dt.setMinutes( dt.getMinutes() + 30 );
            product.promoExpiration = dt.getTime();//1543536000;*/
            //product.discountPercentage = 5; //Porcentage de descuento
            //product.availableUnits = 0;
            //product.isAvailable = "N";
            //product.availableInDays = 3; //Dias en que esta disponible*/
            //product.groupLabel = "Ver mas colores"
            //product.icon = "alarm";
            //product.iconEffect = "shake";
            //product.iconColor = "ffa54f";
            //product.promoText = '<b>Texto promo</b> <i><font color="yellow">Texto promo</font></i><h1>Titulo Grande</h1> <b>Texto promo</b> <i>Texto italico</i> <span style="font-family:courier;">Texto en Courier</span> <i>Texto promo</i>';
            //product.quantityText = '<b>Texto promo</b> <i><font color="yellow">Texto promo</font></i><h1>Titulo Grande</h1> <b>Texto promo</b> <i>Texto italico</i> <span style="font-family:courier;">Texto en Courier</span> <i>Texto promo</i>';
            //product.maxQuantityToSell = 2;
            /////////////////////////////////////////
            //Validacion de banderas
            if (__WEBPACK_IMPORTED_MODULE_1__string_utils__["a" /* StringUtils */].isEmpty(product.isGroup)) {
                product.isGroup = __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultNO;
            }
            if (__WEBPACK_IMPORTED_MODULE_1__string_utils__["a" /* StringUtils */].isEmpty(product.isAvailable)) {
                product.isAvailable = __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultNO;
            }
            if (__WEBPACK_IMPORTED_MODULE_1__string_utils__["a" /* StringUtils */].isEmpty(product.isInWishList)) {
                product.isInWishList = __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultNO;
            }
            if (__WEBPACK_IMPORTED_MODULE_1__string_utils__["a" /* StringUtils */].isEmpty(product.isPromo)) {
                product.isPromo = __WEBPACK_IMPORTED_MODULE_2__config_config__["a" /* AppConfig */].app.defaultNO;
            }
            if (__WEBPACK_IMPORTED_MODULE_1__string_utils__["a" /* StringUtils */].isEmpty(product.discountPercentage)) {
                product.discountPercentage = 0;
            }
            if (__WEBPACK_IMPORTED_MODULE_1__string_utils__["a" /* StringUtils */].isEmpty(product.availableInDays)) {
                product.availableInDays = 0;
            }
            if (product.iconEffect) {
                product.iconEffect = "anim-" + product.iconEffect;
            }
            if (product.iconColor) {
                product.iconColor = "#" + product.iconColor;
            }
            else {
                product.iconColor = "#ed2f51"; //default color
            }
            //Redondeos de montos
            __WEBPACK_IMPORTED_MODULE_0__number_utils__["a" /* NumberUtils */].roundWithPrecision(product.tax);
            __WEBPACK_IMPORTED_MODULE_0__number_utils__["a" /* NumberUtils */].roundWithPrecision(product.price);
            __WEBPACK_IMPORTED_MODULE_0__number_utils__["a" /* NumberUtils */].roundWithPrecision(product.realPrice);
            __WEBPACK_IMPORTED_MODULE_0__number_utils__["a" /* NumberUtils */].roundWithPrecision(product.priceWithNoTax);
            product.imageShow = false; //Se utiliza para carga lazy en las pantallas
        }
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = ProductUtils;

//# sourceMappingURL=product.utils.js.map

/***/ })

},[744]);
//# sourceMappingURL=main.js.map